*****************************************************************************
*
* ITEMDAT.ASM
*
*
* Status bits are 15=taken/gone 14=inactive
* if either of these bits are set, the item will not plot
*
* Status =1 means display, but can't pick up
*
* Format for ID is:
*                   msb - Frame to load
*                   lsb - ID number (provides offset into vram table)
*
*
*
*****************************************************************************
*
* Format is: Item ID        (byte) 
*            Frame          (byte)
*            X              (word)
*            Y              (word)
*            Status         (word)
*
*****************************************************************************

HEALTHBAR	.equ	$0000
HEXNUMS	.equ	$0002

ONEUP	.equ	$0004
DARTS	.equ	$0606
PARTLIFE	.equ	$0708
BONUSCOIN	.equ	$0B0A

WEAPKNIFE	.equ	$080C
WEAPDART	.equ	$090C
ACTDART	.equ	$0A10

TILEBOX	.equ	$0008


tzanhomeitem:
	.dw	BONUSCOIN,$0A0,$0A0,0
	.dw	BONUSCOIN,$150,$030,0
	.dw	BONUSCOIN,$180,$0D0,0
	.dw	BONUSCOIN,$240,$0E0,0
	.dw	BONUSCOIN,$2A0,$030,0

	.dw	BONUSCOIN,$020,$150,0
	.dw	BONUSCOIN,$140,$1B0,0
	.dw	BONUSCOIN,$0D0,$120,0
	.dw	BONUSCOIN,$220,$1B0,0
	.dw	BONUSCOIN,$2C0,$1D0,0

	.dw	BONUSCOIN,$050,$250,0
	.dw	BONUSCOIN,$0A0,$2D0,0
	.dw	BONUSCOIN,$100,$240,0
	.dw	BONUSCOIN,$1A0,$210,0
	.dw	BONUSCOIN,$250,$200,0

	.dw	BONUSCOIN,$020,$320,0
	.dw	BONUSCOIN,$0B0,$390,0
	.dw	BONUSCOIN,$120,$330,0
	.dw	BONUSCOIN,$1B0,$390,0
	.dw	BONUSCOIN,$250,$300,0

	.dw	BONUSCOIN,$150,$480,0
	.dw	BONUSCOIN,$1E0,$4C0,0
	.dw	BONUSCOIN,$240,$480,0
	.dw	BONUSCOIN,$2F0,$440,0
	.dw	BONUSCOIN,$3B0,$440,0

	.dw	BONUSCOIN,$1A0,$5B0,0
	.dw	BONUSCOIN,$190,$530,0
	.dw	BONUSCOIN,$2E0,$510,0
	.dw	BONUSCOIN,$240,$550,0
	.dw	BONUSCOIN,$2C0,$5E0,0

	.dw	ONEUP,$326,$1EB,0
	.dw	DARTS,$0AD,$79F,0
	.dw	DARTS,$218,$385,0

	.dw	$FFFF

jungle1item:
	.dw	BONUSCOIN,$069,$260,0	; /
	.dw	BONUSCOIN,$074,$1FF,0	; /
	.dw	BONUSCOIN,$0B7,$1DF,0	; /
	.dw	BONUSCOIN,$0CB,$26D,0	; /
	.dw	BONUSCOIN,$062,$196,0	; /

	.dw	BONUSCOIN,$139,$26D,0	; /
	.dw	BONUSCOIN,$1BC,$236,0	; /
	.dw	BONUSCOIN,$25E,$25B,0	; /
	.dw	BONUSCOIN,$3A6,$1B4,0	; /
	.dw	BONUSCOIN,$6B3,$0A7,0	; /

	.dw	BONUSCOIN,$206,$259,0	; /
	.dw	BONUSCOIN,$345,$27F,0	; /
	.dw	BONUSCOIN,$2CA,$298,0	; /
	.dw	BONUSCOIN,$3F2,$298,0	; /
	.dw	BONUSCOIN,$52C,$298,0	; /

	.dw	BONUSCOIN,$575,$27A,0	; /
	.dw	BONUSCOIN,$620,$094,0	; /
	.dw	BONUSCOIN,$649,$0E8,0	; /
	.dw	BONUSCOIN,$6AF,$10F,0	; /
	.dw	BONUSCOIN,$726,$082,0	; /

	.dw	BONUSCOIN,$750,$10C,0	; /
	.dw	BONUSCOIN,$71F,$10C,0	; /
	.dw	BONUSCOIN,$7A5,$13F,0	; /
	.dw	BONUSCOIN,$747,$1BD,0	; /
	.dw	BONUSCOIN,$710,$16C,0	; /

	.dw	BONUSCOIN,$67F,$151,0	; /
	.dw	BONUSCOIN,$5EE,$162,0	; /
	.dw	BONUSCOIN,$5BE,$1D2,0	; /
	.dw	BONUSCOIN,$625,$198,0	; /
	.dw	BONUSCOIN,$73B,$264,0	; /

	.dw	DARTS,$8D0,$241,0
	.dw	DARTS,$8D0,$278,0

	.dw	ONEUP,$8D0,$2A9,0

	.dw	PARTLIFE,$34A,$1A8,0


	.dw	$FFFF

clearingitem:
	.dw	BONUSCOIN,$084,$310,0
	.dw	BONUSCOIN,$0C8,$2FD,0
	.dw	BONUSCOIN,$046,$255,0
	.dw	BONUSCOIN,$046,$1E8,0
	.dw	BONUSCOIN,$08C,$1A9,0

	.dw	BONUSCOIN,$0D7,$0DD,0
	.dw	BONUSCOIN,$10D,$188,0
	.dw	BONUSCOIN,$149,$122,0
	.dw	BONUSCOIN,$19C,$214,0
	.dw	BONUSCOIN,$0E5,$261,0

	.dw	BONUSCOIN,$0CD,$1BF,0
	.dw	BONUSCOIN,$124,$2F2,0
	.dw	BONUSCOIN,$1A1,$24D,0
	.dw	BONUSCOIN,$25C,$30A,0
	.dw	BONUSCOIN,$24A,$1DB,0

	.dw	BONUSCOIN,$3DA,$2F4,0
	.dw	BONUSCOIN,$3DA,$268,0
	.dw	BONUSCOIN,$3BF,$1F7,0
	.dw	BONUSCOIN,$3CB,$19C,0
	.dw	BONUSCOIN,$385,$130,0

	.dw	BONUSCOIN,$2D3,$0E5,0
	.dw	BONUSCOIN,$2B2,$181,0
	.dw	BONUSCOIN,$2FD,$184,0
	.dw	BONUSCOIN,$300,$21D,0
	.dw	BONUSCOIN,$2C1,$21D,0

	.dw	BONUSCOIN,$34E,$31F,0
	.dw	BONUSCOIN,$2E5,$2AF,0
	.dw	BONUSCOIN,$310,$25E,0
	.dw	BONUSCOIN,$34B,$17B,0
	.dw	BONUSCOIN,$3A5,$373,0

	.dw	ONEUP,$1F0,$0E4,0
	.dw	ONEUP,$210,$0E4,0
	.dw	DARTS,$1E0,$0F8,0
	.dw	DARTS,$200,$0F8,0
	.dw	DARTS,$220,$0F8,0

	.dw	DARTS,$032,$179,0
	.dw	DARTS,$353,$29D,0

	.dw	PARTLIFE,$385,$373,0
	.dw	PARTLIFE,$080,$220,0

	.dw	$FFFF

swampitem:
	.dw	BONUSCOIN,$09F,$273,0	;
	.dw	BONUSCOIN,$109,$1EA,0	;
	.dw	BONUSCOIN,$042,$164,0	;
	.dw	BONUSCOIN,$134,$0C3,0	;
	.dw	BONUSCOIN,$09A,$10A,0	;

	.dw	BONUSCOIN,$142,$152,0	;
	.dw	BONUSCOIN,$1C2,$0D9,0	;
	.dw	BONUSCOIN,$16c,$264,0	;
	.dw	BONUSCOIN,$2C5,$2A6,0
	.dw	BONUSCOIN,$386,$2C4,0

	.dw	BONUSCOIN,$428,$2A3,0
	.dw	BONUSCOIN,$575,$2C4,0
	.dw	BONUSCOIN,$624,$2AF,0
	.dw	BONUSCOIN,$6C4,$2AF,0
	.dw	BONUSCOIN,$7B6,$291,0

	.dw	BONUSCOIN,$75A,$242,0
	.dw	BONUSCOIN,$6C6,$204,0
	.dw	BONUSCOIN,$7AF,$09F,0
	.dw	BONUSCOIN,$6FB,$151,0
	.dw	BONUSCOIN,$634,$154,0

	.dw	BONUSCOIN,$42B,$1CF,0
	.dw	BONUSCOIN,$299,$1FC,0
	.dw	BONUSCOIN,$360,$091,0
	.dw	BONUSCOIN,$3D5,$259,0
	.dw	BONUSCOIN,$477,$2C2,0

	.dw	BONUSCOIN,$5C2,$2C4,0
	.dw	BONUSCOIN,$236,$2C4,0	;
	.dw	BONUSCOIN,$07B,$2C4,0	;
	.dw	BONUSCOIN,$2FC,$216,0
	.dw	BONUSCOIN,$7C8,$197,0

	.dw	ONEUP,$7D3,$0D4,0
	.dw	ONEUP,$790,$35B,0
	.dw	DARTS,$038,$278,0
	.dw	DARTS,$4C2,$264,0	;
	.dw	DARTS,$2B5,$140,0	;

	.dw	PARTLIFE,$040,$064,0
	.dw	PARTLIFE,$5F0,$1C6,0
	.dw	PARTLIFE,$78C,$200,0

	.dw	$FFFF

beachitem:
	.dw	BONUSCOIN,$020,$380,0
	.dw	BONUSCOIN,$0F0,$370,0
	.dw	BONUSCOIN,$140,$3C0,0
	.dw	BONUSCOIN,$190,$390,0
	.dw	BONUSCOIN,$1E0,$3B0,0

	.dw	BONUSCOIN,$220,$3B0,0
	.dw	BONUSCOIN,$280,$390,0
	.dw	BONUSCOIN,$2C0,$340,0
	.dw	BONUSCOIN,$310,$3B0,0
	.dw	BONUSCOIN,$340,$370,0

	.dw	BONUSCOIN,$3E0,$380,0
	.dw	BONUSCOIN,$410,$3B0,0
	.dw	BONUSCOIN,$490,$3B0,0
	.dw	BONUSCOIN,$450,$380,0
	.dw	BONUSCOIN,$4E0,$380,0

	.dw	BONUSCOIN,$530,$3A0,0
	.dw	BONUSCOIN,$580,$390,0
	.dw	BONUSCOIN,$5F0,$370,0
	.dw	BONUSCOIN,$610,$3A0,0
	.dw	BONUSCOIN,$680,$3B0,0

	.dw	BONUSCOIN,$6F0,$390,0
	.dw	BONUSCOIN,$710,$390,0
	.dw	BONUSCOIN,$760,$3B0,0
	.dw	BONUSCOIN,$7B0,$380,0
	.dw	BONUSCOIN,$7B0,$380,0
	
	.dw	BONUSCOIN,$824,$398,0
	.dw	BONUSCOIN,$91E,$3B2,0
	.dw	BONUSCOIN,$9A5,$368,0
	.dw	BONUSCOIN,$A08,$3B6,0
	.dw	BONUSCOIN,$B3E,$3A5,0
	
	.dw	ONEUP,$BE7,$362,0

	.dw	PARTLIFE,$858,$340,0
	.dw	PARTLIFE,$8E1,$340,0

	.dw	$FFFF

reefitem:
	.dw	BONUSCOIN,$649,$0D3,0
	.dw	BONUSCOIN,$6c6,$151,0
	.dw	BONUSCOIN,$661,$14F,0
	.dw	BONUSCOIN,$5A3,$147,0
	.dw	BONUSCOIN,$4BC,$17B,0

	.dw	BONUSCOIN,$545,$23F,0
	.dw	BONUSCOIN,$4DF,$1E7,0
	.dw	BONUSCOIN,$2C4,$2C8,0
	.dw	BONUSCOIN,$385,$271,0
	.dw	BONUSCOIN,$4A3,$217,0

	.dw	BONUSCOIN,$2F3,$30A,0
	.dw	BONUSCOIN,$294,$341,0
	.dw	BONUSCOIN,$2E8,$398,0
	.dw	BONUSCOIN,$38B,$37D,0
	.dw	BONUSCOIN,$20E,$382,0

	.dw	BONUSCOIN,$493,$361,0
	.dw	BONUSCOIN,$175,$32C,0
	.dw	BONUSCOIN,$1A9,$3A5,0
	.dw	BONUSCOIN,$131,$3A5,0
	.dw	BONUSCOIN,$0BC,$382,0

	.dw	BONUSCOIN,$032,$3A6,0
	.dw	BONUSCOIN,$032,$27E,0
	.dw	BONUSCOIN,$032,$10C,0
	.dw	BONUSCOIN,$0F6,$343,0
	.dw	BONUSCOIN,$09A,$295,0

	.dw	BONUSCOIN,$186,$239,0
	.dw	BONUSCOIN,$186,$155,0
	.dw	BONUSCOIN,$13E,$0CE,0
	.dw	BONUSCOIN,$08A,$10D,0
	.dw	BONUSCOIN,$014,$09E,0

	.dw	ONEUP,$442,$3A6,0
	.dw	ONEUP,$18D,$21D,0
	.dw	DARTS,$420,$3A6,0
	.dw	DARTS,$0E8,$22F,0

	.dw	$FFFF

shipitem:
	.dw	BONUSCOIN,$0E0,$2D0,0
	.dw	BONUSCOIN,$030,$340,0
	.dw	BONUSCOIN,$090,$330,0
	.dw	BONUSCOIN,$0D0,$310,0
	.dw	BONUSCOIN,$1B0,$2B0,0

	.dw	BONUSCOIN,$110,$340,0
	.dw	BONUSCOIN,$2F0,$110,0
	.dw	BONUSCOIN,$270,$140,0
	.dw	BONUSCOIN,$260,$1B0,0
	.dw	BONUSCOIN,$250,$250,0

	.dw	BONUSCOIN,$2F0,$2E0,0
	.dw	BONUSCOIN,$220,$310,0
	.dw	BONUSCOIN,$270,$340,0
	.dw	BONUSCOIN,$2E0,$320,0
	.dw	BONUSCOIN,$350,$210,0

	.dw	BONUSCOIN,$3A0,$2C0,0
	.dw	BONUSCOIN,$340,$310,0
	.dw	BONUSCOIN,$380,$310,0
	.dw	BONUSCOIN,$3E0,$300,0
	.dw	BONUSCOIN,$4A0,$130,0

	.dw	BONUSCOIN,$410,$1F0,0
	.dw	BONUSCOIN,$4D0,$1D0,0
	.dw	BONUSCOIN,$410,$330,0
	.dw	BONUSCOIN,$480,$300,0
	.dw	BONUSCOIN,$4C0,$320,0

	.dw	BONUSCOIN,$560,$150,0
	.dw	BONUSCOIN,$570,$1F0,0
	.dw	BONUSCOIN,$500,$280,0
	.dw	BONUSCOIN,$520,$310,0
	.dw	BONUSCOIN,$570,$310,0

	.dw	$FFFF

shipholdaitem:
	.dw	$FFFF

shipholdbitem:
	.dw	$FFFF

jungle3item:
	.dw	BONUSCOIN,$0C6,$30F,0
	.dw	BONUSCOIN,$043,$2D6,0
	.dw	BONUSCOIN,$047,$271,0
	.dw	BONUSCOIN,$137,$2FD,0
	.dw	BONUSCOIN,$139,$2A9,0

	.dw	BONUSCOIN,$0FF,$2B1,0
	.dw	BONUSCOIN,$0C2,$2B1,0
	.dw	BONUSCOIN,$141,$201,0
	.dw	BONUSCOIN,$154,$061,0
	.dw	BONUSCOIN,$14B,$141,0

	.dw	BONUSCOIN,$1D5,$11A,0
	.dw	BONUSCOIN,$269,$0A9,0
	.dw	BONUSCOIN,$303,$200,0
	.dw	BONUSCOIN,$5E8,$11E,0
	.dw	BONUSCOIN,$58B,$0EB,0

	.dw	BONUSCOIN,$53B,$108,0
	.dw	BONUSCOIN,$513,$156,0
	.dw	BONUSCOIN,$485,$097,0
	.dw	BONUSCOIN,$4B8,$15F,0
	.dw	BONUSCOIN,$4BB,$1F4,0

	.dw	BONUSCOIN,$550,$20B,0
	.dw	BONUSCOIN,$550,$19C,0
	.dw	BONUSCOIN,$5BA,$1D6,0
	.dw	BONUSCOIN,$5D6,$36B,0
	.dw	BONUSCOIN,$2D9,$1AB,0

	.dw	BONUSCOIN,$679,$292,0
	.dw	BONUSCOIN,$639,$191,0
	.dw	BONUSCOIN,$66C,$191,0
	.dw	BONUSCOIN,$746,$15B,0
	.dw	BONUSCOIN,$7AC,$0BF,0

	.dw	ONEUP    ,$282,$374,0
	.dw	ONEUP    ,$429,$382,0
	.dw	ONEUP    ,$77D,$241,0
	.dw	DARTS    ,$24E,$374,0
	.dw	DARTS    ,$2B6,$374,0
	.dw	DARTS    ,$3CE,$356,0
	.dw	DARTS    ,$390,$356,0

	.dw	$FFFF

*
* Need to add more coins & PU's
*

downriveritem:
	.dw	BONUSCOIN,$049,$310,0
	.dw	BONUSCOIN,$094,$3B5,0
	.dw	BONUSCOIN,$160,$3AA,0
	.dw	BONUSCOIN,$113,$317,0
	.dw	BONUSCOIN,$24A,$306,0
			   
	.dw	BONUSCOIN,$2C0,$35D,0
	.dw	BONUSCOIN,$35F,$385,0
	.dw	BONUSCOIN,$3DD,$356,0
	.dw	BONUSCOIN,$424,$304,0
	.dw	BONUSCOIN,$47B,$33A,0

	.dw	BONUSCOIN,$52D,$369,0
	.dw	BONUSCOIN,$561,$314,0
	.dw	BONUSCOIN,$5A1,$378,0
	.dw	BONUSCOIN,$78A,$378,0
	.dw	BONUSCOIN,$71A,$2F0,0

	.dw	BONUSCOIN,$7EC,$380,0
	.dw	BONUSCOIN,$595,$380,0
	.dw	BONUSCOIN,$466,$332,0
	.dw	BONUSCOIN,$1F1,$38A,0
	.dw	BONUSCOIN,$322,$333,0

	.dw	BONUSCOIN,$52D,$369,0
	.dw	BONUSCOIN,$561,$314,0
	.dw	BONUSCOIN,$5A1,$378,0
	.dw	BONUSCOIN,$78A,$378,0
	.dw	BONUSCOIN,$71A,$2F0,0

	.dw	BONUSCOIN,$7EC,$380,0
	.dw	BONUSCOIN,$595,$380,0
	.dw	BONUSCOIN,$466,$332,0
	.dw	BONUSCOIN,$1F1,$38A,0
	.dw	BONUSCOIN,$322,$333,0

	.dw	$FFFF

jungle4item:
	.dw	BONUSCOIN,$020,$070,0
	.dw	BONUSCOIN,$010,$110,0
	.dw	BONUSCOIN,$0D0,$180,0
	.dw	BONUSCOIN,$0F0,$2B0,0
	.dw	BONUSCOIN,$030,$220,0

	.dw	BONUSCOIN,$0A0,$220,0
	.dw	BONUSCOIN,$150,$030,0
	.dw	BONUSCOIN,$1C0,$070,0
	.dw	BONUSCOIN,$1D0,$190,0
	.dw	BONUSCOIN,$110,$110,0

	.dw	BONUSCOIN,$160,$1C0,0
	.dw	BONUSCOIN,$160,$2C0,0
	.dw	BONUSCOIN,$170,$2B0,0
	.dw	BONUSCOIN,$250,$030,0
	.dw	BONUSCOIN,$290,$060,0

	.dw	BONUSCOIN,$2A0,$140,0
	.dw	BONUSCOIN,$240,$1E0,0
	.dw	BONUSCOIN,$260,$290,0
	.dw	BONUSCOIN,$380,$030,0
	.dw	BONUSCOIN,$3D0,$040,0

	.dw	BONUSCOIN,$310,$110,0
	.dw	BONUSCOIN,$370,$270,0
	.dw	BONUSCOIN,$450,$060,0
	.dw	BONUSCOIN,$490,$0C0,0
	.dw	BONUSCOIN,$430,$1A0,0

	.dw	BONUSCOIN,$4F0,$120,0
	.dw	BONUSCOIN,$4D0,$2B0,0
	.dw	BONUSCOIN,$4A0,$200,0
	.dw	BONUSCOIN,$5D0,$090,0
	.dw	BONUSCOIN,$570,$0B0,0

	.dw	ONEUP   ,$5B0,$1B0,0
	.dw	ONEUP   ,$7E0,$0E0,0
	.dw	ONEUP,   $390,$1C0,0

	.dw	DARTS    ,$4A0,$170,0

	.dw	$FFFF

*
* Need to add more coins & PU's
*

upriveritem:
	.dw	BONUSCOIN,$049,$310,0
	.dw	BONUSCOIN,$094,$3B5,0
	.dw	BONUSCOIN,$160,$3AA,0
	.dw	BONUSCOIN,$113,$317,0
	.dw	BONUSCOIN,$24A,$306,0
			   
	.dw	BONUSCOIN,$2C0,$35D,0
	.dw	BONUSCOIN,$35F,$385,0
	.dw	BONUSCOIN,$3DD,$356,0
	.dw	BONUSCOIN,$424,$304,0
	.dw	BONUSCOIN,$47B,$33A,0

	.dw	BONUSCOIN,$52D,$369,0
	.dw	BONUSCOIN,$561,$314,0
	.dw	BONUSCOIN,$5A1,$378,0
	.dw	BONUSCOIN,$78A,$378,0
	.dw	BONUSCOIN,$71A,$2F0,0

	.dw	BONUSCOIN,$7EC,$380,0
	.dw	BONUSCOIN,$595,$380,0
	.dw	BONUSCOIN,$466,$332,0
	.dw	BONUSCOIN,$1F1,$38A,0
	.dw	BONUSCOIN,$322,$333,0

	.dw	BONUSCOIN,$52D,$369,0
	.dw	BONUSCOIN,$561,$314,0
	.dw	BONUSCOIN,$5A1,$378,0
	.dw	BONUSCOIN,$78A,$378,0
	.dw	BONUSCOIN,$71A,$2F0,0

	.dw	BONUSCOIN,$7EC,$380,0
	.dw	BONUSCOIN,$595,$380,0
	.dw	BONUSCOIN,$466,$332,0
	.dw	BONUSCOIN,$1F1,$38A,0
	.dw	BONUSCOIN,$322,$333,0

	.dw	PARTLIFE,$2BB,$3BA,0

	.dw	$FFFF

waterfallitem:
	.dw	BONUSCOIN,$037,$78F,0
	.dw	BONUSCOIN,$057,$78F,0
	.dw	BONUSCOIN,$0B0,$74B,0
	.dw	BONUSCOIN,$0DD,$671,0
	.dw	BONUSCOIN,$033,$6A3,0

	.dw	BONUSCOIN,$3CE,$791,0
	.dw	BONUSCOIN,$3AE,$791,0
	.dw	BONUSCOIN,$38E,$791,0
	.dw	BONUSCOIN,$2E6,$791,0
	.dw	BONUSCOIN,$244,$7A3,0

	.dw	BONUSCOIN,$288,$6E0,0
	.dw	BONUSCOIN,$2A8,$6E0,0
	.dw	BONUSCOIN,$268,$6E0,0
	.dw	BONUSCOIN,$2DA,$595,0
	.dw	BONUSCOIN,$3D7,$508,0

	.dw	BONUSCOIN,$307,$3DD,0
	.dw	BONUSCOIN,$3CD,$2DB,0
	.dw	BONUSCOIN,$343,$33E,0
	.dw	BONUSCOIN,$123,$3DA,0
	.dw	BONUSCOIN,$117,$2FC,0

	.dw	BONUSCOIN,$03A,$2A3,0
	.dw	BONUSCOIN,$190,$348,0
	.dw	BONUSCOIN,$1ED,$332,0
	.dw	BONUSCOIN,$0E5,$238,0
	.dw	BONUSCOIN,$169,$1EB,0

	.dw	BONUSCOIN,$185,$0C1,0
	.dw	BONUSCOIN,$05A,$050,0
	.dw	BONUSCOIN,$08A,$050,0
	.dw	BONUSCOIN,$0CA,$050,0
	.dw	BONUSCOIN,$2FC,$0AA,0

	.dw	ONEUP,$390,$200,0
	.dw	ONEUP,$3B0,$200,0
	.dw	ONEUP,$3D0,$200,0

	.dw	PARTLIFE,$380,$220,0
	.dw	DARTS,$3A0,$220,0
	.dw	DARTS,$3C0,$220,0
	.dw	PARTLIFE,$3E0,$220,0

	.dw	$FFFF

cavernsitem:
	.dw	BONUSCOIN,$0A6,$081,0
	.dw	BONUSCOIN,$0E3,$064,0
	.dw	BONUSCOIN,$16E,$27E,0
	.dw	BONUSCOIN,$0E0,$291,0
	.dw	BONUSCOIN,$1C1,$390,0

	.dw	BONUSCOIN,$22A,$357,0
	.dw	BONUSCOIN,$2A9,$375,0
	.dw	BONUSCOIN,$329,$385,0
	.dw	BONUSCOIN,$410,$385,0
	.dw	BONUSCOIN,$460,$29B,0

	.dw	BONUSCOIN,$388,$1D8,0
	.dw	BONUSCOIN,$309,$1B1,0
	.dw	BONUSCOIN,$28F,$164,0
	.dw	BONUSCOIN,$1FF,$0BF,0
	.dw	BONUSCOIN,$50E,$295,0

	.dw	BONUSCOIN,$463,$292,0
	.dw	BONUSCOIN,$3DA,$298,0
	.dw	BONUSCOIN,$33B,$294,0
	.dw	BONUSCOIN,$54D,$0A8,0
	.dw	BONUSCOIN,$4B6,$086,0

	.dw	BONUSCOIN,$638,$381,0
	.dw	BONUSCOIN,$6DD,$381,0
	.dw	BONUSCOIN,$78B,$39C,0
	.dw	BONUSCOIN,$744,$31C,0
	.dw	BONUSCOIN,$690,$343,0

	.dw	BONUSCOIN,$5B7,$343,0
	.dw	BONUSCOIN,$462,$317,0
	.dw	BONUSCOIN,$462,$33A,0
	.dw	BONUSCOIN,$462,$353,0
	.dw	BONUSCOIN,$462,$2B9,0

	.dw	ONEUP,$6A0,$08F,0
	.dw	ONEUP,$6C0,$08F,0

	.dw	DARTS,$690,$09F,0
	.dw	DARTS,$6B0,$09F,0
	.dw	DARTS,$6D0,$09F,0

	.dw	$FFFF


oparstreeitem:
	.dw	BONUSCOIN,$026,$289,0
	.dw	BONUSCOIN,$026,$2C6,0
	.dw	BONUSCOIN,$026,$359,0
	.dw	BONUSCOIN,$026,$380,0
	.dw	BONUSCOIN,$09F,$36D,0

	.dw	BONUSCOIN,$0B2,$2AA,0
	.dw	BONUSCOIN,$0E1,$2AA,0
	.dw	BONUSCOIN,$11C,$2AA,0
	.dw	BONUSCOIN,$1CB,$2AA,0
	.dw	BONUSCOIN,$217,$2AA,0

	.dw	BONUSCOIN,$13A,$316,0
	.dw	BONUSCOIN,$26D,$340,0
	.dw	BONUSCOIN,$2BE,$39C,0
	.dw	BONUSCOIN,$324,$35A,0
	.dw	BONUSCOIN,$3AC,$38A,0

	.dw	BONUSCOIN,$3D4,$2C7,0
	.dw	BONUSCOIN,$407,$2C7,0
	.dw	BONUSCOIN,$46F,$309,0
	.dw	BONUSCOIN,$4B7,$36F,0
	.dw	BONUSCOIN,$408,$357,0

	.dw	BONUSCOIN,$4E9,$377,0
	.dw	BONUSCOIN,$536,$345,0
	.dw	BONUSCOIN,$5C7,$39B,0
	.dw	BONUSCOIN,$628,$354,0
	.dw	BONUSCOIN,$69A,$38A,0

	.dw	BONUSCOIN,$707,$264,0
	.dw	BONUSCOIN,$73A,$264,0
	.dw	BONUSCOIN,$743,$300,0
	.dw	BONUSCOIN,$71D,$336,0
	.dw	BONUSCOIN,$6F5,$371,0

	.dw	ONEUP,$7DA,$339,0
	.dw	ONEUP,$5E5,$372,0

	.dw	DARTS,$387,$358,0
	.dw	DARTS,$5B7,$34E,0
	.dw	DARTS,$75F,$309,0

	.dw	$FFFF

*
* Not Defined for this level !!!!!!!!!!!!!!!!!!!!
*

oparwellsitem:
	.dw	BONUSCOIN,$0A6,$081,0
	.dw	BONUSCOIN,$0E3,$064,0
	.dw	BONUSCOIN,$16E,$27E,0
	.dw	BONUSCOIN,$0E0,$291,0
	.dw	BONUSCOIN,$1C1,$390,0

	.dw	BONUSCOIN,$22A,$357,0
	.dw	BONUSCOIN,$2A9,$375,0
	.dw	BONUSCOIN,$329,$385,0
	.dw	BONUSCOIN,$410,$385,0
	.dw	BONUSCOIN,$460,$29B,0

	.dw	BONUSCOIN,$388,$1D8,0
	.dw	BONUSCOIN,$309,$1B1,0
	.dw	BONUSCOIN,$28F,$164,0
	.dw	BONUSCOIN,$1FF,$0BF,0
	.dw	BONUSCOIN,$50E,$295,0

	.dw	BONUSCOIN,$463,$292,0
	.dw	BONUSCOIN,$3DA,$298,0
	.dw	BONUSCOIN,$33B,$294,0
	.dw	BONUSCOIN,$54D,$0A8,0
	.dw	BONUSCOIN,$4B6,$086,0

	.dw	BONUSCOIN,$638,$381,0
	.dw	BONUSCOIN,$6DD,$381,0
	.dw	BONUSCOIN,$78B,$39C,0
	.dw	BONUSCOIN,$744,$31C,0
	.dw	BONUSCOIN,$690,$343,0

	.dw	BONUSCOIN,$5B7,$343,0
	.dw	BONUSCOIN,$462,$317,0
	.dw	BONUSCOIN,$462,$33A,0
	.dw	BONUSCOIN,$462,$353,0
	.dw	BONUSCOIN,$462,$2B9,0

	.dw	$FFFF

opartemplitem:
	.dw	BONUSCOIN,$0D5,$2E4,0
	.dw	BONUSCOIN,$09C,$2A9,0
	.dw	BONUSCOIN,$0D5,$1E9,0
	.dw	BONUSCOIN,$087,$233,0
	.dw	BONUSCOIN,$137,$230,0

	.dw	BONUSCOIN,$182,$1FB,0
	.dw	BONUSCOIN,$23B,$241,0
	.dw	BONUSCOIN,$1EB,$21B,0
	.dw	BONUSCOIN,$158,$2F6,0
	.dw	BONUSCOIN,$158,$2AA,0

	.dw	BONUSCOIN,$1E3,$2F2,0
	.dw	BONUSCOIN,$22D,$2B1,0
	.dw	BONUSCOIN,$2A0,$2D0,0
	.dw	BONUSCOIN,$310,$237,0
	.dw	BONUSCOIN,$3FD,$2E9,0

	.dw	BONUSCOIN,$3BB,$20F,0
	.dw	BONUSCOIN,$436,$249,0
	.dw	BONUSCOIN,$4F9,$251,0
	.dw	BONUSCOIN,$4CA,$1AA,0
	.dw	BONUSCOIN,$57A,$235,0

	.dw	BONUSCOIN,$57A,$1D6,0
	.dw	BONUSCOIN,$709,$2D8,0
	.dw	BONUSCOIN,$767,$2E1,0
	.dw	BONUSCOIN,$767,$292,0
	.dw	BONUSCOIN,$524,$217,0

	.dw	BONUSCOIN,$633,$24D,0
	.dw	BONUSCOIN,$46F,$197,0
	.dw	BONUSCOIN,$340,$2F3,0
	.dw	BONUSCOIN,$1E7,$1D3,0
	.dw	BONUSCOIN,$0A0,$1DF,0

	.dw	ONEUP,$020,$233,0
	.dw	ONEUP,$758,$2CE,0
	.dw	ONEUP,$7B8,$2AA,0
	.dw	ONEUP,$758,$286,0

	.dw	DARTS,$020,$1E8,0
	.dw	DARTS,$310,$1DE,0
	.dw	DARTS,$64D,$268,0

	.dw	PARTLIFE,$448,$2E0,0
	.dw	PARTLIFE,$602,$2AB,0

	.dw	$FFFF

bonusxitem:

	.dw	$FFFF

bonusiitem:
	.dw	ONEUP   ,$15F,$281,0
	.dw	ONEUP   ,$16F,$281,0
	.dw	ONEUP   ,$17F,$281,0

	.dw	DARTS   ,$165,$271,0
	.dw	DARTS   ,$175,$271,0

	.dw	$FFFF

noitems:
	.dw	$FFFF

itemlocs:
	.dw	NONE
	.dw	jungle1item
	.dw	tzanhomeitem
	.dw	clearingitem
	.dw	swampitem

	.dw	beachitem
	.dw	noitems
	.dw	reefitem
	.dw	shipitem
	.dw	noitems

	.dw	noitems
	.dw	jungle3item
	.dw	downriveritem
	.dw	jungle4item
	.dw	upriveritem

	.dw	waterfallitem
	.dw	cavernsitem
	.dw	oparstreeitem
	.dw	oparwellsitem
	.dw	opartemplitem

	.dw	noitems

	.dw	bonusxitem
	.dw	bonusiitem


*****************************************************************************
*****************************************************************************
*
* Animation pointers for each anim type
*
* Sequence data

d_miscseq
	.dw	tzhbarseq00,hexnumsseq00
	.dw	tzpups1seq00,tzpups1seq00,tzpups1seq00
	.dw	tzpups1seq03

	.dw	tileboxseq00

* Sequence Mode Data Record

d_miscdrec
	.dw	tzhbar,hexnums
	.dw	tzpups1,tzpups1,tzpups1
	.dw	tzpups1

	.dw	tilebox

* Sequence data bank

d_miscbank
	.dw	^tzhbar,^hexnums
	.dw	^tzpups1,^tzpups1,^tzpups1
	.dw	^tzpups1

	.dw	^tilebox

* Sequence palette number data

d_miscpalette
	.dw	$3400,$3200
	.dw	$3200,$3200,$3200
	.dw	$3200








