*****************************************************************************
*
* CHEK4FLR.ASM
*
*****************************************************************************

MAXRISE	.equ	$fff8
MAXDROP	.equ	$000D
;ABOVEDISTANCE	.equ	$fff0

********************************************************************
*
* makes the rowlocs table for indexing quickly into
* the level map, uses 1 word per tile row of map (32 bytes per screen height)
*
*

Initrowlocs:
Setrowlocs: 
	LAI
	lda   z_bg1width   ;width in tiles of level
	asl
	sta   z_temp0      ;width in bytes

	ldy   z_bg1height  ;height in tiles
	ldx   #0
	lda   #0
.loop
	sta   >_rowlocs1,x

	inx
	inx
	clc
	adc   z_temp0
	dey
	bne   .loop

	rtl
      
**********************************************
* copy tile type table

Inittiletypes:

	ldx   z_levelword	; Get current level
	lda   >_tiletypes,x	; Index to type table for this level
	sta   z_temp0	; Store for long indexed

	lda   >_tiletypesbank,x	; Get bank
	sta   z_temp1

	ldy   #0	; Zero counters
	ldx   #0

	stz   v_sigtiles

.tileloop   
	lda   [z_temp0],y	; Get 1st type
	cmp   #LAST	; End of list?
	beq   .tileend	; Yes - We're done

	sta   >TILETYPE,x	; No - Store 1st type

	inx
	inx
	iny
	iny

	lda   [z_temp0],y
	sta   >TILETYPE,x	; Store 2nd type

	inx
	inx
	iny
	iny

	lda   [z_temp0],y
	sta   >TILETYPE,x	; Store 3rd type

	inx
	inx
	iny
	iny

	lda   [z_temp0],y
	sta   >TILETYPE,x	; Store 4th type

	inx
	inx
	iny
	iny

	lda   v_sigtiles
	clc
	adc   #4
	sta   v_sigtiles	; Store...

	bra   .tileloop
.tileend
	rtl

;grabs the tile number with flip bits, palette, and all 
;from level map based on: 
; A=y map coordinate absolute (0-65535)
; Y=x map coordinate absolute (0-65535)
;
; returns:
; A=tile word
; Y=same as entry
; X=maploc

	LAI
Gettile:                      ;8 cycles
	and   #$fff0      ;3         
	lsr               ;2
	lsr               ;2
	lsr               ;2
	tax               ;2
	tya               ;2
	and   #$fff0      ;3
	lsr               ;2
	lsr               ;2
	lsr               ;2
	adc   >_rowlocs1,x ;5
	tax               ;2
	lda   >BG1MAP,x   ;6
	rtl               ;6 ;49 cycles


Gettilenumber:                  ;8
	and   #$fff0      ;3
	lsr               ;2
	lsr               ;2
	lsr               ;2
	tax               ;2
	tya               ;2
	and   #$fff0      ;3
	lsr               ;2
	lsr               ;2
	lsr               ;2
	adc   >_rowlocs1,x  ;5
	tax               ;2
	lda   >BG1MAP,x   ;6
	stx   z_temp2
            
	sta   z_temp1     ;save  value ;4
	rol               ;2
	rol               ;2+2
	rol              ;rotate flip bits to low bits, p bit is lost
	and   #3          ;3
	sta   z_temp0      ;4
	lda   z_temp1      ;4
	and   #$e         ;3
	asl               ;2
	ora   z_temp0      ;4
	sta   z_temp0      ;4
	lda   z_temp1      ;4
	and   #$3e0       ;3
	ora   z_temp0      ;4 

	cmp   v_sigtiles   ;number of significant tiles *8
	bcs   .skytile
                              ;2
	asl               ;2
	tax               ;2
	lda   >TILETYPE,x ;5
	txa
	lsr
	lsr
	lsr
	and	#$ff
	sta	z_temp0
	lda	z_temp1
	and	#$c000
	ora	z_temp0
	rtl               ;6 ;109

.skytile                      ;3
	lda   #SKY        ;3
	rtl               ;6 ;104

Gettiletype:                  ;8
	and   #$fff0      ;3
	lsr               ;2
	lsr               ;2
	lsr               ;2
	tax               ;2
	tya               ;2
	and   #$fff0      ;3
	lsr               ;2
	lsr               ;2
	lsr               ;2
	adc   >_rowlocs1,x  ;5
	tax               ;2
	lda   >BG1MAP,x   ;6
	stx   z_temp2
            
	sta   z_temp1     ;save  value ;4
	rol               ;2
	rol               ;2+2
	rol              ;rotate flip bits to low bits, p bit is lost
	and   #3          ;3
	sta   z_temp0      ;4
	lda   z_temp1      ;4
	and   #$e         ;3
	asl               ;2
	ora   z_temp0      ;4
	sta   z_temp0      ;4
	lda   z_temp1      ;4
	and   #$3e0       ;3
	ora   z_temp0      ;4 

	cmp   v_sigtiles   ;number of significant tiles *8
	bcs   .skytile
                              ;2
	asl               ;2
	tax               ;2
	lda   >TILETYPE,x ;5
	rtl               ;6 ;109

.skytile                      ;3
	lda   #SKY        ;3
	rtl               ;6 ;104
 
Gettilestat:                  ;8
	and   #$fff0      ;3
	lsr               ;2
	lsr               ;2
	lsr               ;2
	tax               ;2
	tya               ;2
	and   #$fff0      ;3
	lsr               ;2
	lsr               ;2
	lsr               ;2
	adc   >_rowlocs1,x  ;5
	tax               ;2
	lda   >BG1MAP,x   ;6
	stx   z_temp2
            
	sta   z_temp1     ;save  value ;4
	rol               ;2
	rol               ;2+2
	rol              ;rotate flip bits to low bits, p bit is lost
	and   #3          ;3
	sta   z_temp0      ;4
	lda   z_temp1      ;4
	and   #$e         ;3
	asl               ;2
	ora   z_temp0      ;4
	sta   z_temp0      ;4
	lda   z_temp1      ;4
	and   #$3e0       ;3
	ora   z_temp0      ;4 

	cmp   v_sigtiles   ;number of significant tiles *8
	bcs   .skytile
                              ;2
	asl               ;2
	tax               ;2
	lda   >TILETYPE,x ;5
	tax
	lda   >_tiledys+6,x
	rtl               ;6 ;109

.skytile                      ;3
	ldx   #SKY        ;3
	lda   >_tiledys+6,x
	rtl               ;6 ;104

Getoldtilestat:                  ;8
	and   #$fff0      ;3
	lsr               ;2
	lsr               ;2
	lsr               ;2
	tax               ;2
	tya               ;2
	and   #$fff0      ;3
	lsr               ;2
	lsr               ;2
	lsr               ;2
	adc   >_rowlocs1,x  ;5
	tax               ;2
	lda   >BG1MAP,x   ;6
	stx   z_temp2
            
	sta   z_temp1     ;save  value ;4
	rol               ;2
	rol               ;2+2
	rol              ;rotate flip bits to low bits, p bit is lost
	and   #3          ;3
	sta   z_temp0      ;4
	lda   z_temp1      ;4
	and   #$e         ;3
	asl               ;2
	ora   z_temp0      ;4
	sta   z_temp0      ;4
	lda   z_temp1      ;4
	and   #$3e0       ;3
	ora   z_temp0      ;4 

	cmp   v_sigtiles   ;number of significant tiles *8
	bcs   .skytile
                              ;2
	asl               ;2
	tax               ;2
	lda   >TILETYPE,x ;5
	tax
	lda   >_tiledys,x
	rtl               ;6 ;109

.skytile                      ;3
	ldx   #SKY        ;3
	lda   >_tiledys,x
	rtl               ;6 ;104


*****************************************************************************
*
* Calculate offset of floor
*
* Entry:
*       a = Players Y
*       y = Players X
*
*****************************************************************************

Getfloor:
	stz	v_tileindex
	sty	z_temp2

	and	#$fff0	; Do Y

	lsr
	lsr
	lsr

	tax
	tya

	and	#$fff0	; Do X

	lsr
	lsr
	lsr

	adc	>_rowlocs1,x
	tax

	lda	>BG1MAP,x
	sta	z_temp1	; Save  value

	rol
	rol
	rol		; Rotate flip bits to low bits, p bit is lost

	and	#3
	sta	z_temp0

	lda	z_temp1
	and	#$e
	asl
	ora	z_temp0
	sta	z_temp0

	lda	z_temp1
	and	#$3e0
	ora	z_temp0
	cmp	v_sigtiles	; Number of significant tiles
	bcs	.skytile

	asl
	tax

	lda	>TILETYPE,x
	sta	v_tileindex

	lda	z_temp2
	and	#$f
	asl
	adc	v_tileindex	; Add to tile type index from table
	tax

	lda	>_tiledys+8,x

	rtl
.skytile    
	lda	#$10

	rtl

*****************************************************************************
*
* Calculate distance to ground
*
* Entry:
*        a = Players Y
*        y = Players X
*
*****************************************************************************

Getground:
	sta	z_temp3         ;y

	and	#$f
	sta	z_temp4         ;mod 16 (tile dy)

	lda	z_temp3
	bpl	.getit

	lda	#$10

	bra	.gotit
.getit
	jsl	Getfloor       ;temp2 = x
.gotit
	bmi	.above

	cmp	#$10
	bcs	.below

	sec
	sbc	z_temp4
	sta	z_temp4

	rtl

.above      
	lda	z_temp3
	sec
	sbc	#$10

	bmi	.top
	ldy	z_temp2

	jsl	Getfloor

	bmi	.wall

	cmp	#$10
	bcs	.top

	eor	#$ffff
	inc
	clc   
	adc	#$10

	clc
	adc	z_temp4

	eor	#$ffff
	inc
	sta	z_temp4

	rtl

.top        
	lda	z_temp4
	eor	#$ffff
	sta	z_temp4

	rtl

.wall       
	lda	#$10
	clc
	adc	z_temp4

	eor	#$ffff
	inc
	sta	z_temp4

	rtl

.below      
	sec
	sbc	z_temp4
	sta	z_temp4

	ldy	z_temp2
	lda	z_temp3
	clc
	adc	#$10
	bpl	.getit2

	lda	#$10

	bra	.gotit2
.getit2
	jsl	Getfloor
.gotit2
	clc
	adc	z_temp4
	sta	z_temp4

	rtl

*****************************************************************************
*

Chek4stat:
	LAI

	phx		; Save x & y
	phy

	lda	v_playery
	lsr
	lsr
	sta	v_playeryglob

	lda	v_playerx
	lsr
	lsr
	sta	v_playerxglob

	ldy	v_playerxglob	; Get player X
	lda	v_playeryglob	; Get player Y

	jsl	Gettilestat
	
	sta	v_tilestat

	ply
	plx

	rtl

Chek4number:
	LAI

	phx		; Save x & y
	phy

	lda	v_playery
	lsr
	lsr
	sta	v_playeryglob

	lda	v_playerx
	lsr
	lsr
	sta	v_playerxglob

	ldy	v_playerxglob	; Get player X
	lda	v_playeryglob	; Get player Y

	jsl	Gettilenumber
	
	sta	v_tilenum

	ply
	plx

	rtl


*****************************************************************************
*
* Used when surfacing (ascending)
*
*****************************************************************************

Chek4waterstat:
	LAI

	phx		; Save x & y
	phy

	lda	v_playery
	lsr
	lsr
	sec
	sbc	#14
	sta	v_playeryglob

	lda	v_playerx
	lsr
	lsr
	sta	v_playerxglob

	ldy	v_playerxglob	; Get player X
	lda	v_playeryglob	; Get player Y

	jsl	Gettilestat
	
	sta	v_tilestat

	ply
	plx

	rtl



*****************************************************************************
*
* Used when swimming and come in contact with surface
*
*****************************************************************************

Chek4ripstat:
	LAI

	phx		; Save x & y
	phy

	lda	v_playery
	lsr
	lsr
	sec
	sbc	#7
	sta	v_playeryglob

	lda	v_playerx
	lsr
	lsr
	sta	v_playerxglob

	ldy	v_playerxglob	; Get player X
	lda	v_playeryglob	; Get player Y

	jsl	Gettilestat
	
	sta	v_tilestat

	ply
	plx

	rtl




*****************************************************************************
*
* Call Chek4floor to adjust player y to floor height...
* Returns a zero if adjust is too far
* Also z_temp4 will contain distance to ground
* v_tilestat will also be set for current tile
*
*****************************************************************************

Chek4floor:
	LAI

	phx		; Save x & y
	phy

	lda	v_playery
	lsr
	lsr
	sta	v_playeryglob	; Normalize players Y

	lda	v_playerx
	lsr
	lsr
	sta	v_playerxglob	; Normalize players X

	ldy	v_playerxglob	
	lda	v_playeryglob	

	jsl	Getground	; Calc distance to ground

	bpl	.groundbelow	; Below us

	cmp	#MAXRISE	; Otherwise, try to rise up
	bcs	.addground
.nofloor
	ldx	v_tileindex
	lda	>_tiledys+6,x
	sta	v_tilestat
.retnoflr
	ply
	plx

	lda	#0

	rtl
.groundbelow
	cmp	#MAXDROP
	bcs	.nofloor
.addground
	clc
	adc	v_playery
	sta	v_playery
.floor
	ldx	v_tileindex
	lda	>_tiledys+6,x
	sta	v_tilestat

	lda	z_level
	and	#$FF
	cmp	#SHIPHOLDA
	beq	.handleflr

	cmp	#SHIPHOLDB
	beq	.handleflr

;	cmp	#BEACH
;	beq	.handlearch

.retflr
	ply
	plx

	lda	#1

	rtl

.handlearch
	jsl	Chek4number
	
	cmp	#$26
	beq	.retflr

	jmp	.retnoflr

.handleflr
	jsl	Chek4number
	
	cmp	#$AB
	beq	.box1

	cmp	#$AC
	beq	.box1

	cmp	#$AD
	beq	.box1

	cmp	#$30
	beq	.box2

	cmp	#$31
	beq	.box2

	cmp	#$32
	beq	.box2

	cmp	#$93
	beq	.box3

	cmp	#$94
	beq	.box3

	jmp	.retflr

.box1
	lda	v_playerx
	cmp	#$400<<2
      	bcs	.retflr

	jmp	.retnoflr
	
.box2
	lda	v_playery
	cmp	#$2BD<<2
      	bcs	.retflr

	jmp	.retnoflr

.box3
	lda	v_playerx
	cmp	#$530<<2
      	bcs	.retflr

	jmp	.retnoflr
	

*****************************************************************************

Chek4floorfall:
	LAI

	lda	v_disbgscroll
	beq	.ok2chk

	lda	#0

	rtl

.ok2chk
	phx		; Save x & y
	phy

	lda	v_playery
	lsr
	lsr
	sta	v_playeryglob

	lda	v_playerx
	lsr
	lsr
	sta	v_playerxglob

	ldy	v_playerxglob	; Get player X
	lda	v_playeryglob	; Get player Y

	jsl	Getground
	bpl	.groundbelow
.nofloor
	ldx	v_tileindex
	lda	>_tiledys+6,x
	sta	v_tilestat
.retnoflr
	ply
	plx
	lda	#0
	rtl
.groundbelow
	ldx	v_velocity
	bmi	.nofloor
	
	ldx	v_tileindex
	lda	>_tiledys+6,x
	sta	v_tilestat

	lda	z_joy1
	bit	v_JOYPADY
	beq	.nopassthru
	bit	v_JOYPADDOWN
	beq	.nopassthru
	lda	v_tilestat
	bit	#PASSTHRUTYPE
	bne	.nofloor
.nopassthru
	lda	z_temp4
	asl
	asl
	cmp	v_velocity
	bcs	.nofloor
	adc	v_playery
	sta	v_playery
	ldx	v_tileindex
	lda	>_tiledys+6,x
	sta	v_tilestat

	lda	z_level
	cmp	#SHIPHOLDA
	beq	.handleflr

	cmp	#SHIPHOLDB
	beq	.handleflr
.retflr
	ply
	plx
	lda	#1
	rtl

.handleflr
	jsl	Chek4number
	
	cmp	#$AB
	beq	.box1

	cmp	#$AC
	beq	.box1

	cmp	#$AD
	beq	.box1

	cmp	#$30
	beq	.box2

	cmp	#$31
	beq	.box2

	cmp	#$32
	beq	.box2

	cmp	#$93
	beq	.box3

	cmp	#$94
	beq	.box3

	jmp	.retflr

.box1
	lda	v_playerx
	cmp	#$400<<2
      	bcs	.retflr

	jmp	.retnoflr
	
.box2
	lda	v_playery
	cmp	#$2C1<<2
      	bcs	.retflr

	jmp	.retnoflr
	
.box3
	lda	v_playerx
	cmp	#$530<<2
      	bcs	.retflr

	jmp	.retnoflr
	


*****************************************************************************
*
* Returns a flag of all walls and ceilings in area around character
* Flags are "lrud" bit format
*
*****************************************************************************

Chek4wall:
	LAI

	stz	_walls

	lda	v_playerbot	; Check at Tarzans toes
	sec
	sbc	#8
	ldy	v_playerleft	; playerx

	jsl	Gettilestat

	bit	#WALLTYPE
	bne	.setwall1

	lda	v_playerbot	; Check at Tarzans toes
	ldy	v_playerleft	; playerx

	jsl	Gettilestat

	bit	#WALLTYPE
	beq	.rite	; No  - Check right side

.setwall1
	lda	#WALLLT	; Yes - Indicate a wall to left
	ora	_walls	; Save with previous work
	sta	_walls	; New wall indicator

.rite:
	lda	v_playerbot	; 
	sec
	sbc	#8
	ldy	v_playerrite	; Get right edge

	jsl	Gettilestat

	bit	#WALLTYPE
	bne	.setwall2

	lda	v_playerbot	; 
	ldy	v_playerrite	; Get right edge

	jsl	Gettilestat

	bit	#WALLTYPE
	beq	.top

.setwall2
	lda	#WALLRT	; Yes - Indicate a wall to right
	ora	_walls	; Save with previous work
	sta	_walls	; New wall indicator

.top

	lda	v_playerrite
	sec
	sbc	v_playerleft
	lsr
	clc
	adc	v_playerleft
	sta	v_playercentrx

	ldx	v_playerx
	ldy	v_playery

	lda	v_playertop
	asl
	asl
	sta	v_playery

	jsl	Chek4stat

	stx	v_playerx
	sty	v_playery

	and	#CEILING
	beq	.end
.settop:
	lda	#CEILING
	ora	_walls
	sta	_walls
.end
	lda	v_playerx	; Get players x
	lsr		; Normalize
	lsr
	cmp	v_maxx	; Is greater than H max?
	bcc	.leftmin	; No  - Check left

	lda	_walls	; Yes, setup right wall
	ora	#WALLRT
	sta	_walls
.leftmin:
	lda	v_playerx	; Get players x
	lsr		; Normalize
	lsr
	cmp	v_minx	; Is greater than H min?
	bcs	.topmin	; Yes - The check top min

	lda	_walls	; No  - setup left wall
	ora	#WALLLT
	sta	_walls

.topmin:
;	lda	v_playery	; Get players y
;	lsr		; Normalize
;	lsr
;	clc
;	adc	#72
;	cmp	v_voff1min	; Is greater than V min?
;	bcs	.exitwallchk	; Yes


; Need to do ceiling tile checks

	bra	.exitwallchk ;************************ remove

	lda	#CEILING
	ora	_walls
	sta	_walls

.exitwallchk:
	lda	z_levely
	lsr		; Normalize
	lsr
	cmp	v_voff1max	; Is greater than V min?
	bcc	.flrchk	; Yes

	lda	#WALLDN
	ora	_walls
	sta	_walls
.flrchk
	rtl


*****************************************************************************
*
*

Chek4reef:
	LAI

	ldx	v_playerx	; Save original X

	lda	v_playerdir
	and	#MOVRT
	beq	.applylft

	lda	v_playerx
	clc
	adc	#24<<2
	sta	v_playerx

	jsl	Chek4stat

	stx	v_playerx	; Restore original X

	cmp	#DEATHTYPE

	rtl

.applylft
	lda	v_playerx
	sec
	sbc	#24<<2
	sta	v_playerx

	jsl	Chek4stat

	stx	v_playerx	; Restore original X

	cmp	#DEATHTYPE
.noreef
	rtl



