*********************************************************************
*				                  			
*	Copyright 1992 Manley & Associates        	
*		All Rights Reserved	          	
*			        	          			
*********************************************************************

Maininitppu:

	SA		; Set 8-bit addressing mode


; Screen blanking and brightness control

	lda	#$8F	; Register mask	- force blanking...
	sta	INIDISP	; ...full brightness - $2100
	sta	z_inidispshd

; Object stuff

      	lda	#$63
	sta	OBJSEL	; $2101
	stz	OAMADDL	; $2102
	stz	OAMADDH	; $2103
	stz	OAMDATA	; $2104


; Background stuff

	stz	BGMODE	; $2105
	stz	MOSAIC	; $2106
	stz	BG1SC 	; $2107
	stz	BG2SC	; $2108
	stz	BG3SC	; $2109
	stz	BG4SC	; $210A
	stz	BG12NBA	; $210B
	stz	BG34NBA	; $210C


; Horizontal and Vertical scroll values for each BG 
; Write twice (1st write low byte, 2nd write high byte) 

	stz	BG1HOFS	; $210D set low
	stz	BG1HOFS	; $210D set high
	stz	BG1VOFS	; $210E set low
	stz	BG1VOFS	; $210E set high
	stz	BG2HOFS	; $210F set low
	stz	BG2HOFS	; $210F set high
	stz	BG2VOFS	; $2110 set low
	stz	BG2VOFS	; $2110 set high
	stz	BG3HOFS	; $2111 set low
	stz	BG3HOFS	; $2111 set high
	stz	BG3VOFS	; $2112 set low
	stz	BG3VOFS	; $2112 set high
	stz	BG4HOFS	; $2113 set low
	stz	BG4HOFS	; $2113 set high
	stz	BG4VOFS	; $2114 set low
	stz	BG4VOFS	; $2114 set high


; vram access stuff

	lda	#$80
	sta	VMAINC	; $2115
	stz	VMADDL	; $2116
	stz	VMADDH	; $2117
	stz	VMDATAL	; $2118
	stz	VMDATAH	; $2119


; mode 7 stuff

	lda	#$01
	stz	M7SEL	; $211A
	stz	M7A	; $211B set low
	sta	M7A	; $211B set high (to 1)
	stz	M7B	; $211B set low
	stz	M7B	; $211B set high
	stz	M7C	; $211B set low
	stz	M7C	; $211B set high
	stz	M7D	; $211B set low
	sta	M7D	; $211B set high (to 1)
	stz	M7X	; $211B set low
	stz	M7X	; $211B set high
	stz	M7Y	; $211B set low
	stz	M7Y	; $211B set high


; color generator stuff

	stz	CGADD	; $2121
	stz	CGDATA	; $2122


; window stuff

	stz	W12SEL	; $2123
	stz	W34SEL	; $2124
	stz	WOBJSEL	; $2125
	stz	WH0	; $2126
	stz	WH1	; $2127
	stz	WH2	; $2128
	stz	WH3	; $2129
	stz	WBGLOG	; $212A
	stz	WOBJLOG	; $212B


; through-main and through-sub

	stz	TM	; $212C
	stz	TS	; $212D
	stz	TMW	; $212E
	stz	TSW	; $212F


; color addition/subtraction

	lda	#$30
	sta	CGSWSEL	; $2130
	stz	CGADSUB	; $2131


; fixed color addition/subtraction (useful for fading)

	lda	#$E0
	sta	COLDATA	; $2132


; initial screen setting (interlace, 224/239, psuedo 512, etc)

	stz	SETINI	; $2133


; nmi enable/disable

	stz	NMITIMEN	; $4200


; multiply/divide stuff

	lda	#$ff
	sta	WRIO	; $4201
	stz	WRMPYA	; $4202
	stz	WRMPYB	; $4203
	stz	WRDIVL	; $4204
	stz	WRDIVH	; $4205
	stz	WRDIVB	; $4206


; programmable irq stuff

	stz	HTIMEL	; $4207
	stz	HTIMEH	; $4208
	stz	VTIMEL	; $4209
	stz	VTIMEH	; $420A


; dma triggers

	stz	MDMAEN	; $420B
	stz	HDMAEN	; $420C


; clock speed toggle. higher speed only available if no rom access

	stz	MEMSEL	; $420D


; clear vram. this apparently has to be done at start, besides
; being a good idea

	lda	#$80
	sta	VMAINC	; write words to vram
	stz	VMADDL	; write to address $0000
	stz	VMADDH


; set to fixed indexing-- reads from same location repeatedly
; instead of incrementing source address. also set dma transfer
; size to words

	lda	#$09
	sta	DMA0INC	; fixed indexing


; set dma dest address

	lda	#<VMDATAL
	sta	DMA0DEST	; write to vram data register


; clear source and set dma source address

	stz	$00	; clear first two byte of zero page-- source
	stz	$01
	stz	DMA0A1L	; source address (low)
	stz	DMA0A1H	; source address (high)
	stz	DMA0A1B	; source address (bank)


; clear 64k bytes-- $0000 means 64k

	stz	DMA0NUML	; number of bytes to transfer (low)
	stz	DMA0NUMH	; number of bytes to transfer (high)
	stz	DMA0BANK	; shouldn't be necessary for normal dma


; for safety's sake, i guess-- these are h-dma only, i think

	stz	DMA0A2L
	stz	DMA0A2H


; enable dma

	lda	#$01
	sta	MDMAEN	; enable


; clear cgram-- set dma dest address. some stuff still set
; correctly from clearing vram above

	lda	#$08
	sta	DMA0INC	; fixed indexing, bytes
	lda	#<CGDATA	; low byte of CGDATA register
	sta	DMA0DEST	; set dma dest (offset from $2100)


; clear $0200 bytes (entire palette)

	stz	DMA0NUML	; number of bytes to transfer (low)
	lda	#$02		
	sta	DMA0NUMH	; number of bytes to transfer (high)
	stz	DMA0BANK	; shouldn't be necessary for normal dma


; enable dma

	lda	#$01
	sta	MDMAEN	; enable


; clear oamram-- set dma dest address. some stuff still set
; correctly from clearing cgram above

	lda	#<OAMDATA	; low byte of OAMDATA register
	sta	DMA0DEST	; set dma dest (offset from $2100)


; clear $0220 bytes (entire object ram)

	lda	#$20
	sta	DMA0NUML	; number of bytes to transfer (low)
	lda	#$02
	sta	DMA0NUMH	; number of bytes to transfer (high)
	stz	DMA0BANK	; shouldn't be necessary for normal dma


; enable dma

	lda	#$01
	sta	MDMAEN	; enable
	sta	z_nmitimensh

	LA

;	jsl	ClrWRam

	rtl


ClrWRam:
	LAI

	ldx	#$1EfE
.loop 
	stz	$0000,x
	dex
	bpl	.loop

	rtl

