*****************************************************************************
*
* ITEMS.ASM
*
*****************************************************************************


_itemvect:
	.dw	NONE,NONE
	.dw	Itemoneup, Itemdarts, Itemprtlife
	.dw	Itemcoin

_itempoints:
	.dw	NONE,NONE
	.dw	5000,2500,1500
	.dw	1000


*****************************************************************************
*

PlotItems:
	LAI

	lda	v_items	; Get number of items to do
	bne	.doplotitems

	rtl

.doplotitems
	jsr	.anicons	; Check to see if we need to animate

	ldx	#0	; Start with 1st

	ldy	z_attrcount	; No  - Get attr counter

.plotloop:
	lda	v_items+8,x	; Get status
	and	#$C000	; Is item gone?
	beq	.getdata	; No  - Then plot then

	jmp	.nextitem	; Yes - Don't plot then

.getdata
	lda	v_items+4,x	; No  - Get X coord
	sta	ATTRX,y
	sec
	sbc	z_levelx
	cmp	#256
	bcc	.plotit
	cmp	#$ffe1
	bcc	.nextitem
.plotit:
	lda	v_items+6,x	; Y coord
	sta	ATTRY,y
	sec
	sbc	z_levely
	cmp	#224
	bcc	.plotit2
	cmp	#$ffe1
	bcc	.nextitem
.plotit2:
	lda  	v_items+2,x	; Get frame
	and	#$FF00
	xba
	sta	ATTRFRAME,y

	lda	#^tzpups1	; Get data bank
	sta	ATTRBANK,y

	lda	#tzpups1	; Get drec record
	sta	ATTRDREC,y

	lda	v_items+2,x	; Get item ID
	and	#$FF

	clc
	adc	#$20	; Compute "name"

	sec		; Adjust for "name" compute
	sbc	#4

	clc
	adc	#$3200	; Combine with palette & priority

;	ora	ATTROFF,y
	sta	ATTROFF,y	; Store it

.nxtsprt
	iny
	iny

.nextitem:
	txa
	clc
	adc	#8
	tax
	cpx	v_items
	beq	.exit

	jmp	.plotloop
.exit:
	sty	z_attrcount

	rtl


****************************************
*
* Do animated powerup update
*

.anicons
	lda	v_pause
	ora	v_pause2
	beq	.okdf

	rts
.okdf
	dec	v_coinstep	; Time to animate coin?
	bpl	.chk1up	; No  - Go check 1up

	lda	#8	; Yes - Reload Counter
	sta	v_coinstep

	lda	#^tzpups1seq05	; Get sequence bank
	sta	z_temp1

	lda	#tzpups1seq05	; Get sequence offset
	sta	z_temp0

	lda	v_coinseq	; Get sequence pointer
	clc
	adc	#4	; Point to next frame data entry
	sta	v_coinseq	; Store it

	tay		; Index

	lda	[z_temp0],y	; Get frame data
	bpl	.framecoin	; If not end of seq, then frame...

	stz	v_coinseq	; Otherwise, zero out frame pointer

	lda	[z_temp0]	; Get 1st frame info
.framecoin
	and	#$FF	; Isolate frame from time data
	sta	v_coinflip	; Store byte index
	asl		; Make word index
	tay		; (Store for Sendframe)

	lda	#tzpups1	; Get a long ptr to powerup data
	sta	z_spridrec

	lda	#^tzpups1
	sta	z_dreccount

	lda	#$26	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Queue it up...

.chk1up

	dec	v_1upcount
	bpl	.exitanipu

	lda	#10
	sta	v_1upcount

	lda	#^tzpups1seq06	; Get sequence bank
	sta	z_temp1

	lda	#tzpups1seq06	; Get sequence offset
	sta	z_temp0

	lda	v_1upseq	; Get sequence pointer
	clc
	adc	#4	; Point to next frame data entry
	sta	v_1upseq	; Store it

	tay		; Index

	lda	[z_temp0],y	; Get frame data
	bpl	.frame1up	; If not end of seq, then frame...

	stz	v_1upseq	; Otherwise, zero out frame pointer

	lda	[z_temp0]	; Get 1st frame info
.frame1up
	and	#$FF	; Isolate frame from time data
	sta	v_1upflip
	asl
	tay		; (Store for Sendframe)

	lda	#^tzpups1
	sta	z_dreccount

	lda	#tzpups1
	sta	z_spridrec

	lda	#$20	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Queue it up...

.exitanipu
	rts


*****************************************************************************
*
*
*****************************************************************************

InitItems:
	LAI

	lda	v_return
	beq	.doitems

	rtl
.doitems
	ldx	z_levelword	; Get word level index
	lda	#^itemlocs	; Address table pointer (bank)
	sta	z_temp1

	lda	>itemlocs,x	; Address table pointer (offset)
	sta	z_temp0

	ldy	#0	; Counter
.itemloop:
	lda	[z_temp0],y	; Get item data
	cmp	#$ffff	; Done?
	beq	.exit	; Yes -

	sta	v_items+2,y	; No  - Store item data

	iny
	iny

	bra	.itemloop
.exit:
	sty	v_items


	lda	#ONEUP
	and	#$FF00
	xba
	asl
	tay		; (Store for Sendframe)

	lda	#^tzpups1
	sta	z_dreccount

	lda	#tzpups1
	sta	z_spridrec

	lda	#$20	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Queue it up...


	lda	#DARTS
	and	#$FF00
	xba
	asl
	tay		; (Store for Sendframe)

	lda	#^tzpups1
	sta	z_dreccount

	lda	#tzpups1
	sta	z_spridrec

	lda	#$22	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Queue it up...

	lda	#PARTLIFE
	and	#$FF00
	xba
	asl
	tay		; (Store for Sendframe)

	lda	#^tzpups1
	sta	z_dreccount

	lda	#tzpups1
	sta	z_spridrec

	lda	#$24	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Queue it up...

	lda	#BONUSCOIN
	and	#$FF00
	xba
	asl
	tay		; (Store for Sendframe)

	lda	#^tzpups1
	sta	z_dreccount

	lda	#tzpups1
	sta	z_spridrec

	lda	#$26	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Queue it up...


	lda	#ACTDART
	and	#$FF00
	xba
	asl
	tay		; (Store for Sendframe)

	lda	#^tzpups1
	sta	z_dreccount

	lda	#tzpups1
	sta	z_spridrec

	lda	#$2E	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Queue it up...

	jsl	Senddata

	rtl

***************************************************************************** 
*
* Add points to current point total
*
* Entry : a contains points to add
*         x save items index
*
*****************************************************************************
 
Addpoints:
	phx
	pha

	clc
	adc	v_levelpoints	; Add points for this level
	sta	v_levelpoints

	pla
	clc
	adc	v_extrapoints
	sta	v_extrapoints	; Points working towards extra life

	cmp	#25000
	bcc	.nolife

	stz	v_extrapoints

	lda	v_lives
	cmp	#9
	bcs	.nolife

	inc
	sta	v_lives

.nolife:
	plx		; Restore items index

	rtl


*****************************************************************************
*
* Remove item & add points if item is touched
*
*****************************************************************************

Detector:
	LAI

	jsl	Detitem	; Parse item tbl for possible contact

	bcc	.end	; Nothing found if carry clear

	stx	z_temp0	; Otherwise, x contains item index 

	lda	v_items+8,x	; Get item data
	bit	#1	; Display item, but no interaction?
	bne	.end	; Yes -

	bit	#$C000	; Is item invisible or gone? 
	bne	.end	; Yes -

	lda	#$8000	; No  - Make it go away now...
	ora	v_items+8,x
	sta	v_items+8,x

	lda	v_items+2,x	; Get item ID as an index for points
	and	#$FF
	tax

	lda	>_itempoints,x	; Add in points for this item

	jsl	Addpoints	; Compute

	lda	>_itemvect,x	; Get code vector
	sta	z_temp1	; Store routine address

	jmp	(z_temp1)	; Handle item pick up
.end
	rtl



*****************************************************************************
*
* Detect Item
*
* Detitem uses v_playerleft, playertop, playerrite & playerbot to
* detect item. All items in table will be checked and
* return the offset in X of first item detected, if A is positive or 0
*
* Item (coin) hotspots are top-left on a 16x16 size item
*
*****************************************************************************

Detitem:
	LAI

	ldx	v_items	; Get number of items
	beq	.end	; Done if no items in table

	ldx	#0	; Init index
.loop       
	lda	v_items+8,x	; Get item status
	and	#$8000	; Is this item gone?
	bmi	.not	; Yes -

	lda	#$10
	sta	z_temp4	; Size is 16x16

	lda	v_items+4,x	; Get item top X
	sta	z_temp1

	clc
	adc	z_temp4	; Item X+size
	cmp	v_playerleft	; Intersect players left side?
	bcc	.not	; No  -

	lda	v_playerrite	; Get players right
	cmp	z_temp1	; Intersect players right side?
	bcc	.not	; No  -

	lda	v_items+6,x	; Get item top Y
	sta	z_temp1

	clc
	adc	z_temp4	; Item Y+size
	cmp	v_playertop	; Intersect players top?
	bcc	.not	; No  -
	  
	lda	v_playerbot	; Get players bottom
	cmp	z_temp1	; Intersect players bottom?
	bcc	.not	; No  -

	sec		; Carry indicates a positive search

	rtl
.not        
	txa
	clc
	adc	#8	; Compute start of next item data
	tax
	cpx	v_items	; End of items?
	bne	.loop	; No  - Continue for more
.end        
	clc		; Otherwise, indicate negative search

	rtl


*****************************************************************************
*
* Announce Powerup
* 
*****************************************************************************

Powerupmessage
	LAI

	rtl		; Stubbed Out!!!!!


*****************************************************************************
*

Itemoneup:
	lda	#getpop1_eff

	jsl	load_Effect

	lda	v_lives
	cmp	#9
	bcs	.nolife

	inc
	sta	v_lives

.nolife:
	lda	#MAXHEALTH	; Otherwise, regen current life
	sta	v_health

	rtl


****************************************

Itemdarts:
	lda	#getpop3_eff

	jsl	load_Effect

	lda	v_numdart	; Which frame are we in?
	clc
	adc	#3
	cmp	#10
	bcs	.exit

	sta	v_numdart

	rtl
.exit
	lda	#9
	sta	v_numdart

	rtl


****************************************

Itemprtlife:
	lda	#whoosh1_eff

	jsl	load_Effect

	lda	v_health	; Get current health status
	inc
	inc
	cmp	#MAXHEALTH
	bcc	.ok

	lda	#MAXHEALTH
.ok
	sta	v_health

	rtl


****************************************

Itemcoin:
	lda	#getpop2_eff

	jsl	load_Effect

	lda	v_coincur
	dec
	sta	v_coincur

	rtl


*****************************************************************************
*
*

PlotSpecials:

	rtl

