; levsound.asm
;
; Must be in same bank as tzan2.asm



SNDTZCALL	.equ	10	; Module for Tarzans Call
SNDINTROS	.equ	15

SNDTZHOME	.equ	4	; Tarzans Home
SNDLOWERJNGL	.equ	3	; Jungle 1
SNDAPESCLR	.equ	2	; Apes Clearing
SNDSWAMP	.equ	5	; Swamp

SNDBEACH	.equ	1	; Beach

SNDREEF	.equ	6	; Reef
SNDSHIP	.equ	8	; Ship

SNDSHIPHOLD	.equ	8	; Ship

SNDMIDJNGLE	.equ	4	; Jungle 3
SNDDWNRIVR	.equ	6	; Downriver
SNDUPPERJNGL	.equ	13	; Jungle 4
SNDUPRRIVR	.equ	6	; UpRiver

SNDWATRFALL	.equ	7	; Waterfall
SNDCAVERN	.equ	9	; Caverns
SNDSTREETS	.equ	14	; Opar - Street
SNDWELLS	.equ	0	; Opar - Wells
SNDTEMPLE	.equ	11	; Opar - Temple

SNDSHAMON	.equ	12	; Opar - Shamon Boss

SNDBONUSX	.equ	4	; Bonus - Exterior
SNDBONUSI	.equ	0	; Bonus - Interior

SNDSELECT	.equ	15
SNDWINGAME	.equ	16	; Win game song

*****************************************************************************
*
* Level Sound Tables (songs, looping effects, ambient sounds)
*
*****************************************************************************

; Sound modules are identified by a song within that module.

d_soundmodule:
	.db	SNDLOWERJNGL	; Jungle 1
	.db	SNDTZHOME	; Tarzan's Home
	.db	SNDAPESCLR	; Ape's Clearing
	.db	SNDSWAMP	; Swamp

	.db	SNDBEACH	; Beach
	.db	0	; Beach-Bay CANCELLED
	.db	SNDREEF	; Reef
	.db	SNDSHIP	; Ship
	.db	SNDSHIP	; Ship Hold A

	.db	SNDSHIP	; Ship Hold B
	.db	SNDMIDJNGLE	; Jungle 3
	.db	SNDDWNRIVR	; Downriver
	.db	SNDUPPERJNGL	; Jungle 4 (night jungle)
	.db	SNDUPRRIVR	; Upriver

	.db	SNDWATRFALL	; Waterfall
	.db	SNDCAVERN	; Caverns
	.db	SNDSTREETS	; Opar - Street
	.db	SNDWELLS	; Opar - Wells
	.db	SNDTEMPLE	; Opar - Temple

	.db	SNDSHAMON	; Opar - Shamon

	.db	SNDBONUSX	; Bonus Level - Exterior
	.db	SNDBONUSI	; Bonus Level - Interior


; -1 for level theme = no song

d_leveltheme:
	.db	drumpat4_sng	; Jungle 1
	.db	drumpat7_sng	; Tarzan's Home
	.db	apeclear_sng	; Ape's Clearing
	.db	nitboss_sng	; Swamp

	.db	drumpat3_sng	; Beach
	.db	-1	; Beach-Bay CANCELLED
	.db	reef_sng	; Reef
	.db	boat_sng	; Ship
	.db	boat_sng	; Ship Hold A

	.db	boat_sng	; Ship Hold B
	.db	drumpat7_sng	; Jungle 3
	.db	drumpat6_sng	; Downriver
	.db	forestnt_sng	; Jungle 4 (night jungle)
	.db	drumpat6_sng	; UpRiver

	.db	drumpat2_sng	; Waterfall
	.db	-1	; Caverns
	.db	drumpat5_sng	; Opar - Street
	.db	-1	; Opar - Wells
	.db	temple_sng	; Opar - Temple

	.db	priest_sng	; Opar - Shamon

	.db	drumpat7_sng	; Bonus Level - Exterior
	.db	drumpat1_sng	; Bonus Level - Interior


; -1 for d_soundloop means no looping sound effects

d_soundloop:
	.db	-1	; Tarzan's Home
	.db	-1	; Jungle 1
	.db	-1	; Ape's Clearing
	.db	nitcrik_eff	; Swamp

	.db	tzwave_eff	; Beach
	.db	0	; Beach-Bay CANCELLED
	.db	underwat_eff	; Reef
	.db	boatwave_eff	; Ship
	.db	boatwave_eff	; Ship Hold A

	.db	boatwave_eff	; Ship Hold B
	.db	-1	; Jungle 3
	.db	underwat_eff	; Downriver
	.db	nitbuzz_eff	; Jungle 4 (night jungle)
	.db	underwat_eff	; UpRiver

	.db	water8_eff	; Waterfall
	.db	watercav_eff	; Caverns
	.db	-1	; Opar - Street
	.db	-1	; Opar - Wells
	.db	-1	; Opar - Temple

	.db	-1	; Opar - Shamon

	.db	-1	; Bonus Level - Exterior
	.db	-1	; Bonus Level - Interior


; ambient sound effects; format:  effect (byte), min delay / 4 (byte)
; Terminate with -1 (word)

.gull1:	.db	tzgull1_eff,tzgull2_eff,tzgull1m_eff,tzgull1l_eff
.gull2:	.db	tzgull1_eff,tzgull2_eff,tzgull2m_eff,tzgull2l_eff

.j1bird1:	.db	parket1_eff,parket2_eff,parket1m_eff,parket2l_eff
.j1bird2:	.db	parket2_eff,parket1_eff,parket2m_eff,parket1l_eff
.j1bird3:	.db	parket1b_eff,parket2b_eff,prket1bm_eff,prket2bl_eff
.j1bird4:	.db	parket2b_eff,parket1b_eff,prket2bm_eff,prket1bl_eff
.j1bird5:	.db	canary1_eff,canary2_eff,canary1m_eff,canary2l_eff
.j1bird6:	.db	canary2_eff,canary1_eff,canary2m_eff,canary1l_eff
.j1bird7:	.db	canary2b_eff,canary2b_eff,canry2bm_eff,canry2bl_eff

.swampfrg1:	.db	bullfrog_eff,bullfrog_eff,bullfrog_eff,bullfrgm_eff
.swampfrg2:	.db	newfrg1_eff,newfrg1_eff,nwfrg1md_eff,newfrg1l_eff
.swampfrg3:	.db	newfrg2_eff,newfrg2_eff,nwfrg2md_eff,nwfrg1lm_eff
.swampcrk1:	.db	crkswp_eff,crkswp_eff,crkswpm_eff,crkswpl_eff
.swampcrk2:	.db	crkswplo_eff,crkswplo_eff,crkswlom_eff,bullfrgl_eff
.swampcrk3:	.db	ckswpllo_eff,ckswpllo_eff,ckswllom_eff,ckswllol_eff

.boatgull:	.db	boatgul1_eff,boatgul1_eff,boatgul2_eff,boatgul2_eff

.j3crik1:	.db	cricketa_eff,cricketa_eff,criketam_eff,criketal_eff
.j3crik2:	.db	cricklo_eff,cricklo_eff,cricklom_eff,cricklol_eff
.j3crik3:	.db	crickllo_eff,crickllo_eff,crikllom_eff,crikllol_eff
.j3bird1:	.db	pkt1j26_eff,pkt1j26_eff,pkt1j26m_eff,pkt1j26l_eff
.j3bird2:	.db	cny1j26_eff,cny1j26_eff,cny1j26m_eff,cny1j26l_eff
.j3bird3:	.db	cny1aj26_eff,cny1aj26_eff,cy1aj26m_eff,cy1aj26l_eff

.water1:	.db	undwat1_eff,undwat3_eff,undwat4_eff,undwat5_eff

.nite1:	.db	crklofnt_eff,crklofnt_eff,crkllfnt_eff,crkllfnt_eff
.nitebird1:	.db	jngbrd3_eff,jngbrd3l_eff,jngbrd4_eff,jngbrd4h_eff

.chant	.db	chant_eff,chant_eff,chant2_eff,chant2_eff

.watrdrip1	.db	drip1dm_eff,drip1b_eff,drip1cl_eff,drip1_eff
.watrdrip2	.db	drip1dm_eff,drip1bm_eff,drip1c_eff,drip1l_eff
.watrdrip3	.db	drip1dl_eff,drip1b_eff,drip1cm_eff,drip1m_eff
.watrdrip4	.db	drip1d_eff,drip1bm_eff,drip1cl_eff,drip1m_eff
.watrdrip5	.db	drip1dl_eff,drip1bl_eff,drip1c_eff,drip1_eff

.watrdrip1ecc	.db	driprevb_eff,driprevb_eff,drip1cl_eff,driprevm_eff
.watrdrip2ecc	.db	driprevl_eff,drip1bm_eff,driprevc_eff,drip1l_eff
.watrdrip3ecc	.db	driprevc_eff,driprevb_eff,drip1cm_eff,driprevm_eff
.watrdrip4ecc	.db	drip1d_eff,drprevbm_eff,drip1cl_eff,driprev_eff
.watrdrip5ecc	.db	drip1dl_eff,drip1bl_eff,drip1c_eff,driprev_eff


;		driprev_eff 
;		driprevm_eff
;		driprevl_eff
;		driprevb_eff
;		drprevbm_eff
;		drprevbl_eff
;		driprevc_eff
;		drprevcm_eff
;		drprevcl_eff
;

.watrdrip1ec	.db	drip1dm_eff,drip1b_eff,drip1cl_eff,drip1_eff
.watrdrip2ec	.db	drip1dm_eff,drip1bm_eff,drip1c_eff,drip1l_eff
.watrdrip3ec	.db	drip1dl_eff,drip1b_eff,drip1cm_eff,drip1m_eff
.watrdrip4ec	.db	drip1d_eff,drip1bm_eff,drip1cl_eff,drip1m_eff
.watrdrip5ec	.db	drip1dl_eff,drip1bl_eff,drip1c_eff,drip1_eff

.amb1:        	.dw	.j1bird1,35		; Jungle 1
	.dw	.j1bird2,25
	.dw	.j1bird3,25
	.dw	.j1bird4,50
	.dw	.j1bird5,50
	.dw	.j1bird6,45
	.dw	.j1bird7,40
	.dw	-1

.amb2:	.dw	.j3crik1,50		; Tarzan's Tree
	.dw	.j3crik2,50
	.dw	.j3crik3,60
	.dw	.j3bird1,35
	.dw	.j3bird2,30
	.dw	.j3bird3,40
	.dw	-1

.amb3:	.dw	-1		; Ape's Clearing

.amb4:        	.dw	.swampfrg1,75		; Swamp
	.dw	.swampfrg2,70
	.dw	.swampfrg3,90
	.dw	.swampcrk1,50
	.dw	.swampcrk2,25
	.dw	.swampcrk3,40
	.dw	-1

.amb5:        	.dw	.gull1,80		; Beach
	.dw	.gull2,100
	.dw	-1

.amb7:	.dw	.water1,80		; Reef
	.dw	-1

.amb8:	.dw	.boatgull,40		; Ship
	.dw	.boatgull,60
	.dw	-1

.amb9:	.dw	-1		; Ship Hold A
.amb10:	.dw	-1		; Ship Hold B

.amb11:
	.dw	-1
	.dw	.j3crik1,60		; Jungle 3
	.dw	.j3crik2,60
	.dw	.j3crik3,70
	.dw	.j3bird1,35
	.dw	.j3bird2,50
	.dw	.j3bird3,40
	.dw	-1

.amb12:	.dw	.water1,80		; Downriver
	.dw	-1

.amb13:       	.dw	.nite1,50		; Jungle 4 (night jungle)
	.dw	.nite1,50
	.dw	.nitebird1,75
	.dw	-1

.amb14:	.dw	.water1,80		; Upriver
	.dw	-1

.amb15:	.dw	-1		; Waterfall

.amb16:	.dw	.watrdrip1ecc,50	; Caverns
	.dw	.watrdrip2ecc,35
	.dw	.watrdrip3ecc,75
	.dw	.watrdrip4ecc,105
	.dw	.watrdrip5ecc,35
	.dw	-1

.amb17:	.dw	-1		; Opar - Street
.amb18:	.dw	-1		; Opar - Wells

.amb19:	.dw	.chant,125		; Opar - Temple
	.dw	-1

.amb20:
;	.dw	.chant,125		; Opar - Shamon Boss
	.dw	-1


.amb21:	.dw	.j3crik1,60		; Bonus Level - Exterior
	.dw	.j3crik2,70
	.dw	.j3crik3,60
	.dw	.j3bird1,50
	.dw	.j3bird2,50
	.dw	.j3bird3,35
	.dw	-1		

.amb22	.dw	-1		; Bonus Level - Interior

.ambnot	.equ	0



@d_ambientlocs:
	.dw 	.amb1	; Jungle 1
	.dw	.amb2	; Tarzan's Home
	.dw	.amb3	; Ape's Clearing
	.dw	.amb4	; Swamp

	.dw	.amb5	; Beach
	.dw	.ambnot	; Beach-Bay CANCELLED
	.dw	.amb7	; Reef
	.dw	.amb8	; Ship
	.dw	.amb9	; Ship Hold A

	.dw	.amb10	; Ship Hold B
	.dw	.amb11	; Jungle 3
	.dw	.amb12	; Downriver
	.dw	.amb13	; Jungle 4
	.dw	.amb14	; Upriver

	.dw	.amb15	; Waterfall
	.dw	.amb16	; Caverns
	.dw	.amb17	; Opar - Street
	.dw	.amb18	; Opar - Wells
	.dw	.amb19	; Opar - Temple

	.dw	.amb20	; Opar - Shamon

	.dw	.amb2	; Bonus Level - Exterior
	.dw	.amb22	; Bonus Level - Interior


*****************************************************************************
*
* LoadSoundModule
*
* This routine would be much nicer if a module name could be passed directly
* instead of having to use a song to look up the module, but that's the way
* the Sculptured sound stuff seems to work.
*
* in:  a = song within module 
*
*****************************************************************************

;LoadSoundModule:
;	sta  SONGNUMBER
;	lda  >NUM_LM   ;total number of load modules
;	and  #$ff
;	inc            ;add 1 for common module
;	sta  ModTabInd
;	asl
;	clc
;	adc  ModTabInd ;index past MODULE_ADR table (SONG_MOD table)
;	clc
;	adc  #MODULE_ADR & $FFFF
;	clc
;	adc  SONGNUMBER     ;look up module for this song
;	sta  ModTabInd
;	SA
;	lda  #MODULE_ADR >> 16
;	sta  ModTabInd+2    ;bank
;	LA
;	lda  [ModTabInd]    ;module value
;	and  #$ff
;	jml  load_Module    ;load module


*****************************************************************************
*
* Music & Sound Effect Initialization
*
*****************************************************************************

MusicInit:
	.if MUSICOK

	; load sound module & main song for level

	ldx	z_level
	lda	d_soundmodule-1,x
	and	#$00FF
	jsl	load_Module

	lda	v_contrlmap	; if music turned off on options screen,
	bit	#$0008	; don't play a song for this level
	bne	.nomusic

	ldx	z_level
	lda	d_leveltheme-1,x
	and	#$00FF
	cmp	#$00FF		
	beq	.nomusic	; if level theme < 0, don't play a song

	sta	v_cursong

	jsl	load_Song

.nomusic:
	; clear ambient sound effect table

	ldx	#MAXAMB-2
.clear:	stz	v_ambienteff,x
	dex
	dex
	bpl	.clear

	lda	v_contrlmap	;if sound effects turned off,
	bit	#4	;don't load any background sounds
	bne	.done

	; load looping sound effects

	ldx	z_level
	lda	d_soundloop-1,x
	and	#$00FF
	cmp	#$00FF
	beq	.noloop
	jsl	load_Effect
.noloop:
	; load ambient sound effects

	ldx	z_levelword
	lda	d_ambientlocs-2,x
	sta	z_temp0
	ldy	#0
	ldx	#MAXAMB-2
.loadamb:	lda	(z_temp0),y
	cmp	#-1
	beq	.done
	sta	v_ambienteff,x
	iny
	iny
	lda	(z_temp0),y
	asl		; *2
	asl		; *4
	sta	v_ambientrate,x
	jsl	Random
	sta	v_ambientwait,x
	iny
	iny
	dex
	dex
	bpl	.loadamb

	.endif

.done:	rtl

*****************************************************************************
*
* Ambient Sound Handler
*
*****************************************************************************

DoAmbients:
	.if MUSICOK

	ldx	#MAXAMB-2
.loop:
	lda	v_ambienteff,x
	beq	.exit	; exit as soon as an empty slot is found

	dec	v_ambientwait,x
	bpl	.next
	
	sta	z_temp0

	jsl	Random

	and	#3
	tay

	lda	(z_temp0),y
	and	#$00FF
	tay

	phx

	lda	#DCOM_START_EFFECT

	jsl	Pass_Driver_Com

	plx

	jsl	Random

	and	#127
	clc
	adc	v_ambientrate,x
	sta	v_ambientwait,x

	rtl		; only start 1 effect per frame

.next:
	dex
	dex

	bpl	.loop

.exit:
	.endif

	rtl


*******************************************************************************
*
* SoundEffect - play sound effect (effect must in current module)
*
* in:  y = sound effect id
*
*******************************************************************************

OnscreenSound:
	lda	v_foeplot,x
	bne	.exit
@SoundEffect:
	.if MUSICOK

	lda	v_contrlmap
	bit	#4	; 1=sound effects turned off
	bne	.exit

	phx

	lda  #DCOM_START_EFFECT

	jsl  Pass_Driver_Com

	plx

	.endif
.exit:	

	rtl



