*****************************************************************************
*
* LOGOS.ASM
*
*****************************************************************************


LICENSEDELAY	.equ	180

Logos:
	LAI

	lda	#LICENSEDELAY
	sta	v_codedelay

	jsl	Licensedby
.logohold
	jsl	Waitfornmi

	dec	v_codedelay
	bpl	.logohold

	stz	v_codedelay

	jsl	Fadeout

	jsl	GameTeklogo1	; Do GameTek logo

;	lda	v_buttonpress	; Only get a button after 1st time
;	beq	.nextlogo	; But, if 2nd & no press, do Manley's

	rtl		; Otherwise,
.nextlogo

	rtl


*****************************************************************************

Licensedby:
	BLANKON
	NMIOFF


	; Unpack Screen Chars

	pea	|licensebychr	 ; Source
	pea	^licensebychr
	pea	|SCRATCH	 ; Destination
	pea	^SCRATCH

	jsl	UNPACK

	pla
	pla
	pla
	pla


	; VRAM Xfer for Screen Chars

	lda	#^SCRATCH
	sta	z_sendvrambank

	lda	#SCRATCH
	ldy	#$1000
	ldx	#BG1CHAR

	jsl	Sendvram

	lda	#BG1BASE

	jsl	Clrbg

	; Unpack Screen
	pea	|licensebyscr	; push low word of packed file
	pea	^licensebyscr	; push high word of packed file
	pea	|SCRATCH	; push low word of output buffer
	pea	^SCRATCH	; push high word of output buffer

	jsl	UNPACK	; unpack file to output buffer

	pla
	pla
	pla
	pla

	; Copy Screen to BG1
	ldx	#BG1BASE	; BG1 will take rungs & build
	lda	#SCRATCH	; Blank
	ldy	#^SCRATCH
	jsl	Sendbg

	; Copy Screen Palette(s)
	lda	#licensebypal
	sta	z_temp0

	lda	#^licensebypal
	sta	z_temp1

	ldy	#$1FE
.palloop    
	lda	[z_temp0],y
	sta	PALETTE2,y

	dey
	dey
	bpl	.palloop


	; Set Modes

	SA

	lda	#(BG1BASE/256)
	sta	BG1SC

	lda	#1
	sta	BGMODE

	lda	#$1
	sta	TM

	stz	TS

	stz	TMW
	stz	TSW

	lda	#$00
	sta	CGSWSEL		

	lda	#$00
	sta	CGADSUB

	lda	#$00
	sta	BG12NBA


	; BG1 Vertical

	lda	#$0000
	sta	v_bg1vofs

	SAI
	sta	BG1VOFS
	xba
	sta	BG1VOFS
	LAI

	; BG1 Horizontal

	lda	#$0000
	sta	v_bg1hofs

	SAI
	sta	BG1HOFS
	xba
	sta	BG1HOFS
	LAI

	NMION

	jsl	Fadein

	rtl



*****************************************************************************

GameTeklogo1:
	LAI

	stz	MDMAEN

	jsr	.loadgtdata

	lda	#dsptime+160	; Delay count
	sta	z_transartdly	; Store it
	stz	v_buttonpress	; No buttons yet

	stz	z_logostate	; State machine
	stz	z_scrnch	; Change BG1 char data screen maps

	bra	.mainloop


.gteklogtab
	.dw	.gtl_Rolldown
	.dw	.gtl_Rung1
	.dw	.gtl_Rung2
	.dw	.gtl_Rung3
	.dw	.gtl_Rung4
	.dw	.gtl_Rung5
	.dw	.gtl_Rung6
	.dw	.gtl_Rung7
	.dw	0

.mainloop
	lda	z_logostate
	asl
	tax

	jsr	(.gteklogtab,x)


.scrnupdate
	jsl	Waitfornmi

	lda	z_scrnch	; V-Blank VRAM change requested?
	beq	.skpcsrnld

	phy
	txa

	; Copy Screen to BG1
	ldx	#BG1BASE1B	; BG1 will take rungs & build
	ldy	#^SCRATCH
	jsl	Sendbg

	; Copy Screen to BG1
	ldx	#BG1BASE	; BG1 will take rungs & build
	lda	#.scrn01	; Blank
	ldy	#^SCRATCH
	jsl	Sendbg

	pla

	; Copy Screen to BG2
	ldx	#BG2BASE2B	; BG2 does rolldown
	ldy	#^SCRATCH
	jsl	Sendbg

	; Copy Screen to BG2
	ldx	#BG2BASE	; BG2 does rolldown
	lda	#.scrn01	; Blank
	ldy	#^SCRATCH
	jsl	Sendbg

	stz	z_scrnch

.skpcsrnld
	lda	v_bg2vofs	; Modify rolldown

	SAI
	sta	BG2VOFS
	xba
	sta	BG2VOFS
	LAI

	
	lda	v_bg1vofs	; Modify stacker

	SAI
	sta	BG1VOFS
	xba
	sta	BG1VOFS
	LAI


.stayhere
	jsl	Scanjoys	; Check controller

	lda	z_joy1
	and	#JOYPADL
	bne	.stayhere

	lda	z_joy1	; Button pressed?
	beq	.letswait	; No  - Process delay

	lda	z_tzstartup	; Yes - Get startup var
	cmp	#$FE	; Is this 1st time thru?
	beq	.letswait	; Yes - Then continue process delay

	lda	z_joy1	; No  - Get keypress back
	and	#JOYPADSTART	; Was it the "START" button?
	beq	.letswait	; No  - Something else was pressed too

	lda	#JOYPADSTART	; Yes - Get "START" bit pattern
	sta	v_buttonpress	; Store it
	bra	.fadetitle	; Fade this logo out and exit
.letswait
	dec	z_transartdly	; Adjust delay value
	bmi	.fadetitle

	jmp	.mainloop	; Continue logo display if not done

.fadetitle
	jsl	Fadeout

	rtl

	lda	#gametekpal
	sta	z_temp0

	lda	#^gametekpal
	sta	z_temp1

	ldy	#$1FE
.palloop1    
	lda	[z_temp0],y
	sta	PALETTE,y

	dey
	dey
	bpl	.palloop1


	

	ldx	#$1FE	; Otherwise fade this logo out
.palclrloop    
	stz	PALETTE2,x	; Build Target Palette for Clearing

	dex
	dex
	bpl	.palclrloop

	jsl	Colfade	; Fade to Target Palette

	rtl


****************

.loadgtdata
	BLANKON
	NMIOFF


	; Unpack Screen Chars

	pea	|gametekchr	 ; Source
	pea	^gametekchr
	pea	|SCRATCH	 ; Destination
	pea	^SCRATCH

	jsl	UNPACK

	pla
	pla
	pla
	pla


	; VRAM Xfer for Screen Chars

	lda	#^SCRATCH
	sta	z_sendvrambank

	lda	#SCRATCH
	ldy	#$8000	
	ldx	#BG1CHAR

	jsl	Sendvram

	; Unpack Screen
	pea	|gametekscr	; push low word of packed file
	pea	^gametekscr	; push high word of packed file
	pea	|SCRATCH	; push low word of output buffer
	pea	^SCRATCH	; push high word of output buffer

	jsl	UNPACK	; unpack file to output buffer

	pla
	pla
	pla
	pla

	lda	#BG1BASE

	jsl	Clrbg

	lda	#BG1BASE1B

	jsl	Clrbg

	lda	#BG2BASE

	jsl	Clrbg

	lda	#BG2BASE2B

	jsl	Clrbg

	; Copy Screen to BG1
	ldx	#BG1BASE	; BG1 will take rungs & build
	lda	#.scrn01	; Blank
	ldy	#^SCRATCH
	jsl	Sendbg

	; Copy Screen to BG1
	ldx	#BG1BASE1B	; BG1 will take rungs & build
	lda	#.scrn09
	ldy	#^SCRATCH
	jsl	Sendbg

	; Copy Screen to BG2
	ldx	#BG2BASE	; BG2 will scroll down
	lda	#.scrn01	; Blank
	ldy	#^SCRATCH
	jsl	Sendbg

	; Copy Screen to BG2
	ldx	#BG2BASE2B	; BG2 will scroll down
	lda	#.scrn02
	ldy	#^SCRATCH
	jsl	Sendbg

	; Copy Screen Palette(s)
	lda	#gametekpal
	sta	z_temp0

	lda	#^gametekpal
	sta	z_temp1

	ldy	#$1FE
.palloop    
	lda	[z_temp0],y
	sta	PALETTE2,y

	dey
	dey
	bpl	.palloop


	; Set Modes

	SA

	lda	#(BG1BASE/256)+2
	sta	BG1SC

	lda	#(BG2BASE/256)+2
	sta	BG2SC

	lda	#1
	sta	BGMODE

	lda	#$3
	sta	TM

	stz	TS

	stz	TMW
	stz	TSW

	lda	#$00
	sta	CGSWSEL		

	lda	#$00
	sta	CGADSUB

	lda	#$00
	sta	BG12NBA


	; BG1 Vertical

	lda	#$0000
	sta	v_bg1vofs

	SAI
	sta	BG1VOFS
	xba
	sta	BG1VOFS
	LAI


	; BG2 Vertical

	lda	#$0000
	sta	v_bg2vofs

	SAI
	sta	BG2VOFS
	xba
	sta	BG2VOFS
	LAI



	; BG1 Horizontal

	lda	#$00EC
	sta	v_bg1hofs

	SAI
	sta	BG1HOFS
	xba
	sta	BG1HOFS
	LAI


	; BG2 Horizontal

	lda	#$00EC
	sta	v_bg2hofs

	SAI
	sta	BG2HOFS
	xba
	sta	BG2HOFS
	LAI

	NMION

	jsl	Fadein

	rts

*****************************************************************************

.gtl_Rolldown:
	
	lda	v_bg2vofs	; Get vert offset for BG2
	dec		; Scroll the logo down the screen
	dec	
	and	#$3FF
	sta	v_bg2vofs	; Store new position
	sta	v_bg1vofs	; Same for BG1

	cmp	#$02E0	; Have we reached the bottom limit?
	bcs	.xitgtlrd	; No  - Keep scrolling
	
	lda	#$02E0
	sta	v_bg2vofs	; Store new position
	sta	v_bg1vofs	; Same for BG1

	inc	z_logostate	; Yes - Do next state

	lda	#1
	sta	z_scrnch	; Indicate V-Blank VRAM change

	ldx	#.scrn09	; Screen 9 for BG1
	ldy	#.scrn03	; Screen 3 for BG2

.xitgtlrd
	rts

*****************************************************************************

.gtl_Rung1:
	
	lda	v_bg2vofs	; Get vert offset for BG2
	dec		; Scroll the logo down the screen
	dec	
	and	#$3FF
	sta	v_bg2vofs	; Store new position

	cmp	#$02E0-$10	; Have we reached the bottom limit?
	bcs	.xitgtlrd1	; No  - Keep scrolling
	
	lda	#$02E0-$10
	sta	v_bg2vofs	; Store new position

	inc	z_logostate	; Yes - Do next state

	lda	#1
	sta	z_scrnch	; Indicate V-Blank VRAM change

	ldx	#.scrn10	; Screen 10 for BG1
	ldy	#.scrn04	; Screen 04 for BG2

.xitgtlrd1
	rts

*****************************************************************************

.gtl_Rung2:
	lda	v_bg2vofs	; Get vert offset for BG2
	dec		; Scroll the logo down the screen
	dec	
	and	#$3FF
	sta	v_bg2vofs	; Store new position

	cmp	#$02E0-$20	; Have we reached the bottom limit?
	bcs	.xitgtlrd2	; No  - Keep scrolling
	
	lda	#$02E0-$20
	sta	v_bg2vofs	; Store new position

	inc	z_logostate	; Yes - Do next state

	lda	#1
	sta	z_scrnch	; Indicate V-Blank VRAM change

	ldx	#.scrn11	; Screen 11 for BG1
	ldy	#.scrn05	; Screen 05 for BG2

.xitgtlrd2
	rts

*****************************************************************************

.gtl_Rung3:
	lda	v_bg2vofs	; Get vert offset for BG2
	dec		; Scroll the logo down the screen
	dec	
	and	#$3FF
	sta	v_bg2vofs	; Store new position

	cmp	#$02E0-$30	; Have we reached the bottom limit?
	bcs	.xitgtlrd3	; No  - Keep scrolling
	
	lda	#$02E0-$30
	sta	v_bg2vofs	; Store new position

	inc	z_logostate	; Yes - Do next state

	lda	#1
	sta	z_scrnch	; Indicate V-Blank VRAM change

	ldx	#.scrn12	; Screen 12 for BG1
	ldy	#.scrn06	; Screen 06 for BG2

.xitgtlrd3
	rts

*****************************************************************************

.gtl_Rung4:
	lda	v_bg2vofs	; Get vert offset for BG2
	dec		; Scroll the logo down the screen
	dec	
	and	#$3FF
	sta	v_bg2vofs	; Store new position

	cmp	#$02E0-$40	; Have we reached the bottom limit?
	bcs	.xitgtlrd4	; No  - Keep scrolling
	
	lda	#$02E0-$40
	sta	v_bg2vofs	; Store new position

	inc	z_logostate	; Yes - Do next state

	lda	#1
	sta	z_scrnch	; Indicate V-Blank VRAM change

	ldx	#.scrn13	; Screen 13 for BG1
	ldy	#.scrn07	; Screen 07 for BG2

.xitgtlrd4
	rts

*****************************************************************************

.gtl_Rung5:
	lda	v_bg2vofs	; Get vert offset for BG2
	dec		; Scroll the logo down the screen
	dec	
	and	#$3FF
	sta	v_bg2vofs	; Store new position

	cmp	#$02E0-$50	; Have we reached the bottom limit?
	bcs	.xitgtlrd5	; No  - Keep scrolling
	
	lda	#$02E0-$50
	sta	v_bg2vofs	; Store new position

	inc	z_logostate	; Yes - Do next state

	lda	#1
	sta	z_scrnch	; Indicate V-Blank VRAM change

	ldx	#.scrn14	; Screen 14 for BG1
	ldy	#.scrn08	; Screen 08 for BG2

.xitgtlrd5
	rts

*****************************************************************************

.gtl_Rung6:
	lda	v_bg2vofs	; Get vert offset for BG2
	dec		; Scroll the logo down the screen
	dec	
	and	#$3FF
	sta	v_bg2vofs	; Store new position

	cmp	#$02E0-$60	; Have we reached the bottom limit?
	bcs	.xitgtlrd6	; No  - Keep scrolling
	
	lda	#$02E0-$60
	sta	v_bg2vofs	; Store new position

	inc	z_logostate	; Yes - Do next state

	lda	#1
	sta	z_scrnch	; Indicate V-Blank VRAM change

	ldx	#.scrn00	; Screen 15 for BG1
	ldy	#.scrn01	; Screen 00 for BG2

.xitgtlrd6
	rts

*****************************************************************************

.gtl_Rung7:

	rts


****************************************

.scrn00	.equ	SCRATCH+$0000	; Full Logo

.scrn01	.equ	SCRATCH+$0800	; Blank

.scrn02	.equ	SCRATCH+$1000	; Explode of full - 16 dot spacing
.scrn03	.equ	SCRATCH+$1800	; Explode minus bottom rung
.scrn04	.equ	SCRATCH+$2000	;    .
.scrn05	.equ	SCRATCH+$2800	;    .
.scrn06	.equ	SCRATCH+$3000	;    .
.scrn07	.equ	SCRATCH+$3800	;    .
.scrn08	.equ	SCRATCH+$4000	;    .

.scrn09	.equ	SCRATCH+$4800	; Bottom rung     \
.scrn10	.equ	SCRATCH+$5000	; Bottom rung +	1 |
.scrn11	.equ	SCRATCH+$5800	; Bottom rung +	2 |
.scrn12	.equ	SCRATCH+$6000	; Bottom rung +	3 |- BG1
.scrn13	.equ	SCRATCH+$6800	; Bottom rung +	4 |
.scrn14	.equ	SCRATCH+$7000	; Bottom rung +	5 /

.scrn15	.equ	SCRATCH+$7800	; Blank


*****************************************************************************

