*****************************************************************************
*
* 
* OPTIONS.ASM
*
* Handles option screen and password, intro sequences, etc.
*
*****************************************************************************
*
*  Game Over
*
*****************************************************************************

Gameover:
	lda	#SNDWINGAME

	jsl	load_Module

	lda	#tarzend_sng

	jsl	load_Song

	jsl	Liftjane

	jsl	Sunset

	jsl	Fadeout

	jsl	RunCredits

	rtl

GameFail:
	jsl	RunCredits

	rtl

SFXSelect:
	ldy	#$2601
	lda	#DCOM_FADEOUT
	
	jsl	Pass_Driver_Command

	lda	#SNDSELECT

	jsl	load_Module

	lda	#drumpat1_sng

	jsl	load_Song
	
	rtl

TZYell:
	ldy	#$2601
	lda	#DCOM_FADEOUT
	
	jsl	Pass_Driver_Command

	lda	#SNDTZCALL

	jsl	load_Module

	lda	#drumpat1_sng

	jsl	load_Song
	
	rtl


*****************************************************************************
*
* Options screen
*
*****************************************************************************

Options:
	jsl	Preinit

	lda	#1
	sta	v_inoptions
	
	jsl	Optselector

	lda	_optselect
	bne	.options

	lda	#1
	sta	z_level

	asl
	sta	z_levelword

	bra	.exitopt
.options
	cmp	#1
	bne	.password

	jsl	Cnfcontroller

	jsl	TZYell

          	bra	Options
.password
	jsl	Passwrdscrn

	lda	z_level
	cmp	#TZANHOME
	bcs	.exitopt

	jsl	TZYell

          	bra	Options
.exitopt
	stz	v_inoptions

	rtl


*****************************************************************************
*
*
*
*****************************************************************************

Optselector:
	LAI

	lda	#200
	sta	v_codedelay

	stz	_optselect
	stz	v_passcoderr
	stz	z_temp8
	
	jsr	Loadoptscrn

	ldx	#30
	lda	v_demoreturn	; Prevents Tarzan's Yell from becoming
			; totally annoying...
	bne	.waitloop

	lda	#tarzana_eff

	jsl	load_Effect

	ldx	#30
.waitloop
	phx

	jsr	Getcode	; Secret Pass code to enable debugmode

	plx

	jsl	Waitfornmi

	dex
	bpl	.waitloop

	lda	v_codefailed
	bne	.nocodenofun

	lda	#1
	sta	v_JOYPAD2ENABLE
	sta	v_DebugMode
	sta	v_MapGUI

	lda	#tarzroar_eff

	jsl	load_Effect

.nocodenofun
	stz	v_demoreturn

	jsr	Animatetitleman

	jsl	Waitfornmi

	ldx	#BG1BASE
	lda	#TRANSARTSCRATCH
	ldy	#^TRANSARTSCRATCH
	jsl	Sendbg

	jsl	Newgame         ; New Game Initialization

	jsr	Optmenu

.end
	jsl	Fadeout

	rtl

Optmenu:
	jsl	Scanjoys

	lda	v_demoplay	; Playing demo?
	beq	.justoptions	; No  - Just options

	dec	v_demodelay	; Timer expired?
	bpl	.justoptions	; No  - Wait for a while longer

	jsl	Fadeout	; Yes - Fade Start screen out

	stz	v_plotcbox	; Don't want collision box to plot

	jsl	Rndnum	; Generate a random demo start time

	clc
	adc	#DEMODELAY	; Add random to base time
	sta	v_demodelay	; Reset start screen wait timer
.pickagain	
	jsl	Rndnum	; Random demo level

	and	#7	; Just 8 demo levels

	cmp	#4
	bcs	.pickagain

	cmp	v_lastdemo	; Same as last time?
	beq	.pickagain	; Yes - Pick another demo level

	sta	v_lastdemo	; Store selected as old
	asl
	tax

	lda	>d_translevel,x
	and	#$FF
	sta	z_level
	asl		
	sta	z_levelword	

	jsr	Copydemodat	; Unpack data to $7F6000

	pla		; Pull jsr Optmenu	
	pla		; / Pull jsl Optselector \
	pla		; \      jsl Options     /

	lda	#1
	sta	v_demoreturn	; Prevents Tarzan's Yell from becoming
			; totally annoying...

	jsl	GlobalLevInit	; Run Designated Level

	jsl	Fadeout	; Fade to black

	ldy	#$2601	; Done with level - fade music
	lda	#DCOM_FADEOUT
	
	jsl	Pass_Driver_Command

	lda	v_demostate
	beq	.justret

	lda	#SNDTZCALL

	jsl	load_Module

	lda	#drumpat1_sng

	jsl	load_Song

	jml	MainOptions
.justret
	jml	Domain

.justoptions
	jsr	Flashoption

	jsl	Waitfornmi

	ldx	#BG1BASE
	lda	#TRANSARTSCRATCH+$1000
	ldy	#^TRANSARTSCRATCH
	jsl	Sendbg

	jsl	ScanjoysOpt
	
	lda	z_joy1
	bne	.gennewdly

	jmp	Optmenu

.gennewdly
	jsl	Rndnum	; Generate a random demo start time

	sta	z_temp0
	clc
	adc	#DEMODELAY	; Add random to base time
	sta	v_demodelay	; Reset start screen wait timer

	lda	z_joy1

	jsl	Check4start
	bne	.end
	
	jsl	Check4buttons
	bne	.end

	jsl	Check4moveup
	beq	.down

	lda	#blopipe_eff

	jsl	load_Effect

	lda	_optselect
	dec
	bpl	.storeopt
	lda	#2
	bra	.storeopt
.down
	jsl	Check4movedown

       	bne	.foundwm

	jmp	Optmenu
.foundwm
	lda	#blopipe_eff

	jsl	load_Effect

	lda	_optselect
	inc
	cmp	#3
	bcc	.storeopt

	lda	#0
.storeopt
	sta	_optselect

	lda	#4
	sta	z_temp8

	jmp	Optmenu

.end
	stz	v_demoplay

	lda	#tarzroar_eff

	jsl	load_Effect

	rts


*********************************************************************

; Decompress BG2 Character Set to SCRATCH+$6000 (last quad)

Copydemodat:
	LAI

	lda	v_lastdemo	; Get computed demo level
	asl
	tax		; Make word index

	lda	d_demotbl,x	; 
	sta	v_demoptr

            	pha		; 

	ldy	v_lastdemo	; 
	lda	d_demotblbnk,y	; 
	and	#$ff
	sta	v_demobank

	pha		; Stack parameter

	lda	#$6000	; Buffer offset address
            	pha		; Stack parameter

	lda	#$7F	; Buffer bank address
            	pha		; Stack parameter

	jsl	UNPACK	; Decompress

            	pla		; Clear stack
            	pla		;   .
            	pla		;   .
            	pla		;   .

	lda	#$6000
	sta	v_demoptr

	lda	#$7F
	sta	v_demobank

            	rts

************************************
Flashoption:
	
	ldx	#$12
.normal
	lda	>TRANSARTSCRATCH+$414,x
	sta	>TRANSARTSCRATCH+$1414,x
	lda	>TRANSARTSCRATCH+$454,x
	sta	>TRANSARTSCRATCH+$1454,x
	lda	>TRANSARTSCRATCH+$498,x
	sta	>TRANSARTSCRATCH+$1498,x
	lda	>TRANSARTSCRATCH+$4d8,x
	sta	>TRANSARTSCRATCH+$14d8,x
	lda	>TRANSARTSCRATCH+$51c,x
	sta	>TRANSARTSCRATCH+$151c,x
	lda	>TRANSARTSCRATCH+$55c,x
	sta	>TRANSARTSCRATCH+$155c,x
	dex
	dex
	bpl	.normal

	dec	z_temp8
	lda	z_temp8
	and	#$1f
	cmp	#10
	bcs	.end

	ldx	#$12
	lda	>TRANSARTSCRATCH
.flash1
	ldy	_optselect
	bne	.flash2
	sta	>TRANSARTSCRATCH+$1414,x
	sta	>TRANSARTSCRATCH+$1454,x
	bra	.endflash
.flash2
	cpy	#1
	bne	.flash3
	sta	>TRANSARTSCRATCH+$1498,x
	sta	>TRANSARTSCRATCH+$14d8,x
	bra	.endflash
.flash3
	sta	>TRANSARTSCRATCH+$151c,x
	sta	>TRANSARTSCRATCH+$155c,x
.endflash
	dex
	dex
	bpl	.flash1
.end
	rts

	

Animatetitleman:
	stz	z_levelx
	stz	z_levely
	lda	#$fffc
	sta	v_playerseq
	lda	#2000
	sta	v_playerdelay
	stz	v_xfercount

.loop
	jsl	Waitfornmi
	jsl	Senddata2
	jsl	Sendobj
	jsr	Plottitleman

	ldx	v_playerseq
	lda	>titlemrseq+4,x
	bpl	.loop
	
	ldx	#30
.waitloop2
	jsl	Waitfornmi
	dex
	bpl	.waitloop2
	rts

Plottitleman:
	inc	v_playerdelay
	lda	v_playerdelay
	cmp	#4
	bcc	.plot
	stz	v_playerdelay
	lda	v_playerseq
	clc
	adc	#4
	sta	v_playerseq
	
	tax
	
	lda	>titlemrseq,x
	and	#$ff
	asl			; Word entrys
	tay			; (Store for Sendframe)

	lda	#^ANIMSCRATCH	;BG1MAP	; Get Bank
	sta	z_dreccount

	lda	#ANIMSCRATCH	;BG1MAP	; Get Bank
	sta	z_spridrec

	lda	#OBJBASE
	jsl	Sendframe2	; Queue it up

.plot
	jsl	Resetattr2
	jsl	Clearoam2
	ldy	z_attrcount
	ldx	v_playerseq
	lda	>titlemrseq,x
	and	#$ff
	sta	ATTRFRAME,y
	lda	>titlemrseq+2,x
	and	#$ff
	sta	ATTRX,y
	lda	>titlemrseq+3,x
	and	#$ff
	sta	ATTRY,y
	lda	#$2000
	sta	ATTROFF,y
	lda	#ANIMSCRATCH	;bg1map
	sta	ATTRDREC,y
	lda	#^ANIMSCRATCH	;BG1MAP
	sta	ATTRBANK,y
	iny
	iny
	sty	z_attrcount
	jsl	Createoam2
	rts

titlemrseq
	.dw	$0a00,$23ea,$0a00,$52e1,$0a00,$80d8,$0a00,$9dd7
	.dw	$0a01,$9dd7,$0a02,$9dd7,$0a03,$9dd7
	.dw	$0a04,$9dd7,$0a05,$9dd7,$0a06,$9dd7,$0a07,$9dd7
	.dw	$0a08,$9dd7,$0a09,$9dd7,$ffff


Getcode:
	lda	#1	; Assume code failed
	sta	v_codefailed

	lda	v_passcoderr
	beq	.scankeys

	rts
.scankeys
	jsl	ScanjoysOpt	; Scan Controllers


	; Process Debounce

	lda	z_joy1	; Get keys
	bit	#JOYPADA	; A pressed?
	bne	.chkb	; Yes -

	stz	v_acount	; No  - Clear debounce
.chkb
	bit	#JOYPADB	; B pressed?
	bne	.chkx	; Yes -

	stz	v_bcount	; No  - Clear debounce
.chkx
	bit	#JOYPADX	; X pressed?
	bne	.chky	; Yes -

	stz	v_xcount	; No  - Clear debounce
.chky
	bit	#JOYPADY	; Y pressed?
	bne	.chkcurrenta	; Yes -

	stz	v_ycount	; No  - Clear debounce
			

.chkcurrenta
	lda	z_joy1	; Get pad stats
	bne	.getcode	; Check which if active

	rts		; Else return
.getcode
	bit	#JOYPADA	; "A" key pressed?
	bne	.valdt_a	; No  - check to see if it has been...
			; ...pressed the right number of times.
	lda	v_acount	; Yes - Get debounce
	bne	.xpria	; Key still down from previous

	bit	#JOYPADL	; Qualifier pressed?
	beq	.pascoderr	; No  -

	inc		; Yes - Then indicate "A" keypressed
	sta	v_acount

	lda	v_passcode	; Get code
	and	#%00000011	; Mask for "A" keypresses
	cmp	#%00000011	; Pressed twice?
	bne	.valdt_a	; Not yet - Check sequence integretity
.pascoderr
	lda	#1	; Yes - Pressed twice, this is 3rd...
	sta	v_passcoderr	; ...- error...
.xpria
	rts		
.valdt_a			; <---> Code valid to this point <--->
	lda	v_acount	; Get debounce 
	bne	.xpria	; Key still down

	inc		; Else, indicate "A" keypressed
	sta	v_acount

	lda	v_passcode	; Get code
	and	#%00000011	; Mask for "A" keypresses
	cmp	#%00000011	; Pressed twice?
	beq	.pascoderr	; Yes - Error

	lda	v_passcode	; No  - Determine what to set it to
	and	#%00000001
	bne	.settwoa	; Set to a 2

	lda	#%00000001	; Set num taps to 1
	sta	v_passcode

	rts
.settwoa
	lda	#%00000011	; Set num taps to 2
	sta	v_passcode

	rts

.priapadok
	lda	v_passcode
	cmp	#1
	bne	.priapadoka

	lda	#%00000011
	sta	v_passcode

	jmp	.getcode
.priapadoka
	sta	v_passcode

	jmp	.getcode

.chkcurrentb

	


.last
.exit
	rts

*****************************************************************************
*
*

Loadoptscrn:
	LAI
	stz	MDMAEN

	stz	z_temp0
	jsl	Initspritedriver
	jsl	Clearoam2
	jsl	Sendobj

	pea	|titlemancsm	 ; Source
	pea	^titlemancsm
	pea	|ANIMSCRATCH	;BG1MAP	 ; Destination
	pea	^ANIMSCRATCH	;BG1MAP

	jsl	UNPACK

	pla
	pla
	pla
	pla

	; Unpack Screen Chars

	pea	|title1ccs	 ; Source
	pea	^title1ccs
	pea	|TRANSARTSCRATCH	 ; Destination
	pea	^TRANSARTSCRATCH

	jsl	UNPACK

	pla
	pla
	pla
	pla


	; VRAM Xfer for Screen Chars

	lda	#^TRANSARTSCRATCH
	sta	z_sendvrambank

	lda	#TRANSARTSCRATCH
	ldy	#$8000	
	ldx	#BG1CHAR

	jsl	Sendvram

	; Unpack Screen
	pea	|title1csm	; push low word of packed file
	pea	^title1csm	; push high word of packed file
	pea	|TRANSARTSCRATCH	; push low word of output buffer
	pea	^TRANSARTSCRATCH	; push high word of output buffer

	jsl	UNPACK	; unpack file to output buffer

	pla
	pla
	pla
	pla

	ldx	#$7fe
.copyloop
	lda	>TRANSARTSCRATCH,x
	ora	#$2000
	sta	>TRANSARTSCRATCH,x
	sta	>TRANSARTSCRATCH+$1000,x
	dex
	dex
	bpl	.copyloop

	lda	>TRANSARTSCRATCH
	ldx	#$12
.er1
	sta	>TRANSARTSCRATCH+$1414,x
	sta	>TRANSARTSCRATCH+$1454,x
	sta	>TRANSARTSCRATCH+$1498,x
	sta	>TRANSARTSCRATCH+$14d8,x
	sta	>TRANSARTSCRATCH+$151c,x
	sta	>TRANSARTSCRATCH+$155c,x
	dex
	dex
	bpl	.er1


	ldx	#BG1BASE
	lda	#TRANSARTSCRATCH+$1000
	ldy	#^TRANSARTSCRATCH
	jsl	Sendbg

	ldx	#BG2BASE
	lda	#TRANSARTSCRATCH+$800
	ldy	#^TRANSARTSCRATCH
	jsl	Sendbg

	; Copy Screen Palette(s)
	lda	#TITLE1.PALSET
	sta	z_temp0

	lda	#^TITLE1.PALSET
	sta	z_temp1

	ldy	#$FE
.palloop    
	lda	[z_temp0],y
	sta	PALETTE2,y

	dey
	dey
	bpl	.palloop

	; Copy Sprite Palette(s)
	lda	#titlemanpal
	sta	z_temp0

	lda	#^titlemanpal
	sta	z_temp1

	ldy	#$1E
.palloop2    
	lda	[z_temp0],y
	sta	PALETTE2+$100,y

	dey
	dey
	bpl	.palloop2

	; Set Modes

	SA
	lda	#$3
	sta	OBJSEL

	lda	#(BG1BASE/256)
	sta	BG1SC

	lda	#(BG2BASE/256)
	sta	BG2SC

	lda	#1
	sta	BGMODE

	lda	#$13
	sta	TM

	stz	TS	

	stz	CGSWSEL		

	stz	CGADSUB

	stz	BG12NBA

	lda	#$FF
	sta	BG1VOFS
	stz	BG1VOFS

	stz	BG1HOFS
	stz	BG1HOFS

	lda	#$DC
	sta	BG2VOFS
	stz	BG2VOFS

	lda	#$A0
	sta	BG2HOFS
	stz	BG2HOFS

	LAI

	NMION

	jsl	Fadein

	rts


*****************************************************************************
*
* Password Parser
*

vv_creakos	.equ	v_pause

Passwrdscrn:
	LAI

	lda	#0
	sta	z_hdmaenable

	SAI
	sta	MDMAEN	; Disable DMA
	sta	HDMAEN	; Disable DMA
	sta	WBGLOG
	sta	WOBJLOG

	lda	#$0
	sta	DMA2INC	; HDMA parameter

	lda	#$27	; Address $2126 = WH1
	sta	DMA2DEST

	lda	#0	; PPU registers are in bank 0
	sta	DMA2BANK	; Bank of dest address

	lda	#0	; Data Table Address
	sta	DMA2A1B	; Address Bank

	lda	>d_tpasslow	; Data Table Address
	sta	DMA2A1L	; Address Low

	lda	>d_tpasshigh	; Data Table Address
	sta	DMA2A1H	; Address High

	lda	#$4	; Enable HDMA Channel 2
	sta	z_hdmaenable

	LAI


	jsl	SFXSelect

	jsl	Loadpass1

	jsl	Initdoor	; Init Sprite Level Doors

	jsl	Createbackdrop

	jsl	Waitfornmi

	SAI

	lda	z_hdmaenable	; Enable HDMA
	sta	HDMAEN

	LAI

	jsl	Fadein

	stz	v_buttonpress	; No buttons yet

	stz	z_temp7	;row
	stz	z_temp6	;column
	stz	z_temp8
.clearit
	jsl	Clearpassword

.loop
	jsl	Waitfornmi

	ldx	#BG1BASE 	;send screen always 
	lda	#TRANSARTSCRATCH
	ldy	#^TRANSARTSCRATCH
	jsl	Sendbg

	jsl	ScanjoysOpt	; Check controller

	lda	z_joy1

	jsl	Passwordentry

	bmi	.exit

	jsl	Printpassword
	
	jsl	Flashcursor

	bra	.loop

.exit
	jsl	Printpassword

	lda	#$f
	sta	z_temp8

	jsl	Flashcursor

	jsl	Waitfornmi

	ldx	#BG1BASE 	;send screen always 
	lda	#TRANSARTSCRATCH
	ldy	#^TRANSARTSCRATCH

	jsl	Sendbg

	jsl	Comparepassword

	cmp	#2
	bcs	.goodpassword
.badpass
	lda	v_charbuffer
	and	#$ff
	bne	.clearit

	stz	z_level
	stz	z_levelword

	lda	#paff_eff

	jsl	load_Effect

	bra	.end
.goodpassword
	cmp	#22
	beq	.badpass

	sta	z_level
	asl
	sta	z_levelword

	lda	#tarzroar_eff

	jsl	load_Effect

	lda	#120
	sta	v_foedelay

	stz	vv_creakos

.doorloop
	jsl	Waitfornmi

	jsl	Sendobj

	jsl	Senddata

	ldx	z_levelword

	jsl	Animatedoor

	lda	v_foeframe
	cmp	#1
	bne	.skipcreak

	lda	vv_creakos
	bne	.skipcreak

	lda	#1
	sta	vv_creakos

	lda	#dorcrk_eff
	lda	#paff_eff
	jsl	load_Effect

.skipcreak
	lda	v_foeframe
	cmp	#6
	bcs	.end	;swing
	
	jsl	Resetattr

	jsl	Plotdoor

	jsl	Createoam

	bra	.doorloop

.endswing
	jsl	Clearoam

	jsl	Waitfornmi

	jsl	Sendobj

	ldx	#60
.endloop
	jsl	Waitfornmi

	dex
	bpl	.endloop
.end
	jsl	Fadeout	; Fade to Target Palette

	stz	vv_creakos

	ldy	#$2601
	lda	#DCOM_FADEOUT
	
	jsl	Pass_Driver_Command

	lda	#SNDTZHOME

	jsl	load_Module


	rtl

Createbackdrop:
	; Unpack Screen Chars

	pea	|passbackchr	 ; Source
	pea	^passbackchr
	pea	|SCRATCH	 ; Destination
	pea	^SCRATCH

	jsl	UNPACK

	pla
	pla
	pla
	pla


	; VRAM Xfer for Screen Chars

	lda	#^SCRATCH
	sta	z_sendvrambank

	lda	#SCRATCH
	ldy	#$1000	
	ldx	#BG3CHAR

	jsl	Waitfornmi

	jsl	Sendvram

	; Unpack Screen
	pea	|passbackscr	; push low word of packed file
	pea	^passbackscr	; push high word of packed file
	pea	|SCRATCH	; push low word of output buffer
	pea	^SCRATCH	; push high word of output buffer

	jsl	UNPACK	; unpack file to output buffer

	pla
	pla
	pla
	pla

	ldx	#BG3BASE
	lda	#SCRATCH
	ldy	#^SCRATCH

	jsl	Waitfornmi

	jsl	Sendbg

	rtl


****************************************


Clearpassword:
	stz	v_charbuffer
	stz	v_charbuffer+2
	stz	v_charbuffer+4
	stz	v_charbuffer+6
	stz	v_charbuffer+8
	rtl

Printpassword:
	ldy	#0
.loop
	lda	v_charbuffer+1,y
	and	#$ff
	sec
	sbc	#$41
	bpl	.letter
	lda	>TRANSARTSCRATCH+$2c0
	sta	z_temp0
	sta	z_temp1
	sta	z_temp2
	sta	z_temp3
	bra	.print
.letter
	asl
	tax
	lda	>.convertalpha,x
	tax
	lda	>TRANSARTSCRATCH+$A84,x
	sta	z_temp0
	lda	>TRANSARTSCRATCH+$A86,x
	sta	z_temp1
	lda	>TRANSARTSCRATCH+$Ac4,x
	sta	z_temp2
	lda	>TRANSARTSCRATCH+$Ac6,x
	sta	z_temp3
.print
	tya
	asl
	asl
	tax
	lda	z_temp0
	sta	>TRANSARTSCRATCH+$110,x	
	lda	z_temp1
	sta	>TRANSARTSCRATCH+$112,x	
	lda	z_temp2
	sta	>TRANSARTSCRATCH+$150,x	
	lda	z_temp3
	sta	>TRANSARTSCRATCH+$152,x	

	iny
	cpy	#7
	bcc	.loop
.end
	rtl

.convertalpha
	.dw	0,4,8,$c,$10
	.dw	$80,$84,$88,$8c,$90
	.dw	$100,$104,$108,$10c,$110
	.dw	$180,$184,$188,$18c,$190
	.dw	$200,$204,$208,$20c,$210
	.dw	$280

Passwordentry:
	lda	z_temp6
	sta	z_temp4
	lda	z_temp7
	sta	z_temp5

	lda	z_joy1

	jsl	Check4start

	beq	.notstart

	jmp	.endexit
.notstart
	bit	#JOYPADX
	beq	.notrub
	ldx	v_xcount
	bne	.notrub

	lda	#blopipe_eff

	jsl	load_Effect

	jmp	.rubletter
.notrub
	jsl	Check4buttons
	beq	.notadd
	jmp	.addletter
.notadd
	jsl	Check4moveleft
	bne	.moveleft
	
	jsl	Check4moveright
	bne	.moveright

	jsl	Check4moveup
	bne	.moveup

	jsl	Check4movedown
	bne	.movedown

	rtl

.moveleft
	dec	z_temp4
	bpl	.movecursor
	lda	#4
	sta	z_temp4
	bra	.movecursor
.moveright
	inc	z_temp4
	lda	z_temp4
	cmp	#5
	bcc	.moverightend
.wrapright
	stz	z_temp4
	bra	.movecursor
.moverightend
	cmp	#4
	bcc	.movecursor
	lda	z_temp5
	cmp	#5
	bne	.movecursor	
	bra	.wrapright
.moveup
	dec	z_temp5
	bpl	.movecursor
	lda	#5
	sta	z_temp5
	bra	.movecursor
.movedown
	inc	z_temp5
	lda	z_temp5
	cmp	#6
	bcc	.movecursor
	stz	z_temp5
.movecursor
	lda	z_temp5
	cmp	#5
	bcc	.notonend
	lda	z_temp4
	cmp	#4
	bcc	.notonend
	dec	z_temp4
.notonend
	stz	z_temp8
	jsl	Flashcursor 	;replot old cursor position

	lda	#4
	sta	z_temp8
	lda	z_temp4	;new cursor position
	sta	z_temp6	;is now cursor position
	lda	z_temp5	;new cursor position
	sta	z_temp7	;is now cursor position

	lda	#keypick_eff

	jsl	load_Effect

	jsl	Flashcursor	;plot cursor ay new position
.end
	lda	#0
	rtl
.endexit
	lda	#$ffff
	rtl
.addletter

	lda	#getpop1_eff

	jsl	load_Effect

	lda	z_temp7
	tax
	lda	>.convertpos,x
	and	#$ff
	clc
	adc	z_temp6
	cmp	#26
	bcs	.special
	adc	#$41
	ldy	v_charbuffer
	SAI
	sta	v_charbuffer+1,y
	LAI
	cpy	#6
	bcs	.end
	inc	v_charbuffer
	bra	.end
.special
	beq	.back
	cmp	#27
	beq	.forward
	
	bra	.endexit
.back
	SA
	lda	v_charbuffer
	dec
	bpl	.backokay
	inc
.backokay
	sta	v_charbuffer
	LA
	bra	.end
.forward
	SA
	lda	v_charbuffer
	inc
	sta	v_charbuffer
	cmp	#7
	bcc	.forwardokay
	dec
.forwardokay
	sta	v_charbuffer
	LA
	bra	.end
.rubletter
	SAI
	ldy	v_charbuffer
.rubloop
	lda	v_charbuffer+2,y
	sta	v_charbuffer+1,y
	iny
	cpy	#7
	bcc	.rubloop
	LAI
	bra	.end
.convertpos
	.db	0,5,10,15,20,25


Flashcursor:
	lda	z_temp7
	asl
	asl
	asl
	asl
	asl
	ora	z_temp6
	asl
	asl
	tax
	
	dec	z_temp8
	lda	z_temp8
	and	#$1f
	cmp	#10
	bcc	.clearcursor

	lda	>TRANSARTSCRATCH+$A84,x
	sta	>TRANSARTSCRATCH+$284,x
	lda	>TRANSARTSCRATCH+$A86,x
	sta	>TRANSARTSCRATCH+$286,x
	lda	>TRANSARTSCRATCH+$Ac4,x
	sta	>TRANSARTSCRATCH+$2c4,x
	lda	>TRANSARTSCRATCH+$Ac6,x
	sta	>TRANSARTSCRATCH+$2c6,x

	bra	.end
.clearcursor
	lda	>TRANSARTSCRATCH+$2c0
	sta	>TRANSARTSCRATCH+$284,x
	sta	>TRANSARTSCRATCH+$286,x
	sta	>TRANSARTSCRATCH+$2c4,x
	sta	>TRANSARTSCRATCH+$2c6,x

	lda	v_charbuffer
	and	#$ff
	asl
	asl
	clc
	tax
	lda	>TRANSARTSCRATCH+$d0c
	sta	>TRANSARTSCRATCH+$110,x
	lda	>TRANSARTSCRATCH+$d0e
	sta	>TRANSARTSCRATCH+$112,x
	lda	>TRANSARTSCRATCH+$d48
	sta	>TRANSARTSCRATCH+$150,x
	lda	>TRANSARTSCRATCH+$d4a
	sta	>TRANSARTSCRATCH+$152,x
.end
	lda	z_temp7
	cmp	#5
	bne	.exit
	lda	z_temp6
	cmp	#3
	bne	.exit
	inc	z_temp6
	inc	z_temp8
	jsl	Flashcursor
	dec	z_temp6
.exit
	rtl

Comparepassword:
	lda	#Passwords
	sta	z_temp0
	lda	#^Passwords
	sta	z_temp1
	lda	#21	;number of passwords
	sta	z_temp2
.loop0
	SA
	ldy	#0
.loop1
	lda	v_charbuffer+1,y
	beq	.endword
	cmp	[z_temp0],y
	bne	.nextword
	iny
	cpy	#7
	bcc	.loop1
	bra	.exit
.endword
	lda	[z_temp0],y
	beq	.exit
	cmp	#$20
	beq	.exit
.nextword
	dec	z_temp2
	beq	.exit
	LA
	lda	z_temp0
	clc
	adc	#8
	sta	z_temp0
	bra	.loop0
.exit
	LA
	lda	z_temp2
	inc
	rtl

Passwords:
	.db	'NOPASS ',0	;lev 22 - BONUS
	.db	'CREDITS',0	;lev 21 - BONUS
	.db	'KREEGOR',0	;lev 20 - SHAMONBOSS
	.db	'TANTOR ',0	;lev 19 - OPARTEMPLE
	.db	'NOPASS ',0	;lev 18 - OPARWELLS
	.db	'BUNDOLO',0	;lev 17 - OPARSTREET
	.db	'NOPASS ',0	;lev 16 - CAVERNS - (KANDO)
	.db	'MEETA  ',0	;lev 15 - WATERFALL
	.db	'GOMLUL ',0	;lev 14 - UPRIVER
	.db	'HORTA  ',0	;lev 13 - JUNGLE4
	.db	'GIMLA  ',0	;lev 12 - DOWNRIVER
	.db	'HISTAH ',0	;lev 11 - JUNGLE3
	.db	'NOPASS ',0	;lev 10 - No level
	.db	'NOPASS ',0	;lev 9  - No level
	.db	'ABALA  ',0	;lev 8  - SHIP
	.db	'SABOR  ',0	;lev 7  - REEF - (SABOR)
	.db	'NOPASS ',0	;lev 6  - No level
	.db	'LUL    ',0	;lev 5  - BEACH
	.db	'KAGODA ',0	;lev 4  - SWAMP
	.db	'MANGANI',0	;lev 3  - CLEARING
	.db	'DENWALA',0	;lev 2  - TZANHOME

Initdoor:
	lda	#$ffff
	sta	v_foeframe
	stz	v_foedelay

	stz	z_levelx
	stz	z_levely
	stz	v_xfercount   	;clear number of objects to be sent

	lda	#tzfallonly
	sta	v_playernewtype
	lda	#$ffff
	sta	v_playertype
	stz	v_playerdelay

	stz	v_playerx
	stz	v_playery
	stz	v_playeroldy

	jsl	Initdoorvram

	jsl	Doorpal

	rtl

Initdoorvram:
	jsl	Animatedoor
	jsl	Senddata
	
	jsl	Resetattr
	jsl	Plotdoor
	jsl	Createoam
	jsl	Sendobj
	rtl

Animatedoor:
	lda	v_playertype
	cmp	#tzfallonly
	bne	.land
	inc	v_playerx
	lda	v_playeroldy
	cmp	#(MAXVELOCITY*4)
	bcs	.dofall
	inc
	inc
	sta	v_playeroldy
.dofall
	clc
	adc	v_playery
	sta	v_playery
	cmp	#864
	bcc	.delay
	lda	#864
	sta	v_playery
	lda	#tzlandmode00
	sta	v_playernewtype
	bra	.delay
.land
	cmp	#tzlandmode00
	bne	.walk
	lda	v_playerdelay
	bne	.delay
	lda	v_playerseqlog
	cmp	#4
	bcc	.delay
	lda	#tzwalk3mode00
	sta	v_playernewtype
	bra	.delay
.walk

	cmp	#tzwalk3mode00
	bne	.walkaway
	inc	v_playerx
  	lda	v_playerx
	bmi	.delay
	cmp	#150
	bcc	.delay
	lda	#tzwkawaymode00
	sta	v_playernewtype
	bra	.delay
.walkaway
.delay     
	dec	v_playerdelay
	bmi	.newframe

	jmp	.door

.newframe
	lda	v_playernewtype	; Want to do different sequence?
	cmp	v_playertype	; Yes - Same as current sequence?
	beq	.nextframe	;   Yes - Just do next next frame then

	sta	v_playertype	;   No  - Store new type
	tay			; Create index

	stz	v_playerseq	; Clear sequence data index
	stz	v_playerseqlog	; Clear sequence data index

	lda	d_playerbank,y	; Get data bank
	sta	v_playerbank	; Store
	sta	z_temp1

	lda	d_playerseq,y	; Get relative offset
	sta	z_temp0

	ldy	#0		; Point to 1st frame in sequence
	lda	[z_temp0],y	; Get the data

	bra	.frame	; Continue processing frame info

.nextframe
	ldy	v_playertype	; Get Type

	lda	d_playerbank,y	; Get Bank
	sta	v_playerbank	; Store
	sta	z_temp1

	lda	d_playerseq,y	; Get sequence offset
	sta	z_temp0

	lda	v_playerseq	; Get sequence pointer
	clc
	adc	#4		; Point to next frame data entry
	sta	v_playerseq	; Store it

	tay			; Index
	lsr
	lsr
	sta	v_playerseqlog	; Clear sequence data index

	lda	[z_temp0],y	; Get frame data
	bpl	.frame	; If not end of seq, then frame...

	stz	v_playerseq	; Otherwise, zero out frame pointer
	stz	v_playerseqlog	; Clear sequence data index

	lda	[z_temp0]	; Get 1st frame info
.frame
	sta	v_playerframe	; Store both frm# & time for now

	xba		; Switch frm# & frame time
	and	#$3f	; Limit value to 32
	asl
	tay		; Create index

	lda	d_delconv,y	; Convert from frames/sec to 1/60th
	sta	v_playerdelay	; Delay for this frame

	lda	v_playerframe	; Get frame data back
	and	#$FF	; Just the frame number
	sta	v_playerframe	; Store it

	asl		; Word entrys
	tay		; (Store for Sendframe)

	ldx	v_playertype	; Get Type

	lda	v_playerbank	; Get Bank
	sta	z_dreccount

	lda	d_playerdrec,x	; Get sprite table loc of anim
	sta	v_playerdrec	; Store
	sta	z_spridrec

	lda	#(OBJBASE+$800)
	jsl	Sendframe	; Queue it up
.door
	dec	v_foedelay
	bpl	.end
	lda	#5
	sta	v_foedelay

	inc	v_foeframe
	lda	v_foeframe
	cmp	#5
	bcc	.plot
	lda	#90
	sta	v_foedelay
	bra	.end
.plot
	asl
	tay
	lda	#^door
	sta	z_dreccount
	lda	#door
	sta	z_spridrec
	lda	#OBJBASE
	jsl	Sendframe	;call send frame routine to set up xfer info
.end
	rtl

Plotdoor:
	ldy	z_attrcount

	lda	v_playerx
	sta	ATTRX,y
	lda	v_playery
	lsr
	lsr
	sec
	sbc	#$10
	sta	ATTRY,y
	lda	v_playertype
	tax
	lda	d_playerdrec,x
	sta	ATTRDREC,y
	lda	d_playerbank,x
	sta	ATTRBANK,y	
	lda	v_playerframe
	sta	ATTRFRAME,y
	lda	#$3280
	sta	ATTROFF,y
	iny
	iny

	lda	v_foeframe
	cmp	#5
	bcs	.end

	lda	#128
	sta	ATTRX,y
	lda	#192
	sta	ATTRX+2,y
	lda	#190
	sta	ATTRY,y
	sta	ATTRY+2,y
	lda	#door
	sta	ATTRDREC,y
	sta	ATTRDREC+2,y
	lda	#^door
	sta	ATTRBANK,y	
	sta	ATTRBANK+2,y	
	lda	v_foeframe
	sta	ATTRFRAME,y
	sta	ATTRFRAME+2,y
	lda	#$2000
	sta	ATTROFF,y
	lda	#$6000
	sta	ATTROFF+2,y
	iny
	iny
	iny
	iny
.end
	sty	z_attrcount
	rtl
	
Doorpal:
	lda	#DOOR.PALSET
	sta	z_temp0
	lda	#^DOOR.PALSET
	sta	z_temp1
	ldy	#$1e
.loop
	lda	[z_temp0],y
	sta	PALETTE2+$100,y
	dey
	dey
	bpl	.loop

	lda	#TZAN.PALSET
	sta	z_temp0
	lda	#^TZAN.PALSET
	sta	z_temp1
	ldy	#$1e
.loop2
	lda	[z_temp0],y
	sta	PALETTE2+$120,y
	dey
	dey
	bpl	.loop2
	rtl
	

Loadpass1:
	jsl	Waitfornmi
	lda	#BG2BASE
	jsl	Clrbg

	jsl	Waitfornmi
	lda	#BG3BASE
	jsl	Clrbg


	; Unpack Screen Chars

	pea	|password.ccs	 ; Source
	pea	^password.ccs
	pea	|TRANSARTSCRATCH	 ; Destination
	pea	^TRANSARTSCRATCH

	jsl	UNPACK

	pla
	pla
	pla
	pla


	; VRAM Xfer for Screen Chars

	lda	#^TRANSARTSCRATCH
	sta	z_sendvrambank

	lda	#TRANSARTSCRATCH
	ldy	#$8000	
	ldx	#BG1CHAR

	jsl	Sendvram

	; Unpack Screen
	pea	|password.clm	; push low word of packed file
	pea	^password.clm	; push high word of packed file
	pea	|TRANSARTSCRATCH	; push low word of output buffer
	pea	^TRANSARTSCRATCH	; push high word of output buffer

	jsl	UNPACK	; unpack file to output buffer

	pla
	pla
	pla
	pla

	ldx	#$7FE	; Set priority
.copyscreen
	lda	>TRANSARTSCRATCH,x
	ora	#$2000
	sta	>TRANSARTSCRATCH,x
	sta	>TRANSARTSCRATCH+$800,x
	dex
	dex
	bpl	.copyscreen

	; Copy Screen to BG1
	ldx	#BG1BASE
	lda	#TRANSARTSCRATCH
	ldy	#^TRANSARTSCRATCH
	jsl	Sendbg

.dopals
	; Copy Screen Palette(s)
	lda	#password.pal
	sta	z_temp0

	lda	#^password.pal
	sta	z_temp1

	ldy	#$FE
.palloop    
	lda	[z_temp0],y
	sta	PALETTE2,y

	dey
	dey
	bpl	.palloop

	; Set Modes

	SA

	lda	#3
	sta	OBJSEL

	lda	#(BG1BASE/256)
	sta	BG1SC

	lda	#(BG2BASE/256)
	sta	BG2SC

	lda	#(BG3BASE/256)
	sta	BG3SC

	lda	#$1
	sta	BGMODE

	lda	#$15
	sta	TM

	stz	TS	

	stz	CGSWSEL		

	stz	CGADSUB

	lda	#BG3CHAR >> 12
	sta	BG34NBA

	lda	#DIVIDED
	sta	BG12NBA

	lda	#$ff
	sta	BG1VOFS
	stz	BG1VOFS

	stz	BG1HOFS
	stz	BG1HOFS

	sta	BG2VOFS
	sta	BG2VOFS

	stz	BG2HOFS
	stz	BG2HOFS

	lda	#$CD
	sta	BG3VOFS
	stz	BG3VOFS

	lda	#$CD
	sta	BG3HOFS
	stz	BG3HOFS

	lda	#$3
	sta	WOBJSEL	; Enable Window 1 on OBJ's

	lda	#0	; Set left side to 0
	sta	WH0
	sta	WH1

	LAI

	NMION

	rtl


*****************************************************************************
*
* Config controller


Cnfcontroller:

	LAI
	stz	MDMAEN

	jsl	SFXSelect

	jsl	Loadcntrl1

.loop
	jsl	Waitfornmi

	ldx	#BG1BASE	;send overlay screen every time
	lda	#TRANSARTSCRATCH	;just in case it was rebuilt
	ldy	#^TRANSARTSCRATCH
	jsl	Sendbg

	jsl	ScanjoysOpt

	lda	z_joy1

	jsl	Check4start	;exit if start pressed

	beq	.noexit

	lda	#tarzroar_eff

	jsl	load_Effect

	jmp	.exit
.noexit

	jsl	Check4buttons	;abxy to modify item
	beq	.chk04mr

	lda	#grab2_eff
	jsl	load_Effect

	jmp	.changeplus
.chk04mr
	jsl	Check4moveright	;right to modify item
	beq	.chk04ml

	lda	#grab2_eff
	jsl	load_Effect

	jmp	.changeplus
.chk04ml
	jsl	Check4moveleft	;left to modify item
	beq	.chk04mu

	lda	#grab2_eff
	jsl	load_Effect

	jmp	.changeminus
.chk04mu
	jsl	Check4moveup	;up to select previous item
	beq	.chk04md

	lda	#keypick_eff
	jsl	load_Effect

	jmp	.moveup
.chk04md
	jsl	Check4movedown	;down and select to select next item
	beq	.loop

	lda	#keypick_eff
	jsl	load_Effect

	jmp	.movedown

.changeplus
	lda	v_contrlmap
	and	#$300
	bne	.changeother

	lda	v_contrlmap
	and	#$7ffc
	sta	z_temp0
	lda	v_contrlmap
	and	#3
	inc
	cmp	#3
	bcc	.remakepad
	lda	#0
	bra	.remakepad
.changeother
	cmp	#$100
	bne	.changemusic

	lda	#4
	eor	v_contrlmap
	sta	v_contrlmap
	brl	.rebuild
.changemusic
	lda	#8
	eor	v_contrlmap
	sta	v_contrlmap
	bra	.rebuild
.changeminus
	lda	v_contrlmap
	and	#$300
	bne	.changeother

	lda	v_contrlmap
	and	#$7ffc
	sta	z_temp0
	lda	v_contrlmap
	and	#3
	dec
	bpl	.remakepad
	lda	#2
.remakepad
	ora	z_temp0
	sta	v_contrlmap
	bra	.rebuild
.movedown
	lda	v_contrlmap
	and	#$f
	sta	z_temp0
	lda	v_contrlmap
	and	#$300
	xba
	dec
	bpl	.remakeopt
	lda	#2
	bra	.remakeopt
.moveup
	lda	v_contrlmap
	and	#$f
	sta	z_temp0
	lda	v_contrlmap
	and	#$300
	xba
	inc
	cmp	#3
	bcc	.remakeopt
	lda	#0
.remakeopt
	xba
	ora	z_temp0
	sta	v_contrlmap
	bra	.rebuild
.exit
	lda	v_contrlmap
	and	#$f
	sta	v_contrlmap

	jsl	Fadeout
	rtl

	ldx	#$1FE	; Otherwise fade this logo out
.palclrloop    
	stz	PALETTE2,x	; Build Target Palette for Clearing

	dex
	dex
	bpl	.palclrloop

	jsl	Colfade	; Fade to Target Palette

	jsl	Ctrlremap	; Remap controller keys

	rtl
.rebuild
	jsl	Buildscreen
	jmp	.loop

Check4buttons:
	bit	#JOYPADA
	beq	.b
	ldx	v_acount
	beq	.button
.b
	bit	#JOYPADB
	beq	.x
	ldx	v_bcount
	beq	.button
.x
	bit	#JOYPADX
	beq	.y
	ldx	v_xcount
	beq	.button
.y
	bit	#JOYPADY
	beq	.nobutton
	ldx	v_ycount
	beq	.button
.nobutton
	ldx	#0
	rtl
.button
	ldx	#1
	rtl

Check4xy:
	bit	#JOYPADX
	beq	.y
	ldx	v_xcount
	beq	.button
.y
	bit	#JOYPADY
	beq	.nobutton
	ldx	v_ycount
	beq	.button
.nobutton
	ldx	#0
	rtl
.button
	ldx	#1
	rtl

Check4ab:
	bit	#JOYPADA
	beq	.b
	ldx	v_acount
	beq	.button
.b
	bit	#JOYPADB
	beq	.nobutton
	ldx	v_bcount
	beq	.button
.nobutton
	ldx	#0
	rtl
.button
	ldx	#1
	rtl

Check4moveup:
	bit	#JOYPADUP
	beq	.nobutton
	ldx	v_upcount
	beq	.button
.nobutton
	ldx	#0
	rtl
.button
	ldx	#1
	rtl

Check4movedown:
	bit	#JOYPADDOWN
	beq	.sel
	ldx	v_downcount
	beq	.button
.sel
	bit	#JOYPADSELECT
	beq	.nobutton
	ldx	v_selectcount
	beq	.button
.nobutton
	ldx	#0
	rtl
.button
	ldx	#1
	rtl

Check4start:
	bit	#JOYPADSTART
	beq	.nobutton
	ldx	v_startcount
	beq	.button
.nobutton
	ldx	#0
	rtl
.button
	ldx	#1
	rtl

Check4moveleft:
	bit	#JOYPADLEFT
	beq	.nobutton
	ldx	v_leftcount
	beq	.button
.nobutton
	ldx	#0
	rtl
.button
	ldx	#1
	rtl

Check4moveright:
	bit	#JOYPADRIGHT
	beq	.nobutton
	ldx	v_rightcount
	beq	.button
.nobutton
	ldx	#0
	rtl
.button
	ldx	#1
	rtl


;contrlmap
;	bit value = 8421/8421/8421/8421
;	bit name  = ..../..hh/..../mscc
;	------------------
;	cc = controlmap selected
;	s  = sound off
;	m  = music off
;	hh = hilited area 0=c,1=s,2=m

Buildscreen:
	lda	v_contrlmap
	and 	#3
	asl
	sta	z_temp0
	lda	v_contrlmap
	and	#$300
	bne	.nohilite
	inc	z_temp0
.nohilite
	lda	z_temp0
	xba
	asl
	asl
	asl
	tay
	lda	#(TRANSARTSCRATCH+$800)
	sta	z_temp2
	lda	#^TRANSARTSCRATCH
	sta	z_temp3
	ldx	#0
.padloop
	lda	[z_temp2],y
	sta	>TRANSARTSCRATCH+$200,x
	iny
	iny
	inx
	inx
	cpx	#$600
	bcc	.padloop

	lda	v_contrlmap
	and	#4
	lsr
	sta	z_temp0
	lda	v_contrlmap
	and	#$300
	cmp	#$100
	bne	.nohilite2
	inc	z_temp0
.nohilite2
	lda	z_temp0
	xba
	asl
	tay
	lda	#(TRANSARTSCRATCH+$3820)
	sta	z_temp2
	ldx	#0
.soundloop
	lda	[z_temp2],y
	sta	>TRANSARTSCRATCH+$20,x
	iny
	iny
	inx
	inx
	txa
	and	#$1f
	bne	.soundloop
	tya
	clc
	adc	#$20
	tay
	txa
	clc
	adc	#$20
	tax
	cmp	#$200
	bcc	.soundloop

	lda	v_contrlmap
	and	#8
	lsr
	lsr
	sta	z_temp0
	lda	v_contrlmap
	and	#$300
	cmp	#$200
	bne	.nohilite3
	inc	z_temp0
.nohilite3
	lda	z_temp0
	xba
	asl
	tay
	lda	#(TRANSARTSCRATCH+$3800)
	sta	z_temp2
	ldx	#0
.musicloop
	lda	[z_temp2],y
	sta	>TRANSARTSCRATCH,x
	iny
	iny
	inx
	inx
	txa
	and	#$1f
	bne	.musicloop
	tya
	clc
	adc	#$20
	tay
	txa
	clc
	adc	#$20
	tax
	cmp	#$200
	bcc	.musicloop

	rtl

	

Loadcntrl1:
	BLANKON
	NMIOFF


	; Unpack Screen Chars for paddle

	pea	|options.ccs	 ; Source
	pea	^options.ccs
	pea	|TRANSARTSCRATCH	 ; Destination
	pea	^TRANSARTSCRATCH

	jsl	UNPACK

	pla
	pla
	pla
	pla


	; VRAM Xfer for Screen Chars

	lda	#^TRANSARTSCRATCH
	sta	z_sendvrambank

	lda	#TRANSARTSCRATCH
	ldy	#$8000	
	ldx	#BG1CHAR

	jsl	Sendvram

	; Unpack Screen
	pea	|options.clm	; push low word of packed file
	pea	^options.clm	; push high word of packed file
	pea	|TRANSARTSCRATCH	; push low word of output buffer
	pea	^TRANSARTSCRATCH	; push high word of output buffer

	jsl	UNPACK	; unpack file to output buffer

	pla
	pla
	pla
	pla

	; Copy Screen to BG2
	ldx	#BG2BASE
	lda	#TRANSARTSCRATCH
	ldy	#^TRANSARTSCRATCH
	jsl	Sendbg

	jsl	Buildscreen

	ldx	#BG1BASE
	lda	#TRANSARTSCRATCH	;+$800
	ldy	#^TRANSARTSCRATCH
	jsl	Sendbg

	; Copy Screen Palette(s)
	lda	#options.pal
	sta	z_temp0

	lda	#^options.pal
	sta	z_temp1

	ldy	#$FE
.palloop    
	lda	[z_temp0],y
	sta	PALETTE2,y

	dey
	dey
	bpl	.palloop


	; Set Modes

	SAI

	lda	#(BG1BASE/256)
	sta	BG1SC

	lda	#(BG2BASE/256)
	sta	BG2SC

	lda	#$9
	sta	BGMODE

	lda	#3
	sta	TM
	stz	TS	

	lda	#$00
	sta	CGSWSEL		

	lda	#$00
	sta	CGADSUB

	stz	BG12NBA
	
	lda	#$ff

	sta	BG1VOFS
	stz	BG1VOFS

	stz	BG1HOFS
	stz	BG1HOFS

	lda	#$90

	sta	BG2VOFS
	stz	BG2VOFS

	lda	#$d0

	sta	BG2HOFS
	stz	BG2HOFS

	LAI

	NMION

	jsl	Fadein

	rtl


ScanjoysOpt:
	SAI		; Set 8 bit addr & index mode

	ldx	#$01
	stx	$4016	; toggle the scan to happen

	dex
	stx	$4016

	ldx	#16	; do 16 bits
.loop
	lda	$4016	; get bit for joypad 1 from register
	lsr		; move bit into carry
	rol	z_temp0	; move bit into variable
	rol	z_temp0+1

	lda	$4017	; get bit for joypad 2 from register
	lsr		; move bit into carry
	rol	z_temp1	; move bit into variable
	rol	z_temp1+1

	dex		; check counter

	bne	.loop
.end  
	LAI

	lda	z_temp1
	eor	z_joy2
	sta	z_temp2

	lda	z_temp1
	sta	z_joy2

	lda	z_temp0
	eor	z_joy1
	sta	z_temp1

	lda	z_temp0
	sta	z_joy1

	lda	z_temp1
	ldx	#0
.loop1
	asl
	bcs	.clear1

	inc	v_bcount,x
	bpl	.next1

	dec	v_bcount,x

	bra	.next1
.clear1
	stz	v_bcount,x
.next1
	inx
	inx
	cpx	#24
	bcc	.loop1

;	lda	z_temp2
;	ldx	#0
;.loop2
;	asl
;	bcs	.clear2
;	inc	v_bcount2,x
;	bpl	.next2
;	dec	v_bcount2,x
;	bra	.next2
;.clear2
;	stz	v_bcount2,x
;.next2
;	inx
;	inx
;	cpx	#24
;	bcc	.loop2

	rtl

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;
;; lift jane sequence screen
;;
;;

Liftjane:	 
	jsr	Loadliftjane

	stz	z_levelx
	stz	z_levely
	lda	#$fffc
	sta	v_playerseq
	lda	#2000
	sta	v_playerdelay
	lda	#$2100
	sta	v_playeroff
	stz	v_xfercount

	ldy	#0
	lda	#^oldguy	; Get Bank
	sta	z_dreccount
	lda	#oldguy	; Get Bank
	sta	z_spridrec
	lda	#OBJBASE+$c00
	jsl	Sendframe2	; Queue it up
	jsl	Senddata2

	jsr	Preparenextjane
	jsr	Sendnextjanea
	jsr	Sendnextjaneb

	jsr	Plotliftjane

	jsl	Sendobj

	ldx	#16	
	jsr	Introprint

	lda	#introhdmatable4
	sta	DMA4A1L	
	SA
	lda	#^introhdmatable4
	sta	DMA4A1B
	lda	#$0
	sta	DMA4INC
	lda	#<TM
	sta	DMA4DEST 
	stz	DMA4BANK
	lda	#$f0
	sta	HDMAEN
	LA

	lda	#20
	sta	v_startcount

	NMION
	jsl	Fadein

	;	ldx	#60
.waitloop
	jsl	Waitfornmi
	jsr	Introscroll
	bcs	.loop
	bpl	.waitloop
.loop
	jsr	Preparenextjane

	jsr	Plotliftjane
	
	jsl	Waitfornmi
	jsr	Sendnextjanea
	jsl	Waitfornmi
	jsr	Sendnextjaneb
	jsl	Sendobj

	jsl	Waitfornmi

	ldx	v_playerseq
	cpx	#48
	bcc	.loop

	ldx	#180
.waitloop2
	jsl	Waitfornmi
	dex
	bpl	.waitloop2

	jsl	Fadeout
	stz	MDMAEN

	rtl

		
Sendnextjanea:
	lda	v_xferbank
	sta	z_sendvrambank

	lda	v_xferloc

	ldy	#$c00

	ldx	v_xferdest

	jsl	Sendvram

	rts

Sendnextjaneb:
	lda	v_xferlen
	sec
	sbc	#$c00
	sta	v_xferlen
	lda	v_xferloc
	clc
	adc	#$c00
	sta	v_xferloc
	lda	v_xferdest
	clc
	adc	#$600
	sta	v_xferdest

	jsl	Senddata2

	rts

Preparenextjane:
	lda	v_playeroff
	eor	#$100
	sta	v_playeroff

	lda	v_playerseq
	clc
	adc	#4
	sta	v_playerseq
	tax
	cpx	#28
	bcc	.seq
	bne	.normal

	pea	|liftjan2csm	 ; Source
	pea	^liftjan2csm
	pea	|ANIMSCRATCH	 ; Destination
	pea	^ANIMSCRATCH

	jsl	UNPACK

	pla
	pla
	pla
	pla

	ldx	#28
.normal
	inx
	inx
.seq
	lda	>liftjan1seq00,x
	and	#$ff
	asl
	tay

	lda	#^ANIMSCRATCH	; Get Bank
	sta	z_dreccount

	lda	#ANIMSCRATCH	; Get Bank
	sta	z_spridrec

	lda	v_playeroff
	and	#$100
	asl
	asl
	asl
	asl
	clc
	adc	#OBJBASE
	
	jsl	Sendframe2	; Queue it up

	rts

Plotliftjane:
	jsl	Resetattr2
	jsl	Clearoam2

	ldy	z_attrcount

	lda	#0
	sta	ATTRFRAME,y
	lda	#$d6
	sta	ATTRX,y
	lda	#$86
	sta	ATTRY,y
	lda	#$22c0
	sta	ATTROFF,y
	lda	#oldguy
	sta	ATTRDREC,y
	lda	#^oldguy
	sta	ATTRBANK,y
	iny
	iny

	ldx	v_playerseq
	cpx	#28
	bcc	.seq
	inx
	inx
.seq
	lda	>liftjan1seq00,x
	and	#$ff
	sta	ATTRFRAME,y
	lda	#$6e
	sta	ATTRX,y
	lda	#$7c
	sta	ATTRY,y
	lda	v_playeroff
	sta	ATTROFF,y
	lda	#ANIMSCRATCH
	sta	ATTRDREC,y
	lda	#^ANIMSCRATCH
	sta	ATTRBANK,y
	iny
	iny
	sty	z_attrcount

	jsl	Createoam2
	
	rts

*****************************************************************************
*
*

Loadliftjane:
	LAI
	stz	MDMAEN

	stz	z_temp0
	jsl	Initspritedriver
	jsl	Clearoam2
	jsl	Sendobj

	; Unpack Screen Chars

	pea	|tempwinccs	 ; Source
	pea	^tempwinccs
	pea	|TRANSARTSCRATCH	 ; Destination
	pea	^TRANSARTSCRATCH

	jsl	UNPACK

	pla
	pla
	pla
	pla


	; VRAM Xfer for Screen Chars

	lda	#^TRANSARTSCRATCH
	sta	z_sendvrambank

	lda	#TRANSARTSCRATCH
	ldy	#$8000	
	ldx	#BG1CHAR

	jsl	Sendvram

	; Unpack Screen
	pea	|tempwincsm	; push low word of packed file
	pea	^tempwincsm	; push high word of packed file
	pea	|TRANSARTSCRATCH	; push low word of output buffer
	pea	^TRANSARTSCRATCH	; push high word of output buffer

	jsl	UNPACK	; unpack file to output buffer

	pla
	pla
	pla
	pla

	ldx	#BG1BASE
	lda	#TRANSARTSCRATCH
	ldy	#^TRANSARTSCRATCH
	jsl	Sendbg

	pea	|liftjan1csm	 ; Source
	pea	^liftjan1csm
	pea	|ANIMSCRATCH	 ; Destination
	pea	^ANIMSCRATCH

	jsl	UNPACK

	pla
	pla
	pla
	pla

	; Copy Screen Palette(s)
	lda	#tempwinpal
	sta	z_temp0

	lda	#^tempwinpal
	sta	z_temp1

	ldy	#$1e
.palloop    
	lda	[z_temp0],y
	sta	PALETTE2+$60,y

	dey
	dey
	bpl	.palloop

	; Copy Sprite Palette(s)
	lda	#liftjanpal
	sta	z_temp0

	lda	#^liftjanpal
	sta	z_temp1

	ldy	#$1E
.palloop2    
	lda	[z_temp0],y
	sta	PALETTE2+$100,y

	dey
	dey
	bpl	.palloop2

	lda	#oldguypal
	sta	z_temp0

	lda	#^oldguypal
	sta	z_temp1

	ldy	#$1E
.palloop3    
	lda	[z_temp0],y
	sta	PALETTE2+$120,y

	dey
	dey
	bpl	.palloop3
	; Set Modes

	SA
	lda	#$3
	sta	OBJSEL

	lda	#(BG1BASE/256)+1
	sta	BG1SC

	lda	#(BG2BASE/256)
	sta	BG2SC

	lda	#1
	sta	BGMODE

	lda	#$11
	sta	TM

	stz	TS	

	stz	CGSWSEL		

	stz	CGADSUB

	stz	BG12NBA

	lda	#$ff
	sta	BG1VOFS
	stz	BG1VOFS

	stz	BG1HOFS
	stz	BG1HOFS

	sta	BG2VOFS
	stz	BG2VOFS

	stz	BG2HOFS
	stz	BG2HOFS

	LAI

	rts


*****************************************************************************

Introscreens:
	LAI

	jsl	Initjoys	; Clear key debounce

	stz	z_joy1

	lda	#100
	sta	z_temp8

	ldx	#0
	jsr	Loadintroscreen

	ldx	#20	;22
	jsr	Loadintroscreen

	ldx	#0
	jsr	Introprint

	NMION

	jsl	Fadein
.wait
	jsl	ScanjoysOpt
	jsl	Waitfornmi
	jsr	Introscroll
	bcc	.ckwait

	jmp	.fadeaway
.ckwait
	bpl	.wait

	jsl	Fadeout

;	NMIOFF

	stz	MDMAEN

	ldx	#2
	jsr	Loadintroscreen

	ldy	#^TRANSARTSCRATCH
	lda	#TRANSARTSCRATCH+$800
	ldx	#BG1BASE
	jsl	Sendbg
	
	ldx	#20	;22
	jsr	Loadintroscreen

	ldx	#2
	jsr	Introprint

	NMION

	jsl	Fadein
.wait1
	jsl	ScanjoysOpt
	jsl	Waitfornmi
	jsr	Introscroll
	bcc	.ckwait1

	jmp	.fadeaway
.ckwait1
	bpl	.wait1

	jsl	Fadeout

	stz	MDMAEN

	ldx	#4
	jsr	Loadintroscreen
	
	SA
	lda	#1
	sta	TM
	LA

	ldx	#4
	jsr	Introprint
	
	NMION
	jsl	Fadein
.wait2
	jsl	ScanjoysOpt
	jsl	Waitfornmi
	jsr	Introscroll
	bcc	.ckwait2

	jmp	.fadeaway
.ckwait2
	bpl	.wait2

	jsl	Fadeout
	stz	MDMAEN

	ldx	#6
	jsr	Loadintroscreen
	ldx	#8
	jsr	Loadintroscreen
	
	ldx	#6
	jsr	Introprint
	
	NMION
	jsl	Fadein
.wait3
	jsl	ScanjoysOpt
	jsl	Waitfornmi
	jsr	Introscroll
	bcc	.ckwait3

	jmp	.fadeaway
.ckwait3
	bpl	.wait3

	jsl	Fadeout
	stz	MDMAEN

	ldx	#20
	jsr	Loadintroscreen

	ldx	#2
	jsr	Loadintroscreen

	ldy	#^TRANSARTSCRATCH
	lda	#TRANSARTSCRATCH+$800
	ldx	#BG1BASE
	jsl	Sendbg

	ldx	#8
	jsr	Introprint
	
	NMION
	jsl	Fadein
	lda	z_temp8
	sec
	sbc	#15		;60
	sta	z_temp8	;z_temp7
;	lda	#60
;	sta	z_temp8
.wait4
	jsl	ScanjoysOpt
	jsl	Waitfornmi
	jsr	Introscroll
	bpl	.wait4

	lda	z_joy1
	bit	#JOYPADSTART
	beq	.lifthead
	lda	v_startcount
	beq	.fade4

.lifthead			  	
	ldy	#^TRANSARTSCRATCH
	lda	#TRANSARTSCRATCH
	ldx	#BG1BASE
	jsl	Sendbg

	lda	#15	;lda	z_temp7
	sta	z_temp8
.wait4a
	jsl	ScanjoysOpt
	jsl	Waitfornmi
	jsr	Introscroll
	bcc	.ckwait6

	jmp	.fadeaway
.ckwait6
	bpl	.wait4a
.fade4
	jsl	Fadeout
	stz	MDMAEN


	ldx	#10
	jsr	Loadintroscreen
	
	ldx	#8
	jsr	Loadintroscreen
	
	ldx	#10
	jsr	Introprint
	
	NMION
	jsl	Fadein
.wait5
	jsl	ScanjoysOpt
	jsl	Waitfornmi
	jsr	Introscroll
	bcs	.fadeaway
	bpl	.wait5

	jsl	Fadeout
	stz	MDMAEN


	ldx	#12
	jsr	Loadintroscreen
	
	ldx	#8
	jsr	Loadintroscreen
	
	ldx	#12
	jsr	Introprint
	
	NMION
	jsl	Fadein
.wait6
	jsl	ScanjoysOpt
	jsl	Waitfornmi
	jsr	Introscroll
	bcs	.fadeaway
	bpl	.wait6

	jsl	Fadeout
	stz	MDMAEN

	ldx	#20
	jsr	Loadintroscreen

	ldx	#2
	jsr	Loadintroscreen
	
	ldx	#14
	jsr	Introprint
	
	NMION
	jsl	Fadein
.wait7
	jsl	ScanjoysOpt
	jsl	Waitfornmi
	jsr	Introscroll
	bcs	.fadeaway
	bpl	.wait7
.fadeaway
	jsl	Fadeout
	stz	MDMAEN

	rtl

Sunset:
	stz	z_temp0
	jsl	Initspritedriver
	stz	v_xfercount
	stz	_levelx
	stz	_levely
	jsl	Clearoam2
	jsl	Sendobj

	ldx	#14
	jsr	Loadintroscreen
	ldy	#^TRANSARTSCRATCH
	lda	#TRANSARTSCRATCH
	ldx	#OBJBASE+$400
	jsl	Sendbg

	ldx	#16
	jsr	Loadintroscreen
	
	ldx	#18
	jsr	Loadintroscreen

	lda	#OBJBASE
	jsl	Clrbg

	lda	#BG2BASE
	jsl	Clrbg

	ldy	#^TRANSARTSCRATCH
	lda	#TRANSARTSCRATCH+$1000
	ldx	#BG3BASE
	jsl	Sendbg

	ldy	#^TRANSARTSCRATCH
	lda	#TRANSARTSCRATCH+$800
	ldx	#BG3BASE3B
	jsl	Sendbg

	lda	#$ffff
	sta	v_bg2vofs
  	lda	#$13f
	sta	v_bg1vofs
	sta	v_bg3vofs

	SA

	sta	BG2VOFS
	xba
	sta	BG2VOFS
	xba
	sta	BG3VOFS
	xba
	sta	BG3VOFS

	lda	#(BG2BASE/256)+2
	sta	BG2SC

	lda	#(BG3BASE/256)+2
	sta	BG3SC

	lda	#$20
	sta	BG12NBA

	LA

	ldx	#18	
	jsr	Introprint

	lda	#introhdmatable4a
	sta	DMA4A1L	
	lda	#introhdmatable5
	sta	DMA3A1L             
	lda	#introhdmatable6
	sta	DMA2A1L
	SA
	lda	#^introhdmatable4a
	sta	DMA4A1B
	lda	#^introhdmatable5
	sta	DMA3A1B
	lda	#^introhdmatable5
	sta	DMA2A1B
	lda	#$0
	sta	DMA4INC
	lda	#$42
	sta	DMA3INC
	lda	#$0
	sta	DMA2INC
	lda	#<TM
	sta	DMA4DEST 
	stz	DMA4BANK
	lda	#<BG1VOFS
	sta	DMA3DEST
	stz	DMA3BANK
	lda	#<BG1SC
	sta	DMA2DEST
	lda	#$fc
	sta	HDMAEN
	LA

	lda	#^METEOR.PALSET
	sta	z_temp1
	lda	#METEOR.PALSET
	sta	z_temp0
	ldy	#$1e
.palloop
	lda	[z_temp0],y
	sta	PALETTE2+$100,y
	dey
	dey
	bpl	.palloop

	lda	#20
	sta	v_startcount

	NMION
	jsl	Fadein
;	ldx	#300
.wait
	jsl	Waitfornmi
	jsr	Introscroll
;	dex
	bpl	.wait

.scroll
	jsl	Waitfornmi
	lda	v_bg1vofs
	bmi	.skipdec
	dec	v_bg1vofs
.skipdec
	dec	v_bg3vofs
	lda	v_bg3vofs
	bpl	.divide2
	lsr
	ora	#$8000
	bra	.set2
.divide2
	lsr
.set2
	clc
	adc	#$a0
	bmi	.do3
	SA
	sta	BG2VOFS
	xba
	sta	BG2VOFS
	LA
.do3
	lda	v_bg3vofs
	bpl	.divide3
	lsr
	lsr
	ora	#$c000
	bra	.set3
.divide3
	lsr
	lsr
.set3
	clc
	adc	#$30
	sta	z_temp0
	SA
	sta	BG3VOFS
	xba
	sta	BG3VOFS
	LA
	lda	z_temp0
	bpl	.scroll

	ldx	#30
.endwait
	jsl	Waitfornmi
	dex
	bpl	.endwait
	
	lda	#$3
	sta	z_temp0
	jsl	Initspritedriver

	stz	v_playerdelay
.loop
	jsr	Plotmeteor
	inc	v_playerdelay
	lda	v_playerdelay
	cmp	#40
	bcc	.loop

	jsl	Clearoam2
	jsl	Waitfornmi
	jsl	Sendobj

	ldx	#120
.endwait2
	jsl	Waitfornmi
	dex
	bpl	.endwait2

	jsl	Fadeout
	stz	MDMAEN

	rtl
Plotmeteor:
	jsl	Resetattr2
	jsl	Clearoam2
	
	lda	v_playerdelay
	and	#$fffc
	lsr
	tay			; (Store for Sendframe)

	lda	#^meteor	; Get Bank
	sta	z_dreccount

	lda	#meteor	; Get Bank
	sta	z_spridrec

	lda	#OBJBASE+$1000
	jsl	Sendframe2	; Queue it up

	ldx	_attrcount
	lda	#meteor
	sta	ATTRDREC,x
	lda	#^meteor
	sta	ATTRBANK,x
	lda	#128
	sta	ATTRX,x
	sta	ATTRY,x
	lda	#$3100
	sta	ATTROFF,x
	lda	v_playerdelay
	and	#$fffc
	lsr
	lsr
	sta	ATTRFRAME,x
	inx
	inx
	stx	_attrcount

	jsl	Createoam2

	jsl	Waitfornmi
	
	jsl	Senddata2
	
	jsl	Sendobj
	
	rts

Loadintroscreen:
	; Unpack Screen Chars

	stx	z_screenindex
	lda	>introccs,x
	pha
	lda	>introccsbank,x
	pha
	pea	|TRANSARTSCRATCH	 ; Destination
	pea	^TRANSARTSCRATCH

	jsl	UNPACK

	pla
	pla
	pla
	pla


	; VRAM Xfer for Screen Chars

	lda	#^TRANSARTSCRATCH
	sta	z_sendvrambank

	ldx	z_screenindex
	lda	>introccslen,x
	tay
	lda	>introccsdest,x
	tax
	lda	#TRANSARTSCRATCH
	jsl	Sendvram


	ldx	z_screenindex
	lda	>introcsm,x
	pha
	lda	>introcsmbank,x
	pha
	pea	|TRANSARTSCRATCH	 ; Destination
	pea	^TRANSARTSCRATCH

	jsl	UNPACK

	pla
	pla
	pla
	pla


	; VRAM Xfer for Screen Chars

	lda	#^TRANSARTSCRATCH
	sta	z_sendvrambank

	ldx	z_screenindex
	lda	>introcsmdest,x
	tax
	lda	#TRANSARTSCRATCH
	ldy	#^TRANSARTSCRATCH
	jsl	Sendbg

	; Copy Screen Palette(s)
	ldx	z_screenindex
	lda	>intropalbank,x
	beq	.nopal
	sta	z_temp3a

	lda	>intropal,x
	sta	z_temp2a

	lda	>intropallen,x
	tay
	cpy	#$fe
	bne	.palloop
.palloopa
	lda	[z_temp2a],y
	sta	PALETTE2,y
	dey
	dey
	cpy	#$40
	bcs	.palloopa
	bra	.nopal
.palloop    
	lda	[z_temp2a],y
	sta	PALETTE2,y

	dey
	dey
	bpl	.palloop
.nopal

	SA
	lda	#$3
	sta	OBJSEL

	lda	#(BG1BASE/256)+1
	sta	BG1SC

	lda	#(BG2BASE/256)
	sta	BG2SC

	lda	#(BG3BASE3B/256)
	sta	BG3SC

	lda	#1
	sta	BGMODE

	lda	#5
	sta	TM

	stz	TS	

	stz	CGSWSEL		

	stz	CGADSUB

	lda	#DIVIDED
	sta	BG12NBA

	lda	#(BG3CHAR>>12)
	sta	BG34NBA

	lda	#$ff
	sta	BG1VOFS
	stz	BG1VOFS

	stz	BG1HOFS
	stz	BG1HOFS

	sta	BG2VOFS
	stz	BG2VOFS

	stz	BG2HOFS
	stz	BG2HOFS

	sta	BG3VOFS
	stz	BG3VOFS

	stz	BG3HOFS
	stz	BG3HOFS

	LAI

	rts
	
introccs
	.dw	crouch1ccs
	.dw	closeupccs
	.dw	clearingccs
	.dw	shot31ccs
	.dw	shot33ccs
	.dw	cage1ccs
	.dw	stirccs
	.dw	sunset1ccs
	.dw	sunset2ccs
	.dw	sunset3ccs
	.dw	closeup3ccs
introccsbank
	.dw	^crouch1ccs
	.dw	^closeupccs
	.dw	^clearingccs
	.dw	^shot31ccs
	.dw	^shot33ccs
	.dw	^cage1ccs
	.dw	^stirccs
	.dw	^sunset1ccs
	.dw	^sunset2ccs
	.dw	^sunset3ccs
	.dw	^closeup3ccs
introccslen
	.dw	$6000
	.dw	$6000
	.dw	$6000
	.dw	$6000
	.dw	$c00
	.dw	$6000
	.dw	$6000
	.dw	$4000
	.dw	$4000
	.dw	$800
	.dw	$1000
introccsdest
	.dw	BG1CHAR
	.dw	BG1CHAR
	.dw	BG1CHAR
	.dw	BG1CHAR
	.dw	BG3CHAR
	.dw	BG1CHAR
	.dw	BG1CHAR
	.dw	BG1CHAR
	.dw	BG1CHAR+$2000
	.dw	BG3CHAR
	.dw	BG3CHAR
introcsm
	.dw	crouch1csm
	.dw	closeupcsm
	.dw	clearingcsm
	.dw	shot31csm
	.dw	shot33csm
	.dw	cage1csm
	.dw	stircsm
	.dw	sunset1csm
	.dw	sunset2csm
	.dw	sunset3csm
	.dw	closeup3csm
introcsmbank
	.dw	^crouch1csm
	.dw	^closeupcsm
	.dw	^clearingcsm
	.dw	^shot31csm
	.dw	^shot33csm
	.dw	^cage1csm
	.dw	^stircsm
	.dw	^sunset1csm
	.dw	^sunset2csm
	.dw	^sunset3csm
	.dw	^closeup3csm
introcsmdest
	.dw	BG1BASE
	.dw	BG1BASE
	.dw	BG1BASE
	.dw	BG1BASE
	.dw	BG3BASE3B
	.dw	BG1BASE
	.dw	BG1BASE
	.dw	BG1BASE
	.dw	BG2BASE2B
	.dw	BG3BASE3B
	.dw	BG3BASE3B
intropal
	.dw	CROUCH1.PALSET
	.dw	CLOSEUP.PALSET
	.dw	CLEARING.PALSET
	.dw	SHOT31.PALSET
	.dw	SHOT33.PALSET
	.dw	CAGE1.PALSET
	.dw	STIR.PALSET
	.dw	SUNSET1.PALSET
	.dw	NONE
	.dw	SUNSET3.PALSET
	.dw	CLOSEUP3.PALSET
intropalbank
	.dw	^CROUCH1.PALSET
	.dw	^CLOSEUP.PALSET
	.dw	^CLEARING.PALSET
	.dw	^SHOT31.PALSET
	.dw	^SHOT33.PALSET
	.dw	^CAGE1.PALSET
	.dw	^STIR.PALSET
	.dw	^SUNSET1.PALSET
	.dw	NONE
	.dw	^SUNSET3.PALSET
	.dw	^CLOSEUP3.PALSET
intropallen
	.dw	$fe
	.dw	$fe
	.dw	$fe
	.dw	$fe
	.dw	$3e
	.dw	$fe
	.dw	$fe
	.dw	$fe
	.dw	0
	.dw	$3e
	.dw	$3e


Introscroll:
	lda	#^TRANSARTSCRATCH3
	sta	z_ztemp
	inc	v_bg3hofs
	lda	v_bg3hofs
	and	#$fff8
	lsr
	lsr
	clc
	adc	#TRANSARTSCRATCH3+$c0
	ldx	#BG1BASE+$320
	ldy	#$40
	jsl	Sendvram

	lda	v_bg3hofs
	and	#$fff8
	lsr
	lsr
	clc
	adc	#TRANSARTSCRATCH3+$100
	ldx	#BG1BASE1B+$320
	ldy	#$2
	jsl	Sendvram

	lda	v_bg3hofs
	and	#7
	sta	v_bg2hofs
	bne	.exit
	dec	z_temp8
	bmi	.end
.exit
	lda	z_joy1
	bit	#JOYPADSTART
	beq	.chkfast

	clc

	lda	v_startcount
	bne	.end

	sec		; Indicate User wants to skip all

	rts
.chkfast
	lda	z_joy1

	bit	#JOYPADA
	beq	.end

	bit	#JOYPADB
	beq	.end

	bit	#JOYPADX
	beq	.end

	bit	#JOYPADY
	beq	.end

	lda	#$ffff
.end
	rts

	
Introprint:
	lda	>introtext,x
	sta	z_temp0
	lda	#^introtext
	sta	z_temp1

	ldx	#0
	lda	#$3ff7	;space
.preloop
	sta	>TRANSARTSCRATCH3,x
	inx
	inx
	cpx	#$300
	bcc	.preloop

	ldx	#0
	ldy	#0
.loop
	lda	[z_temp0],y
	inc	z_temp0
	and	#$ff
	beq	.endmessage
	cmp	#$20
	beq	.space
	cmp	#$27
	beq	.quote
	cmp	#$2c
	beq	.coma
	cmp	#$2e
	beq	.period
	sbc	#$41
	cmp	#$1a
	bcc	.letter
	sbc	#$6
	bra	.letter
.space
	lda	#$37
	bra	.letter
.quote
	lda	#$34
	bra	.letter
.coma
	lda	#$35
	bra	.letter
.period
	lda	#$36
.letter
	clc
	adc	#$3c0
	ora	#$3c00	;high priority, last palette
	sta	>TRANSARTSCRATCH3+$100,x
	inx
	inx
	bra	.loop
.endmessage
	txa
	lsr
	clc
	adc	#32
	sta	z_temp8
	
	lda	#^TRANSARTSCRATCH3
	sta	z_ztemp

	lda	#TRANSARTSCRATCH3
	ldx	#BG1BASE+$300
	ldy	#$100

	jsl	Sendvram
	
	lda	#^TRANSARTSCRATCH3
	sta	z_ztemp

	lda	#TRANSARTSCRATCH3
	ldx	#BG1BASE1B+$300
	ldy	#$100

	jsl	Sendvram

	jsl	Copyfont8x8

	rts

Copyfont8x8:
	lda	#FONT8X8.PALSET
	sta	z_temp2

	lda	#^FONT8X8.PALSET
	sta	z_temp3
	ldy	#$1e
.palloop2   
	lda	[z_temp2],y
	sta	PALETTE2+$e0,y

	dey
	dey
	bpl	.palloop2

	pea	|font8x8ccs	 ; Source
	pea	^font8x8ccs
	pea	|$7f6000	 ; Destination
	pea	^$7f6000

	jsl	UNPACK

	pla
	pla
	pla
	pla


	; VRAM Xfer for font Chars

	lda	#$7f
	sta	z_sendvrambank

	lda	#$6000
	ldy	#$800	
	ldx	#BG1CHAR+$3c00

	jsl	Sendvram

;	lda	#$3

	jsr	Introhdma

	stz	v_bg1hofs
	stz	v_bg2hofs
	stz	v_bg3hofs

	rtl

Introhdma:	
	lda	#introhdmatable1
	sta	DMA6A1L	
	lda	#introhdmatable2
	sta	DMA7A1L	
	lda	#introhdmatable3
	sta	DMA5A1L	
	SA
	lda	#^introhdmatable1
	sta	DMA6A1B
	lda	#^introhdmatable2
	sta	DMA7A1B
	lda	#^introhdmatable3
	sta	DMA5A1B
	lda	#$0
	sta	DMA6INC
	lda	#$42
	sta	DMA7INC
	stz	DMA7BANK
	lda	#$42
	sta	DMA5INC
	stz	DMA5BANK
	lda	#<CGADD
	sta	DMA6DEST	
	lda	#<CGDATA
	sta	DMA7DEST
   	lda	#<BG1HOFS
	sta	DMA5DEST
	lda	#$e0
	sta	HDMAEN
	LA
	rts

introhdmatable1
	.db	100
	.db	0
	.db	92
	.db	0
	.db	32
	.db	0
	.db	0
introhdmatable2
	.db	100
	.dw	PALETTE
	.db	92
	.dw	PALETTE
	.db	32
	.dw	PALETTE+$e0
	.db	0
introhdmatable3
	.db	100
	.dw	v_bg1hofs
	.db	92
	.dw	v_bg1hofs
	.db	32
	.dw	v_bg2hofs
	.db	0
introhdmatable4
	.db	100
	.db	$13	;_bgenable
	.db	92
	.db	$13	;_bgenable
	.db	32
	.db	1
	.db	0
introhdmatable4a
	.db	100
	.db	$17	;_bgenable
	.db	92
	.db	$17	;_bgenable
	.db	32
	.db	1
	.db	0
introhdmatable5
	.db	100
	.dw	v_bg1vofs
	.db	92
	.dw	v_bg1vofs
	.db	32
	.dw	v_bg2vofs
	.db 	0
introhdmatable6
	.db	100
	.db	(OBJBASE/256)+2
	.db	92
	.db	(OBJBASE/256)+2
	.db	32
	.db	(BG1BASE/256)+1
	.db	0


introtext	
	.dw	introtext1
	.dw	introtext2
	.dw	introtext3
	.dw	introtext4
	.dw	introtext5
	.dw	introtext6
	.dw	introtext7
	.dw	introtext8
	.dw	wintext1
	.dw	wintext2

introtext1
 .db "Deep in the savage African jungle, Tarzan emerges from the tangled foliage.  "
 .db "Tarzan's acute senses detect trouble on the jungle floor.",0
introtext2
 .db "Though brought up by apes, Tarzan immediately understands the significance of what he sees...",0
introtext3
 .db "Two of his own kind...",0
introtext4
 .db "And one of them is a beautiful female.",0
introtext5
 .db "Filled with the desire to protect her from harm, "
 .db "Tarzan resolves to rescue the captive woman.",0
introtext6
 .db "But the captors look dangerous and alert.  He must follow them, waiting until the time is right...",0
introtext7
 .db "Before the captors leave, their Shaman casts a curse on the jungle.",0
introtext8
 .db "Immediately, Tarzan senses a change in the jungle...  "
 .db "A change in the jungle's animals.",0
wintext1
 .db "After freeing the captives from their bonds, Tarzan takes Jane into his arms.",0
wintext2
 .db "Tarzan and Jane embrace as the sun sinks into the Atlantic, giving way to the African night.",0



*****************************************************************************
*
* Run Credits
*
*	lda	v_levelfail	; Check for level failure
*
*****************************************************************************

RunCredits:
	BLANKON

	stz	v_bg1vofs
	stz	v_bg1hofs
	stz	v_bg2vofs
	stz	v_bg2hofs


	ldy	#$2601	; Done with level - fade music
	lda	#DCOM_FADEOUT
	
	jsl	Pass_Driver_Command

	lda	#SNDUPPERJNGL

	jsl	load_Module

	lda	#forestnt_sng

	jsl	load_Song
	
	jsr	.getchars	; Decompress & Download chars & scrns

	jsr	.dopalettes	; Load palettes

	jsr	.setmode	; Set hardware mode

	jsr	.setuphdma

	lda	#$1EF
	sta	v_bg2vofs

	jsr	.scroll1n2

	lda	#300
	sta	v_gmovrdly

	BLANKOFF

	jsl	Fadein

	jsl	Waitfornmi

	lda	z_hdmaenable

	SA
	sta	HDMAEN
	LA

	stz	z_joy1

	ldx	#30
.dlyloop
	jsl	Waitfornmi

	dex
	bpl	.dlyloop

.creditloop
	jsl	Scanjoys

	lda	v_levelfail
	bne	.failedlev

	stz	z_joy1
.dsploop
	jsl	Waitfornmi

	jsl	Switchscrns

	jsl	Waitfornmi

	jsl	Waitfornmi

	jsr	.scroll1n2

	lda	z_joy1
	and	#JOYPADSTART
	bne	.gamebrk

	lda	v_levelfail
	beq	.dsploop

.failedlev
	lda	z_joy1
	beq	.creditloop

	dec	v_gmovrdly
	bmi	.gamebrk

	and	#JOYPADSTART
	beq	.creditloop
.gamebrk
	jsl	Fadeout

	lda	#0	; Disable HDMA 
	sta	z_hdmaenable

	SA
	sta	HDMAEN

	stz	W12SEL
	LA

	rtl


*****************************************

.getchars
	; Unpack Screen Chars

	pea	|gameoverchr	 ; Source
	pea	^gameoverchr
	pea	|SCRATCH	 ; Destination
	pea	^SCRATCH

	jsl	UNPACK

	pla
	pla
	pla
	pla


	; VRAM Xfer for Screen Chars

	lda	#^SCRATCH
	sta	z_sendvrambank

	lda	#SCRATCH
	ldy	#$8000
	ldx	#BG1CHAR

	jsl	Sendvram

	; Unpack Screen Chars

	pea	|gameoverchr2	 ; Source
	pea	^gameoverchr2
	pea	|SCRATCH	 ; Destination
	pea	^SCRATCH

	jsl	UNPACK

	pla
	pla
	pla
	pla


	; VRAM Xfer for Screen Chars

	lda	#^SCRATCH
	sta	z_sendvrambank

	lda	#SCRATCH
	ldy	#$1500
	ldx	#BG3CHAR

	jsl	Sendvram

	; Unpack Screen
	pea	|gameoverscr	; push low word of packed file
	pea	^gameoverscr	; push high word of packed file
	pea	|SCRATCH	; push low word of output buffer
	pea	^SCRATCH	; push high word of output buffer

	jsl	UNPACK	; unpack file to output buffer

	pla
	pla
	pla
	pla

	; character screens for map

	; Copy Screen to BG1	; 4000-5000
	ldx	#BG1BASE
	lda	#.scrn00
	ldy	#^SCRATCH  ;
	jsl	Sendbg

	; Unpack Screen
	pea	|gameoverscr2	; push low word of packed file
	pea	^gameoverscr2	; push high word of packed file
	pea	|SCRATCH	; push low word of output buffer
	pea	^SCRATCH	; push high word of output buffer

	jsl	UNPACK	; unpack file to output buffer

	pla
	pla
	pla
	pla

	; Copy Screen to BG2
	ldx	#BG2BASE
	lda	#.scrn00
	ldy	#^SCRATCH  ;
	jsl	Sendbg

	; Copy Screen to BG2
	ldx	#BG2BASE2B
	lda	#.scrn01
	ldy	#^SCRATCH  ;
	jsl	Sendbg

	rts

.scrn00	.equ	SCRATCH+$0000	; 
.scrn01	.equ	SCRATCH+$0800	; 
.scrn02	.equ	SCRATCH+$1000	; 
.scrn03	.equ	SCRATCH+$1800	; 


***************************************

.dopalettes
	; Copy Screen Palette(s)
	lda	#gameoverpal
	sta	z_temp0

	lda	#^gameoverpal
	sta	z_temp1

	ldy	#$FE
.palloop    
	lda	[z_temp0],y
	sta	PALETTE2,y

	dey
	dey
	bpl	.palloop

	rts


****************************************

.setmode
	; Set Modes

	SA

	lda	#(BG1BASE/256)	; 1x1 screen
	sta	BG1SC

	lda	#(BG2BASE/256)+2 ; 1wx2h screen
	sta	BG2SC

	lda	#$3	; Set mode 3 8x8 char
	sta	BGMODE

	lda	#$3	; Set BG1 & BG2 as main screen
	sta	TM
	sta	TMW

	stz	TS
	stz	TSW

	stz	CGSWSEL		

	lda	#$C1
	stz	CGADSUB	; enable add/sub

	lda	#$E0
	stz	COLDATA

	lda	#$50
	sta	BG12NBA

	lda	#$30
	sta	W12SEL	; Enable Window 1 on BG3

	lda	#0	; Set left side to 0
	sta	WH0
	sta	WH1

	stz	CGSWSEL

	lda	#$C1
	sta	CGADSUB

	lda	#$E0
	sta	COLDATA


	LA

	rts


*****************************************************************************

.scroll1n2
	lda	v_bg1vofs	; Get BG1 Y offset

	SA
	sta	BG1VOFS	; Update PPU
	xba
	sta	BG1VOFS
	LA

	lda	v_bg1hofs	; Get BG1 X offset

	SA
	sta	BG1HOFS	; Update PPU
	xba
	sta	BG1HOFS
	LA

	lda	v_bg2vofs	; Get BG2 Y offset

	SA
	sta	BG2VOFS	; Update PPU
	xba
	sta	BG2VOFS
	LA

	lda	v_bg2hofs	; Get BG2 X offset

	SA
	sta	BG2HOFS	; Update PPU
	xba
	sta	BG2HOFS
	LA

	rts


*****************************************************************************

.setuphdma
	SAI

	lda	#$0
	sta	DMA3INC	; HDMA parameter

	lda	#$27	; Address $2127 = WH1
	sta	DMA3DEST

	lda	#0	; PPU registers are in bank 0
	sta	DMA3BANK	; Bank of dest address

	lda	#0	; Data Table Address
	sta	DMA3A1B	; Address Bank

	lda	>d_gmovrlow	; Data Table Address
	sta	DMA3A1L	; Address Low

	lda	>d_gmovrhigh	; Data Table Address
	sta	DMA3A1H	; Address High

	lda	#$8	; Enable HDMA Channel 3
	sta	z_hdmaenable

	LAI

	rts

*****************************************************************************


Switchscrns:
	LAI

	inc	v_bg2vofs

	lda	v_bg2vofs
	cmp	#$260
	beq	.switch

	cmp	#$3F0
	bcs	.fadeout

	rtl
.switch
	; Copy Screen to BG2
	ldx	#BG2BASE
	lda	#SCRATCH+$1000
	ldy	#^SCRATCH  ;

	jsl	Sendbg

	rtl
.fadeout
	lda	#JOYPADSTART
	sta	z_joy1

	rtl
	
