_ztemp	.equ	z_ztemp
_temp0	.equ	z_temp0
_temp1	.equ	z_temp1
_temp2	.equ	z_temp2
_temp3	.equ	z_temp3
_temp4	.equ	z_temp4
_temp5	.equ	z_temp5
_temp6	.equ	z_temp6
_temp7	.equ	z_temp7
_temp8	.equ	z_temp8

_attrcount	.equ	z_attrcount
_oamcount	.equ	z_oamcount
_levelx	.equ	z_levelx   
_levely	.equ	z_levely   
_sprix	.equ	z_sprix    
_spriy	.equ	z_spriy    
_modeframe	.equ	z_drecframe
_modecount	.equ	z_dreccount
_sprimode	.equ	z_spridrec 
;_modesize	.equ	z_drecsize 
_modenum	.equ	z_drecnum  
_modex	.equ	z_drecx    
_modey	.equ	z_drecy    
_modefpc	.equ	z_drecfpc  
_modedim	.equ	z_drecdim  
_sprisize	.equ	z_sprisize 

ATTRMODE	.equ	ATTRDREC

_bordertop	.equ	z_bg1col31	
_borderbot	.equ	z_bg2col31
_borderleft	.equ	z_bg3col31
_borderright	.equ	z_newcol1

_smallspritesize	.equ	z_newcol2
_largespritesize	.equ	z_newcol3
_spritesizediff	.equ	z_sud1
_objsize	.equ	z_sud2

_data	.equ	$7f8000
_objcomp	.equ	z_sud3   ;4 bytes
_nextdataaddress	.equ	z_slr2
_objkey	.equ	z_slr3
_objtemp	.equ	z_sdir

;sprite driver for use with roxy/rocks output files
;
;	-Initspritedriver
;		sets up sizes and window for full screen
;	-Clearoam
;		sets oam construct to neutral values
;	-Resetattr
;		clear ATTR tables and index
;	-Creatoam
;		uses ATTR tables to create oam structure
;		(can be called multiple times for multiple
;		windows without resetting attr or oam)
;	-Sendframe
;		adds frame image info to download request arrays
;		has three extra global routines linked into it:
;		-Decompressframe
;			for frames with zeros rle compressed
;		-Global
;			for frames taken from global char sets
;		-Compressedglobal
;			for global char sets rle compressed
;	-Senddata
;		called during vblank to send frame images		
;		


;call an Initspritedriver routine before using
;Createoam
;
;Createoam expects both sprite sizes
;	(_smallspritesize= 8,16,32; _largespritesize= 16,32,64)
;the difference in sprite sizes
;	(_spritesizediff= 8,16,24,32,48,56)
;and window borders
;	(_borderleft, _borderright, _bordertop, _borderbot in pixels)
;to be defined before entry

	LAI
;initspritedriver for full screen
; send objsize (s2,s1,s0 of OBJSEL) in _temp0 in same bit positions
Initspritedriver:
	lda	_temp0
	and	#$e0
	lsr
	lsr
	lsr
	lsr
	tax
	lda	>.spritesizestable,x
	and	#$ff
	sta	_smallspritesize
	lda	>.spritesizestable,x
	and	#$ff00
	xba
	sta	_largespritesize
	sec
	sbc	_smallspritesize
	sta	_spritesizediff
	stz	_borderleft
	lda	#$100
	sta	_borderright
	stz	_bordertop
	lda	#$e0
	sta	_borderbot
	rtl

.spritesizestable
	.db	8,16,8,32,8,64,16,32,16,64,32,64
	;secret sprite modes
	.db	16,64,32,64

;clear the oam shadow table to neutral values
Clearoam2:
            LAI
            lda   #$5555         ;sets high bit to off screen
            ldx   #$21E          ;length of oam
.loop       sta   OBJECT,x       ;object is oam shadow
            dex
            dex
            bpl   .loop
            stz	_oamcount
            rtl


;
Resetattr2:  LAI
            stz   _attrcount
            ldx   #$fe
.clrloop    stz   ATTROFF,x
            dex
            dex
            bpl   .clrloop
            rtl

;create oam -- routine specific data
_croamdat2   
	.dw	$FFFE,$00,$FFFB,$00,$FFEF,$00,$FFBF,$00,$FEFF,$00,$FBFF,$00,$EFFF,$00,$BFFF,$00
	.dw	$FFFE,$02,$FFFB,$02,$FFEF,$02,$FFBF,$02,$FEFF,$02,$FBFF,$02,$EFFF,$02,$BFFF,$02
	.dw	$FFFE,$04,$FFFB,$04,$FFEF,$04,$FFBF,$04,$FEFF,$04,$FBFF,$04,$EFFF,$04,$BFFF,$04
	.dw	$FFFE,$06,$FFFB,$06,$FFEF,$06,$FFBF,$06,$FEFF,$06,$FBFF,$06,$EFFF,$06,$BFFF,$06
	.dw	$FFFE,$08,$FFFB,$08,$FFEF,$08,$FFBF,$08,$FEFF,$08,$FBFF,$08,$EFFF,$08,$BFFF,$08
	.dw	$FFFE,$0a,$FFFB,$0a,$FFEF,$0a,$FFBF,$0a,$FEFF,$0a,$FBFF,$0a,$EFFF,$0a,$BFFF,$0a
	.dw	$FFFE,$0c,$FFFB,$0c,$FFEF,$0c,$FFBF,$0c,$FEFF,$0c,$FBFF,$0c,$EFFF,$0c,$BFFF,$0c
	.dw	$FFFE,$0e,$FFFB,$0e,$FFEF,$0e,$FFBF,$0e,$FEFF,$0e,$FBFF,$0e,$EFFF,$0e,$BFFF,$0e
	.dw	$FFFE,$10,$FFFB,$10,$FFEF,$10,$FFBF,$10,$FEFF,$10,$FBFF,$10,$EFFF,$10,$BFFF,$10
	.dw	$FFFE,$12,$FFFB,$12,$FFEF,$12,$FFBF,$12,$FEFF,$12,$FBFF,$12,$EFFF,$12,$BFFF,$12
	.dw	$FFFE,$14,$FFFB,$14,$FFEF,$14,$FFBF,$14,$FEFF,$14,$FBFF,$14,$EFFF,$14,$BFFF,$14
	.dw	$FFFE,$16,$FFFB,$16,$FFEF,$16,$FFBF,$16,$FEFF,$16,$FBFF,$16,$EFFF,$16,$BFFF,$16
	.dw	$FFFE,$18,$FFFB,$18,$FFEF,$18,$FFBF,$18,$FEFF,$18,$FBFF,$18,$EFFF,$18,$BFFF,$18
	.dw	$FFFE,$1a,$FFFB,$1a,$FFEF,$1a,$FFBF,$1a,$FEFF,$1a,$FBFF,$1a,$EFFF,$1a,$BFFF,$1a
	.dw	$FFFE,$1c,$FFFB,$1c,$FFEF,$1c,$FFBF,$1c,$FEFF,$1c,$FBFF,$1c,$EFFF,$1c,$BFFF,$1c
	.dw	$FFFE,$1e,$FFFB,$1e,$FFEF,$1e,$FFBF,$1e,$FEFF,$1e,$FBFF,$1e,$EFFF,$1e,$BFFF,$1e

Createoam2:
	LAI

	phb

	ldx	#0

.croam0	cpx	_attrcount     ;word partiton in ATTR
	bne	.croam1
	plb
	rtl

.croam1	lda	_oamcount
	cmp	#$1fc
     	bcc	.okay
	plb
	rtl
.okay
	lda	ATTRX,x        ;16 bit X position in level
	sec
	sbc	_levelx        ;X pos of screen left edge
	sta	_sprix
	lda	ATTRY,x        ;16 bit Y position in level
	sec
	sbc	_levely        ;Y pos of screen top edge
	sta	_spriy
	lda	ATTRBANK,x
	SA
	pha
	LA
	plb
	lda	ATTRMODE,x     ;address of adresses for this mode
	sta	_sprimode      ;store in zpage for indirect use
	ldy	#0
	lda	(_sprimode),y
	bit	#4		;check for interlaced x,y,size data
	beq	.noninterlaced
	jmp	.interlaced
.noninterlaced
	bit	#1		;check for relative addressing
	beq	.normalmode
.relativemode
	clc
	ldy	#2
	lda	(_sprimode),y   ;get size addr for current mode
	adc	_sprimode
	sta	_modecount
	ldy	#4
	lda	(_sprimode),y   ;get number addr for current mode
	adc	_sprimode
	sta	_modenum
	ldy	#6
	lda	(_sprimode),y   ;get x offset addr for current mode
	adc	_sprimode
	sta	_modex
	ldy	#8
	lda	(_sprimode),y   ;get y offset addr for current mode
	adc	_sprimode
	sta	_modey
	ldy	#10
	lda	(_sprimode),y   ;get dimension addr
	adc	_sprimode
	sta	_modedim
	ldy	#12
	lda	(_sprimode),y   ;get frame offset addr
	adc	_sprimode
	sta	_modeframe
	bra	.modeset
.normalmode
	ldy	#2
	lda	(_sprimode),y   ;get size addr for current mode
	sta	_modecount
	ldy	#4
	lda	(_sprimode),y   ;get number addr for current mode
	sta	_modenum
	ldy	#6
	lda	(_sprimode),y   ;get x offset addr for current mode
	sta	_modex
	ldy	#8
	lda	(_sprimode),y   ;get y offset addr for current mode
	sta	_modey
	ldy	#10
	lda	(_sprimode),y   ;get dimension addr
	sta	_modedim
	ldy	#12
	lda	(_sprimode),y   ;get frame offset addr
	sta	_modeframe
.modeset
	stx	_ztemp
	lda	ATTRFRAME,x    ;offset into frame table
	asl
	tay
	lda	ATTROFF,x      ;offset into sprite table and pal bits
	sta	v_spriteoff
	and	#$c000
	beq	.croamnorm    ;normal high speed no flip routine
	brl	.croamflip     ;flip routine
.croamnorm
	lda	(_modecount),y   ;number of objects in sprite
	sta	_sprisize
	lda	(_modeframe),y  ;frame # -- offset into other tables
	tay                   ;           the new indirect index
.croamloop
	lda	#1             ;amount of object that must show 
	sec
	sbc	(_modedim),y   ;dimension of object
	sta	v_spriedge      ;negative edge for display
	ldx	_oamcount      ;index for next object in oam
	stz	_temp0
	lda	(_modex),y     ;the x offset for this sub object
	clc
	adc	_sprix         ;add to sprite x location
	cmp	_borderright   ; is it greater than right edge?
	bcc	.croamx        ;if not then branch to store it
	cmp	v_spriedge      ;is it less than negative edge?
	bcc	.croamnext     ;if not then do next object
	clc
	adc	_borderleft
	bpl	.croamx2
	dec	_temp0         ;flag negative x
	bmi	.croamx2
.croamx     
	adc	_borderleft
.croamx2
	sta	OBJECT,x       ;put x location in oam shadow
	lda	(_modey),y     ;the y offset
	clc
	adc	_spriy         ;add to sprite y loc
	cmp	_borderbot     ;is it below screen?
	bcc	.croamy        ;if not then store it
	cmp	v_spriedge      ;is it less than neg edge above screen?
	bcc	.croamnext     ;if not then do next object
	clc
.croamy
	adc	_bordertop
	sta	OBJECT+1,x     ;put y in oam shadow
	lda	(_modenum),y    ;the object number
	clc
	adc	v_spriteoff     ;offset of this sprite in vram table
	sta	OBJECT+2,x

	lda	>_croamdat2,x	;oam size/highbit mask for this offset
	sta	_temp4	;save it

	lda	>_croamdat2+2,x	;oam loc for this offset
	tax

	lda	_temp0         ;x sign flag
	bmi	.croamxneg
	lda	_temp4         ;get the mask
	and	OBJECT+$200,x  ;mask the word with the bit in it
	sta	OBJECT+$200,x  ;store it back
.croamxneg  
	lda	(_modedim),y   ;dimension of object
	cmp	_largespritesize     ;set to larger size dim
	bne	.croamcont     ;if not equal then small size so skip
	rol	_temp4         ;carry is set for rol
	lda	_temp4         ;get it
	eor	#$FFFF         ;reverse it
	ora	OBJECT+$200,x  ;set size bit with it
	sta	OBJECT+$200,x  ;store size bit
.croamcont
	lda	_oamcount      ;increment oamcount to reflect addition
	clc
	adc	#4             ;four bytes per entry
	sta	_oamcount
	cmp	#$200          ;end of oam? (last slot skipped for speed above)
	beq	.croamdone     ;yes then exit
.croamnext  
	iny                  ;otherwise, get next object in sprite
	iny                  ;otherwise, get next object in sprite
	dec	_sprisize      ;check for next object
	beq	.croaminc      ;if not more skip jump
	jmp	.croamloop     ;more so jump back
.croaminc   
	ldx	_ztemp        ;done so get count
	inx                  ;increment for next attr entry
	inx
	jmp	.croam0        ;loop back to beginning
.croamdone  
	plb
	rtl

.croamflip  
	cmp	#$4000
	beq	.hcroam
	cmp	#$8000
	bne	.bcroamlink
	brl	.vcroam
.bcroamlink 
	brl	.bcroam

.hcroam
	lda	v_spriteoff
	and	#$3fff
	sta	v_spriteoff
	lda	(_modecount),y   ;number of objects in sprite
	sta	_sprisize
	lda	(_modeframe),y  ;frame # -- offset into other tables
	tay                   ;           the new indirect index
.hcroamloop
	lda	(_modedim),y   ;dimension of object
	sta	_temp2
	lda	#1             ;amount of object that must show 
	sec
	sbc	_temp2         ;dimension of object
	sta	v_spriedge      ;negative edge for display
	ldx	_oamcount      ;index for next object in oam
	stz	_temp0
	lda	(_modex),y     ;the x offset for this sub object
	eor	#$ffff         ;negate
	inc
	sty	_temp3
	ldy	_temp2
	cpy	_largespritesize            ;small size
	ldy	_temp3
	bcs	.hbigdim
	adc	_spritesizediff            ;8x8 offset compared with 16x16 flipped
	sec
.hbigdim    
	sbc	_largespritesize
	clc
	adc	_sprix         ;add to sprite x location
	cmp	_borderright           ; is it greater than right edge?
	bcc	.hcroamx        ;if not then branch to store it
	cmp	v_spriedge      ;is it less than negative edge?
	bcc	.hcroamnext     ;if not then do next object
	clc
	adc	_borderleft
	bpl	.hcroamx2
	dec	_temp0         ;flag negative x
	bmi	.hcroamx2
.hcroamx     
	adc	_borderleft
.hcroamx2
	sta	OBJECT,x       ;put x location in oam shadow
	lda	(_modey),y     ;the y offset
	clc
	adc	_spriy         ;add to sprite y loc
	cmp	_borderbot           ;is it below screen?
	bcc	.hcroamy        ;if not then store it
	cmp	v_spriedge      ;is it less than neg edge above screen?
	bcc	.hcroamnext     ;if not then do next object
	clc
.hcroamy
	adc	_bordertop
	sta	OBJECT+1,x     ;put y in oam shadow
	lda	v_spriteoff
	clc
	adc	(_modenum),y    ;the object number
	eor	#$4000
	sta	OBJECT+2,x

	lda   >_croamdat2,x    ;oam size/highbit mask for this offset
	sta   _temp4         ;save it

	lda	>_croamdat2+2,x
	tax

	lda   _temp0         ;x sign flag
	bmi   .hcroamxneg
	lda   _temp4         ;get the mask
	and   OBJECT+$200,x  ;mask the word with the bit in it
	sta   OBJECT+$200,x  ;store it back
.hcroamxneg  
	lda	(_modedim),y   ;dimension of object
	cmp	_largespritesize     ;set to larger size dim
	bne	.hcroamcont     ;if not equal then small size so skip
	rol	_temp4         ;carry is set for rol
	lda	_temp4         ;get it
	eor	#$FFFF         ;reverse it
	ora	OBJECT+$200,x  ;set size bit with it
	sta	OBJECT+$200,x  ;store size bit
.hcroamcont
	lda	_oamcount      ;increment oamcount to reflect addition
	clc
	adc	#4             ;four bytes per entry
	sta	_oamcount
	cmp	#$200          ;end of oam? (last slot skipped for speed above)
	beq	.hcroamdone     ;yes then exit
.hcroamnext  
	iny                  ;otherwise, get next object in sprite
	iny                  ;otherwise, get next object in sprite
	dec	_sprisize      ;check for next object
	beq	.hcroaminc      ;if not more skip jump
	jmp	.hcroamloop     ;more so jump back
.hcroaminc   
	ldx	_ztemp                  ;done so get count
	inx                  ;increment for next attr entry
	inx
	jmp	.croam0        ;loop back to beginning
.hcroamdone  
	plb
	rtl

.vcroam
	lda	v_spriteoff
	and	#$3fff
	sta	v_spriteoff
	lda	(_modecount),y   ;number of objects in sprite
	sta	_sprisize
	lda	(_modeframe),y  ;frame # -- offset into other tables
	tay                   ;           the new indirect index
.vcroamloop
	lda	(_modedim),y   ;dimension of object
	sta	_temp2
	lda	#1             ;amount of object that must show 
	sec
	sbc	_temp2         ;dimension of object
	sta	v_spriedge      ;negative edge for display
	ldx	_oamcount      ;index for next object in oam
	sty	_temp3
	stz	_temp0
	lda	(_modex),y     ;the x offset for this sub object
	clc
	adc	_sprix         ;add to sprite x location
	cmp	_borderright           ; is it greater than right edge?
	bcc	.vcroamx        ;if not then branch to store it
	cmp	v_spriedge      ;is it less than negative edge?
	bcs	.vcroamx0
	brl	.vcroamnext     ;if not then do next object
.vcroamx0
	clc
	adc	_borderleft
	bpl	.vcroamx2
	dec	_temp0         ;flag negative x
	bmi	.vcroamx2
.vcroamx     
	adc	_borderleft
.vcroamx2
	sta	OBJECT,x       ;put x location in oam shadow
	lda	(_modey),y     ;the y offset
	eor	#$ffff         ;negate
	inc
	ldy	_temp2
	cpy	_largespritesize            ;small size
	ldy	_temp3
	bcs	.vbigdim
	adc	_spritesizediff            ;8x8 offset compared with 16x16 flipped
	sec
.vbigdim
	sbc	_largespritesize
	clc
	adc	_spriy         ;add to sprite y loc
	cmp	_borderbot           ;is it below screen?
	bcc	.vcroamy        ;if not then store it
	cmp	v_spriedge      ;is it less than neg edge above screen?
	bcc	.vcroamnext    ;if not then do next object
	clc
.vcroamy
	adc	_bordertop
	sta	OBJECT+1,x     ;put y in oam shadow
	lda   v_spriteoff     ;offset of this sprite in vram table
	clc
	adc	(_modenum),y    ;the object number
	eor	#$8000
	sta	OBJECT+2,x

	lda	>_croamdat2,x    ;oam size/highbit mask for this offset
	sta	_temp4         ;save it

	lda	>_croamdat2+2,x
	tax

	lda	_temp0         ;x sign flag
	bmi	.vcroamxneg
	lda	_temp4         ;get the mask
	and	OBJECT+$200,x  ;mask the word with the bit in it
	sta	OBJECT+$200,x  ;store it back
.vcroamxneg  
	lda	(_modedim),y   ;dimension of object
	cmp	_largespritesize     ;set to larger size dim
	bne	.vcroamcont     ;if not equal then small size so skip
	rol	_temp4         ;carry is set for rol
	lda	_temp4         ;get it
	eor	#$FFFF         ;reverse it
	ora	OBJECT+$200,x  ;set size bit with it
	sta	OBJECT+$200,x  ;store size bit
.vcroamcont
	lda	_oamcount      ;increment oamcount to reflect addition
	clc
	adc	#4             ;four bytes per entry
	sta	_oamcount
	cmp	#$200          ;end of oam? (last slot skipped for speed above)
	beq	.vcroamdone     ;yes then exit
.vcroamnext 
	iny
	iny                  ;otherwise, get next object in sprite
	dec	_sprisize      ;check for next object
	beq	.vcroaminc      ;if not more skip jump
	jmp	.vcroamloop     ;more so jump back
.vcroaminc   
	LAI
	ldx	_ztemp                  ;done so get count
	inx                  ;increment for next attr entry
	inx
	jmp	.croam0        ;loop back to beginning
.vcroamdone  
	plb
	rtl


.bcroam
	lda	v_spriteoff
	and	#$3fff
	sta	v_spriteoff
	lda	(_modecount),y   ;number of objects in sprite
	sta	_sprisize
	lda	(_modeframe),y  ;frame # -- offset into other tables
	tay                   ;           the new indirect index
.bcroamloop
	lda	(_modedim),y   ;dimension of object
	sta	_temp2
	lda	#1             ;amount of object that must show 
	sec
	sbc	_temp2         ;dimension of object
	sta	v_spriedge      ;negative edge for display
	ldx	_oamcount      ;index for next object in oam
	sty	_temp3
	stz	_temp0
	lda	(_modex),y     ;the x offset for this sub object
	eor	#$ffff         ;negate
	inc
	ldy	_temp2
	cpy	_largespritesize            ;big size
	ldy	_temp3
	bcs	.bigdimx
	adc	_spritesizediff            ;8x8 offset compared with 16x16 flipped
	sec
.bigdimx    
	sbc	_largespritesize
	clc
	adc	_sprix         ;add to sprite x location
	cmp	_borderright           ; is it greater than right edge?
	bcc	.bcroamx        ;if not then branch to store it
	cmp	v_spriedge      ;is it less than negative edge?
	bcs	.bcroamx0
	brl	.bcroamnext     ;if not then do next object
.bcroamx0
	clc
	adc	_borderleft
	bpl	.bcroamx2
	dec	_temp0         ;flag negative x
	bmi	.bcroamx2
.bcroamx     
	adc	_borderleft
.bcroamx2
	sta	OBJECT,x       ;put x location in oam shadow
	lda	(_modey),y     ;the y offset
	eor	#$ffff         ;negate
	inc
	ldy	_temp2
	cpy	_largespritesize            ;big size
	ldy	_temp3
	bcs	.bigdimy
	adc	_spritesizediff            ;8x8 offset compared with 16x16 flipped
	sec
.bigdimy    
	sbc	_largespritesize
	clc
	adc	_spriy         ;add to sprite y loc
	cmp	_borderbot           ;is it below screen?
	bcc	.bcroamy        ;if not then store it
	cmp	v_spriedge      ;is it less than neg edge above screen?
	bcc	.bcroamnext     ;if not then do next object
	clc
.bcroamy
	adc	_bordertop
	sta	OBJECT+1,x     ;put y in oam shadow
	lda	v_spriteoff     ;offset of this sprite in vram table
	clc
	adc	(_modenum),y    ;the object number
	eor	#$c000
	sta	OBJECT+2,x

	lda	>_croamdat2,x    ;oam size/highbit mask for this offset
	sta	_temp4         ;save it

	lda	>_croamdat2+2,x
	tax

	lda	_temp0         ;x sign flag
	bmi	.bcroamxneg
	lda	_temp4         ;get the mask
	and	OBJECT+$200,x  ;mask the word with the bit in it
	sta	OBJECT+$200,x  ;store it back
.bcroamxneg  
	lda	(_modedim),y   ;dimension of object
	cmp	_largespritesize     ;set to larger size dim
	bne	.bcroamcont     ;if not equal then small size so skip
	rol	_temp4         ;carry is set for rol
	lda	_temp4         ;get it
	eor	#$FFFF         ;reverse it
	ora	OBJECT+$200,x  ;set size bit with it
	sta	OBJECT+$200,x  ;store size bit
.bcroamcont
	lda	_oamcount      ;increment oamcount to reflect addition
	clc
	adc	#4             ;four bytes per entry
	sta	_oamcount
	cmp	#$200          ;end of oam? (last slot skipped for speed above)
	beq	.bcroamdone     ;yes then exit
.bcroamnext  
	iny                  ;otherwise, get next object in sprite
	iny                  ;otherwise, get next object in sprite
	dec	_sprisize      ;check for next object
	beq	.bcroaminc      ;if not more skip jump
	jmp	.bcroamloop     ;more so jump back
.bcroaminc   
	ldx	_ztemp                  ;done so get count
	inx 	                ;increment for next attr entry
	inx
	jmp	.croam0        ;loop back to beginning
.bcroamdone  
	plb
	rtl

.interlaced
	bit	#1		;check for relative addressing
	beq	.inormalmode
.irelativemode
	clc
	ldy	#2
	lda	(_sprimode),y   ;get size addr for current mode
	adc	_sprimode
	sta	_modecount
	ldy	#4
	lda	(_sprimode),y   ;get number addr for current mode
	adc	_sprimode
	sta	_modenum
	sta	_modedim	;number array interlaced with size
	ldy	#6
	lda	(_sprimode),y   ;get x offset addr for current mode
	adc	_sprimode
	sta	_modex
	inc
	sta	_modey
;	ldy	#8
;	lda	(_sprimode),y   ;get y offset addr for current mode
;	adc	_sprimode
;	sta	_modey
;	ldy	#10
;	lda	(_sprimode),y   ;get dimension addr
;	adc	_sprimode
;	sta	_modedim
	ldy	#12
	lda	(_sprimode),y   ;get frame offset addr
	adc	_sprimode
	sta	_modeframe
	bra	.imodeset
.inormalmode
	ldy	#2
	lda	(_sprimode),y   ;get size addr for current mode
	sta	_modecount
	ldy	#4
	lda	(_sprimode),y   ;get number addr for current mode
	sta	_modenum
	sta	_modedim
	ldy	#6
	lda	(_sprimode),y   ;get x offset addr for current mode
	sta	_modex
	inc
	sta	_modey	;interlaced x,y
;	ldy	#8
;	lda	(_sprimode),y   ;get y offset addr for current mode
;	sta	_modey
;	ldy	#10
;	lda	(_sprimode),y   ;get dimension addr
;	sta	_modedim
	ldy	#12
	lda	(_sprimode),y   ;get frame offset addr
	sta	_modeframe
.imodeset
	stx	_ztemp
	lda	ATTRFRAME,x    ;offset into frame table
	asl
	tay
	lda	ATTROFF,x      ;offset into sprite table and pal bits
	sta	v_spriteoff
	and	#$c000
	beq	.icroamnorm    ;normal high speed no flip routine
	brl	.icroamflip     ;flip routine
.icroamnorm
	lda	(_modecount),y   ;number of objects in sprite
	sta	_sprisize
	lda	(_modeframe),y  ;frame # -- offset into other tables
	tay                   ;           the new indirect index
.icroamloop
	lda	(_modedim),y	;unpack sprite size
	and	#$3000
	bne	.inot8
	lda	#8
	bra	.inot64
.inot8
	xba
	cmp	#48
	bcc	.inot64
	lda	#48
.inot64
	sta	_objsize	;object size
	lda	#1             ;amount of object that must show 
	sec
	sbc	_objsize       ;dimension of object
	sta	v_spriedge      ;negative edge for display
	ldx	_oamcount      ;index for next object in oam
	stz	_temp0
	lda	(_modex),y     ;the x offset for this sub object
	and	#$ff	         	;x is low byte only (interlaced)
	bit	#$80		;check for sign extend of byte
	beq	.inoxsex
	ora	#$ff00
.inoxsex
	clc
	adc	_sprix         ;add to sprite x location
	cmp	_borderright   ; is it greater than right edge?
	bcc	.icroamx        ;if not then branch to store it
	cmp	v_spriedge      ;is it less than negative edge?
	bcc	.icroamnext     ;if not then do next object
	clc
	adc	_borderleft
	bpl	.icroamx2
	dec	_temp0         ;flag negative x
	bmi	.icroamx2
.icroamx     
	adc	_borderleft
.icroamx2
	sta	OBJECT,x       ;put x location in oam shadow
	lda	(_modey),y     ;the y offset
	and	#$ff	         	;y is low byte only (interlaced)
	bit	#$80		;check for sign extend of byte
	beq	.inoysex
	ora	#$ff00
.inoysex
	clc
	adc	_spriy         ;add to sprite y loc
	cmp	_borderbot     ;is it below screen?
	bcc	.icroamy        ;if not then store it
	cmp	v_spriedge      ;is it less than neg edge above screen?
	bcc	.icroamnext     ;if not then do next object
	clc
.icroamy
	adc	_bordertop
	sta	OBJECT+1,x     ;put y in oam shadow
	lda	(_modenum),y    ;the object number
	and	#$cfff	;kill size bits in interlace mode
	clc
	adc	v_spriteoff     ;offset of this sprite in vram table
	sta	OBJECT+2,x

	lda	>_croamdat2,x	;oam size/highbit mask for this offset
	sta	_temp4	;save it

	lda	>_croamdat2+2,x	;oam loc for this offset
	tax

	lda	_temp0         ;x sign flag
	bmi	.icroamxneg
	lda	_temp4         ;get the mask
	and	OBJECT+$200,x  ;mask the word with the bit in it
	sta	OBJECT+$200,x  ;store it back
.icroamxneg  
	lda	_objsize	;dimension of object
	cmp	_largespritesize     ;set to larger size dim
	bne	.icroamcont     ;if not equal then small size so skip
	rol	_temp4         ;carry is set for rol
	lda	_temp4         ;get it
	eor	#$FFFF         ;reverse it
	ora	OBJECT+$200,x  ;set size bit with it
	sta	OBJECT+$200,x  ;store size bit
.icroamcont
	lda	_oamcount      ;increment oamcount to reflect addition
	clc
	adc	#4             ;four bytes per entry
	sta	_oamcount
	cmp	#$200          ;end of oam? (last slot skipped for speed above)
	beq	.icroamdone     ;yes then exit
.icroamnext  
	iny                  ;otherwise, get next object in sprite
	iny                  ;otherwise, get next object in sprite
	dec	_sprisize      ;check for next object
	beq	.icroaminc      ;if not more skip jump
	jmp	.icroamloop     ;more so jump back
.icroaminc   
	ldx	_ztemp        ;done so get count
	inx                  ;increment for next attr entry
	inx
	jmp	.croam0        ;loop back to beginning
.icroamdone  
	plb
	rtl

.icroamflip  
	cmp	#$4000
	beq	.ihcroam
	cmp	#$8000
	bne	.ibcroamlink
	brl	.ivcroam
.ibcroamlink 
	brl	.ibcroam

.ihcroam
	lda	v_spriteoff
	and	#$3fff
	sta	v_spriteoff
	lda	(_modecount),y   ;number of objects in sprite
	sta	_sprisize
	lda	(_modeframe),y  ;frame # -- offset into other tables
	tay                   ;           the new indirect index
.ihcroamloop
	lda	(_modedim),y	;unpack sprite size
	and	#$3000
	bne	.ihnot8
	lda	#8
	bra	.ihnot64
.ihnot8
	xba
	cmp	#48
	bcc	.ihnot64
	lda	#48
.ihnot64
	sta	_objsize	;object size
	lda	#1             ;amount of object that must show 
	sec
	sbc	_objsize       ;dimension of object
	sta	v_spriedge      ;negative edge for display
	ldx	_oamcount      ;index for next object in oam
	stz	_temp0
	lda	(_modex),y     ;the x offset for this sub object
	and	#$ff	         	;x is low byte only (interlaced)
	bit	#$80		;check for sign extend of byte
	beq	.ihnoxsex
	ora	#$ff00
.ihnoxsex
	eor	#$ffff         ;negate
	inc
	sty	_temp3
	ldy	_objsize
	cpy	_largespritesize            ;small size
	ldy	_temp3
	bcs	.ihbigdim
	adc	_spritesizediff            ;8x8 offset compared with 16x16 flipped
	sec
.ihbigdim    
	sbc	_largespritesize
	clc
	adc	_sprix         ;add to sprite x location
	cmp	_borderright           ; is it greater than right edge?
	bcc	.ihcroamx        ;if not then branch to store it
	cmp	v_spriedge      ;is it less than negative edge?
	bcc	.ihcroamnext     ;if not then do next object
	clc
	adc	_borderleft
	bpl	.ihcroamx2
	dec	_temp0         ;flag negative x
	bmi	.ihcroamx2
.ihcroamx     
	adc	_borderleft
.ihcroamx2
	sta	OBJECT,x       ;put x location in oam shadow
	lda	(_modey),y     ;the y offset
	and	#$ff	         	;y is low byte only (interlaced)
	bit	#$80		;check for sign extend of byte
	beq	.ihnoysex
	ora	#$ff00
.ihnoysex
	clc
	adc	_spriy         ;add to sprite y loc
	cmp	_borderbot           ;is it below screen?
	bcc	.ihcroamy        ;if not then store it
	cmp	v_spriedge      ;is it less than neg edge above screen?
	bcc	.ihcroamnext     ;if not then do next object
	clc
.ihcroamy
	adc	_bordertop
	sta	OBJECT+1,x     ;put y in oam shadow
	lda	(_modenum),y    ;the object number
	and	#$cfff	;kill size bits in interlace mode
	clc
	adc	v_spriteoff     ;offset of this sprite in vram table
	eor	#$4000
	sta	OBJECT+2,x

	lda   >_croamdat2,x    ;oam size/highbit mask for this offset
	sta   _temp4         ;save it

	lda	>_croamdat2+2,x
	tax

	lda   _temp0         ;x sign flag
	bmi   .ihcroamxneg
	lda   _temp4         ;get the mask
	and   OBJECT+$200,x  ;mask the word with the bit in it
	sta   OBJECT+$200,x  ;store it back
.ihcroamxneg  
	lda	_objsize   ;dimension of object
	cmp	_largespritesize     ;set to larger size dim
	bne	.ihcroamcont     ;if not equal then small size so skip
	rol	_temp4         ;carry is set for rol
	lda	_temp4         ;get it
	eor	#$FFFF         ;reverse it
	ora	OBJECT+$200,x  ;set size bit with it
	sta	OBJECT+$200,x  ;store size bit
.ihcroamcont
	lda	_oamcount      ;increment oamcount to reflect addition
	clc
	adc	#4             ;four bytes per entry
	sta	_oamcount
	cmp	#$200          ;end of oam? (last slot skipped for speed above)
	beq	.ihcroamdone     ;yes then exit
.ihcroamnext  
	iny                  ;otherwise, get next object in sprite
	iny                  ;otherwise, get next object in sprite
	dec	_sprisize      ;check for next object
	beq	.ihcroaminc      ;if not more skip jump
	jmp	.ihcroamloop     ;more so jump back
.ihcroaminc   
	ldx	_ztemp                  ;done so get count
	inx                  ;increment for next attr entry
	inx
	jmp	.croam0        ;loop back to beginning
.ihcroamdone  
	plb
	rtl

.ivcroam
	lda	v_spriteoff
	and	#$3fff
	sta	v_spriteoff
	lda	(_modecount),y   ;number of objects in sprite
	sta	_sprisize
	lda	(_modeframe),y  ;frame # -- offset into other tables
	tay                   ;           the new indirect index
.ivcroamloop
	lda	(_modedim),y	;unpack sprite size
	and	#$3000
	bne	.ivnot8
	lda	#8
	bra	.ivnot64
.ivnot8
	xba
	cmp	#48
	bcc	.ivnot64
	lda	#48
.ivnot64
	sta	_objsize	;object size
	lda	#1             ;amount of object that must show 
	sec
	sbc	_objsize       ;dimension of object
	sta	v_spriedge      ;negative edge for display
	ldx	_oamcount      ;index for next object in oam
	sty	_temp3
	stz	_temp0
	lda	(_modex),y     ;the x offset for this sub object
	and	#$ff	         	;x is low byte only (interlaced)
	bit	#$80		;check for sign extend of byte
	beq	.ivnoxsex
	ora	#$ff00
.ivnoxsex
	clc
	adc	_sprix         ;add to sprite x location
	cmp	_borderright           ; is it greater than right edge?
	bcc	.ivcroamx        ;if not then branch to store it
	cmp	v_spriedge      ;is it less than negative edge?
	bcs	.ivcroamx0
	brl	.ivcroamnext     ;if not then do next object
.ivcroamx0
	clc
	adc	_borderleft
	bpl	.ivcroamx2
	dec	_temp0         ;flag negative x
	bmi	.ivcroamx2
.ivcroamx     
	adc	_borderleft
.ivcroamx2
	sta	OBJECT,x       ;put x location in oam shadow
	lda	(_modey),y     ;the y offset
	and	#$ff	         	;y is low byte only (interlaced)
	bit	#$80		;check for sign extend of byte
	beq	.ivnoysex
	ora	#$ff00
.ivnoysex
	eor	#$ffff         ;negate
	inc
	ldy	_objsize
	cpy	_largespritesize            ;small size
	ldy	_temp3
	bcs	.ivbigdim
	adc	_spritesizediff            ;8x8 offset compared with 16x16 flipped
	sec
.ivbigdim
	sbc	_largespritesize
	clc
	adc	_spriy         ;add to sprite y loc
	cmp	_borderbot           ;is it below screen?
	bcc	.ivcroamy        ;if not then store it
	cmp	v_spriedge      ;is it less than neg edge above screen?
	bcc	.ivcroamnext    ;if not then do next object
	clc
.ivcroamy
	adc	_bordertop
	sta	OBJECT+1,x     ;put y in oam shadow
	lda	(_modenum),y    ;the object number
	and	#$cfff	;kill size bits in interlace mode
	clc
	adc	v_spriteoff     ;offset of this sprite in vram table
	eor	#$8000
	sta	OBJECT+2,x

	lda	>_croamdat2,x    ;oam size/highbit mask for this offset
	sta	_temp4         ;save it

	lda	>_croamdat2+2,x
	tax

	lda	_temp0         ;x sign flag
	bmi	.ivcroamxneg
	lda	_temp4         ;get the mask
	and	OBJECT+$200,x  ;mask the word with the bit in it
	sta	OBJECT+$200,x  ;store it back
.ivcroamxneg  
	lda	_objsize   ;dimension of object
	cmp	_largespritesize     ;set to larger size dim
	bne	.ivcroamcont     ;if not equal then small size so skip
	rol	_temp4         ;carry is set for rol
	lda	_temp4         ;get it
	eor	#$FFFF         ;reverse it
	ora	OBJECT+$200,x  ;set size bit with it
	sta	OBJECT+$200,x  ;store size bit
.ivcroamcont
	lda	_oamcount      ;increment oamcount to reflect addition
	clc
	adc	#4             ;four bytes per entry
	sta	_oamcount
	cmp	#$200          ;end of oam? (last slot skipped for speed above)
	beq	.ivcroamdone     ;yes then exit
.ivcroamnext 
	iny
	iny                  ;otherwise, get next object in sprite
	dec	_sprisize      ;check for next object
	beq	.ivcroaminc      ;if not more skip jump
	jmp	.ivcroamloop     ;more so jump back
.ivcroaminc   
	LAI
	ldx	_ztemp                  ;done so get count
	inx                  ;increment for next attr entry
	inx
	jmp	.croam0        ;loop back to beginning
.ivcroamdone  
	plb
	rtl


.ibcroam
	lda	v_spriteoff
	and	#$3fff
	sta	v_spriteoff
	lda	(_modecount),y   ;number of objects in sprite
	sta	_sprisize
	lda	(_modeframe),y  ;frame # -- offset into other tables
	tay                   ;           the new indirect index
.ibcroamloop
	lda	(_modedim),y	;unpack sprite size
	and	#$3000
	bne	.ibnot8
	lda	#8
	bra	.ibnot64
.ibnot8
	xba
	cmp	#48
	bcc	.ibnot64
	lda	#48
.ibnot64
	sta	_objsize	;object size
	lda	#1             ;amount of object that must show 
	sec
	sbc	_objsize       ;dimension of object
	sta	v_spriedge      ;negative edge for display
	ldx	_oamcount      ;index for next object in oam
	sty	_temp3
	stz	_temp0
	lda	(_modex),y     ;the x offset for this sub object
	and	#$ff	         	;x is low byte only (interlaced)
	bit	#$80		;check for sign extend of byte
	beq	.ibnoxsex
	ora	#$ff00
.ibnoxsex
	eor	#$ffff         ;negate
	inc
	ldy	_objsize
	cpy	_largespritesize            ;big size
	ldy	_temp3
	bcs	.ibigdimx
	adc	_spritesizediff            ;8x8 offset compared with 16x16 flipped
	sec
.ibigdimx    
	sbc	_largespritesize
	clc
	adc	_sprix         ;add to sprite x location
	cmp	_borderright           ; is it greater than right edge?
	bcc	.ibcroamx        ;if not then branch to store it
	cmp	v_spriedge      ;is it less than negative edge?
	bcs	.ibcroamx0
	brl	.ibcroamnext     ;if not then do next object
.ibcroamx0
	clc
	adc	_borderleft
	bpl	.ibcroamx2
	dec	_temp0         ;flag negative x
	bmi	.ibcroamx2
.ibcroamx     
	adc	_borderleft
.ibcroamx2
	sta	OBJECT,x       ;put x location in oam shadow
	lda	(_modey),y     ;the y offset
	and	#$ff	         	;y is low byte only (interlaced)
	bit	#$80		;check for sign extend of byte
	beq	.ibnoysex
	ora	#$ff00
.ibnoysex
	eor	#$ffff         ;negate
	inc
	ldy	_objsize
	cpy	_largespritesize            ;big size
	ldy	_temp3
	bcs	.ibigdimy
	adc	_spritesizediff            ;8x8 offset compared with 16x16 flipped
	sec
.ibigdimy    
	sbc	_largespritesize
	clc
	adc	_spriy         ;add to sprite y loc
	cmp	_borderbot           ;is it below screen?
	bcc	.ibcroamy        ;if not then store it
	cmp	v_spriedge      ;is it less than neg edge above screen?
	bcc	.ibcroamnext     ;if not then do next object
	clc
.ibcroamy
	adc	_bordertop
	sta	OBJECT+1,x     ;put y in oam shadow
	lda	(_modenum),y    ;the object number
	and	#$cfff	;kill size bits in interlace mode
	clc
	adc	v_spriteoff     ;offset of this sprite in vram table
	eor	#$c000
	sta	OBJECT+2,x

	lda	>_croamdat2,x    ;oam size/highbit mask for this offset
	sta	_temp4         ;save it

	lda	>_croamdat2+2,x
	tax

	lda	_temp0         ;x sign flag
	bmi	.ibcroamxneg
	lda	_temp4         ;get the mask
	and	OBJECT+$200,x  ;mask the word with the bit in it
	sta	OBJECT+$200,x  ;store it back
.ibcroamxneg  
	lda	_objsize   ;dimension of object
	cmp	_largespritesize     ;set to larger size dim
	bne	.ibcroamcont     ;if not equal then small size so skip
	rol	_temp4         ;carry is set for rol
	lda	_temp4         ;get it
	eor	#$FFFF         ;reverse it
	ora	OBJECT+$200,x  ;set size bit with it
	sta	OBJECT+$200,x  ;store size bit
.ibcroamcont
	lda	_oamcount      ;increment oamcount to reflect addition
	clc
	adc	#4             ;four bytes per entry
	sta	_oamcount
	cmp	#$200          ;end of oam? (last slot skipped for speed above)
	beq	.ibcroamdone     ;yes then exit
.ibcroamnext  
	iny                  ;otherwise, get next object in sprite
	iny                  ;otherwise, get next object in sprite
	dec	_sprisize      ;check for next object
	beq	.ibcroaminc      ;if not more skip jump
	jmp	.ibcroamloop     ;more so jump back
.ibcroaminc   
	ldx	_ztemp                  ;done so get count
	inx 	                ;increment for next attr entry
	inx
	jmp	.croam0        ;loop back to beginning
.ibcroamdone  
	plb
	rtl

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

Senddata2:
	SI
	ldx	#<VMDATAL
	stx	DMA0DEST	; write to vram data register
	ldx	#$01
	stx	DMA0INC	; write words
	ldx	#$80
	stx	VMAINC	; set inc on $2119 (write words)
	ldx	v_xfercount
.loop
	dex
	dex
	bmi	.end

	lda	v_xferloc,x
	sta	DMA0A1L	; set source address
	lda	v_xferdest,x
	sta	VMADDL 	; address to write to
	lda	v_xferlen,x
	sta	DMA0NUML	; set dma size
	ldy	v_xferbank,x	; get bank from stack
	sty	DMA0A1B	; set source bank
	ldy	#$01
	sty	MDMAEN	; trigger dma
	bra	.loop
.end
	LI
	stz	v_xfercount
	stz	_nextdataaddress	;assume all _data is purged
	rtl

;a=vram addr
;y=frame * 2 (word index)
;send frame for proxy
Sendframe2:
	phb

	ldx	v_xfercount
	
	sta	_temp7	;vram address (dest0)
	sty	_temp6	;frame

	lda	_modecount      	;bank
	SA
	pha
	LA
	plb
	
	ldy	#0
	lda	(_sprimode),y
	bpl	.uncompressed
	jmp	.compressed
.uncompressed
	bit	#2
	beq	.notglobal
	jmp	Global
.notglobal
	bit	#1
	beq	.normalmode
.relativemode
	clc
	ldy	#16
	lda	(_sprimode),y
	adc	_sprimode
	sta	_modex
	ldy	#14
	lda	(_sprimode),y	;loc pointer
	adc	_sprimode
	sta	_modenum
	ldy	_temp6	;frame number

	lda	(_modenum),y	;loc for this frame
	adc	_sprimode
	sta	_modenum

	lda	(_modex),y
	adc	_sprimode
	sta	_modey	;len array for this frame

	iny
	iny
	lda	(_modex),y	;next len array
	adc	_sprimode
	sta	_modex	;save over len pointer

	bra	.endmode
.normalmode
	ldy	#16
	lda	(_sprimode),y	;len pointer
	sta	_modex
	ldy	#14
	lda	(_sprimode),y	;loc pointer
	sta	_modenum

	ldy	_temp6	;frame number

	lda	(_modenum),y	;loc for this frame
	sta	_modenum

	lda	(_modex),y
	sta	_modey	;len array for this frame

	iny
	iny
	lda	(_modex),y	;next len array
	sta	_modex	;save over len pointer

.endmode
	stz	_temp8
	ldy	#0
.loop
	lda	_temp7	;dest vram address
	clc
	adc	_temp8
	sta	v_xferdest,x

	lda	_modecount	;source bank
	sta	v_xferbank,x

	lda	_modenum	;source record loc
	sta	v_xferloc,x
	
	lda	(_modey),y	;len from array
	sta	v_xferlen,x	

	clc
	adc	_modenum
	sta	_modenum	;udate source addr with current len
				;for next loop

	lda	v_xferlen,x	;get curr len
	lsr
	clc
	adc	_temp8	;old vram dest
	sta	_temp8	;save as new dest

	and	#$ff		;check for partial line
	beq	.addrokay	;if not then okay
	lda	_temp8
	clc			;otherwise add one more line
	adc	#$100
	and	#$ff00
	sta	_temp8

.addrokay
	inx
	inx

	inc	_modey
	inc	_modey
	lda	_modey
	cmp	_modex
	bcc	.loop
.end
	stx	v_xfercount
	plb
	rtl
.compressed
	bit	#2
	beq	.cnotglobal
	jmp	Compressedglobal
.cnotglobal
	bit	#1
	beq	.cnormalmode
.crelativemode
	clc
	ldy	#16
	lda	(_sprimode),y
	adc	_sprimode
	sta	_modex
	ldy	#14
	lda	(_sprimode),y	;loc pointer
	adc	_sprimode
	sta	_modenum
	ldy	_temp6	;frame number

	lda	(_modenum),y	;loc for this frame
	adc	_sprimode
	sta	_objcomp

	lda	(_modex),y
	adc	_sprimode
	sta	_modey	;len array for this frame

	iny
	iny
	lda	(_modex),y	;next len array
	adc	_sprimode
	sta	_modex	;save over len pointer

	bra	.cendmode
.cnormalmode
	ldy	#16
	lda	(_sprimode),y	;len pointer
	sta	_modex
	ldy	#14
	lda	(_sprimode),y	;loc pointer
	sta	_modenum

	ldy	_temp6	;frame number

	lda	(_modenum),y	;loc for this frame
	sta	_objcomp

	lda	(_modex),y
	sta	_modey	;len array for this frame

	iny
	iny
	lda	(_modex),y	;next len array
	sta	_modex	;save over len pointer

.cendmode
	lda	#_data
	clc
	adc	_nextdataaddress	;offset into data buffers
	sta	_modenum

	stz	_temp8
	ldy	#0
.cloop
	lda	_temp7	;dest vram address
	clc
	adc	_temp8
	sta	v_xferdest,x

	lda	#^_data	;_modecount	;source bank
	sta	v_xferbank,x

	lda	_modenum	;source record loc
	sta	v_xferloc,x
	
	lda	(_modey),y	;len from array
	sta	v_xferlen,x	

	clc
	adc	_modenum
	sta	_modenum	;udate source addr with current len
				;for next loop

	lda	v_xferlen,x	;get curr len
	lsr
	clc
	adc	_temp8	;old vram dest
	sta	_temp8	;save as new dest

	and	#$ff		;check for partial line
	beq	.caddrokay	;if not then okay
	lda	_temp8
	clc			;otherwise add one more line
	adc	#$100
	and	#$ff00
	sta	_temp8

.caddrokay
	inx
	inx

	inc	_modey
	inc	_modey
	lda	_modey
	cmp	_modex
	bcc	.cloop
.cend
	stx	v_xfercount
	jsr	Decompressframe
	plb
	rtl


Global:
	bit	#1
	beq	.normalmode
.relativemode
	clc
	ldy	#18
	lda	(_sprimode),y
	adc	_sprimode
	sta	_objcomp	;loc of compressed global char set

	ldy	#16
	lda	(_sprimode),y
	adc	_sprimode
	sta	_modex
	ldy	#14
	lda	(_sprimode),y	;loc pointer
	adc	_sprimode
	sta	_modenum
	ldy	_temp6	;frame number

	lda	(_modenum),y	;loc for this frame
	adc	_sprimode
	sta	_modefpc

	lda	(_modex),y
	adc	_sprimode
	sta	_modey	;len array for this frame

	iny
	iny

	lda	(_modenum),y
	adc	_sprimode
	sta	_modenum	;next loc address

	lda	(_modex),y	;next len array
	adc	_sprimode
	sta	_modex	;save over len pointer

	bra	.endmode
.normalmode
	ldy	#18
	lda	(_sprimode),y
	sta	_objcomp       	;location of compressed global char set
	ldy	#16
	lda	(_sprimode),y	;len pointer
	sta	_modex
	ldy	#14
	lda	(_sprimode),y	;loc pointer
	sta	_modenum

	ldy	_temp6	;frame number

	lda	(_modenum),y	;loc for this frame
	sta	_modefpc

	lda	(_modex),y
	sta	_modey	;len array for this frame

	iny
	iny

	lda	(_modenum),y	;next loc addr
	sta	_modenum

	lda	(_modex),y	;next len array
	sta	_modex	;save over len pointer

.endmode
	lda	_nextdataaddress
	clc
	adc	#_data
	pha

	lda	_modecount
	sta	_objcomp+2	;bank of charset

	jsr	Buildframe

	pla
	sta	_modenum

	ldx	v_xfercount

	stz	_temp8
	ldy	#0
.cloop
	lda	_temp7	;dest vram address
	clc
	adc	_temp8
	sta	v_xferdest,x

	lda	#^_data	;_modecount	;source bank
	sta	v_xferbank,x

	lda	_modenum	;source record loc
	sta	v_xferloc,x
	
	lda	(_modey),y	;len from array
	sta	v_xferlen,x	

	clc
	adc	_modenum
	sta	_modenum	;udate source addr with current len
				;for next loop

	lda	v_xferlen,x	;get curr len
	lsr
	clc
	adc	_temp8	;old vram dest
	sta	_temp8	;save as new dest

	and	#$ff		;check for partial line
	beq	.caddrokay	;if not then okay
	lda	_temp8
	clc			;otherwise add one more line
	adc	#$100
	and	#$ff00
	sta	_temp8

.caddrokay
	inx
	inx

	inc	_modey
	inc	_modey
	lda	_modey
	cmp	_modex
	bcc	.cloop
.cend
	stx	v_xfercount
	plb
	rtl

Compressedglobal:
	bit	#1
	beq	.normalmode
.relativemode
	clc
	ldy	#18
	lda	(_sprimode),y
	adc	_sprimode
	sta	_objcomp	;loc of compressed global char set

	ldy	#16
	lda	(_sprimode),y
	adc	_sprimode
	sta	_modex
	ldy	#14
	lda	(_sprimode),y	;loc pointer
	adc	_sprimode
	sta	_modenum
	ldy	_temp6	;frame number

	lda	(_modenum),y	;loc for this frame
	adc	_sprimode
	sta	_modefpc

	lda	(_modex),y
	adc	_sprimode
	sta	_modey	;len array for this frame

	iny
	iny

	lda	(_modenum),y	;next loc for this frame
	adc	_sprimode
	sta	_modenum

	lda	(_modex),y	;next len array
	adc	_sprimode
	sta	_modex	;save over len pointer

	bra	.endmode
.normalmode
	ldy	#18
	lda	(_sprimode),y
	sta	_objcomp       	;location of compressed global char set
	ldy	#16
	lda	(_sprimode),y	;len pointer
	sta	_modex
	ldy	#14
	lda	(_sprimode),y	;loc pointer
	sta	_modenum

	ldy	_temp6	;frame number

	lda	(_modenum),y	;loc for this frame
	sta	_modefpc

	lda	(_modex),y
	sta	_modey	;len array for this frame

	iny
	iny
	
	lda	(_modenum),y	;next loc for this frame
	sta	_modenum

	lda	(_modex),y	;next len array
	sta	_modex	;save over len pointer

.endmode
	lda	_nextdataaddress
	clc
	adc	#_data
	pha

	jsr	Decompressframe

	pla
	sta	_objcomp
	lda	#^_data
	sta	_objcomp+2

	lda	_nextdataaddress
	clc
	adc	#_data
	pha

	jsr	Buildframe

	pla
	sta	_modenum
	
	ldx	v_xfercount

	stz	_temp8
	ldy	#0
.cloop
	lda	_temp7	;dest vram address
	clc
	adc	_temp8
	sta	v_xferdest,x

	lda	#^_data	;_modecount	;source bank
	sta	v_xferbank,x

	lda	_modenum	;source record loc
	sta	v_xferloc,x
	
	lda	(_modey),y	;len from array
	sta	v_xferlen,x	

	clc
	adc	_modenum
	sta	_modenum	;udate source addr with current len
				;for next loop

	lda	v_xferlen,x	;get curr len
	lsr
	clc
	adc	_temp8	;old vram dest
	sta	_temp8	;save as new dest

	and	#$ff		;check for partial line
	beq	.caddrokay	;if not then okay
	lda	_temp8
	clc			;otherwise add one more line
	adc	#$100
	and	#$ff00
	sta	_temp8

.caddrokay
	inx
	inx

	inc	_modey
	inc	_modey
	lda	_modey
	cmp	_modex
	bcc	.cloop
.cend
	stx	v_xfercount
	plb
	rtl

Decompressframe:
	SA
	ldy	#0		;2
	lda	(_objcomp),y     
	sta	_objkey
	iny
	ldx	_nextdataaddress	;2
	bra	.loop		;2
.zeros
	iny			;2
	lda	(_objcomp),y	
	bne	.zeros2	;2
.end
	LA			;3
	stx	_nextdataaddress
	rts			;6
	SA
.zeros2
	iny			;2
	sta	_objtemp
	lda	#0
.zeroloop
	sta	>_data,x	;5
	inx			;2
	dec	_objtemp	;2
	bne	.zeroloop	;2
.loop
	lda	(_objcomp),y
     	beq	.singlezero
.notzero
	cmp	_objkey
	beq	.zeros	;2
	iny			;2
	sta	>_data,x	;5
	inx			;2
	bra	.loop		;2

.singlezero
	iny
	sta	>_data,x
	inx
	lda	(_objcomp),y
	bne	.notzero
	jmp	.end
	LAI


; [_objcomp]	address of global charset
; (_modefpc)	address of char list
; _modenum	address of next char list
Buildframe:
	ldy	#0		;get next char # in list
	lda	(_modefpc),y
	tay			;convert to offset in global chars
	ldx	_nextdataaddress	;get _nextdataaddress

	lda	#$f		;counter for 16 words
	sta	_modedim
	
	;transfer char at _objcomp + y to _data buffer at _nextdataaddress
.loop
	lda	[_objcomp],y
	sta	>_data,x
	inx
	inx
	iny
	iny
	dec	_modedim	;word count
	bpl	.loop

	stx	_nextdataaddress	;save next available address

	lda	_modefpc
	inc		  	;move address up one word
	inc
	sta	_modefpc
	cmp	_modenum	;at end of list (into next list)?
	bcc	Buildframe

	rts
