*****************************************************************************
*
* STAT.ASM
*
* Status Bar Routines
*
* See VRAM layout at end of file.
*
*****************************************************************************

*****************************************************************************
*
* Creates status bar
*
*****************************************************************************

PlotStats:
	lda	v_pause2
	beq	.dostats

	jsl	Loaddebuginfo

	rtl

.dostats

**** Plot Health Bar *******************

	ldy	z_attrcount	; Get attr counter

	lda	#8	; HealthBar X
	clc
	adc	z_levelx
	sta	ATTRX,y

	lda	#16	; HealthBar Y
	clc
	adc	z_levely
	sta	ATTRY,y

	lda	v_healthframe	; Which frame are we in?
	sta	ATTRFRAME,y

	lda	#^tzhbar
	sta	ATTRBANK,y

	lda	#tzhbar
	sta	ATTRDREC,y

	lda	#$3400
	ora	ATTROFF,y
	sta	ATTROFF,y

	iny
	iny


**** Plot Number of Lives **************

	lda	#38	; Number of lives X position
	clc
	adc	z_levelx
	sta	ATTRX,y

	lda	#16	; Number of lives Y position
	clc
	adc	z_levely
	sta	ATTRY,y

	lda	v_lives	; Get number of lives
	sta	ATTRFRAME,y

	lda	#^hexnums
	sta	ATTRBANK,y

	lda	#hexnums
	sta	ATTRDREC,y

	lda	#$322A	; Object name, palette, flip, etc.
	ora	ATTROFF,y
	sta	ATTROFF,y

	iny
	iny


*****************************************************
*
* Display either dart / num dart or,
*                interface stats.
*

	lda	v_frmdsp	; Which mode? 0=normal ; 1=debug
	beq	.normdartplt	; Normal plot mode

	lda	#230	; Dart Symbol X position
	clc
	adc	z_levelx
	sta	ATTRX,y

	lda	#34	; Dart Symbol Y position
	clc
	adc	z_levely
	sta	ATTRY,y

	lda	v_numdart	; Which frame are we in?
	sta	ATTRFRAME,y

	lda	#^hexnums
	sta	ATTRBANK,y

	lda	#hexnums
	sta	ATTRDREC,y

	lda	#$3240	; Object name, palette, flip, etc.
	ora	ATTROFF,y
	sta	ATTROFF,y

	iny
	iny

	lda	#220	; Dart Count X position
	clc
	adc	z_levelx
	sta	ATTRX,y

	lda	#34	; Dart Count Y position
	clc
	adc	z_levely
	sta	ATTRY,y

	lda	v_numdart+2	; Which frame are we in?
	sta	ATTRFRAME,y

	lda	#^hexnums
	sta	ATTRBANK,y

	lda	#hexnums
	sta	ATTRDREC,y

	lda	#$3222	; Object name, palette, flip, etc.
	ora	ATTROFF,y
	sta	ATTROFF,y

	iny
	iny

	jmp	.plotcoins


**** Plot Dart Symbol ******************

.normdartplt
;	lda	#200	; Dart Symbol X position
;	clc
;	adc	z_levelx
;	sta	ATTRX,y
;
;	lda	#30	; Dart Symbol Y position
;	clc
;	adc	z_levely
;	sta	ATTRY,y
;
;	lda	#0	; Which frame are we in?
;	sta	ATTRFRAME,y
;
;	lda	#^tzpups1
;	sta	ATTRBANK,y
;
;	lda	#tzpups1
;	sta	ATTRDREC,y
;
;	lda	#$3222	; Object name, palette, flip, etc.
;	ora	ATTROFF,y
;	sta	ATTROFF,y
;
;	iny
;	iny
;

**** Plot number of darts **************

	lda	v_weaponsel
	beq	.plotcoins

	lda	#230	; Dart Count X position
	clc
	adc	z_levelx
	sta	ATTRX,y

	lda	#34	; Dart Count Y position
	clc
	adc	z_levely
	sta	ATTRY,y

	lda	v_numdart	; Which frame are we in?
	sta	ATTRFRAME,y

	lda	#^hexnums
	sta	ATTRBANK,y

	lda	#hexnums
	sta	ATTRDREC,y

	lda	#$3240	; Object name, palette, flip, etc.
	ora	ATTROFF,y
	sta	ATTROFF,y

	iny
	iny


.plotcoins

**** Plot Coin Symbol ******************

	lda	#200	; Coin Symbol X position
	clc
	adc	z_levelx
	sta	ATTRX,y

	lda	#16	; Coin Symbol Y position
	clc
	adc	z_levely
	sta	ATTRY,y


**** Check mode ****

	lda	v_frmdsp	; Display frame & sequence data?
	beq	.docoin	; No  - Display coin normally

	lda	#34	; Coin Symbol Y position
	clc
	adc	z_levely
	sta	ATTRY,y

	lda	#0	; Do inverted arrowhead for indicator
	sta	ATTRFRAME,y

	lda	#^tzpups1
	sta	ATTRBANK,y

	lda	#tzpups1
	sta	ATTRDREC,y

	lda	#$B228	; Object name, palette, flip, etc.
	ora	ATTROFF,y
	sta	ATTROFF,y

	bra	.nownumber

.docoin
	lda	z_level
	cmp	#SHAMONBOSS
	bne	.okdocoin

	jmp	.plotselweapn

.okdocoin
	lda	#0	; Do coin
	sta	ATTRFRAME,y

	lda	#^tzpups1
	sta	ATTRBANK,y

	lda	#tzpups1
	sta	ATTRDREC,y

	lda	#$3228	; Object name, palette, flip, etc.
	ora	ATTROFF,y
	sta	ATTROFF,y

.nownumber
	iny
	iny


**** Plot Coin Tens Place **************


	lda	#220	; Coin Count (tens) X position
	clc
	adc	z_levelx
	sta	ATTRX,y

	lda	#16	; Coin Count (tens) Y position
	clc
	adc	z_levely
	sta	ATTRY,y

	lda	v_xynumframe	; Which frame are we in?
	sta	ATTRFRAME,y

	lda	#^hexnums
	sta	ATTRBANK,y

	lda	#hexnums
	sta	ATTRDREC,y

	lda	#$3242	; Object name, palette, flip, etc.
	ora	ATTROFF,y
	sta	ATTROFF,y

	iny
	iny


**** Plot Coin Ones Place ****

	lda	#230	; Coin Count (ones) X position
	clc
	adc	z_levelx
	sta	ATTRX,y

	lda	#16	; Coin Count (ones) Y position
	clc
	adc	z_levely
	sta	ATTRY,y

	ldx	#2
	lda	v_xynumframe,x	; Which frame are we in?
	sta	ATTRFRAME,y

	lda	#^hexnums
	sta	ATTRBANK,y

	lda	#hexnums
	sta	ATTRDREC,y

	lda	#$3244	; Object name, palette, flip, etc.
	ora	ATTROFF,y
	sta	ATTROFF,y

	iny
	iny


**** Plot Selected Weapon ****
.plotselweapn
	lda	#200	; Selected Weapon X position
	clc
	adc	z_levelx
	sta	ATTRX,y

	lda	#34	; Selected Weapon Y position
	clc
	adc	z_levely
	sta	ATTRY,y

	lda	#WEAPKNIFE
	xba
	and	#$FF
	clc
	adc	v_lastweap
	sta	ATTRFRAME,y

	lda	#^tzpups1
	sta	ATTRBANK,y

	lda	#tzpups1
	sta	ATTRDREC,y

	lda	#$322C	; Object name, palette, flip, etc.
	ora	ATTROFF,y
	sta	ATTROFF,y

	iny
	iny

	sty	z_attrcount

	lda	v_dartactive
	beq	.xitplot

	lda	v_dartx	; Selected Weapon X position
	sta	ATTRX,y

	lda	v_darty	; Selected Weapon Y position
	sta	ATTRY,y

	lda	#0
	sta	ATTRFRAME,y

	lda	#^tzdart
	sta	ATTRBANK,y

	lda	#tzdart
	sta	ATTRDREC,y

	lda	v_dartdir
	ora	#$202E
	sta	ATTROFF,y

	iny
	iny

	sty	z_attrcount


.xitplot
	rtl


*****************************************************************************
*
* Update the score & health if they have changed
*
*****************************************************************************

Statupdate:
	lda	v_pause2
	beq	.dostats

	rtl
.dostats
	lda	v_togstatupdate
        	eor	#1
	sta	v_togstatupdate

	beq	toggle1
	
	jmp	toggle2
@toggle1:
	lda	v_health	; Get current health status
	cmp	v_lasthealth

	beq	.dodart
	
.update
	lda	v_health	; Get current health status
	sta	v_lasthealth

	lda	#MAXHEALTH
	sec
	sbc	v_health
	sta	v_healthframe

	asl
	tay		; Store frame number

	lda	#^tzhbar
	sta	z_dreccount

	lda	#tzhbar
	sta	z_spridrec

	lda	#OBJBASE	; Healthbar goes at the start

	jsl	Sendframe	; Send Frame

.dodart:
	lda	v_dartactive	; Get current health status
	beq	.dolives

.updatedart:
	ldy	#0

	lda	#^tzdart
	sta	z_dreccount

	lda	#tzdart
	sta	z_spridrec

	lda	#$2E	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame

.dolives:
	lda	v_lives	; Get current health status
	cmp	v_lastlives

	beq	.weaponsel

.updateliv:
	lda	v_lives	; Get current health status
	sta	v_lastlives
	asl
	tay

	lda	#^hexnums
	sta	z_dreccount

	lda	#hexnums
	sta	z_spridrec

	lda	#$2A	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame

.weaponsel
	lda	v_weaponsel
	cmp	v_lastweap
	beq	.xittog1
.updateweap
	lda	v_weaponsel
	sta	v_lastweap

	lda	#WEAPKNIFE
	xba
	and	#$FF
	clc
	adc	v_lastweap
	asl
	tay

	lda	#^tzpups1
	sta	z_dreccount

	lda	#tzpups1
	sta	z_spridrec

	lda	#$2C	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame
.xittog1
        	rtl

@toggle2:

.chkcbox
	lda	v_plotcbox
	beq	.chkfrmdsp
.loadcbox
	ldy	#0

	lda	#^tilebox
	sta	z_dreccount

	lda	#tilebox
	sta	z_spridrec

	lda	#$4C	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame

	ldy	#0

	lda	#^tilebox
	sta	z_dreccount

	lda	#tilebox
	sta	z_spridrec

	lda	#$4E	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame
.exitbox
	rtl

**************************************** 

.chkfrmdsp
	lda	v_frmdsposhot	; One shot set for frames/coins dsp?
	bne	.switchmode	; Yes - Switch to other mode

	lda	v_frmdsp	; No  - What is current mode?
	beq	.switchtcoin	; Coin mode

****************************************
*
* Do Frame display for debug mode
*

.debfrmode
	lda	#DARTS	; Otherwise, do frame/seq display
	and	#$FF00
	xba
	asl
	tay		; (Store for Sendframe)

	lda	#^tzpups1
	sta	z_dreccount

	lda	#tzpups1
	sta	z_spridrec

	lda	#$28	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame

	lda	v_coincur	; Preset so current coin count is
	dec		; ...displayed when mode switch occurs
	sta	v_coinlast

	lda	v_playerseqlog	; Get Current Frame number
	
	jsr	Computecoincnt	; Convert to decimal & stuf VRAM

	jsr	Numcoinres	; Stuff VRAM at coin count spot

	lda	v_playertype	; Get current player type
	cmp	v_oldplytype	; Same ?
	bne	.updateptfld	; No  - Update

	rtl		; Yes -
           
.updateptfld
	sta	v_oldplytype	; Store new as old

	jsr	Computecoincnt	; Convert to decimal

	lda	v_xynumframe
	sta	v_numdart
	lda	v_xynumframe+2
	sta	v_numdart+2

	jsr	Numdartres	; Stuff VRAM at dart count spot

	rtl


****************************************	

.switchmode
	stz	v_frmdsposhot	; Reset one shot

	lda	v_frmdsp	; Toggle feature
	eor	#1
	sta	v_frmdsp

	lda	v_frmdsp	; Which mode? 0=normal ; 1=debug
	bne	.debfrmode	; Debug frame mode

****************************************
*
* Do Coin display for normal game mode
*

.switchtcoin
	lda	#BONUSCOIN
	and	#$FF00
	xba
	asl
	tay		; (Store for Sendframe)

	lda	#^tzpups1
	sta	z_dreccount

	lda	#tzpups1
	sta	z_spridrec

	lda	#$28	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame

	lda	#DARTS
	and	#$FF00
	xba
	asl
	tay		; (Store for Sendframe)

	lda	#^tzpups1
	sta	z_dreccount

	lda	#tzpups1
	sta	z_spridrec

	lda	#$22	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame


.docoincnt
	lda	v_playertype	; Preset old player type
	dec
	sta	v_oldplytype	;

	lda	v_coincur
	cmp	v_coinlast

	beq	.donumdrt

	jsr	Computecoincnt

	jsr	Numcoinres

	lda	v_coincur
	sta	v_coinlast

.donumdrt
	lda	v_numdart
	cmp	v_lastnumdart

	beq	.exitcoin
.updatenumdrt
	lda	v_numdart	; Which frame are we in?
	sta	v_lastnumdart
	asl
	tay

	lda	#^hexnums
	sta	z_dreccount 

	lda	#hexnums
	sta	z_spridrec

	lda	#$40	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame
.exitcoin
	rtl


Computecoincnt:
	
	SA

	sta	WRDIVL	; Store lsb of dividend
	xba
	sta	WRDIVH	; Store msb of dividend

	lda	#$0A	
	sta	WRDIVB	;

	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop

	lda	RDMPYL	; Get remainder (ones component)
	xba
	lda	RDMPYH
	xba
	LA

	sta	v_xynumframe+2

	SA
	lda	RDDIVL	; Get quotient (tens component)
	xba
	lda	RDDIVH
	xba
	LA

	sta	v_xynumframe

	rts

Numcoinres:
	lda	v_xynumframe
	asl
	tay

	lda	#^hexnums
	sta	z_dreccount 

	lda	#hexnums
	sta	z_spridrec

	lda	#$42	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame


	lda	v_xynumframe+2
	asl
	tay

	lda	#^hexnums
	sta	z_dreccount 

	lda	#hexnums
	sta	z_spridrec

	lda	#$44	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame

	rts	


Numdartres:
	lda	v_xynumframe
	asl
	tay

	lda	#^hexnums
	sta	z_dreccount 

	lda	#hexnums
	sta	z_spridrec

	lda	#$22	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame


	lda	v_xynumframe+2
	asl
	tay

	lda	#^hexnums
	sta	z_dreccount 

	lda	#hexnums
	sta	z_spridrec

	lda	#$40	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame

	rts	



	
*****************************************************************************
*
* Called during VBLANK
*
*****************************************************************************

InitStat:

**** Do Dart ****

	ldy	#0

	lda	#^tzdart
	sta	z_dreccount

	lda	#tzdart
	sta	z_spridrec

	lda	#$2E	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame


**** Do Animated Portrait (Health) ****

	lda	v_healthframe	; Get current health frame
	asl
	tay		; Store frame number (word)

	lda	#^tzhbar
	sta	z_dreccount

	lda	#tzhbar
	sta	z_spridrec

	lda	#OBJBASE	; Healthbar goes at the start

	jsl	Sendframe	; Send Frame


**** Do num lives ****

	lda	v_lives	; Number of lives to start
	asl
	tay		; Store frame number (word)

	lda	#^hexnums
	sta	z_dreccount

	lda	#hexnums
	sta	z_spridrec

	lda	#$2A	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame


**** Do DART Symbol ****

	lda	#DARTS
	and	#$FF00
	xba
	asl
	tay		; (Store for Sendframe)

	lda	#^tzpups1
	sta	z_dreccount

	lda	#tzpups1
	sta	z_spridrec

	lda	#$22	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame



**** Do DART Count ****

	lda	v_numdart
	asl
	tay		; (Store for Sendframe)

	lda	#^hexnums
	sta	z_dreccount

	lda	#hexnums
	sta	z_spridrec

	lda	#$40	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame

	jsl	Senddata


**** Do Bonus Coin ****

	lda	#BONUSCOIN
	and	#$FF00
	xba
	asl
	tay		; (Store for Sendframe)

	lda	#^tzpups1
	sta	z_dreccount

	lda	#tzpups1
	sta	z_spridrec

	lda	#$28	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame

**** Do Boss Health Bar ****


	ldy	#0

	lda	#^bossbar
	sta	z_dreccount

	lda	#bossbar
	sta	z_spridrec

	lda	#$0E	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

;	jsl	Sendframe	; Send Frame

	jsl	Senddata


**** Do Coin Decimal Value ****

	lda	v_coincur

	jsr	Computecoincnt

**** Do Weapon ****

	lda	#WEAPKNIFE
	xba
	and	#$FF
	clc
	adc	v_lastweap
	asl
	tay		; (Store for Sendframe)

	lda	#^tzpups1
	sta	z_dreccount

	lda	#tzpups1
	sta	z_spridrec

	lda	#$2C	; Object name - Weapon
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Queue it up...

;	jsl	Senddata


**** Do PAUSE mode ****

	ldy	#0

	lda	#^tzpause
	sta	z_dreccount

	lda	#tzpause
	sta	z_spridrec

	lda	#$46	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	;

	jsl	Sendframe	; Send Frame

	jsl	Senddata

	lda	v_plotcbox
	beq	.dose

	jsl	Loadtileboxes

	jsl	Senddata

.dose
	rtl


****************************************

PlotPause
	lda	v_pause2	; Debug Mode?
	bne	.skippp	; Yes -

	lda	v_pause	; Pause Game?
	bne	.skippmp	; Yes -
.skippp
	lda	v_pauseos	; One shot triggered?
	beq	.normskip	; No  - Process normally

	stz	v_pauseos	; Yes -

	lda	#1
	sta	v_resettbos

	jsl	Loadtileboxes
.normskip
	rtl		; No  -
.skippmp
	lda	v_pauseos	; One shot triggered?
	beq	.normpp	; No  - Process normally

	stz	v_pauseos	; Yes -

	ldy	#0

	lda	#^tzpause
	sta	z_dreccount

	lda	#tzpause
	sta	z_spridrec

	lda	#$46	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	;

	jsl	Sendframe	; Send Frame


.normpp
	ldy	z_attrcount	; Get attr counter

	lda	#.pausex	
	clc
	adc	z_levelx
	sta	ATTRX,y

	lda	#.pausey	
	clc
	adc	z_levely
	sta	ATTRY,y

	lda	#0
	sta	ATTRFRAME,y

	lda	#^hexnums
	sta	ATTRBANK,y

	lda	#hexnums
	sta	ATTRDREC,y

	lda	#$3446	; Object name, palette, flip, etc.
	sta	ATTROFF,y

	iny
	iny

	lda	#.pausex + 14	
	clc
	adc	z_levelx
	sta	ATTRX,y

	lda	#.pausey	
	clc
	adc	z_levely
	sta	ATTRY,y

	lda	#1
	sta	ATTRFRAME,y

	lda	#^hexnums
	sta	ATTRBANK,y

	lda	#hexnums
	sta	ATTRDREC,y

	lda	#$3448	; Object name, palette, flip, etc.
	ora	ATTROFF,y
	sta	ATTROFF,y

	iny
	iny

	lda	#.pausex + 28	
	clc
	adc	z_levelx
	sta	ATTRX,y

	lda	#.pausey	
	clc
	adc	z_levely
	sta	ATTRY,y

	lda	#2
	sta	ATTRFRAME,y

	lda	#^hexnums
	sta	ATTRBANK,y

	lda	#hexnums
	sta	ATTRDREC,y

	lda	#$344A	; Object name, palette, flip, etc.
	ora	ATTROFF,y
	sta	ATTROFF,y

	iny
	iny

	lda	#.pausex + 42	; Number of lives X position
	clc
	adc	z_levelx
	sta	ATTRX,y

	lda	#.pausey	; Number of lives Y position
	clc
	adc	z_levely
	sta	ATTRY,y

	lda	#3
	sta	ATTRFRAME,y

	lda	#^hexnums
	sta	ATTRBANK,y

	lda	#hexnums
	sta	ATTRDREC,y

	lda	#$344C	; Object name, palette, flip, etc.
	ora	ATTROFF,y
	sta	ATTROFF,y

	iny
	iny

	lda	#.pausex + 56	; Number of lives X position
	clc	   
	adc	z_levelx
	sta	ATTRX,y

	lda	#.pausey	; Number of lives Y position
	clc
	adc	z_levely
	sta	ATTRY,y

	lda	#4
	sta	ATTRFRAME,y

	lda	#^hexnums
	sta	ATTRBANK,y

	lda	#hexnums
	sta	ATTRDREC,y

	lda	#$344E	; Object name, palette, flip, etc.
	ora	ATTROFF,y
	sta	ATTROFF,y

	iny
	iny

	sty	z_attrcount

	rtl	   

.pausex	.equ	90
.pausey	.equ	98

*****************************************************************************
*
*
*    0    2    4    6    8    A    C    E
* 00 +----+----+----+----+----+----+----+----+\
*    |          	 |                   | \
*    | Animated Health   |      F R E E      |  - Also Debug X,Y (whole row)
*    |          	 |                   | /
* 20 +----+----+----+----+----+----+----+----+[
*    |1-UP|Dart|Heal|Bnus|Bnus|Num |Weap|Dart| \
*    |anim|syml|syml|anim|coin|life|    |    |  - Debug Tile outline
*    |    |    |    |    |    |    |    |    | /
* 40 +----+----+----+----+----+----+----+----+
*    |Num |Num |Num |    |    |    |tile|tile|
*    | of |coin|coin| P  | A  | U  |    |    |
*    |Dart|tens|ones|    |    |    | S  | E  |
* 60 +----+----+----+----+----+----+----+----+<-- Tarzan Load Point
*    |    |    |    |    |    |    |    |    |
*    |    |    |    |    |    |    |    |    |
*    |    |    |    |    |    |    |    |    |
* 80 +----+----+----+----+----+----+----+----+
*    |    |    |    |    |    |    |    |    |
*    |    |    |    |    |    |    |    |    |
*    |    |    |    |    |    |    |    |    |
* A0 +----+----+----+----+----+----+----+----+
*    |    |    |    |    |    |    |    |    |
*    |    |    |    |    |    |    |    |    |
*    |    |    |    |    |    |    |    |    |
* C0 +----+----+----+----+----+----+----+----+
*    |    |    |    |    |    |    |    |    |
*    |    |    |    |    |    |    |    |    |
*    |    |    |    |    |    |    |    |    |
* E0 +----+----+----+----+----+----+----+----+
*    |    |    |    |    |    |    |    |    |
*    |    |    |    |    |    |    |    |    |
*    |    |    |    |    |    |    |    |    |
*100 +----+----+----+----+----+----+----+----+
*    |    |    |    |    |    |    |    |    |
*    |    |    |    |    |    |    |    |    |
*    |    |    |    |    |    |    |    |    |
*120 +----+----+----+----+----+----+----+----+
*    |    |    |    |    |    |    |    |    |
*    |    |    |    |    |    |    |    |    |
*    |    |    |    |    |    |    |    |    |
*140 +----+----+----+----+----+----+----+----+
*
*
*
*
*****************************************************************************

Loaddebuginfo:
	lda	v_dboneshot
	beq	.skipit

	stz	v_dboneshot
.lddebi
	lda	v_playeroldx
	cmp	v_playerx
	bne	.goforit

	dec	v_playeroldx
	bra	.lddebi
.goforit
	jsl	Objxy
.skipit
	rtl


****************************************

Loadtileboxes:
	ldy	#0

	lda	#^tilebox
	sta	z_dreccount

	lda	#tilebox
	sta	z_spridrec

	lda	#$4C	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	;

	jsl	Sendframe	; Send Frame

	ldy	#0

	lda	#^tilebox
	sta	z_dreccount

	lda	#tilebox
	sta	z_spridrec

	lda	#$4E	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	;

	jsl	Sendframe	; Send Frame

	rtl


*****************************************************************************
*

UpBossBar:
	lda	v_pause2
	beq	.dobar

	rtl
.dobar
	lda	v_bossbaron
	bne	.ok2update
.exitupboss
	rtl

.ok2update
	lda	v_bossdead
	bmi	.exitupboss

	lda	v_priestdead
	bne	.exitupboss

	lda	v_bosshealth
	beq	.exitupboss

	ldy	#0

	lda	#^bossbar
	sta	z_dreccount

	lda	#bossbar
	sta	z_spridrec

	lda	#$0E	; Object name
	asl
	asl
	asl
	asl
	adc	#OBJBASE	; Compute VRAM address

	jsl	Sendframe	; Send Frame

;	jsl	Senddata

        	rtl

*---------------------------------------

Plotbossbar:
	lda	v_apebossdead
	beq	.plotbbar

	rtl
.plotbbar
	lda	v_bossbaron	; Is it ok to plot boss health
	bne	.ok2update

	rtl
.ok2update
	lda	#10
	sta	v_bary

	lda	v_bossdead
	bmi	.exitplotboss

	lda	v_priestdead
	bne	.exitplotboss

	lda	v_bosshealth
	inc
	beq	.exitplotboss
	bmi	.exitplotboss

	bra	.plotem
.exitplotboss
	lda	#240
	sta	v_bary

.plotem
	ldy	z_attrcount

;	lda	v_bosslevel
;	asl
;	tax
;	lda	>d_xstart,x

	lda	#56
	clc
	adc	z_levelx
	sta	z_temp0

	lda	v_bosshealth
	dec
	sta	z_temp1
.loop1
	lda	z_temp0
	sta	ATTRX,y

	lda	v_bary
	clc
	adc	z_levely
	sta	ATTRY,y

	lda  	#1
	sta	ATTRFRAME,y

	lda	#^bossbar
	sta	ATTRBANK,y

	lda	#bossbar
	sta	ATTRDREC,y

	lda	v_bosslevel
	cmp	#CLEARING
	beq	.setpri

	lda	#$240E
.setpri
	lda	#$340E
.exit
	ora	ATTROFF,y
	sta	ATTROFF,y

	iny
	iny

	lda	z_temp0
	clc
	adc	#8
	sta	z_temp0

	dec	z_temp1
	bpl	.loop1

	sty	z_attrcount

	rtl


d_xstart
	.dw	NONE	; Null Level
	.dw	NONE	; Jungle 1
	.dw	NONE	; Tarzans Home
	.dw	56	; Apes Clearing
	.dw	NONE	; Swamp

	.dw	56	; Beach
	.dw	NONE	; Beach-Bay
	.dw	NONE	; Reef
	.dw	NONE	; Ship
	.dw	NONE	; Ship Hold A

	.dw	NONE	; Ship Hold B
	.dw	NONE	; Jungle 3
            	.dw	NONE	; Downriver
	.dw	56	; Jungle 4
	.dw	NONE	; UpRiver

	.dw	NONE	; Waterfall
	.dw	NONE	; Caverns
	.dw	NONE	; Opar - Street
	.dw	NONE	; Opar - Wells
	.dw	NONE	; Opar - Temple

	.dw	56	; Opar - Shamon Boss




