*****************************************************************************
*
* Tarzan - Main File
*          Filename : TZAN.ASM
*          Created  : 14-JUL-93
*
*****************************************************************************
*
* Bank Map:
*
* Bank 00 - Interupts, Startup Code, Main Loop, Low Level, Utils, etc. [CODE]
* Bank 01 - Player, Foe & Boss Control Routines, Tile detect routines  [CODE]
* Bank 02 - [DATA] Foe & Item tables
* Bank 03 - [DATA] Tile Data
* Bank 04 - Collision Routine; Level Definitions for Foes & Items [CODE/DATA]
* Bank 05 - FREE
* Bank 06 - Tarzan Character Data [DATA] - Bank 01
* Bank 07 - Tarzan Character Data [DATA] - Bank 02
* Bank 08 - Tarzan Character Data [DATA] - Bank 03
* Bank 09 - Tarzan Character Data [DATA] - Bank 04
* Bank 0A - Tarzan Character Data [DATA] - Bank 05
* Bank 0B - Tarzan Character Data [DATA] - Bank 06
* Bank 0C - Tarzan Character Data [DATA] - Bank 07
* Bank 0D - Tarzan Character Data [DATA] - Bank 08
* Bank 0E - Start of Music & SFX (Common Module)
* Bank 0F - Music & SFX Bank 02
* ---------
* Bank 10 - Music & SFX Bank 03
* Bank 11 - Music & SFX Bank 04
* Bank 12 - Music & SFX Bank 05
* Bank 13 - Music & SFX Bank 06
* Bank 14 - Music & SFX Bank 07
* Bank 15 - Music & SFX Bank 08
* Bank 16 - Music & SFX Bank 09
* Bank 17 - FREE
* Bank 18 - Compressed Level Data [DATA]
* Bank 19 - Compressed Level Data [DATA]
* Bank 1A - Compressed Level Data [DATA]
* Bank 1B - Compressed Level Data [DATA]
* Bank 1C - Compressed Level Data [DATA]
* Bank 1D - Compressed Level Data [DATA]
* Bank 1E - Compressed Level Data [DATA]
* Bank 1F - Compressed Level Data [DATA]
* ---------
* Bank 20 - Compressed Level Data [DATA]
* Bank 21 - Compressed Level Data [DATA]
* Bank 22 - Compressed Level Data [DATA]
* Bank 23 - Compressed Level Data [DATA]
* Bank 24 - Compressed Level Data [DATA]
* Bank 25 - Compressed Level Data [DATA]
* Bank 26 - FREE
* Bank 27 - FREE
* Bank 28 - Foe/Boss Data
* Bank 29 - Foe/Boss Data
* Bank 2A - Foe/Boss Data
* Bank 2B - Foe/Boss Data
* Bank 2C - Foe/Boss Data
* Bank 2D - Foe/Boss Data
* Bank 2E - Foe/Boss Data
* Bank 2F - Foe/Boss Data
* ---------
* Bank 30 - Foe/Boss Data
* Bank 31 - Foe/Boss Data
* Bank 32 - Transart
* Bank 33 - Transart
* Bank 34 - Transart
* Bank 35 - Transart
* Bank 36 - Transart
* Bank 37 - Transart
* Bank 38 - Transart
* Bank 39 - Transart
* Bank 3A - Tarzan Character Data [DATA]
* Bank 3B - Tarzan Character Data [DATA]
* Bank 3C - Tarzan Character Data [DATA]
* Bank 3D - Tarzan Character Data [DATA]
* Bank 3E - Tarzan Character Data [DATA]
* Bank 3F - FREE
*
*****************************************************************************
           
	.list	'tzan.lst'

	.fast		; Change map modes

;	.psym		; Generate global label file

	.dpage	$0000	; Specify direct page

	.dbreg	$80	; Specify data bank

	.output	'dasm'	; Output SFX binary image



	; Include Equates, External Labal & Macros

	.incl	'equ.asm'	; Major equates
	.incl   'snesmac.asm'	; Macros
	.incl   'dcom.asm'	; Music


	; External Symbol Files

	.incl	'transart.sym'	; Transision / Intro Art
	.incl   'ldata.sym'	; Level data from EON
	.incl   'rdata.sym'	; Tarzan animation data from ROCKS
	.incl   'fdata.sym'	; Foe / Boss animation data from ROCKS

	;***********************
	.org	$000000
	.incl   'zpage.asm'	; Zero-Page Variables

	;***********************
	.org    $000100
	.incl   'vars.asm'	; Program Variables

	;***********************
	.org    $028000

	.incl   'init.asm'	; Main initializer
	.incl	'stat.asm'	; Games stats
	.incl	'items.asm'	; Item Detection & Effect Routines
	.incl	'control.asm'	; Control Pad Handler
	.incl   'rnc2.asm'	; Decompress by Method 2
	.incl	'ttype1.asm'	; Tile detection data

	;***********************
	.org    $038000    
	.incl	'ttype.asm'	; Tile detection tables

	;***********************
	.org    $048000    
;	.incl   'foes\foedat.asm' ; 
;	.incl   'foes\collide.asm'
;	.incl	'foes\foe.asm'	; Foe control code
;	.incl	'foes\foe2.asm'	; Foe control code
;	.incl	'foes\priest.asm'

	.incl   'foedat.asm' ; 
	.incl   'collide.asm'
	.incl	'foe.asm'	; Foe control code
	.incl	'foe2.asm'	; Foe control code
	.incl	'priest.asm'

	.incl   'itemdat.asm'	; Item data tables
	.incl	'logos.asm'	; Logo handler
	.incl	'tzutils.asm'	; Misc. utilities

	;***********************
	.org    $008000

	.incl	'sprite.asm'	; Sprite Utilities
	.incl	'sprite2.asm'	; Sprite Utilities
	.incl	'playdat.asm'	; Main Char. (Tarzan) data tables
	.incl	'worlddat.asm'	; Level indexed data tables
	.incl	'utils.asm'	; Subroutines
	.incl	'scroll.asm'	; Main scroll routines
	.incl	'pal.asm'	; Palette routines
	.incl	'hdma.asm'	; HDMA setup 
	.incl	'xfervram.asm'	; Routines to transfer data to vram
	.incl	'music.asm'	; music routines
	.incl	'levsound.asm' ; Music

d_demojungle1
   	.inclbin 'demo1.bin'
d_demohome
   	.inclbin 'demo2.bin'
d_demobeach
   	.inclbin 'demo3.bin'
d_demowaterfall
   	.inclbin 'demo4.bin'

   	.incl	'demodat.asm'

*****************************************************************************
*
* Program entry point
*
*****************************************************************************

Startup:                                                       
	sei		; Disable Interupts
	cld 
	clc		; Initialize Native Mode...
	xce		; ...and turn it on.

	jml	Startup1

Startup1:
	LAI

	lda	#STACK	; Set Stack Pointer
	tcs

	lda	#<ZPAGE	; Init Direct Page Register
	tad

	lda	#$8080	; Init Data Bank Register

	pha
	plb
	plb

	jsl	Maininitppu	; Init PPU with Defaults

	lda	#1
	sta	z_nmitimensh

;	jsl	ClrWRam

	LAI

	lda	#$FE
	sta	z_tzstartup	; Indicate Startup -
			; Must remain $FE until past 1 sec.
			; licencing display. Then change to
			; $37...



	.incl	'tzan2.asm'	; main routines 

*****************************************************************************
*
* INTERRUPT ROUTINES
*
*****************************************************************************

Breakservice:
	jsl	$40E000	; debug hook

	rti

*****************************************************************************
*
* NMI ROUTINE
*
*****************************************************************************

Nmiroutine:

	php		; Save Status

	LAI

	pha

	lda	RDNMI	; Clear NMI
	inc	z_intcount	; NMI count

;	lda	_pause
;	bne	.notimer
;
;	inc	z_bonustimer
;.notimer

	pla
	plp

	rti		; Return from interupt

*****************************************************************************
*
* IRQ ROUTINE
*
*****************************************************************************

Irqroutine:

	php               ; Save Status
	plp

	rti               ; Return from interupt


	; Interrupt Vectors
                
	.org	$00FFE6
	.dw	Breakservice
 
	.org	$00FFEA
	.dw	Nmiroutine
	.dw	Startup
	.dw	Irqroutine

	.org	$00FFFA
	.dw	Nmiroutine
	.dw	Startup
	.dw	Irqroutine


*****************************************************************************

	.org	$018000

	.incl	'player.asm'
	.incl	'chek4flr.asm'
	.incl	'options.asm'
	.incl	'specials.asm'

