*********************************************************************
*
* XFERVRAM.ASM contains the following:
*
* Copyvram	- 
* Copychr	- 
* Copychr2	- 
* Copychr3	- 
* Copyscr	- 
* Copyscr3	- 
* Copyvert	- 
* Copylevel	- 
* Unpackbg1	- 
* Unpackbg2	- 
* Unpackbg3	- 
*
*********************************************************************
*
* Must be done during vblank (after fade-out)
*
*

Copyvram:
	LAI

	jsl	Copypalall	; Copy full BG palette to palette2

	bra	.fixtzpal

.jmptbl
	.dw	.stndpal	; Null Level
	.dw	.stndpal	; Jungle 1
 	.dw	.stndpal	; Tarzans Home
	.dw	.stndpal	; Apes Clearing
	.dw	.stndpal	; Swamp

	.dw	.stndpal	; Beach
	.dw	0	; Beach-Bay
	.dw	.undrwatrpal	; Reef
	.dw	.stndpal	; Ship
	.dw	.stndpal	; Ship Hold A

	.dw	.stndpal	; Ship Hold B
	.dw	.stndpal	; Jungle 3
	.dw	.undrwatrpal	; Downriver
	.dw	.drkpal04	; Jungle 4
	.dw	.undrwatrpal	; UpRiver

	.dw	.stndpal	; Waterfall
	.dw	.drkpal04	; Caverns
	.dw	.stndpal	; Opar - Street
	.dw	.drkpal02	; Opar - Wells
	.dw	.stndpal	; Opar - Temple

	.dw	.stndpal	; Bonus Level - Exterior
	.dw	.stndpal	; Bonus Level - Interior

.fixtzpal
	ldx	z_levelword
@Forcepal
	jmp	(.jmptbl,x)

	jsl	Loaddamage	; (Pal 0) Load Tarzans palette
.undrwatrpal
	lda	#6
	sta	v_curtzanpal

	jsl	Loadundrwtr

	bra	.cont
.drkpal00
	lda	#8
	sta	v_curtzanpal

	jsl	Loaddrkpal00

	bra	.cont
.drkpal01
	lda	#10
	sta	v_curtzanpal

	jsl	Loaddrkpal01

	bra	.cont
.drkpal02
	lda	#12
	sta	v_curtzanpal

	jsl	Loaddrkpal02

	bra	.cont
.drkpal03
	lda	#14
	sta	v_curtzanpal

	jsl	Loaddrkpal03

	bra	.cont
.drkpal04
	lda	#16
	sta	v_curtzanpal

	jsl	Loaddrkpal04

	bra	.cont
.stndpal
	stz	v_curtzanpal

	jsl	Loadtzanpal	; (Pal 0) Load Tarzans palette
.cont:
	jsl	Loadhealthpal	; (Pal 2) Load health bar palette
			; Also for "PAUSE"
	jsl	Loaditemspal	; (Pal 1) 

	jsl	Copychr	; Decompress & Transfer BG1 & BG2

	jsl	Copychr3	; Decompress & Transfer BG3

	rtl


*********************************************************************

; Decompress & transfer the character data for BG1 & BG2 to VRAM

Copychr:
	LAI

	ldy	z_level	; Byte index for level
	ldx	z_levelword	; Word index for level
	lda	_charsets,x	; BG1 character set address

	pha		; Stack parameter

	lda	_charbanks,y	; BG1 character set bank
	and	#$ff
	pha		; Stack parameter

	lda	#SCRATCH	; buffer offset address
	pha		; Stack parameter

	lda	#^SCRATCH	; buffer bank address
	pha		; Stack parameter

	jsl	UNPACK	; Decompress

	pla		; Clear stack
	pla		;   .
	pla		;   .
	pla		;   .
            
	jsl	Copychr2	; Overlay or Append BG2 Chars

	lda	#^SCRATCH	; Source bank address
	sta	z_sendvrambank

	lda	#SCRATCH	; Source offset address
	ldy	#$8000	; Full character set length
	ldx	#BG1CHAR	; VRAM address

	jsl	Sendvram

	rtl


*********************************************************************

; Decompress BG2 Character Set to SCRATCH+$6000 (last quad)

Copychr2:   
	LAI

	ldx	z_levelword	; Word index for level
	lda	_bg2sets,x	; Do we have a BG2 character set?
	beq	.exit	; No  - Skip 

            	pha		; Yes - Stack parameter

	ldy	z_level	; Byte index for level
	lda	_bg2chrbanks,y	; BG2 character set bank
	and	#$ff
	pha		; Stack parameter

	lda	#SCRATCH+$6000	; Buffer offset address
            	pha		; Stack parameter

	lda	#^SCRATCH	; Buffer bank address
            	pha		; Stack parameter

	jsl	UNPACK	; Decompress

            	pla		; Clear stack
            	pla		;   .
            	pla		;   .
            	pla		;   .
.exit
            	rtl


*********************************************************************

; Decompress & Transfer BG3 Character Data

Copychr3:   
	LAI

	ldx	z_levelword	; Word index for level
	lda	_bg3sets,x	; Do we have a BG2 character set?
	beq	.exit	; No  - Skip 

            	pha		; Yes - Stack parameter

	ldy	z_level	; Byte index for level
	lda	_bg3chrbanks,y	; BG1 character set bank
	and	#$ff
	pha		; Stack parameter

	lda	#SCRATCH	; Buffer offset address
            	pha		; Stack parameter

	lda	#^SCRATCH	; Buffer bank address
            	pha		; Stack parameter

	jsl	UNPACK	; Decompress

            	pla		; Clear stack
            	pla		;   .
            	pla		;   .
            	pla		;   .

	lda	#^SCRATCH	; Source bank address
	sta	z_sendvrambank

	lda	#SCRATCH	; Source offset address
	ldy	#$1000	; Character set length
	ldx	#BG3CHAR	; VRAM address

	jsl	Sendvram	; Copy to VRAM

	lda	#BG3BASE

	jsl	Clrbg
.exit
            	rtl


****************************************************************************

; Copies initial screens from background maps to vram

Copyscr:    
	LAI               
	ldx	z_bg1col0	;first column of init screen
	ldy	z_bg2col0	;first column of bg2 init screen
	lda	z_bg3col0
	sta	z_temp8

	lda	z_xfertype	;vram addressing mode
	and	#3	;check for vertical addressing
	bne	.normal

	jmp	Copyvert	;if so go to vertical copy
.normal     
	stx	z_temp0	;bg1col0
	sty	z_temp4	;bg2col0

	txa
	clc
	adc	#32	;last screen column
	cmp	z_bg1width
	bcc	.store1

	sec
	sbc	z_bg1width
.store1
	sta	z_temp2	;bg1col32

	lda	_bgenable
	bit	#1
	beq	.bg2
.loop1 
	lda	z_bg1width	;width in columns
	ldx	z_temp0	;bg1col  (starts at 0)
	jsl	Setbuff1	;set buffer from map at column 0
	ldx	#BG1BUFF	;prepare for transfer
	lda	z_newcol1	;screen base
	clc
	adc	#BG1BASE
	ldy	z_bg1size	;transfer size (64, 128 bytes)
	jsl	Bgdma	;xfer it
	inc	z_newcol1	;next column in vram
	lda	z_newcol1
	and	#$1f
	sta	z_newcol1
	inc	z_temp0	;next column in ram
	lda	z_temp0
	cmp	z_bg1width
	bcc	.compare1
	sec
	sbc	z_bg1width
	sta	z_temp0
.compare1   
	cmp	z_temp2	;check for end at col32
	bne	.loop1	;loop back if not

.bg2
	lda	_bgenable
	bit	#2
	beq	.bg3

	lda	z_temp4	;start same process for bg2
	clc
	adc	#32	;etc.
.loop2a                            
	cmp	z_bg2width
	bcc	.store2

	sec
	sbc	z_bg2width

	bra	.loop2a          ; Try for now!!!!!!!!!!!!!!!!!!!
.store2
	sta	z_temp2
.loop2 
	lda	z_bg2width
	ldx	z_temp4
	jsl	Setbuff2
	ldx	#BG2BUFF
	lda	z_newcol2
	clc
	adc	#BG2BASE
	ldy	z_bg2size
	jsl	Bgdma
	inc	z_newcol2
	lda	z_newcol2
	and	#$1f
	sta	z_newcol2
	inc	z_temp4
	lda	z_temp4
	cmp	z_bg2width
	bcc	.compare2
	sec
	sbc	z_bg2width
	sta	z_temp4
.compare2   
	cmp	z_temp2
	bne	.loop2
.bg3:
	lda	_bgenable
	bit	#4
	beq	.donescr

	lda	z_temp8	; Start same process for bg3
	clc
	adc	#32	; etc.
.loop3a:
	cmp	z_bg3width
	bcc	.store3
	sec
	sbc	z_bg3width
	bra	.loop3a          
.store3:
	sta	z_temp2
.loop3:
	lda	z_bg3width
	ldx	z_temp8
	jsl	Setbuff3
	ldx	#BG3BUFF
	lda	z_newcol3
	clc
	adc	#BG3BASE
	ldy	z_bg3size
	jsl	Bgdma
	inc	z_newcol3
	lda	z_newcol3
	and	#$1f
	sta	z_newcol3
	inc	z_temp8
	lda	z_temp8
	cmp	z_bg3width
	bcc	.compare3
	sec
	sbc	z_bg3width
	sta	z_temp8
.compare3:
	cmp	z_temp2
	bne	.loop3
.donescr:
	rtl


*****************************************************************************
*
* Copies initial screens from background maps to vram
*

Copyvert:
	LAI               
	stx	z_temp0	;bg1col0
	sty	z_temp4	;bg2col0

	txa
	clc
	adc	#32	;last screen column
	cmp	z_bg1height
	bcc	.store1
	sec
	sbc	z_bg1height
.store1     
	sta	z_temp2	;bg1col32

	lda	_bgenable
	bit	#1
	beq	.bg2
.loop1
	SA
	lda	z_bg1width	;multiply width by first row number
	sta	WRMPYA	;to get offset into map for row
	lda	z_temp0	;row number
	sta	WRMPYB
	LA
	nop
	nop
	nop
	nop		;waiting for mult to settle
	ldx	RDMPYL
	lda	#1	;height in columns
	jsl	Setbuff1	;set buffer from map at column 0
	ldx	#BG1BUFF	;prepare for transfer
	lda	z_newcol1	;screen base
	asl
	asl
	asl
	asl
	asl
	clc
	adc	#BG1BASE
	ldy	#64	;transfer size (64, 128 bytes)
	jsl	Bgdma	;xfer it
	lda	z_bg1size	;check size to see if two screens
	cmp	#64	;no?
	beq	.lv1	;then skip this part
	ldx	#BG1BUFF+64	;transfer second half of buffer...
	lda	z_newcol1
	asl
	asl
	asl
	asl
	asl
	clc
	adc	#(BG1BASE+$400)	;to next screen in vram
	ldy	#64
	jsl	Bgdma	;xfer it
.lv1        
	inc	z_newcol1	;next column in vram
	lda	z_newcol1
	and	#$1f
	sta	z_newcol1
	inc	z_temp0	;next column in ram
	lda	z_temp0
	cmp	z_bg1height
	bcc	.compare1
	sec
	sbc	z_bg1height
	sta	z_temp0
.compare1   
	cmp	z_temp2	;check for end at col32
	bne	.loop1	;loop back if not

.bg2
	lda	_bgenable
	bit	#2
	beq	.bg3

	lda	z_temp4
	clc
	adc	#32	;last screen column
.loop2a			;DAD
	cmp	z_bg2height
	bcc	.store2
	sec
	sbc	z_bg2height
	bra	.loop2a	;DAD
.store2     
	sta	z_temp2	;bg2col32
.loop2
	SA
	lda	z_bg2width	;multiply width by first row number
	sta	WRMPYA	;to get offset into map for row
	lda	z_temp4	;row number
	sta	WRMPYB
	LA
	nop
	nop
	nop
	nop		;waiting for mult to settle
	ldx	RDMPYL
	lda	#1
	jsl	Setbuff2	;set buffer from map at column 0
	ldx	#BG2BUFF	;prepare for transfer
	lda	z_newcol2	;screen base
	asl
	asl
	asl
	asl
	asl
	clc
	adc	#BG2BASE
	ldy	#64	;transfer size (64, 128 bytes)
	jsl	Bgdma	;xfer it
	inc	z_newcol2	;next column in vram
	lda	z_newcol2
	and	#$1f
	sta	z_newcol2
	inc	z_temp4	;next column in ram
	lda	z_temp4
	cmp	z_bg2height
	bcc	.compare2
	sec
	sbc	z_bg2height
	sta	z_temp4
.compare2   
	cmp	z_temp2	;check for end at col32
	bne	.loop2	;loop back if not
.bg3
	lda	_bgenable
	bit	#4
	beq	.donescr

	lda	z_temp8
	clc
	adc	#32	;last screen column
.loop3a			;DAD
	cmp	z_bg3height
	bcc	.store3
	sec
	sbc	z_bg3height
	bra	.loop3a	;DAD
.store3     
	sta	z_temp2	;bg2col32
.loop3
	SA
	lda	z_bg3width	;multiply width by first row number
	sta	WRMPYA	;to get offset into map for row
	lda	z_temp8	;row number
	sta	WRMPYB
	LA
	nop
	nop
	nop
	nop		;waiting for mult to settle
	ldx	RDMPYL
	lda	#1
	jsl	Setbuff3	;set buffer from map at column 0
	ldx	#BG3BUFF	;prepare for transfer
	lda	z_newcol3	;screen base
	asl
	asl
	asl
	asl
	asl
	clc
	adc	#BG3BASE
	ldy	#64	;transfer size (64, 128 bytes)
	jsl	Bgdma	;xfer it
	inc	z_newcol3	;next column in vram
	lda	z_newcol3
	and	#$1f
	sta	z_newcol3
	inc	z_temp8	;next column in ram
	lda	z_temp8
	cmp	z_bg3height
	bcc	.compare3
	sec
	sbc	z_bg3height
	sta	z_temp8
.compare3:
	cmp	z_temp2	;check for end at col32
	bne	.loop3	;loop back if not
.donescr:
	rtl


*********************************************************************
*
* Send bg enable bits in A: bit order 0000(bg4)(bg3)(bg2)(bg1)
* and copy level will put the data from ROM into the background
* maps for current level, also xfers tiletypes, itemtables
* all these copies can be done before a fadeout of previous level
*

Copylevel:
	lda	_bgenable
	bit	#1
	beq	.copy2	; no then skip to bg2

	phb		; save bank

	jsl	Unpackbg1	; unpack bg1 map for this level

	plb		; restore data bank
.copy2
	lda	_bgenable
	bit	#2
	beq	.copy3	; no then skip to bg3

	phb		; save bank

	jsl	Unpackbg2	; copy bg2 map

	plb		; restore data bank
.copy3
	lda	_bgenable
	bit	#4
	beq	.copydata	; no then skip to other data

	phb		; save bank

	jsl	Unpackbg3	; copy bg3 map

	plb		; restore data bank

.copydata   
	rtl


*********************************************************************
*
* Decompress BG1 Map Data

Unpackbg1:
	LAI

	ldy	z_level
	ldx	z_levelword

	lda	_levelbg1,x
	pha		;  push low word of packed file

	lda	_bg1banks,y
	and	#$FF
	pha		;  push high word of packed file

	pea	|BG1MAP	;  push low word of output buffer
	pea	^BG1MAP	;  push high word of output buffer

	jsl	UNPACK	;  unpack file to output buffer

	pla
	pla
	pla
	pla

	rtl


*********************************************************************
*
* Decompress BG2 Map Data

Unpackbg2:  
	LAI

	ldy	z_level
	ldx	z_levelword

	lda	_levelbg2,x	; BG map offset address
	pha		; Stack Parameter

	lda	_bg2lvlbanks,y	; BG map bank address
	and	#$FF	
	pha		; Stack Parameter

	pea	|BG2MAP	; Dest buffer offset address
	pea	^BG2MAP	; Dest buffer offset address

	jsl	UNPACK	; Decompress

	pla		; Clear Stack
	pla		;   .
	pla		;   .
	pla		;   .

	rtl


*********************************************************************
*
* Decompress BG3 Map Data

Unpackbg3:  
	LAI

	ldy	z_level
	ldx	z_levelword

	lda	_levelbg3,x	; BG map offset address
	pha		; Stack Parameter

	lda	_bg3lvlbanks,y	; BG map bank address
	and	#$FF	
	pha		; Stack Parameter

	pea	|BG3MAP	; Dest buffer offset address
	pea	^BG3MAP	; Dest buffer offset address

	jsl	UNPACK	; Decompress

	pla		; Clear Stack
	pla		;   .
	pla		;   .
	pla		;   .

	rtl

