*****************************************************************************
*
* ZPAGE.ASM
*
*****************************************************************************

; Used by ClearVRAM as source for DMA xfer

nonwritebyte	.ds	$02


; Music Driver Stuff

APU_Ind0	.ds	3	; in direct page
APU_SN	.ds	1	; can be anywhere in RAM.
APU_NextLen	.ds	2	; in direct page
APU_Temp	.ds	2	; in direct page
ModTabInd	.ds	3	; Indirect location of a module table

PAmodbyte	.ds	$01

; NMI Interrupts

z_intcount	.ds	$02

; hdma shadow

z_hdmaenable	.ds	$02
z_inidispshd	.ds	$02 

; Temp variables

z_ztemp	.ds	$02
z_temp0	.ds	$02
z_temp1	.ds	$02
z_temp2	.ds	$02
z_temp3	.ds	$02
z_temp4	.ds	$02
z_temp5	.ds	$02
z_temp6	.ds	$02
z_temp7	.ds	$02
z_temp8	.ds	$02

src_ptr	.equ	z_ztemp
z_sendvrambank	.equ	z_ztemp

z_screenindex	.ds	$02
z_temp0a	.ds	$02
z_temp1a	.ds	$02
z_temp2a	.ds	$02
z_temp3a	.ds	$02
z_temp4a	.ds	$02

; Util module variables



z_seed0	.ds	$02
z_pad	.ds	$02

z_joy1	.ds	$01
z_joy1high	.ds	$01

z_joy2	.ds	$01
z_joy2high	.ds	$01

;z_joy3	.ds	$01
;z_joy3high	.ds	$01

;z_joy4	.ds	$01
;z_joy4high	.ds	$01

;z_joy5	.ds	$01
;z_joy5high	.ds	$01


; SFX register shadows

z_nmitimensh	.ds	$01

PAmodbyte01	.ds	$01


; game pointers and vars

z_level	.ds	$02	;current level number (0,1,2...)
z_levelword	.ds	$02	;level word index (level-1)*2

z_xfertype	.ds	$02	;type of VMAINC for dma transfer

z_bg1width	.ds	$02	;width of background in columns
z_bg2width	.ds	$02
z_bg3width	.ds	$02

z_bg1height	.ds	$02
z_bg2height	.ds	$02
z_bg3height	.ds	$02

z_bg1size	.ds	$02	;length of transfer buffer in bytes
z_bg2size	.ds	$02
z_bg3size	.ds	$02

z_bg1col0	.ds	$02	;background column number of far left
z_bg2col0	.ds	$02	;screen column 
z_bg3col0	.ds	$02	;screen column 

z_hoff1	.ds	$02	;horizontal offset in dots
z_hoff2	.ds	$02
z_hoff3	.ds	$02
z_voff1	.ds	$02	;vertical offset in lines
z_voff2	.ds	$02
z_voff3	.ds	$02

z_h1	.ds	$02	;horizontal offset in 1/2 dots
z_h2	.ds	$02
z_h3	.ds	$02
z_v1	.ds	$02	;vertical offset in 1/2 lines
z_v2	.ds	$02
z_v3	.ds	$02

z_bg1col31	.ds	$02	;far right column
z_bg2col31	.ds	$02
z_bg3col31	.ds	$02

z_newcol1	.ds	$02	;screen loc to put next column update
z_newcol2	.ds	$02
z_newcol3	.ds	$02

z_sud1	.ds	$02	;scroll up down by this many dots on bg1
z_sud2	.ds	$02   
z_sud3	.ds	$02

z_slr1	.ds	$02	;scroll left right by this many dots
z_slr2	.ds	$02
z_slr3	.ds	$02

z_sdir	.ds	$02	;direction to scroll (0000lrud)
z_sup	.ds	$02	;scroll update (000321321) bits set when update
			; is necessary for that bg, left 3 are rite scroll

z_skipsup	.ds	$02	;backgrounds flag, set by user, if zero, all bg


; updated otherwise set bg flag (00000321)    

z_attrcount	.ds	$02	;object attribute table
z_oamcount	.ds	$02	;object shadow table
z_levelx	.ds	$02	;left edge of screen
z_levely	.ds	$02	;top of screen
z_sprix	.ds	$02
z_spriy	.ds	$02
z_drecframe	.ds	$02
z_dreccount	.ds	$02
z_spridrec	.ds	$02
z_drecsize	.ds	$02
z_drecnum	.ds	$02
z_drecx	.ds	$02
z_drecy	.ds	$02
z_drecfpc	.ds	$02
z_drecdim	.ds	$02
z_sprisize	.ds	$02

;decompress vars must be zero page!
IN	.ds	$04	; long address of packed file    (4 bytes)
OUT	.ds	$02	; short address of output buffer (2 bytes)
SPOS	.ds	$03	; (3 bytes)
SLEN	.ds	$02	; (2 bytes)

PAmodbyte02	.ds	$01

z_tzstartup	.ds	$02
z_transartdly	.ds	$02

z_logostate	.ds	$02
z_scrnch	.ds	$02

z_colfade1	.ds	$02
z_colfade2	.ds	$02
z_colfade3	.ds	$02
z_colfade4	.ds	$02
z_colfadeip	.ds	$02
z_docolfade	.ds	$02
z_colfadeos	.ds	$02


