********************************************************************
*
* WORLDDAT.ASM
*
*********************************************************************
*
*
* LEVEL TABLES
*
*
* Note : when adding to these tables, 
*        also add to:
*
*	TTYPES.ASM
*
*********************************************************************

	; level # index constants

RETURN	.equ	-1	; Return from sublevel

JUNGLE1	.equ	1
TZANHOME	.equ	2
CLEARING	.equ	3
SWAMP	.equ	4

BEACH	.equ	5
BEACHBAY	.equ	6	; Cancelled
REEF	.equ	7
SHIP	.equ	8
SHIPHOLDA	.equ	9

SHIPHOLDB	.equ	10
JUNGLE3	.equ	11
DOWNRIVER	.equ	12
JUNGLE4	.equ	13
UPRIVER	.equ	14

WATERFALL	.equ	15
CAVERNS	.equ	16	; Insert Elephants after
OPARSTREET	.equ	17
OPARWELLS	.equ	18
OPARTEMPLE	.equ	19

SHAMONBOSS	.equ	20

BONUSEXT	.equ	21
BONUSINT	.equ	22

OVERSHOOT	.equ	-1

INTRO	.equ	24


d_datjungle1:
	.dw	jungle1bg1ccs	; Jungle 1 - bg1charset offset
	.db	^jungle1bg1ccs	; Jungle 1 - bg1charset bank
	.dw	jungle1bg1clm	; Jungle 1 - bg1levelmap offset
	.db	^jungle1bg1clm	; Jungle 1 - bg1levelmap bank
	.dw	JUNG11.PALSET	; Jungle 1 - bg1palette offset
	.db	^JUNG11.PALSET	; Jungle 1 - bg1palette bank
	.dw	jungle1bg2ccs	; Jungle 1 - bg2charset offset
	.db	^jungle1bg2ccs	; Jungle 1 - bg2charset bank
	.dw	jungle1bg2clm	; Jungle 1 - bg2levelmap offset
	.db	^jungle1bg2clm	; Jungle 1 - bg2levelmap bank
	.dw	jungle1bg3ccs	; Jungle 1 - bg3charset offset
	.db	^jungle1bg3ccs	; Jungle 1 - bg3charset bank
	.dw	jungle1bg3clm	; Jungle 1 - bg3levelmap offset
	.db	^jungle1bg3clm	; Jungle 1 - bg3levelmap bank
	.dw	jungle1tile	; Jungle 1 - tileset offset
	.dw	^jungle1tile	; Jungle 1 - tileset bank
	.dw	16*12	; Jungle 1 - bg1widths
	.dw	16*6	; Jungle 1 - bg2widths
	.dw	16*2	; Jungle 1 - bg3widths
	.dw	16*4	; Jungle 1 - bg1heights
	.dw	16*4	; Jungle 1 - bg2heights
	.dw	16*2	; Jungle 1 - bg3heights
	.db	128	; Jungle 1 - bg1sizes
	.db	128	; Jungle 1 - bg2sizes
	.db	64	; Jungle 1 - bg3sizes
	.db	NONE	; Jungle 1 - skipsups
	.db	$81	; Jungle 1 - xfertypes
	.dw	11*256	; Jungle 1 - hoff1maxs
	.dw	32	; Jungle 1 - hoff1mins
	.dw	528	; Jungle 1 - voff1maxs
	.dw	64	; Jungle 1 - voff1mins
	.dw	CHARMASK16	; Jungle 1 - bg1chrmasks
	.dw	CHARMASK16	; Jungle 1 - bg2chrmasks
	.dw	CHARMASK16	; Jungle 1 - bg3chrmasks
	.db	$71	; Jungle 1 - bgmodes
	.db	$17	; Jungle 1 - bgenables
	.dw	32	; Jungle 1 - bg1hoffs
	.dw	16	; Jungle 1 - bg2hoffs
	.dw	16	; Jungle 1 - bg3hoffs
	.dw	528	; Jungle 1 - bg1voffs
	.dw	256	; Jungle 1 - bg2voffs
	.dw	128	; Jungle 1 - bg3voffs
	.db	2	; Jungle 1 - scsize1
	.db	2	; Jungle 1 - scsize2
	.db	NONE	; Jungle 1 - scsize3
	.db	DIVIDED	; Jungle 1 - bg12nba
	.dw	DXMID	; Jungle 1 - dxstart
	.dw	722	; Jungle 1 - dystart
	.dw	$BE5+$10	; Jungle 1 - d_maxxs
	.dw	$30	; Jungle 1 - d_minx
	.dw	$0420	; Jungle 1 - d_maxy
	.dw	$812	; Jungle 1 - d_fallmax [vine]
	.dw	$60	; Jungle 1 - d_tzanslot [vine]
	.dw	$2000	; Jungle 1 - d_priority
	.db	MOVRT	; Jungle 1 - d_initdir
	.db	tzidle4mode00	; Jungle 1 - d_initdir
	.db	$02,$02	; Jungle 1 - d_phyics
	.dw	LowerJungle	; Jungle 1 - jumpvectors
	.dw	TZANHOME	; Jungle 1 - nextlevel
	.dw	30	; Jungle 1 - d_numcoins
	.dw	6	; Jungle 1 - d_numcoinsget
	.dw	0	; Jungle 1 - d_disablecycle


d_dattzanhome:
























_charsets  
	.dw	tzanhomeccs	; Tarzans Home
	.dw	apeclr1ccs	; Apes Clearing
	.dw	swamp1ccs	; Swamp

	.dw	beachccs1	; Beach
	.dw	NONE	; Beach-Bay
	.dw	bay1ccs	; Reef
	.dw	ship1ccs	; Ship
	.dw	shiphold1ccs	; Ship Hold A

	.dw	shiphold1ccs	; Ship Hold B
	.dw	jung3bg1ccs	; Jungle 3
            	.dw	dwnrivr1ccs	; Downriver
	.dw	jungle4bg1ccs	; Jungle 4
	.dw	uprivr1ccs	; UpRiver

	.dw	waterfall1ccs	; Waterfall
	.dw	caverns1ccs	; Caverns
	.dw	opar1streetccs	; Opar - Street
	.dw	oparwells1ccs	; Opar - Wells
	.dw	temple1ccs	; Opar - Temple

	.dw	temple1ccs	; Opar - Shamon Boss

	.dw	hutx1ccs	; Bonus Level - Exterior
	.dw	hutintr1ccs	; Bonus Level - Interior


_charbanks 
	.db	^tzanhomeccs	; Tarzans Home
	.db	^apeclr1ccs	; Apes Clearing
	.db	^swamp1ccs	; Swamp

	.db	^beachccs1	; Beach
	.db	NONE	; Beach-Bay
	.db	^bay1ccs	; Reef
	.db	^ship1ccs	; Ship
	.db	^shiphold1ccs	; Ship Hold A

	.db	^shiphold1ccs	; Ship Hold B
	.db	^jung3bg1ccs	; Jungle 3
	.db	^dwnrivr1ccs	; Downriver
	.db	^jungle4bg1ccs	; Jungle 4
	.db	^uprivr1ccs	; UpRiver

	.db	^waterfall1ccs	; Waterfall
	.db	^caverns1ccs	; Caverns
	.db	^opar1streetccs	; Opar - Street
	.db	^oparwells1ccs	; Opar - Wells
	.db	^temple1ccs	; Opar - Temple

	.db	^temple1ccs	; Opar - Shamon Boss

	.db	^hutx1ccs	; Bonus Level - Exterior
	.db	^hutintr1ccs	; Bonus Level - Interior


_levelbg1
	.dw	tzanhomeclm	; Tarzans Home
	.dw	apeclr1clm	; Apes Clearing
	.dw	swamp1clm	; Swamp

	.dw	beachclm1	; Beach
	.dw	NONE	; Beach-Bay
	.dw	bay1clm	; Reef
	.dw	ship1clm	; Ship
	.dw	shiphold1clm	; Ship Hold A

	.dw	shiphold1clm	; Ship Hold B
	.dw	jung3bg1clm	; Jungle 3
	.dw	dwnrivr1clm	; Downriver
	.dw	jungle4bg1clm	; Jungle 4
	.dw	uprivr1clm	; UpRiver

	.dw	waterfall1clm	; Waterfall
	.dw	caverns1clm	; Caverns
	.dw	opar1streetclm	; Opar - Street
	.dw	oparwells1clm	; Opar - Wells
	.dw	temple1clm	; Opar - Temple

	.dw	shamonclm	; Opar - Shamon Boss

	.dw	hutx1clm	; Bonus Level - Exterior
	.dw	hutintr1clm	; Bonus Level - Interior


_bg1banks  
	.db	^tzanhomeclm	; Tarzans Home
	.db	^apeclr1clm	; Apes Clearing
	.db	^swamp1clm	; Swamp

	.db	^beachclm1	; Beach
	.db	NONE	; Beach-Bay
	.db	^bay1clm	; Reef
	.db	^ship1clm	; Ship
	.db	^shiphold1clm	; Ship Hold A

	.db	^shiphold1clm	; Ship Hold B
	.db	^jung3bg1clm	; Jungle 3
	.db	^dwnrivr1clm	; Downriver
	.db	^jungle4bg1clm	; Jungle 4
	.db	^uprivr1clm	; UpRiver

	.db	^waterfall1clm	; Waterfall
	.db	^caverns1clm	; Caverns
	.db	^opar1streetclm	; Opar - Street
	.db	^oparwells1clm	; Opar - Wells
	.db	^temple1clm	; Opar - Temple

	.db	^shamonclm	; Opar - Shamon Boss

	.db	^hutx1clm	; Bonus Level - Exterior
	.db	^hutintr1clm	; Bonus Level - Interior


_bg1pal
	.dw	TREE1.PALSET	; Tarzans Home
	.dw	APECLR1.PALSET	; Apes Clearing
	.dw	SWAMP1.PALSET	; Swamp

	.dw	BEACH1.PALSET	; Beach
	.dw	NONE	; Beach-Bay
	.dw	BAY1.PALSET	; Reef
	.dw	SHIP1.PALSET	; Ship
	.dw	SHIPHOLD.PALSET	; Ship Hold A

	.dw	SHIPHOLD.PALSET	; Ship Hold B
	.dw	JUNG31.PALSET	; Jungle 3
	.dw	DNRIVR1.PALSET	; Downriver
	.dw	JUNG41.PALSET	; Jungle 4
	.dw	UPRIVR1.PALSET	; UpRiver

	.dw	WATFAL1.PALSET	; Waterfall
	.dw	CAVES1.PALSET	; Caverns
	.dw	OPSTR1.PALSET	; Opar - Street
	.dw	WELLS1.PALSET	; Opar - Wells
	.dw	TEMPLE1.PALSET	; Opar - Temple

	.dw	TEMPLE1.PALSET	; Opar - Shamon Boss

	.dw	HUTX1.PALSET	; Bonus Level - Exterior
	.dw	HUTINTER.PALSET	; Bonus Level - Interior


_bg1palbank
	.db	^TREE1.PALSET	; Tarzans Home
	.db	^APECLR1.PALSET	; Apes Clearing
	.db	^SWAMP1.PALSET	; Swamp

	.db	^BEACH1.PALSET	; Beach
	.db	NONE	; Beach-Bay
	.db	^BAY1.PALSET	; Reef
	.db	^SHIP1.PALSET	; Ship
	.db	^SHIPHOLD.PALSET ; Ship Hold A

	.db	^SHIPHOLD.PALSET ; Ship Hold B
	.db	^JUNG31.PALSET	; Jungle 3
	.db	^DNRIVR1.PALSET	; Downriver
	.db	^JUNG41.PALSET	; Jungle 4
	.db	^UPRIVR1.PALSET	; UpRiver

	.db	^WATFAL1.PALSET ; Waterfall
	.db	^CAVES1.PALSET	; Caverns
	.db	^OPSTR1.PALSET	; Opar - Street
	.db	^WELLS1.PALSET	; Opar - Wells
	.db	^TEMPLE1.PALSET ; Opar - Temple

	.db	^TEMPLE1.PALSET ; Opar - Shamon Boss

	.db	^HUTX1.PALSET	; Bonus Level - Exterior
	.db	^HUTINTER.PALSET; Bonus Level - Interior


_levelbg2  
	.dw	tzanhomeclm2	; Tarzans Home
	.dw	apeclr2clm	; Apes Clearing
	.dw	swamp2clm	; Swamp

	.dw	beachclm2	; Beach
	.dw	NONE	; Beach-Bay
	.dw	bay2clm	; Reef
	.dw	ship2clm	; Ship
	.dw	NONE	; Ship Hold A

	.dw	NONE	; Ship Hold B
	.dw	jung3bg2clm	; Jungle 3
	.dw	dwnrivr2clm	; Downriver
	.dw	jungle4bg2clm	; Jungle 4
	.dw	uprivr2clm	; UpRiver

	.dw	waterfall2clm	; Waterfall
	.dw	caverns2clm	; Caverns
	.dw	opar2streetclm	; Opar - Street
	.dw	oparwells2clm	; Opar - Wells
	.dw	temple2clm	; Opar - Temple

	.dw	temple2clm	; Opar - Shamon Boss

	.dw	hutx2clm	; Bonus Level - Exterior
	.dw	NONE	; Bonus Level - Interior


_bg2lvlbanks  
	.db	^tzanhomeclm2	; Tarzans Home
	.db	^apeclr2clm	; Apes Clearing
	.db	^swamp2clm	; Swamp

	.db	^beachclm2	; Beach
	.db	NONE	; Beach-Bay
	.db	^bay2clm	; Reef
	.db	^ship2clm	; Ship
	.db	NONE	; Ship Hold A

	.db	NONE	; Ship Hold B
	.db	^jung3bg2clm	; Jungle 3
	.db	^dwnrivr2clm	; Downriver
	.db	^jungle4bg2clm	; Jungle 4
	.db	^uprivr2clm	; UpRiver

	.db	^waterfall2clm	; Waterfall
	.db	^caverns2clm	; Caverns
	.db	^opar2streetclm	; Opar - Street
	.db	^oparwells2clm	; Opar - Wells
	.db	^temple2clm	; Opar - Temple

	.db	^temple2clm	; Opar - Shamon Boss

	.db	^hutx2clm	; Bonus Level - Exterior
	.db	NONE	; Bonus Level - Interior


_bg2sets  
	.dw	tzanhomeccs2	; Tarzans Home
	.dw	apeclr2ccs	; Apes Clearing
	.dw	swamp2ccs	; Swamp

	.dw	beachccs2	; Beach
	.dw	NONE	; Beach-Bay
	.dw	bay2ccs	; Reef
	.dw	ship2ccs	; Ship
	.dw	NONE	; Ship Hold A

	.dw	NONE	; Ship Hold B
	.dw	jung3bg2ccs	; Jungle 3
	.dw	dwnrivr2ccs	; Downriver
	.dw	jungle4bg2ccs	; Jungle 4
	.dw	uprivr2ccs	; UpRiver

	.dw	waterfall2ccs	; Waterfall
	.dw	caverns2ccs	; Caverns
	.dw	opar2streetccs	; Opar - Street
	.dw	oparwells2ccs	; Opar - Wells
	.dw	temple2ccs	; Opar - Temple

	.dw	temple2ccs	; Opar - Shamon Boss

	.dw	hutx2ccs	; Bonus Level - Exterior
	.dw	NONE	; Bonus Level - Interior


_bg2chrbanks 
	.db	^tzanhomeccs2	; Tarzans Home
	.db	^apeclr2ccs	; Apes Clearing
	.db	^swamp2ccs	; Swamp

	.db	^beachccs2	; Beach
	.db	NONE	; Beach-Bay
	.db	^bay2ccs	; Reef
	.db	^ship2ccs	; Ship
	.db	NONE	; Ship Hold A

	.db	NONE	; Ship Hold B
	.db	^jung3bg2ccs	; Jungle 3
	.db	^dwnrivr2ccs	; Downriver
	.db	^jungle4bg2ccs	; Jungle 4
	.db	^uprivr2ccs	; UpRiver

	.db	^waterfall2ccs	; Waterfall
	.db	^caverns2ccs	; Caverns
	.db	^opar2streetccs	; Opar - Street
	.db	^oparwells2ccs	; Opar - Wells
	.db	^temple2ccs	; Opar - Temple

	.db	^temple2ccs	; Opar - Shamon Boss

	.db	^hutx2ccs	; Bonus Level - Exterior
	.db	NONE	; Bonus Level - Interior


_levelbg3
	.dw	tzanhomeclm3	; Tarzans Home
	.dw	apeclr3clm	; Apes Clearing
	.dw	swamp3clm	; Swamp

	.dw	beachclm3	; Beach
	.dw	NONE	; Beach-Bay
	.dw	bay3clm	; Reef
	.dw	ship3clm	; Ship
	.dw	NONE	; Ship Hold A

	.dw	NONE	; Ship Hold B
	.dw	jung3bg3clm	; Jungle 3
	.dw	dwnrivr3clm	; Downriver
	.dw	jungle4bg3clm	; Jungle 4
	.dw	uprivr3clm	; UpRiver

	.dw	NONE	; Waterfall
	.dw	NONE	; Caverns
	.dw	opar3streetclm	; Opar - Street
	.dw	NONE	; Opar - Wells
	.dw	temple3clm	; Opar - Temple

	.dw	temple3clm	; Opar - Shamon Boss

	.dw	hutx3clm	; Bonus Level - Exterior
	.dw	NONE	; Bonus Level - Interior


_bg3lvlbanks  
	.db	^tzanhomeclm3	; Tarzans Home
	.db	^apeclr3clm	; Apes Clearing
	.db	^swamp3clm	; Swamp

	.db	^beachclm3	; Beach
	.db	NONE	; Beach-Bay
	.db	^bay3clm	; Reef
	.db	^ship3clm	; Ship
	.db	NONE	; Ship Hold A

	.db	NONE	; Ship Hold B
	.db	^jung3bg3clm	; Jungle 3
	.db	^dwnrivr3clm	; Downriver
	.db	^jungle4bg3clm	; Jungle 4
	.db	^uprivr3clm	; UpRiver

	.db	NONE	; Waterfall
	.db	NONE	; Caverns
	.db	^opar3streetclm	; Opar - Street
	.db	NONE	; Opar - Wells
	.db	^temple3clm	; Opar - Temple

	.db	^temple3clm	; Opar - Shamon Boss

	.db	^hutx3clm	; Bonus Level - Exterior
	.db	NONE	; Bonus Level - Interior


_bg3sets  
	.dw	tzanhomeccs3	; Tarzans Home
	.dw	apeclr3ccs	; Apes Clearing
	.dw	swamp3ccs	; Swamp

	.dw	beachccs3	; Beach
	.dw	NONE	; Beach-Bay
	.dw	bay3ccs	; Reef
	.dw	ship3ccs	; Ship
	.dw	NONE	; Ship Hold A

	.dw	NONE	; Ship Hold B
	.dw	jung3bg3ccs	; Jungle 3
	.dw	dwnrivr3ccs	; Downriver
	.dw	jungle4bg3ccs	; Jungle 4
	.dw	uprivr3ccs	; UpRiver

	.dw	NONE	; Waterfall
	.dw	NONE	; Caverns
	.dw	opar3streetccs	; Opar - Street
	.dw	NONE	; Opar - Wells
	.dw	temple3ccs	; Opar - Temple

	.dw	temple3ccs	; Opar - Shamon Boss

	.dw	hutx3ccs	; Bonus Level - Exterior
	.dw	NONE	; Bonus Level - Interior


_bg3chrbanks 
	.db	^tzanhomeccs3	; Tarzans Home
	.db	^apeclr3ccs	; Apes Clearing
	.db	^swamp3ccs	; Swamp

	.db	^beachccs3	; Beach
	.db	NONE	; Beach-Bay
	.db	^bay3ccs	; Reef
	.db	^ship3ccs	; Ship
	.db	NONE	; Ship Hold A

	.db	NONE	; Ship Hold B
	.db	^jung3bg3ccs	; Jungle 3
	.db	^dwnrivr3ccs	; Downriver
	.db	^jungle4bg3ccs	; Jungle 4
	.db	^uprivr3ccs	; UpRiver

	.db	NONE	; Waterfall
	.db	NONE	; Caverns
	.db	^opar3streetccs	; Opar - Street
	.db	NONE	; Opar - Wells
	.db	^temple3ccs	; Opar - Temple

	.db	^temple3ccs	; Opar - Shamon Boss

	.db	^hutx3ccs	; Bonus Level - Exterior
	.db	NONE	; Bonus Level - Interior




_tiletypes
	.dw	tzanhometile	; Tarzans Home
	.dw	apeclrtile	; Apes Clearing
	.dw	swamptile	; Swamp

	.dw	beachtile	; Beach
	.dw	NONE	; Beach-Bay
	.dw	baytile	; Reef
	.dw	shiptile	; Ship
	.dw	shiphold1tile	; Ship Hold A

	.dw	shiphold1tile	; Ship Hold B
	.dw	jung3bg1tile	; Jungle 3
	.dw	dnrivrtile	; Downriver
	.dw	jungle4tile	; Jungle 4
	.dw	uprivrtile	; UpRiver

	.dw	waterfaltile	; Waterfall
	.dw	caverntile	; Caverns
	.dw	oparstretile	; Opar - Street
	.dw	oparwellstile	; Opar - Wells
	.dw	templetile	; Opar - Temple

	.dw	templetile	; Opar - Shamon Boss

	.dw	hutxtile	; Bonus Level - Exterior
	.dw	hutintile	; Bonus Level - Interior


_tiletypesbank
	.dw	^tzanhometile	; Tarzans Home
	.dw	^apeclrtile	; Apes Clearing
	.dw	^swamptile	; Swamp

	.dw	^beachtile	; Beach
	.dw	NONE	; Beach-Bay
	.dw	^baytile	; Reef
	.dw	^shiptile	; Ship
	.dw	^shiphold1tile	; Ship Hold A

	.dw	^shiphold1tile	; Ship Hold B
	.dw	^jung3bg1tile	; Jungle 3
	.dw	^dnrivrtile	; Downriver
	.dw	^jungle4tile	; Jungle 4
	.dw	^uprivrtile	; UpRiver

	.dw	^waterfaltile	; Waterfall
	.dw	^caverntile	; Caverns
	.dw	^oparstretile	; Opar - Street
	.dw	^oparwellstile	; Opar - Wells
	.dw	^templetile	; Opar - Temple

	.dw	^templetile	; Opar - Shamon Boss

	.dw	^hutxtile	; Bonus Level - Exterior
	.dw	^hutintile	; Bonus Level - Interior



; width of levels in tiles (1 screen = 16 tiles)

_bg1widths 
	.dw	16*4	; Tarzans Home
	.dw	16*4	; Apes Clearing
	.dw	16*8	; Swamp

	.dw	16*12	; Beach
	.dw	NONE	; Beach-Bay
	.dw	16*8	; Reef
	.dw	16*8	; Ship
	.dw	16*6	; Ship Hold A

	.dw	16*6	; Ship Hold B
	.dw	16*8	; Jungle 3
	.dw	16*8	; Downriver
	.dw	16*8	; Jungle 4
	.dw	16*8	; UpRiver

	.dw	16*4	; Waterfall
	.dw	16*8	; Caverns
	.dw	16*8	; Opar - Street
	.dw	16*10	; Opar - Wells
	.dw	16*8	; Opar - Temple

	.dw	16*4	; Opar - Shamon Boss

	.dw	16*6	; Bonus Level - Exterior
	.dw	16*4	; Bonus Level - Interior


_bg2widths 
	.dw	16*4	; Tarzans Home
	.dw	16*4	; Apes Clearing
	.dw	16*6	; Swamp

	.dw	16*6	; Beach
	.dw	NONE	; Beach-Bay
	.dw	16*6	; Reef
	.dw	16*6	; Ship
	.dw	NONE	; Ship Hold A

	.dw	NONE	; Ship Hold B
	.dw	16*6	; Jungle 3
	.dw	16*6	; Downriver
	.dw	16*6	; Jungle 4
	.dw	16*6	; UpRiver

	.dw	16*4	; Waterfall
	.dw	16*6	; Caverns
	.dw	16*6	; Opar - Street
	.dw	16*4	; Opar - Wells
	.dw	16*6	; Opar - Temple

	.dw	16*6	; Opar - Shamon Boss

	.dw	16*6	; Bonus Level - Exterior
	.dw	NONE	; Bonus Level - Interior


_bg3widths 
	.dw	16*2	; Tarzans Home
	.dw	16*2	; Apes Clearing
	.dw	16*2	; Swamp

	.dw	16*2	; Beach
	.dw	16*2	; Beach-Bay
	.dw	16*2	; Reef
	.dw	16*2	; Ship
	.dw	NONE	; Ship Hold A

	.dw	NONE	; Ship Hold B
	.dw	16*2	; Jungle 3
	.dw	16*2	; Downriver
	.dw	16*2	; Jungle 4
	.dw	16*2	; UpRiver

	.dw	NONE	; Waterfall
	.dw	NONE	; Caverns
	.dw	16*2	; Opar - Street
	.dw	16*2	; Opar - Wells
	.dw	16*2	; Opar - Temple

	.dw	16*2	; Opar - Shamon Boss

	.dw	16*2	; Bonus Level - Exterior
	.dw	NONE	; Bonus Level - Interior



; height of levels in tiles (1 screen = 16)
; These values are a function of how big _bgxsizes are....
;
; bg1sizes =  64 => bg1height = 16*2
; bg1sizes = 128 => bg1height = 16*4

_bg1heights 
	.dw	16*8	; Tarzans Home
	.dw	16*4	; Apes Clearing
	.dw	16*4	; Swamp

	.dw	16*4	; Beach
	.dw	NONE	; Beach-Bay
	.dw	16*4	; Reef
	.dw	16*4	; Ship
	.dw	16*4	; Ship Hold A

	.dw	16*4	; Ship Hold B
	.dw	16*4	; Jungle 3
	.dw	16*4	; Downriver
	.dw	16*4	; Jungle 4
	.dw	16*4	; UpRiver

	.dw	16*8	; Waterfall
	.dw	16*4	; Caverns
	.dw	16*4	; Opar - Street
	.dw	16*4	; Opar - Wells
	.dw	16*4	; Opar - Temple

	.dw	16*4	; Opar - Shamon Boss

	.dw	16*4	; Bonus Level - Exterior
	.dw	16*4	; Bonus Level - Interior


_bg2heights 
	.dw	16*6	; Tarzans Home
	.dw	16*4	; Apes Clearing
	.dw	16*4	; Swamp

	.dw	16*4	; Beach
	.dw	NONE	; Beach-Bay
	.dw	16*4	; Reef
	.dw	16*4	; Ship
	.dw	NONE	; Ship Hold A

	.dw	NONE	; Ship Hold B
	.dw	16*4	; Jungle 3
	.dw	16*4	; Downriver
	.dw	16*4	; Jungle 4
	.dw	16*4	; UpRiver

	.dw	16*6	; Waterfall
	.dw	16*4	; Caverns
	.dw	16*4	; Opar - Street
	.dw	16*4	; Opar - Wells
	.dw	16*4	; Opar - Temple

	.dw	16*4	; Opar - Shamon Boss

	.dw	16*4	; Bonus Level - Exterior
	.dw	NONE	; Bonus Level - Interior


_bg3heights 
	.dw	16*2	; Tarzans Home
	.dw	16*2	; Apes Clearing
	.dw	16*2	; Swamp

	.dw	16*2	; Beach
	.dw	NONE	; Beach-Bay
	.dw	16*2	; Reef
	.dw	16*2	; Ship
	.dw	NONE	; Ship Hold A

	.dw	NONE	; Ship Hold B
	.dw	16*2	; Jungle 3
	.dw	16*2	; Downriver
	.dw	16*2	; Jungle 4
	.dw	16*2	; UpRiver

	.dw	NONE	; Waterfall
	.dw	NONE	; Caverns
	.dw	16*2	; Opar - Street
	.dw	16*2	; Opar - Wells
	.dw	16*2	; Opar - Temple

	.dw	16*2	; Opar - Shamon Boss

	.dw	16*2	; Bonus Level - Exterior
	.dw	NONE	; Bonus Level - Interior


; sizes are the length in bytes of the transfer buffer

_bg1sizes  
	.db	128	; Tarzans Home
	.db	128 	; Apes Clearing
	.db	128	; Swamp

	.db	128	; Beach
	.db	NONE	; Beach-Bay
	.db	128	; Reef
	.db	128	; Ship
	.db	128	; Ship Hold A

	.db	128	; Ship Hold B
	.db	128	; Jungle 3
	.db	128	; Downriver
	.db	128	; Jungle 4
	.db	128	; UpRiver

	.db	128	; Waterfall
	.db	128	; Caverns
	.db	128	; Opar - Street
	.db	128	; Opar - Wells
	.db	128	; Opar - Temple

	.db	128	; Opar - Shamon Boss

	.db	128	; Bonus Level - Exterior
	.db	128	; Bonus Level - Interior


_bg2sizes  
	.db	128	; Tarzans Home
	.db	128 	; Apes Clearing
	.db	128	; Swamp

	.db	128	; Beach
	.db	NONE	; Beach-Bay
	.db	128	; Reef
	.db	128	; Ship
	.db	NONE	; Ship Hold A

	.db	NONE	; Ship Hold B
	.db	128	; Jungle 3
	.db	128	; Downriver
	.db	128	; Jungle 4
	.db	128	; UpRiver

	.db	128	; Waterfall
	.db	128	; Caverns
	.db	128	; Opar - Street
	.db	128	; Opar - Wells
	.db	128	; Opar - Temple

	.db	128	; Opar - Shamon Boss

	.db	128	; Bonus Level - Exterior
	.db	NONE	; Bonus Level - Interior


_bg3sizes  
	.db	64	; Tarzans Home
	.db	64  	; Apes Clearing
	.db	64	; Swamp

	.db	64	; Beach
	.db	NONE	; Beach-Bay
	.db	64	; Reef
	.db	64	; Ship
	.db	NONE	; Ship Hold A

	.db	NONE	; Ship Hold B
	.db	64	; Jungle 3
	.db	64	; Downriver
	.db	64	; Jungle 4
	.db	64	; UpRiver

	.db	NONE	; Waterfall
	.db	NONE	; Caverns
	.db	64	; Opar - Street
	.db	64	; Opar - Wells
	.db	64	; Opar - Temple

	.db	64	; Opar - Shamon Boss

	.db	64	; Bonus Level - Exterior
	.db	NONE	; Bonus Level - Interior


; skip scrolling for planes indicated

_skipsups 
	.db	NONE	; Tarzans Home
	.db	NONE	; Apes Clearing
	.db	NONE	; Swamp

	.db	NONE	; Beach
	.db	NONE	; Beach-Bay
	.db	NONE	; Reef
	.db	NONE	; Ship
	.db	$06	; Ship Hold A

	.db	$06	; Ship Hold B
	.db	NONE	; Jungle 3
	.db	NONE	; Downriver
	.db	NONE	; Jungle 4
	.db	NONE	; UpRiver

	.db	$04	; Waterfall (Skip BG3)
	.db	$04	; Caverns
	.db	$04	; Opar - Street
	.db	$04	; Opar - Wells
	.db	NONE	; Opar - Temple

	.db	NONE	; Opar - Shamon Boss

	.db	NONE	; Bonus Level - Exterior
	.db	$06	; Bonus Level - Interior



; xfertypes are $81 for column updates, $80 for row updates

_xfertypes 
	.db	$80	; Tarzans Home
	.db	$81 	; Apes Clearing
	.db	$81	; Swamp

	.db	$81	; Beach
	.db	NONE	; Beach-Bay
	.db	$81	; Reef
	.db	$81	; Ship
	.db	$81	; Ship Hold A

	.db	$81	; Ship Hold B
	.db	$81	; Jungle 3
	.db	$81	; Downriver
	.db	$81	; Jungle 4
	.db	$81	; UpRiver

	.db	$80	; Waterfall
	.db	$81	; Caverns
	.db	$81	; Opar - Street
	.db	$81	; Opar - Wells
	.db	$81	; Opar - Temple

	.db	$81	; Opar - Shamon Boss

	.db	$81	; Bonus Level - Exterior
	.db	$81	; Bonus Level - Interior



; max horiz scroll offset, in pixels

_hoff1maxs 
	.dw	3*256	; Tarzans Home
	.dw	3*256	; Apes Clearing
	.dw	7*256	; Swamp

	.dw	11*256	; Beach
	.dw	NONE	; Beach-Bay
	.dw	7*256	; Reef
	.dw	7*256	; Ship
	.dw	5*256	; Ship Hold A

	.dw	5*256	; Ship Hold B
	.dw	7*256	; Jungle 3
	.dw	7*256	; Downriver
	.dw	7*256	; Jungle 4
	.dw	7*256	; UpRiver

	.dw	3*256	; Waterfall
	.dw	7*256	; Caverns
	.dw	7*256	; Opar - Street
	.dw	9*256	; Opar - Wells
	.dw	7*256	; Opar - Temple

	.dw	3*256	; Opar - Shamon Boss

	.dw	5*256	; Bonus Level - Exterior
	.dw	384	; Bonus Level - Interior


; min horiz scroll offset, in pixels

_hoff1mins 
	.dw	32	; Tarzans Home
	.dw	32	; Apes Clearing
	.dw	32	; Swamp

	.dw	32	; Beach
	.dw	NONE	; Beach-Bay
	.dw	32	; Reef
	.dw	32	; Ship
	.dw	32	; Ship Hold A

	.dw	32	; Ship Hold B
	.dw	32	; Jungle 3
	.dw	32	; Downriver
	.dw	32	; Jungle 4
	.dw	32	; UpRiver

	.dw	32	; Waterfall
	.dw	32	; Caverns
	.dw	32	; Opar - Street
	.dw	32	; Opar - Wells
	.dw	32	; Opar - Temple

	.dw	32	; Opar - Shamon Boss

	.dw	32	; Bonus Level - Exterior
	.dw	384	; Bonus Level - Interior



; max vert scroll offset, in pixels

_voff1maxs 
	.dw	1824	; Tarzans Home
	.dw	736	; Apes Clearing
	.dw	702	; Swamp

	.dw	800	; Beach
	.dw	NONE	; Beach-Bay
	.dw	800	; Reef
	.dw	768	; Ship
	.dw	532	; Ship Hold A

	.dw	532	; Ship Hold B
	.dw	800	; Jungle 3
	.dw	800	; Downriver
	.dw	560	; Jungle 4
	.dw	800	; UpRiver

	.dw	1800	; Waterfall
	.dw	800	; Caverns
	.dw	784	; Opar - Street
	.dw	800	; Opar - Wells
	.dw	544	; Opar - Temple

	.dw	544	; Opar - Shamon Boss

	.dw	800	; Bonus Level - Exterior
	.dw	544	; Bonus Level - Interior


; min vert scroll offset, in pixels

_voff1mins 
	.dw	32	; Tarzans Home
	.dw	64	; Apes Clearing
	.dw	64	; Swamp

	.dw	800	; Beach
	.dw	NONE	; Beach-Bay
	.dw	16	; Reef
	.dw	16	; Ship
	.dw	16	; Ship Hold A

	.dw	16	; Ship Hold B
	.dw	32	; Jungle 3
	.dw	624	; Downriver
	.dw	32	; Jungle 4
	.dw	300	; UpRiver

	.dw	80	; Waterfall
	.dw	64	; Caverns
	.dw	64	; Opar - Street
	.dw	64	; Opar - Wells
	.dw	64	; Opar - Temple

	.dw	64	; Opar - Shamon Boss

	.dw	32	; Bonus Level - Exterior
	.dw	544	; Bonus Level - Interior



_bg1chrmasks 
	.dw	CHARMASK16	; Tarzans Home
	.dw	CHARMASK16	; Apes Clearing
	.dw	CHARMASK16	; Swamp

	.dw	CHARMASK16	; Beach
	.dw	CHARMASK16	; Beach-Bay
	.dw	CHARMASK16	; Reef
	.dw	CHARMASK16	; Ship
	.dw	CHARMASK16	; Ship Hold A

	.dw	CHARMASK16	; Ship Hold B
	.dw	CHARMASK16	; Jungle 3
	.dw	CHARMASK16	; Downriver
	.dw	CHARMASK16	; Jungle 4
	.dw	CHARMASK16	; UpRiver

	.dw	CHARMASK16	; Waterfall
	.dw	CHARMASK16	; Caverns
	.dw	CHARMASK16	; Opar - Street
	.dw	CHARMASK16	; Opar - Wells
	.dw	CHARMASK16	; Opar - Temple

	.dw	CHARMASK16	; Opar - Shamon Boss

	.dw	CHARMASK16	; Bonus Level - Exterior
	.dw	CHARMASK16	; Bonus Level - Interior


_bg2chrmasks 
	.dw	CHARMASK16	; Jungle 1
	.dw	CHARMASK16	; Tarzans Home
	.dw	CHARMASK16	; Apes Clearing
	.dw	CHARMASK16	; Swamp

	.dw	CHARMASK16	; Beach
	.dw	CHARMASK16	; Beach-Bay
	.dw	CHARMASK16	; Reef
	.dw	CHARMASK16	; Ship
	.dw	CHARMASK16	; Ship Hold A

	.dw	CHARMASK16	; Ship Hold B
	.dw	CHARMASK16	; Jungle 3
	.dw	CHARMASK16	; Downriver
	.dw	CHARMASK16	; Jungle 4
	.dw	CHARMASK16	; UpRiver

	.dw	CHARMASK16	; Waterfall
	.dw	CHARMASK16	; Caverns
	.dw	CHARMASK16	; Opar - Street
	.dw	CHARMASK16	; Opar - Wells
	.dw	CHARMASK16	; Opar - Temple

	.dw	CHARMASK16	; Opar - Shamon Boss

	.dw	CHARMASK16	; Bonus Level - Exterior
	.dw	CHARMASK16	; Bonus Level - Interior


_bg3chrmasks 
	.dw	CHARMASK16	; Jungle 1
	.dw	CHARMASK16	; Tarzans Home
	.dw	CHARMASK16	; Apes Clearing
	.dw	CHARMASK16	; Swamp

	.dw	CHARMASK16	; Beach
	.dw	CHARMASK16	; Beach-Bay
	.dw	CHARMASK16	; Reef
	.dw	CHARMASK16	; Ship
	.dw	CHARMASK16	; Ship Hold A

	.dw	CHARMASK16	; Ship Hold B
	.dw	CHARMASK16	; Jungle 3
	.dw	CHARMASK16	; Downriver
	.dw	CHARMASK16	; Jungle 4
	.dw	CHARMASK16	; UpRiver

	.dw	CHARMASK16	; Waterfall
	.dw	CHARMASK16	; Caverns
	.dw	CHARMASK16	; Opar - Street
	.dw	CHARMASK16	; Opar - Wells
	.dw	CHARMASK16	; Opar - Temple

	.dw	CHARMASK16	; Opar - Shamon Boss

	.dw	CHARMASK16	; Bonus Level - Exterior
	.dw	CHARMASK16	; Bonus Level - Interior


_bgmodes
	.db	$71	; Tarzans Home
	.db	$71	; Apes Clearing
	.db	$79	; Swamp

	.db	$71	; Beach
	.db	NONE	; Beach-Bay
	.db	$71	; Reef
	.db	$71	; Ship
	.db	$71	; Ship Hold A

	.db	$71	; Ship Hold B
	.db	$71	; Jungle 3
	.db	$71	; Downriver
	.db	$71	; Jungle 4
	.db	$71	; UpRiver

	.db	$71	; Waterfall
	.db	$71	; Caverns
	.db	$71	; Opar - Street
	.db	$71	; Opar - Wells
	.db	$71	; Opar - Temple

	.db	$71	; Opar - Shamon Boss

	.db	$71	; Bonus Level - Exterior
	.db	$71	; Bonus Level - Interior


_bgenables 
	.db	$17	; Tarzans Home
	.db	$17	; Apes Clearing
	.db	$13	; Swamp

	.db	$17	; Beach
	.db	NONE	; Beach-Bay
	.db	$17	; Reef
	.db	$17	; Ship
	.db	$11	; Ship Hold A

	.db	$11	; Ship Hold B
	.db	$17	; Jungle 3
	.db	$17	; Downriver
	.db	$17	; Jungle 4
	.db	$17	; UpRiver

	.db	$13	; Waterfall
	.db	$13	; Caverns
	.db	$17	; Opar - Street
	.db	$13	; Opar - Wells
	.db	$17	; Opar - Temple

	.db	$17	; Opar - Shamon Boss

	.db	$17	; Bonus Level - Exterior
	.db	$11	; Bonus Level - Interior



; STARTing horizontal offsets of screens (z_levely)

_bg1hoffs
	.dw	224	; Tarzans Home
	.dw	24	; Apes Clearing
	.dw	24	; Swamp

	.dw	24	; Beach
	.dw	NONE	; Beach-Bay
	.dw	1776	; Reef
	.dw	1792	; Ship
	.dw	1228	; Ship Hold A

	.dw	28	; Ship Hold B
	.dw	24	; Jungle 3
	.dw	104	; Downriver
	.dw	24	; Jungle 4
	.dw	104	; UpRiver

	.dw	24	; Waterfall
	.dw	24	; Caverns
	.dw	24	; Opar - Street
	.dw	24	; Opar - Wells
	.dw	24	; Opar - Temple

	.dw	24	; Opar - Shamon Boss

	.dw	112	; Bonus Level - Exterior
	.dw	256	; Bonus Level - Interior


_bg2hoffs 
	.dw	160	; Tarzans Home
	.dw	16	; Apes Clearing
	.dw	16	; Swamp

	.dw	352	; Beach
	.dw	NONE	; Beach-Bay
	.dw	1216	; Reef
	.dw	16	; Ship
	.dw	NONE	; Ship Hold A

	.dw	NONE	; Ship Hold B
	.dw	16	; Jungle 3
	.dw	16	; Downriver
	.dw	16	; Jungle 4
	.dw	384	; UpRiver

	.dw	16	; Waterfall
	.dw	16	; Caverns
	.dw	16	; Opar - Street
	.dw	536	; Opar - Wells
	.dw	16	; Opar - Temple

	.dw	16	; Opar - Shamon Boss

	.dw	16	; Bonus Level - Exterior
	.dw	NONE	; Bonus Level - Interior


_bg3hoffs 
	.dw	16	; Tarzans Home
	.dw	16	; Apes Clearing
	.dw	16	; Swamp

	.dw	16	; Beach
	.dw	NONE	; Beach-Bay
	.dw	16	; Reef
	.dw	16	; Ship
	.dw	NONE	; Ship Hold A

	.dw	NONE	; Ship Hold B
	.dw	16	; Jungle 3
	.dw	16	; Downriver
	.dw	16	; Jungle 4
	.dw	16	; UpRiver

	.dw	NONE	; Waterfall
	.dw	NONE	; Caverns
	.dw	16	; Opar - Street
	.dw	16	; Opar - Wells
	.dw	16	; Opar - Temple

	.dw	16	; Opar - Shamon Boss

	.dw	16	; Bonus Level - Exterior
	.dw	NONE	; Bonus Level - Interior


; starting vertical offsets of screens (z_levelx)
; STARTV

_bg1voffs  
	.dw	66	; Tarzans Home
	.dw	736	; Apes Clearing
	.dw	712	; Swamp

	.dw	800	; Beach
	.dw	NONE	; Beach-Bay
	.dw	64	; Reef
	.dw	728	; Ship
	.dw	528	; Ship Hold A

	.dw	528	; Ship Hold B
	.dw	232	; Jungle 3
	.dw	716	; Downriver
	.dw	560	; Jungle 4
	.dw	716	; UpRiver

	.dw	1792	; Waterfall
	.dw	92	; Caverns
	.dw	768	; Opar - Street
	.dw	32	; Opar - Wells
	.dw	544	; Opar - Temple

	.dw	446	; Opar - Shamon Boss

	.dw	136	; Bonus Level - Exterior
	.dw	526	; Bonus Level - Interior


_bg2voffs
	.dw	200	; Tarzans Home
	.dw	768	; Apes Clearing
	.dw	768	; Swamp

	.dw	800	; Beach
	.dw	NONE	; Beach-Bay
	.dw	224	; Reef
	.dw	752	; Ship
	.dw	NONE	; Ship Hold A

	.dw	1616	; Ship Hold B
	.dw	256	; Jungle 3
	.dw	720	; Downriver
	.dw	496	; Jungle 4
	.dw	656	; UpRiver

	.dw	1296	; Waterfall
	.dw	16	; Caverns
	.dw	768	; Opar - Street
	.dw	336	; Opar - Wells (336)
	.dw	816	; Opar - Temple

	.dw	816	; Opar - Shamon Boss

	.dw	480	; Bonus Level - Exterior
	.dw	NONE	; Bonus Level - Interior


_bg3voffs
	.dw	32	; Tarzans Home
	.dw	264	; Apes Clearing
	.dw	280	; Swamp

	.dw	288	; Beach
	.dw	NONE	; Beach-Bay
	.dw	96	; Reef
	.dw	288	; Ship
	.dw	NONE	; Ship Hold A

	.dw	NONE	; Ship Hold B
	.dw	48	; Jungle 3
	.dw	112	; Downriver
	.dw	96	; Jungle 4
	.dw	252	; UpRiver

	.dw	16	; Waterfall
	.dw	NONE	; Caverns
	.dw	272	; Opar - Street
	.dw	16	; Opar - Wells
	.dw	340	; Opar - Temple

	.dw	340	; Opar - Shamon Boss

	.dw	16	; Bonus Level - Exterior
	.dw	NONE	; Bonus Level - Interior




; 0 = single height (also NONE)
; 1 = double height
; 2 = double width
; 3 = double in both

_scsize1
	.db	1	; Tarzans Home
	.db	2	; Apes Clearing
	.db	2	; Swamp

	.db	2	; Beach
	.db	NONE	; Beach-Bay
	.db	2	; Reef
	.db	2	; Ship
	.db	2	; Ship Hold A

	.db	2	; Ship Hold B
	.db	2	; Jungle 3
	.db	2	; Downriver
	.db	2	; Jungle 4
	.db	2	; UpRiver

	.db	1	; Waterfall
	.db	2	; Caverns
	.db	2	; Opar - Street
	.db	2	; Opar - Wells
	.db	2	; Opar - Temple

	.db	2	; Opar - Shamon Boss

	.db	2	; Bonus Level - Exterior
	.db	2	; Bonus Level - Interior


_scsize2   
	.db	1	; Tarzans Home
	.db	2	; Apes Clearing
	.db	2	; Swamp

	.db	2	; Beach
	.db	NONE	; Beach-Bay
	.db	2	; Reef
	.db	2	; Ship
	.db	NONE	; Ship Hold A

	.db	NONE	; Ship Hold B
	.db	2	; Jungle 3
	.db	2	; Downriver
	.db	2	; Jungle 4
	.db	2	; UpRiver

	.db	1	; Waterfall
	.db	2	; Caverns
	.db	2	; Opar - Street
	.db	2	; Opar - Wells
	.db	2	; Opar - Temple

	.db	2	; Opar - Shamon Boss

	.db	2	; Bonus Level - Exterior
	.db	NONE	; Bonus Level - Interior



_scsize3   
	.db	NONE	; Tarzans Home
	.db	NONE	; Apes Clearing
	.db	NONE	; Swamp

	.db	NONE	; Beach
	.db	NONE	; Beach-Bay
	.db	NONE	; Reef
	.db	NONE	; Ship
	.db	NONE	; Ship Hold A

	.db	NONE	; Ship Hold B
	.db	NONE	; Jungle 3
	.db	NONE	; Downriver
	.db	NONE	; Jungle 4
	.db	NONE	; UpRiver

	.db	NONE	; Waterfall
	.db	NONE	; Caverns
	.db	NONE	; Opar - Street
	.db	NONE	; Opar - Wells
	.db	NONE	; Opar - Temple

	.db	NONE	; Opar - Shamon Boss

	.db	NONE	; Bonus Level - Exterior
	.db	NONE	; Bonus Level - Interior


; SHARED: 1 & 2 share char set, DIVIDED: 1 & 2 char sets are divided

_bg12nba   
	.db	DIVIDED	; Tarzans Home
	.db	DIVIDED	; Apes Clearing
	.db	DIVIDED	; Swamp

	.db	DIVIDED	; Beach
	.db	NONE	; Beach-Bay
	.db	DIVIDED	; Reef
	.db	DIVIDED	; Ship
	.db	DIVIDED	; Ship Hold A

	.db	DIVIDED	; Ship Hold B
	.db	DIVIDED	; Jungle 3
	.db	DIVIDED	; Downriver
	.db	DIVIDED	; Jungle 4
	.db	DIVIDED	; UpRiver

	.db	DIVIDED	; Waterfall
	.db	DIVIDED	; Caverns
	.db	DIVIDED	; Opar - Street
	.db	DIVIDED	; Opar - Wells
	.db	DIVIDED	; Opar - Temple

	.db	DIVIDED	; Opar - Shamon Boss

	.db	DIVIDED	; Bonus Level - Exterior
	.db	DIVIDED	; Bonus Level - Interior


_dxstart   
	.dw	352	; Tarzans Home
	.dw	DXMID	; Apes Clearing
	.dw	64	; Swamp

	.dw	DXMID	; Beach
	.dw	NONE	; Beach-Bay
	.dw	1904	; Reef
	.dw	1984	; Ship
	.dw	1356	; Ship Hold A

	.dw	DXMID+32	; Ship Hold B
	.dw	DXMID-32	; Jungle 3
	.dw	DXMID+104	; Downriver
	.dw	DXMID	; Jungle 4
	.dw	DXMID+104	; UpRiver

	.dw	DXMID-48	; Waterfall
	.dw	DXMID	; Caverns
	.dw	DXMID	; Opar - Street
	.dw	DXMID-16	; Opar - Wells
	.dw	DXMID	; Opar - Temple

	.dw	DXMID	; Opar - Shamon Boss

	.dw	DXMID+112	; Bonus Level - Exterior
	.dw	DXMID+156	; Bonus Level - Interior


_dystart
	.dw	194	; Tarzans Home
	.dw	928	; Apes Clearing
	.dw	856	; Swamp

	.dw	992	; Beach
	.dw	NONE	; Beach-Bay
	.dw	192	; Reef
	.dw	856	; Ship
	.dw	464	; Ship Hold A

	.dw	464	; Ship Hold B
	.dw	360	; Jungle 3
	.dw	844	; Downriver
	.dw	752	; Jungle 4
	.dw	844	; UpRiver

	.dw	1992	; Waterfall
	.dw	220	; Caverns
	.dw	960	; Opar - Street
	.dw	632	; Opar - Wells
	.dw	736	; Opar - Temple

	.dw	606	; Opar - Shamon Boss

	.dw	264	; Bonus Level - Exterior
	.dw	712	; Bonus Level - Interior


; max horizontal distance that Tarzan can go

d_maxxs
	.dw	$3E5+$10	; Tarzans Home
	.dw	$3E5+$10	; Apes Clearing
	.dw	$7E5+$10	; Swamp

	.dw	$BE5+$10	; Beach
	.dw	NONE	; Beach-Bay
	.dw	$7E0+$10	; Reef
	.dw	$7E0+$10	; Ship
	.dw	$5E5+$10	; Ship Hold A

	.dw	$5E5+$10	; Ship Hold B
	.dw	$7E5+$10	; Jungle 3
	.dw	$7E5+$10	; Downriver
	.dw	$7E5+$10	; Jungle 4
	.dw	$7E5+$10	; UpRiver

	.dw	$3E5+$10	; Waterfall
	.dw	$7E5+$10	; Caverns
	.dw	$7E5+$10	; Opar - Street
	.dw	$9E5+$10	; Opar - Wells
	.dw	$7E5+$10	; Opar - Temple

	.dw	$3E5+$10	; Opar - Shamon Boss

	.dw	$5E5+$10	; Bonus Level - Exterior
	.dw	$1E5+$10	; Bonus Level - Interior


; min horizontal distance that Tarzan can go

d_minx
	.dw	$30	; Tarzans Home
	.dw	$30 	; Apes Clearing
	.dw	$30	; Swamp

	.dw	$30	; Beach
	.dw	NONE	; Beach-Bay
	.dw	$30	; Reef
	.dw	$30	; Ship
	.dw	$30	; Ship Hold A

	.dw	$30	; Ship Hold B
	.dw	$30	; Jungle 3
	.dw	$30	; Downriver
	.dw	$30	; Jungle 4
	.dw	$30	; UpRiver

	.dw	$30	; Waterfall
	.dw	$30	; Caverns
	.dw	$30	; Opar - Street
	.dw	$30	; Opar - Wells
	.dw	$30	; Opar - Temple

	.dw	$30	; Opar - Shamon Boss

	.dw	$30	; Bonus Level - Exterior
	.dw	$01	; Bonus Level - Interior



d_maxy
	.dw	$1000	; Tarzans Home
	.dw	$1000	; Apes Clearing
	.dw	$1000	; Swamp

	.dw	$1000	; Beach
	.dw	$1000	; none
	.dw	$1000	; Reef
	.dw	$1000	; Ship
	.dw	$02D4	; Ship Hold A

	.dw	$02D4	; Ship Hold B
	.dw	$1000	; Jungle 3
	.dw	$03E3	; Downriver
	.dw	$1000	; Jungle 4
	.dw	$1000	; UpRiver

	.dw	$2000	; Waterfall
	.dw	$1000	; Caverns
	.dw	$1000	; Opar - Street
	.dw	$1000	; Opar - Wells
	.dw	$1000	; Opar - Temple

	.dw	$1000	; Opar - Shamon Boss

	.dw	$1000	; Bonus Level - Exterior
	.dw	$1000	; Bonus Level - Interior


d_fallmax
	.dw	$812	; Tarzans Home
	.dw	$912	; Apes Clearing	- Vine
	.dw	$912	; Swamp	- Vine (maybe)

	.dw	$812	; Beach
	.dw	NONE	; Beach-Bay
	.dw	$812	; Reef
	.dw	$812	; Ship	- Vine
	.dw	$812	; Ship Hold A

	.dw	$812	; Ship Hold B
	.dw	$812	; Jungle 3	- Vine
	.dw	$812	; Downriver
	.dw	$812	; Jungle 4	- Vine
	.dw	$812	; UpRiver

	.dw	$812 	; Waterfall	- Vine
	.dw	$812	; Caverns
	.dw	$812	; Opar - Street
	.dw	$812	; Opar - Wells
	.dw	$812	; Opar - Temple

	.dw	$812	; Opar - Shamon Boss

	.dw	$812	; Bonus Level - Exterior
	.dw	$812	; Bonus Level - Interior


d_tzanslot:
	.dw	$60	; Tarzans Home
	.dw	$60	; Apes Clearing	- Vine
	.dw	$60	; Swamp	- Vine (maybe)

	.dw	$60	; Beach
	.dw	NONE	; Beach-Bay
	.dw	$60	; Reef
	.dw	$60	; Ship	- Vine
	.dw	$60	; Ship Hold A

	.dw	$60	; Ship Hold B
	.dw	$60	; Jungle 3	- Vine
	.dw	$60	; Downriver
	.dw	$60	; Jungle 4	- Vine
	.dw	$60	; UpRiver

	.dw	$60 	; Waterfall	- Vine
	.dw	$60	; Caverns
	.dw	$60	; Opar - Street
	.dw	$60	; Opar - Wells
	.dw	$60	; Opar - Temple

	.dw	$60	; Opar - Shamon Boss

	.dw	$60	; Bonus Level - Exterior
	.dw	$60	; Bonus Level - Interior


d_priority
	.dw	$3000	; Tarzans Home
	.dw	$3000	; Apes Clearing
	.dw	$2000	; Swamp

	.dw	$2000	; Beach
	.dw	$3000	; none
	.dw	$2000	; Reef
	.dw	$2000	; Ship
	.dw	$2000	; Ship Hold A

	.dw	$2000	; Ship Hold B
	.dw	$3000	; Jungle 3
	.dw	$2000	; Downriver
	.dw	$3000	; Jungle 4
	.dw	$2000	; UpRiver

	.dw	$3000	; Waterfall
	.dw	$2000	; Caverns
	.dw	$2000	; Opar - Street
	.dw	$2000	; Opar - Wells
	.dw	$2000	; Opar - Temple

	.dw	$2000	; Opar - Shamon Boss

	.dw	$3000	; Bonus Level - Exterior
	.dw	$2000	; Bonus Level - Interior

*
* Initial player direction
*
* LSB is direction :
*
*     MOVUP = 1
*     MOVDN = 2
*     MOVLT = 4
*     MOVRT = 8
*
* MSB is initial Animation mode which ultimatly 
*     serves as a pointer into a table containing
*     AI routine addresses.
*


d_initdir
	.db	MOVRT,tzidle4mode00	; Tarzans Home
	.db	MOVRT,tzidle4mode00	; Apes Clearing
	.db	MOVRT,tzidle4mode00	; Swamp

	.db	MOVRT,tzwait1mode00	; Beach
	.db	$00,$00		; Replace
	.db	MOVLT,tzswimmode00	; Reef
	.db	MOVLT,tzwait1mode00	; Ship
	.db	MOVLT,tzwait1mode00	; Ship Hold A

	.db	MOVRT,tzwait1mode00	; Ship Hold B
	.db	MOVRT,tzwait1mode00	; Jungle 3
	.db	MOVRT,tzswimmode01	; Downriver
	.db	MOVRT,tzwait1mode00	; Jungle 4
	.db	MOVRT,tzswimmode01	; UpRiver

	.db	MOVRT,tzwait1mode00	; Waterfall
	.db	MOVRT,tzwait1mode00	; Caverns
	.db	MOVRT,tzwait1mode00	; Opar - Street
	.db	MOVRT,tzfallonly	; Opar - Wells
	.db	MOVRT,tzwait1mode00	; Opar - Temple

	.db	MOVRT,tzidle4mode00	; Opar - Shamon Boss

	.db	MOVRT,tzwait1mode00	; Bonus Level - Exterior
	.db	MOVRT,tzwait1mode00	; Bonus Level - Interior


	; Current (for water) & gravity values
d_phyics
	.db	$02,$02		; Tarzans Home 
	.db	$02,$02		; Apes Clearing 
	.db	$02,$02		; Swamp 

	.db	$02,$02		; Beach 
	.db	$02,$02		; Replace 
	.db	$00,$02		; Reef 
	.db	$02,$02		; Ship 
	.db	$02,$02		; Ship Hold A 

	.db	$02,$02		; Ship Hold B 
	.db	$02,$02		; Jungle 3 
	.db	$02,$02		; Downriver 
	.db	$02,$02		; Jungle 4 
	.db	$02,$02		; UpRiver 

	.db	$02,$02		; Waterfall 
	.db	$02,$02		; Caverns 
	.db	$02,$02		; Opar - Street 
	.db	$02,$02		; Opar - Wells 
	.db	$02,$02		; Opar - Temple 

	.db	$02,$02		; Opar - Shamon Boss 

	.db	$02,$02		; Bonus Level - Exterior 
	.db	$02,$02		; Bonus Level - Interior 



_jumpvectors
	.dw	Tzantreelevel	; Tarzans Home
	.dw	Apeclearing	; Apes Clearing
	.dw	Swamplevel	; Swamp

	.dw	Beachlevel	; Beach
	.dw	NoLevelYet	; Beach-Bay
	.dw	Reeflevel	; Reef
	.dw	Shiplevel	; Ship
	.dw	Shipshold	; Ship Hold A

	.dw	Shipshold	; Ship Hold B
	.dw	MidJungle	; Jungle 3
	.dw	Downriver	; Downriver
	.dw	UpperJungle	; Jungle 4
	.dw	Upriver	; UpRiver

	.dw	Waterfall	; Waterfall
	.dw	Cavernlevel	; Caverns
	.dw	Oparstreet	; Opar - Street
	.dw	Wellslevel	; Opar - Wells
	.dw	Templelevel	; Opar - Temple

	.dw	DoShamonBoss	; Opar - Shamon Boss

	.dw	BonusX	; Bonus Level - Exterior
	.dw	BonusI	; Bonus Level - Interior


; which level to go to next

_nextlevel
	.dw	CLEARING	; Tarzans Home
	.dw	SWAMP	; Apes Clearing
	.dw	BEACH	; Swamp

	.dw	REEF	; Beach
	.dw	REEF	; Beach-Bay
	.dw	SHIP	; Reef
	.dw	JUNGLE3	; Ship
	.dw	SHIP	; Ships Hold 

	.dw	JUNGLE3	; Ship Hold B
	.dw	DOWNRIVER	; Jungle 3
	.dw	JUNGLE4	; Downriver
	.dw	UPRIVER	; Jungle 4
	.dw	WATERFALL	; UpRiver

	.dw	CAVERNS	; Waterfall
	.dw	OPARSTREET	; Caverns
	.dw	OPARTEMPLE	; Opar - Street
	.dw	OPARTEMPLE	; Opar - Wells [REMOVED FROM GAME]
	.dw	SHAMONBOSS	; Opar - Temple

	.dw	BONUSEXT	; Opar - Shamon Boss

	.dw	BONUSINT	; Bonus Level - Exterior
	.dw	OVERSHOOT	; Bonus Level - Exterior
	.dw	NONE	; Bonus Level - Interior

d_numcoins
	.dw	30	; Tarzans Home
	.dw	30	; Apes Clearing	- Vine
	.dw	30	; Swamp	- Vine (maybe)

	.dw	30	; Beach
	.dw	NONE	; Beach-Bay
	.dw	30	; Reef
	.dw	20	; Ship	- Vine
	.dw	10	; Ship Hold A

	.dw	0	; Ship Hold B
	.dw	30	; Jungle 3	- Vine
	.dw	30	; Downriver
	.dw	30	; Jungle 4	- Vine
	.dw	30	; UpRiver

	.dw	30 	; Waterfall	- Vine
	.dw	30	; Caverns
	.dw	30	; Opar - Street
	.dw	30	; Opar - Wells
	.dw	30	; Opar - Temple

	.dw	NONE	; Opar - Shamon Boss

	.dw	30	; Bonus Level - Exterior
	.dw	05	; Bonus Level - Interior


d_numcoinsget
	.dw	6	; Tarzans Home
	.dw	6	; Apes Clearing	- Vine
	.dw	6	; Swamp	- Vine (maybe)

	.dw	6	; Beach
	.dw	NONE	; Beach-Bay
	.dw	6	; Reef
	.dw	6	; Ship	- Vine
	.dw	1	; Ship Hold A

	.dw	1	; Ship Hold B
	.dw	6	; Jungle 3	- Vine
	.dw	6	; Downriver
	.dw	6	; Jungle 4	- Vine
	.dw	6	; UpRiver

	.dw	6 	; Waterfall	- Vine
	.dw	6	; Caverns
	.dw	6	; Opar - Street
	.dw	6	; Opar - Wells
	.dw	6	; Opar - Temple

	.dw	NONE	; Opar - Shamon Boss

	.dw	6	; Bonus Level - Exterior
	.dw	5	; Bonus Level - Interior

                                  
d_disablecycle
	.dw	0	; Tarzans Home
	.dw	0	; Apes Clearing	- Vine
	.dw	0	; Swamp	- Vine (maybe)

	.dw	1	; Beach
	.dw	NONE	; Beach-Bay
	.dw	1	; Reef
	.dw	1	; Ship	- Vine
	.dw	0	; Ship Hold A

	.dw	0	; Ship Hold B
	.dw	0	; Jungle 3	- Vine
	.dw	1	; Downriver
	.dw	0	; Jungle 4	- Vine
	.dw	1	; UpRiver

	.dw	1 	; Waterfall	- Vine
	.dw	0	; Caverns
	.dw	0	; Opar - Street
	.dw	0	; Opar - Wells
	.dw	1	; Opar - Temple

	.dw	1	; Opar - Shamon Boss

	.dw	0	; Bonus Level - Exterior
	.dw	0	; Bonus Level - Interior


                                  
*****************************************************************************
*
* Vine Data
*
*****************************************************************************

VINEA	.equ	0

VLEFT	.equ	0
VRIGHT	.equ	$4000
VINERST	.equ	-1	; Reset to initial position

d_novine	.equ	0

d_vinedats:
	.dw	d_novine	; Null Level
	.dw	d_vinejngl1	; Jungle 1
	.dw	d_novine	; Tarzans Home
	.dw	d_vineapec	; Apes Clearing
	.dw	d_vineswamp	; Swamp

	.dw	d_novine	; Beach
	.dw	d_novine	; Beach-Bay
	.dw	d_novine	; Reef
	.dw	d_novine	; Ship
	.dw	d_novine	; Ship Hold A

	.dw	d_novine	; Ship Hold B
	.dw	d_vinejngl3	; Jungle 3
	.dw	d_novine	; Downriver
	.dw	d_vinejngl4	; Jungle 4
	.dw	d_novine	; UpRiver

	.dw	d_vinewatrfall	; Waterfall
	.dw	d_novine	; Caverns
	.dw	d_novine	; Opar - Street
	.dw	d_novine	; Opar - Wells
	.dw	d_novine	; Opar - Temple

	.dw	d_novine	; Opar - Shamon Boss

	.dw	d_novine	; Bonus Exterior
	.dw	d_novine	; Bonus Level - Interior

d_vinejngl1:
	.dw	VINEA,$7E8,$13E,VLEFT,VINERST
	.dw	$ffff
d_vineapec:
	.dw	VINEA,$274,$172,VRIGHT,VLEFT
	.dw	$ffff
d_vineswamp:
	.dw	VINEA,$23F,$0AB,VLEFT,VRIGHT
	.dw	VINEA,$458,$0AB,VLEFT,VINERST
	.dw	$ffff
d_vinejngl3:
	.dw	VINEA,$258,$173,VLEFT,VRIGHT
	.dw	$ffff
d_vinejngl4:
	.dw	VINEA,$2D1,$166,VLEFT,VRIGHT
	.dw	$FFFF
d_vinewatrfall:
	.dw	VINEA,$312,$32e,VRIGHT,VINERST
	.dw	$ffff
		        
*****************************************

d_vineseq:
	.dw	NONE
	.dw	tzvine1aseq00
	.dw	tzvine1aseq00

d_vinecol:
	.dw	NONE
	.dw	tzvine1acol
	.dw	tzvine1acol

d_vinedrec:
	.dw	NONE
	.dw	tzvine1a
	.dw	tzvine1a

d_vinebank:
	.dw	NONE
	.dw	^tzvine1a
	.dw	^tzvine1a


*****************************************************************************
*
* The bulk of item related data & code is located in ITEMDAT.ASM & ITEMS.ASM
* respectively.
*
*****************************************************************************

*****************************************************************************
*
* Password pointers
*
*****************************************************************************

d_pass2hoffs 
	.dw	NONE	; Null Level
	.dw	16	; Jungle 1
	.dw	160	; Tarzans Home
	.dw	16	; Apes Clearing
	.dw	16	; Swamp

	.dw	352	; Beach
	.dw	NONE	; Beach-Bay
	.dw	1216	; Reef
	.dw	16	; Ship
	.dw	NONE	; Ship Hold A

	.dw	NONE	; Ship Hold B
	.dw	16	; Jungle 3
	.dw	16	; Downriver
	.dw	16	; Jungle 4
	.dw	32	; UpRiver

	.dw	40	; Waterfall
	.dw	256	; Caverns
	.dw	56	; Opar - Street
	.dw	536	; Opar - Wells
	.dw	56	; Opar - Temple

	.dw	16	; Opar - Shamon Boss

	.dw	16	; Bonus Level - Exterior
	.dw	NONE	; Bonus Level - Interior


d_pass3hoffs 
	.dw	NONE	; Null Level
	.dw	16	; Jungle 1
	.dw	16	; Tarzans Home
	.dw	16	; Apes Clearing
	.dw	16	; Swamp

	.dw	16	; Beach
	.dw	NONE	; Beach-Bay
	.dw	16	; Reef
	.dw	16	; Ship
	.dw	NONE	; Ship Hold A

	.dw	NONE	; Ship Hold B
	.dw	16	; Jungle 3
	.dw	16	; Downriver
	.dw	16	; Jungle 4
	.dw	16	; UpRiver

	.dw	NONE	; Waterfall
	.dw	16	; Caverns
	.dw	48	; Opar - Street
	.dw	16	; Opar - Wells
	.dw	48	; Opar - Temple

	.dw	16	; Opar - Shamon Boss

	.dw	16	; Bonus Level - Exterior
	.dw	NONE	; Bonus Level - Interior


****************************************

d_pass2voffs
	.dw	NONE	; Null Level
	.dw	256	; Jungle 1
	.dw	200	; Tarzans Home
	.dw	48	; Apes Clearing
	.dw	768	; Swamp

	.dw	756	; Beach
	.dw	NONE	; Beach-Bay
	.dw	224	; Reef
	.dw	752	; Ship
	.dw	NONE	; Ship Hold A

	.dw	1616	; Ship Hold B
	.dw	256	; Jungle 3
	.dw	736	; Downriver
	.dw	496	; Jungle 4
	.dw	456	; UpRiver

	.dw	16	; Waterfall
	.dw	256	; Caverns
	.dw	688	; Opar - Street
	.dw	336	; Opar - Wells (336)
	.dw	128	; Opar - Temple

	.dw	816	; Opar - Shamon Boss

	.dw	480	; Bonus Level - Exterior
	.dw	NONE	; Bonus Level - Interior


d_pass3voffs
	.dw	NONE	; Null Level
	.dw	128	; Jungle 1
	.dw	0	; Tarzans Home
	.dw	32	; Apes Clearing
	.dw	280	; Swamp

	.dw	244	; Beach
	.dw	NONE	; Beach-Bay
	.dw	96	; Reef
	.dw	272	; Ship
	.dw	NONE	; Ship Hold A

	.dw	NONE	; Ship Hold B
	.dw	48	; Jungle 3
	.dw	112	; Downriver
	.dw	96	; Jungle 4
	.dw	176	; UpRiver

	.dw	16	; Waterfall
	.dw	16	; Caverns
	.dw	204	; Opar - Street
	.dw	16	; Opar - Wells
	.dw	340	; Opar - Temple

	.dw	340	; Opar - Shamon Boss

	.dw	16	; Bonus Level - Exterior
	.dw	NONE	; Bonus Level - Interior



