*****************************************************************************
*
* Tarzan's Behavior Table (Animation type pointers to sequence data)
*
*

tzwait1mode00	.equ	00
tzidle1mode00	.equ	02
tzidle2mode00	.equ	04
tzidle3mode00	.equ	06
tzidle4mode00	.equ	08

tzfalltrans	.equ	10
tzvinfallmode00	.equ	12
tzwalk3mode00	.equ	14
tzwalk3mode01	.equ	16
tzwalk3mode02	.equ	18

tzrunmode00	.equ	20
tzrunxumode00	.equ	22
tzrunxdmode00	.equ	24
tzlandmode00	.equ	26
tzlandmode01	.equ	28

tzducksmode00	.equ	30
tzducksmode01	.equ	32
tzducksmode02	.equ	34
tzhitfalmode00	.equ	36
tzwkrnxumode00	.equ	38

tzducksmode03	.equ	40
tzswimmode00	.equ	42
tzjumpupmode00	.equ	44
tzstab1mode00	.equ	46
tzstdjmpmode00	.equ	48

tzrnwkxdmode00	.equ	50
tzfallonly	.equ	52
tzshtstdmode00	.equ	54
tzstdjmpmode01	.equ	56
tzstdjmpmode02	.equ	58

tzswimmode01	.equ	60
tzwkawaymode00	.equ	62
tzswingmodeb1	.equ	64
tzswingmodeb2	.equ	66
tzswimmode02	.equ	68

tzvnlandmode00	.equ	70
tzvineonly00	.equ	72
tzswimhit	.equ	74
tzswimrecov	.equ	76
tzfloating	.equ	78

tzfloaturn	.equ	80
tzwalktoclimb	.equ	82
tzclimbingup	.equ	84
tzladrtoplat	.equ	86
tzclimbtofloat	.equ	88

tzljmptoladr	.equ	90
tzclimbingdn	.equ	92
tzclimbtowalk	.equ	94
tzjmpnstb	.equ	96
tzroarmode00	.equ	98

tzfloat2swim	.equ	100
tzregentolife	.equ	102
tzfall2land	.equ	104
tzfall2run	.equ	106
tzjmpfal00	.equ	108

tzjmpfal01	.equ	110
tzhitfalmode01	.equ	112
tzidle4mode01	.equ	114
tzidle4mode02	.equ	116
tzidle4mode03	.equ	118


*****************************************************************************
*
* Animation pointers for each anim type
*

* Sequence data

d_playerseq:
	.dw	tzwait1seq00
	.dw	tzidle1seq00
	.dw	tzidle2seq00
	.dw	tzidle3seq00
	.dw	tzidle4seq00
	
	.dw	tzjpdnhdseq01
	.dw	tzvinfalseq00
	.dw	tzwalk3seq00
	.dw	tzwalk3seq01
	.dw	tzwalk3seq02

	.dw	tzrun2seq02
	.dw	tzrun2seq00
	.dw	tzrun2seq01
	.dw	tzlandseq00
	.dw	tzlandseq01

	.dw	tzducksseq00
	.dw	tzducksseq01
	.dw	tzducksseq02
	.dw	tzhitfalseq00
	.dw	tzwkrnxuseq00

	.dw	tzducksseq03
	.dw	tzswimseq00
	.dw	tzjumpupseq00
	.dw	tzstab1seq00
	.dw	tzstdjmpseq00

	.dw	tzrnwkxdseq00
	.dw	tzjpdnhdseq00
	.dw	tzshtstdseq00
	.dw	tzstdjmpseq01
	.dw	tzstdjmpseq02

	.dw	tzswimseq01
	.dw	tzwkawayseq00
	.dw	tzvineb1seq00
	.dw	tzvineb2seq00
	.dw	tzswimseq02

	.dw	tzvnlandseq00
	.dw	tzvine1aseq00
	.dw	tzswim1seq00
	.dw	tzswim1seq01
	.dw	tzfloatseq00

	.dw	tzfloatseq02
	.dw	tzclimbseq00
	.dw	tzclimbseq01
	.dw	tzclimbseq02
	.dw	tzclimbseq03

	.dw	tzclimbseq04
	.dw	tzclimbseq05
	.dw	tzclimbseq06
	.dw	tzjmpstbseq00
	.dw	tzroarseq00

	.dw	tzfloatseq01
	.dw	tzregenseq00
	.dw	tzlandseq02
	.dw	tzlandseq03
	.dw	tzjmpfalseq00

	.dw	tzjmpfalseq01
	.dw	tzhitfalseq01
	.dw	tzidle4seq01
	.dw	tzidle4seq02
	.dw	tzidle4seq03


d_playercol
	.dw	tzwait1col
	.dw	tzidle1col
	.dw	tzidle2col
	.dw	tzidle3col
	.dw	tzidle4col

	.dw	tzjpdnhdcol
	.dw	tzvinfalcol
	.dw	tzwalk3col
	.dw	tzwalk3col
	.dw	tzwalk3col

	.dw	tzrun2col
	.dw	tzrun2col
	.dw	tzrun2col
	.dw	tzlandcol
	.dw	tzlandcol

	.dw	tzduckscol
	.dw	tzduckscol
	.dw	tzduckscol
	.dw	tzhitfalcol
	.dw	tzwkrnxucol

	.dw	tzduckscol
	.dw	tzswimcol
	.dw	tzjumpupcol
	.dw	tzstab1col
	.dw	tzstdjmpcol

	.dw	tzrnwkxdcol
	.dw	tzjpdnhdcol
	.dw	tzshtstdcol
	.dw	tzstdjmpcol
	.dw	tzstdjmpcol

	.dw	tzswimcol
	.dw	tzwkawaycol
	.dw	tzvineb1col
	.dw	tzvineb2col
	.dw	tzswimcol

	.dw	tzvnlandcol
	.dw	tzvine1acol
	.dw	tzswim1col
	.dw	tzswim1col
	.dw	tzfloatcol
	
	.dw	tzfloatcol
	.dw	tzclimbcol
	.dw	tzclimbcol
	.dw	tzclimbcol
	.dw	tzclimbcol

	.dw	tzclimbcol
	.dw	tzclimbcol
	.dw	tzclimbcol
	.dw	tzjmpstbcol
	.dw	tzroarcol

	.dw	tzfloatcol
	.dw	tzregencol
	.dw	tzlandcol
	.dw	tzlandcol
	.dw	tzjmpfalcol

	.dw	tzjmpfalcol
	.dw	tzhitfalcol
	.dw	tzidle4col
	.dw	tzidle4col
	.dw	tzidle4col



* Sequence Mode Data Record

d_playerdrec
	.dw	tzwait1	;  00
	.dw	tzidle1	;  02
	.dw	tzidle2	;  04
	.dw	tzidle3	;  06
	.dw	tzidle4	;  08

	.dw	tzjpdnhd	;  10
	.dw	tzvinfal	;  12
	.dw	tzwalk3	;  14
	.dw	tzwalk3	;  16
	.dw	tzwalk3	;  18

	.dw	tzrun2	;  20
	.dw	tzrun2	;  22
	.dw	tzrun2	;  24
	.dw	tzland	;  26
	.dw	tzland	;  28

	.dw	tzducks	;  30
	.dw	tzducks	;  32
	.dw	tzducks	;  34
	.dw	tzhitfal	;  36
	.dw	tzwkrnxu	;  38

	.dw	tzducks	;  40
	.dw	tzswim	;  42
	.dw	tzjumpup	;  44
	.dw	tzstab1	;  46
	.dw	tzstdjmp	;  48

	.dw	tzrnwkxd	;  50
	.dw	tzjpdnhd	;  52
	.dw	tzshtstd	;  54
	.dw	tzstdjmp	;  56
	.dw	tzstdjmp	;  58

	.dw	tzswim	;  60
	.dw	tzwkaway	;  62
	.dw	tzvineb1	;  64
	.dw	tzvineb2	;  66
	.dw	tzswim	;  68

	.dw	tzvnland	;  70
	.dw	tzvine1a	;  72
	.dw	tzswim1	;  74
	.dw	tzswim1	;  76
	.dw	tzfloat	;  78
	
	.dw	tzfloat	;  80
	.dw	tzclimb	;  82
	.dw	tzclimb	;  84
	.dw	tzclimb	;  86
	.dw	tzclimb	;  88

	.dw	tzclimb	;  90
	.dw	tzclimb	;  92
	.dw	tzclimb	;  94
	.dw	tzjmpstb	;  96
	.dw	tzroar	;  98

	.dw	tzfloat	; 100
	.dw	tzregen	; 102
	.dw	tzland	; 104
	.dw	tzland	; 106
	.dw	tzjmpfal	; 108

	.dw	tzjmpfal	; 110
	.dw	tzhitfal	; 112
	.dw	tzidle4	; 114
	.dw	tzidle4	; 116
	.dw	tzidle4	; 118



* Sequence data bank

d_playerbank
	.dw	^tzwait1
	.dw	^tzidle1
	.dw	^tzidle2
	.dw	^tzidle3
	.dw	^tzidle4

	.dw	^tzjpdnhd
	.dw	^tzvinfal
	.dw	^tzwalk3
	.dw	^tzwalk3
	.dw	^tzwalk3

	.dw	^tzrun2
	.dw	^tzrun2
	.dw	^tzrun2
	.dw	^tzland
	.dw	^tzland

	.dw	^tzducks
	.dw	^tzducks
	.dw	^tzducks
	.dw	^tzhitfal
	.dw	^tzwkrnxu

	.dw	^tzducks
	.dw	^tzswim
	.dw	^tzjumpup
	.dw	^tzstab1
	.dw	^tzstdjmp

	.dw	^tzrnwkxd
	.dw	^tzjpdnhd
	.dw	^tzshtstd
	.dw	^tzstdjmp
	.dw	^tzstdjmp

	.dw	^tzswim
	.dw	^tzwkaway
	.dw	^tzvineb1
	.dw	^tzvineb2
	.dw	^tzswim

	.dw	^tzvnland
	.dw	^tzvine1a
	.dw	^tzswim1
	.dw	^tzswim1
	.dw	^tzfloat
	
	.dw	^tzfloat
	.dw	^tzclimb
	.dw	^tzclimb
	.dw	^tzclimb
	.dw	^tzclimb

	.dw	^tzclimb
	.dw	^tzclimb
	.dw	^tzclimb
	.dw	^tzjmpstb
	.dw	^tzroar

	.dw	^tzfloat
	.dw	^tzregen
	.dw	^tzland
	.dw	^tzland
	.dw	^tzjmpfal

	.dw	^tzjmpfal
	.dw	^tzhitfal
	.dw	^tzidle4
	.dw	^tzidle4
	.dw	^tzidle4



*****************************************************************************

d_animode
	.dw	tzwait1mode00	;  00
	.dw	tzidle1mode00	;  02
	.dw	tzidle2mode00	;  04
	.dw	tzidle3mode00	;  06
	.dw	tzidle4mode00	;  08

	.dw	tzfalltrans	;  10
	.dw	tzvinfallmode00	;  12
	.dw	tzwalk3mode00	;  14
	.dw	tzwalk3mode01	;  16
	.dw	tzwalk3mode02	;  18

	.dw	tzrunmode00	;  20
	.dw	tzrunxumode00	;  22
	.dw	tzrunxdmode00	;  24
	.dw	tzlandmode00	;  26
	.dw	tzlandmode01	;  28

	.dw	tzducksmode00	;  30
	.dw	tzducksmode01	;  32
	.dw	tzducksmode02	;  34
	.dw	tzhitfalmode00	;  36
	.dw	tzwkrnxumode00	;  38

	.dw	tzducksmode03	;  40
	.dw	tzswimmode00	;  42
	.dw	tzjumpupmode00	;  44
	.dw	tzstab1mode00	;  46
	.dw	tzstdjmpmode00	;  48

	.dw	tzrnwkxdmode00	;  50
	.dw	tzfallonly	;  52
	.dw	tzshtstdmode00	;  54
	.dw	tzstdjmpmode01	;  56
	.dw	tzstdjmpmode02	;  58

	.dw	tzswimmode01	;  60
	.dw	tzwkawaymode00	;  62
	.dw	tzswingmodeb1	;  64
	.dw	tzswingmodeb2	;  66
	.dw	tzswimmode02	;  68

	.dw	tzvnlandmode00	;  70
	.dw	tzvineonly00	;  72
	.dw	tzswimhit	;  74
	.dw	tzswimrecov	;  76
	.dw	tzfloating	;  78

	.dw	tzfloaturn	;  80
	.dw	tzwalktoclimb	;  82
	.dw	tzclimbingup	;  84
	.dw	tzladrtoplat	;  86
	.dw	tzclimbtofloat	;  88

	.dw	tzljmptoladr	;  90
	.dw	tzclimbingdn	;  92
	.dw	tzclimbtowalk	;  94
	.dw	tzjmpnstb	;  96
	.dw	tzroarmode00	;  98

	.dw	tzfloat2swim	; 100
	.dw	tzregen	; 102
	.dw	tzfall2land	; 104
	.dw	tzfall2run	; 106
	.dw	tzjmpfal00	; 108

	.dw	tzjmpfal01	; 110
	.dw	tzhitfalmode01	; 112
	.dw	tzidle4mode01	; 114
	.dw	tzidle4mode02	; 116
	.dw	tzidle4mode03	; 118


d_aiproc
	.dw	TZWait	;  00
	.dw	TZIdle1	;  02
	.dw	TZIdle2	;  04
	.dw	TZIdle3	;  06
	.dw	TZIdle4	;  08

	.dw	TZFall1	;  10
	.dw	Notdone	;  12
	.dw	TZWalk	;  14
	.dw	TZWaittowalk	;  16
	.dw	TZWalktowait	;  18

	.dw	TZRun	;  20
	.dw	TZWaittorun	;  22
	.dw	TZRuntowait	;  24
	.dw	TZLand0	;  26
	.dw	TZLand0	;  28

	.dw	TZDuck00	;  30
	.dw	TZDuck01	;  32
	.dw	TZDart2	;  34
	.dw	TZBighit	;  36
	.dw	TZWalktorun	;  38

	.dw	TZDart3	;  40
	.dw	TZFloat	;  42
	.dw	TZJmpup	;  44
	.dw	TZStab1	;  46
	.dw	TZStdjmp	;  48

	.dw	TZRuntowalk	;  50
	.dw	TZFall	;  52
	.dw	TZDart1	;  54
	.dw	TZStdjmp	;  56
	.dw	TZStdjmp	;  58

	.dw	TZFloat	;  60
	.dw	TZWalkaway	;  62
	.dw	TZSwing1	;  64
	.dw	TZSwing2	;  66
	.dw	Notdone	;  68

	.dw	Notdone	;  70
	.dw	Notdone	;  72
	.dw	Notdone	;  74
	.dw	Notdone	;  76
	.dw	TZSwimtoFloat	;  78

	.dw	TZFloaturn	;  80
	.dw	TZWalknclimb	;  82
	.dw	TZClimbup	;  84
	.dw	TZOffladder	;  86
	.dw	Notdone	;  88

	.dw	TZJmptoladr	;  90
	.dw	TZClimbdn	;  92
	.dw	TZClimbtowalk	;  94
	.dw	TZJmpnstb	;  96
	.dw	Notdone	;  98

	.dw	TZFloat2swim	; 100
	.dw	TZLive	; 102
	.dw	TZFallvine	; 104
	.dw	TZFallvine	; 106
	.dw	TZFalltrans1	; 108

	.dw	Notdone	; 110
	.dw	TZBighitback	; 112
	.dw	TZIdle4a	; 114
	.dw	TZIdle4b	; 116
	.dw	TZIdle4c	; 118


*****************************************************************************

d_delconv:
	.dw	60,60,30,20,15,12,10,09,08,07	; 00 - 09
	.dw	06,05,05,05,04,04,04,04,03,03	; 10 - 19
	.dw	03,03,03,03,03,03,03,03,02,02	; 20 - 29
	.dw	02,02,02,02,02,02,02,02,02,02	; 30 - 39
	.dw	01,01,01,01,01,01,01,01,01,01	; 40 - 49



