
;tile type data

LAST     .equ  $FFFF



;for each tile type:
   ;
   ; word tilestat0 -- undefined
   ; word tilestat1 -- undefined
   ; word tilestat2 -- undefined
   ; word tilestat3 -- statusword
   ; word array(16): vertical offsets from left to right
   ;			of floor from top of tile 
   ;
   ; statusword: 20=water 10=passthru 8=death 4=climb 2=ceiling 1=wall

;status word equates

WALKSOLID	.equ	$0100
RIPPLETYPE	.equ	$0080
PITTYPE	.equ	$0040
WATERTYPE	.equ	$0020
PASSTHRUTYPE	.equ	$0010
DEATHTYPE	.equ	$0008
CLIMBTYPE	.equ	$0004
CEILINGTYPE	.equ	$0002
WALLTYPE	.equ	$0001

_tiledys

tilestart

skytile
 .dw   0,0,0,0        ;sky
 .dw   $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10

notskytile
 .dw   0,0,0,0        ;not sky (but acts quite the same)
 .dw   $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10

solidtile
 .dw   0,0,0,0        ;solid
 .dw   $ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff

slope45rtile
 .dw   0,0,0,0       ;slope 45 right
 .dw   $ffff,$0,$1,$2,$3,$4,$5,$6,$7,$8,$9,$a,$b,$c,$d,$e

slope45ltile
 .dw   0,0,0,0       ;slope 45 left
 .dw   $e,$d,$c,$b,$a,$9,$8,$7,$6,$5,$4,$3,$2,$1,$0,$ffff

slope22r1tile
 .dw   0,0,0,0        ;sl22r1
 .dw   $ffff,$ffff,0,0,1,1,2,2,3,3,4,4,5,5,6,6

slope22r2tile
 .dw   0,0,0,0        ;sl22r2
 .dw   7,7,8,8,9,9,10,10,11,11,12,12,13,13,14,14

slope22l1tile
 .dw   0,0,0,0        ;sl22l1
 .dw   6,6,5,5,4,4,3,3,2,2,1,1,0,0,$ffff,$ffff

slope22l2tile
 .dw   0,0,0,0        ;sl22l2
 .dw   14,14,13,13,12,12,11,11,10,10,9,9,8,8,7,7

floor2tile
 .dw   0,0,0,0        ;floor 2
 .dw   2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2

floor4tile
 .dw   0,0,0,0        ;floor 4
 .dw   4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4

floor6tile
 .dw   0,0,0,0        ;floor 6
 .dw   6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6

floor8tile
 .dw   0,0,0,0        ;floor 8
 .dw   8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8

floor10tile
 .dw   0,0,0,0        ;floor 10
 .dw   $a,$a,$a,$a,$a,$a,$a,$a,$a,$a,$a,$a,$a,$a,$a,$a

floor12tile
 .dw   0,0,0,0        ;floor 12
 .dw   $c,$c,$c,$c,$c,$c,$c,$c,$c,$c,$c,$c,$c,$c,$c,$c

floor14tile
 .dw   0,0,0,0        ;floor 14
 .dw   $e,$e,$e,$e,$e,$e,$e,$e,$e,$e,$e,$e,$e,$e,$e,$e

walltile
 .dw   0,0,0,1        ;solid wall
 .dw   $ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff

solidwalltile
 .dw   0,0,0,WALKSOLID
 .dw   $ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff

solidwalltile4
 .dw   0,0,0,WALKSOLID
 .dw   4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4

solidwalltile8
 .dw   0,0,0,WALKSOLID
 .dw   8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8

ceiltile
 .dw   0,0,0,2        ;solid ceiling
 .dw   $ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff

ceilwalltile
 .dw   0,0,0,3        ;solid block
 .dw   $ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff

climbtile
 .dw   0,0,0,4        ;climb
 .dw   $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10

solidclimbtile
 .dw   0,0,0,4        ;solid with climb
 .dw   $c,$c,$c,$c,$c,$c,$c,$c,$c,$c,$c,$c,$c,$c,$c,$c

skyceiltile
 .dw   0,0,0,2        ;sky ceiling
 .dw   $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10

skywalltile
 .dw   0,0,0,1        ;sky wall
 .dw   $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10

skyceilwalltile
 .dw   0,0,0,3        ;sky ceil wall
 .dw   $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10

skydeathtile
 .dw   0,0,0,8        ;sky death
 .dw   $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10

solidpasstile
 .dw   0,0,0,$10        ;solid pass
 .dw   $ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff,$ffff

floor2passtile
 .dw   0,0,0,$10        ;floor 2 pass
 .dw   2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2

floor4passtile
 .dw   0,0,0,$10        ;floor 4 pass
 .dw   4,4,4,4,4,4,4,4,4,4,4,4,4,4,4,4

floor6passtile
 .dw   0,0,0,$10        ;floor 6 pass
 .dw   6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6

floor8passtile
 .dw   0,0,0,$10        ;floor 8 pass
 .dw   8,8,8,8,8,8,8,8,8,8,8,8,8,8,8,8

floor10passtile
 .dw   0,0,0,$10        ;floor 10 pass
 .dw   $a,$a,$a,$a,$a,$a,$a,$a,$a,$a,$a,$a,$a,$a,$a,$a

floor12passtile
 .dw   0,0,0,$10        ;floor 12 pass
 .dw   $c,$c,$c,$c,$c,$c,$c,$c,$c,$c,$c,$c,$c,$c,$c,$c

floor14passtile
 .dw   0,0,0,$10        ;floor 14 pass
 .dw   $e,$e,$e,$e,$e,$e,$e,$e,$e,$e,$e,$e,$e,$e,$e,$e

slope45rpasstile
 .dw   0,0,0,$10       ;slope 45 right pass
 .dw   $ffff,$0,$1,$2,$3,$4,$5,$6,$7,$8,$9,$a,$b,$c,$d,$e

slope45lpasstile
 .dw   0,0,0,$10       ;slope 45 left pass
 .dw   $e,$d,$c,$b,$a,$9,$8,$7,$6,$5,$4,$3,$2,$1,$0,$ffff

slope22r1passtile
 .dw   0,0,0,$10        ;sl22r1 pass
 .dw   $ffff,$ffff,0,0,1,1,2,2,3,3,4,4,5,5,6,6

slope22r2passtile
 .dw   0,0,0,$10        ;sl22r2 pass
 .dw   7,7,8,8,9,9,10,10,11,11,12,12,13,13,14,14

slope22l1passtile
 .dw   0,0,0,$10        ;sl22l1 pass
 .dw   6,6,5,5,4,4,3,3,2,2,1,1,0,0,$ffff,$ffff

slope22l2passtile
 .dw   0,0,0,$10        ;sl22l2 pass
 .dw   14,14,13,13,12,12,11,11,10,10,9,9,8,8,7,7

watertile
 .dw   0,0,0,$20        ;water
 .dw   $10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10,$10

solidclimbtile8
 .dw   0,0,0,4        ;solid with climb
 .dw   $8,$8,$8,$8,$8,$8,$8,$8,$8,$8,$8,$8,$8,$8,$8,$8

pittypetile
 .dw   0,0,0,$40        ;floor 2
 .dw   2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2

rippletypetile
 .dw   0,0,0,$80
 .dw   $fff8,$fff8,$fff8,$fff8,$fff8,$fff8,$fff8,$fff8,$fff8,$fff8,$fff8,$fff8,$fff8,$fff8,$fff8,$fff8

quiksandtile
 .dw   0,0,0,0        ;pass
 .dw   2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2

walkonwalltile2
 .dw   0,0,0,1
 .dw   2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2

walkonwalltile6
 .dw   0,0,0,1
 .dw   6,6,6,6,6,6,6,6,6,6,6,6,6,6,6,6



SKY	.equ	(skytile-tilestart)
NOTSKY	.equ	(notskytile-tilestart)
SOLID	.equ	(solidtile-tilestart)
SLOPE45R	.equ	(slope45rtile-tilestart)
SLOPE45L	.equ	(slope45ltile-tilestart)
SLOPE22RT	.equ	(slope22r1tile-tilestart)
SLOPE22RB	.equ	(slope22r2tile-tilestart)
SLOPE22LT	.equ	(slope22l1tile-tilestart)
SLOPE22LB	.equ	(slope22l2tile-tilestart)
FLOOR2	.equ	(floor2tile-tilestart)
FLOOR4	.equ	(floor4tile-tilestart)
FLOOR6	.equ	(floor6tile-tilestart)
FLOOR8	.equ	(floor8tile-tilestart)
FLOOR10	.equ	(floor10tile-tilestart)
FLOOR12	.equ	(floor12tile-tilestart)
FLOOR14	.equ	(floor14tile-tilestart)
SOLIDWALL	.equ	(solidwalltile-tilestart)
SOLIDWALL4	.equ	(solidwalltile4-tilestart)
SOLIDWALL8	.equ	(solidwalltile8-tilestart)
SOLIDCEIL	.equ	(ceiltile-tilestart)
SOLIDBOTH	.equ	(ceilwalltile-tilestart)
CLIMB	.equ	(climbtile-tilestart)
CLIMBSOLID	.equ	(solidclimbtile-tilestart)
CLIMBSOLID8	.equ	(solidclimbtile8-tilestart)
CEIL	.equ	(skyceiltile-tilestart)
WALL	.equ	(skywalltile-tilestart)
CEILWALL	.equ	(skyceilwalltile-tilestart)
WALKWALL2	.equ	(walkonwalltile2-tilestart)
WALKWALL6	.equ	(walkonwalltile6-tilestart)
DEATH	.equ	(skydeathtile-tilestart)
SOLIDPASS	.equ	(solidpasstile-tilestart)
FLOOR2PASS	.equ	(floor2passtile-tilestart)
FLOOR4PASS	.equ	(floor4passtile-tilestart)
FLOOR6PASS	.equ	(floor6passtile-tilestart)
FLOOR8PASS	.equ	(floor8passtile-tilestart)
FLOOR10PASS	.equ	(floor10passtile-tilestart)
FLOOR12PASS	.equ	(floor12passtile-tilestart)
FLOOR14PASS	.equ	(floor14passtile-tilestart)
SLOPE45RPASS	.equ	(slope45rpasstile-tilestart)
SLOPE45LPASS	.equ	(slope45lpasstile-tilestart)
SLOPE22RTPASS	.equ	(slope22r1passtile-tilestart)
SLOPE22RBPASS	.equ	(slope22r2passtile-tilestart)
SLOPE22LTPASS	.equ	(slope22l1passtile-tilestart)
SLOPE22LBPASS	.equ	(slope22l2passtile-tilestart)
WATER	.equ	(watertile-tilestart)
PIT	.equ	(pittypetile-tilestart)
RIPPLE	.equ	(rippletypetile-tilestart)
QUIKSAND	.equ	(quiksandtile-tilestart)


	; Normal, X flip, Y flip, X-Y flip
tzanhometile:
	.dw	SKY,SKY,SKY,SKY	;$00 0
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$04 4
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$08 8
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$0c 12
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR10PASS,FLOOR10PASS,FLOOR10PASS,FLOOR10PASS	;$10 16
	.dw	SOLIDPASS,SOLIDPASS,SKY,SKY
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS	;$14 20
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	SOLIDPASS,SOLIDPASS,FLOOR4PASS,FLOOR4PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$18 24
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR6PASS,FLOOR6PASS,FLOOR6PASS,FLOOR6PASS	;$1c 28
	.dw	FLOOR2PASS,FLOOR2PASS,SOLIDPASS,SOLIDPASS
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$20 32
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR4PASS,FLOOR4PASS,FLOOR4PASS,FLOOR4PASS	;$24 36
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	
	.dw	SKY,SKY,SKY,SKY	;$28 40
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$2c 44
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$30 48
	.dw	SKY,SKY,SKY,SKY 
	.dw	SLOPE45RPASS,SLOPE45LPASS,FLOOR8PASS,FLOOR8PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$34 52
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SKY,SKY,SKY,SKY	;$38 56
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$3c 60
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8PASS,FLOOR8PASS,SKY,SKY	;$40 64
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS	;$44 68
	.dw	SLOPE22RBPASS,SLOPE22LBPASS,FLOOR8PASS,FLOOR8PASS 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$48 72
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$4c 76
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$50 80
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$54 84
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$58 88
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$5c 92
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR4PASS,FLOOR4PASS,FLOOR4PASS,FLOOR4PASS	;$60 96
	.dw	FLOOR6PASS,FLOOR6PASS,FLOOR6PASS,FLOOR6PASS
	.dw	SLOPE22RBPASS,SLOPE22LBPASS,FLOOR14PASS,FLOOR14PASS
	.dw	FLOOR14PASS,FLOOR14PASS,FLOOR14PASS,FLOOR14PASS 
	.dw	FLOOR14PASS,FLOOR14PASS,FLOOR14PASS,FLOOR14PASS	;$64 100
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$68 104
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$6c 108
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$70 112
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS	;$74 116
	.dw	SLOPE45RPASS,SLOPE45LPASS,FLOOR8PASS,FLOOR8PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SLOPE45L,SLOPE45R,SKY,SKY	;$78 120
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$7c 124
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$80 128
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SLOPE22RBPASS,SLOPE22LBPASS,SKY,SKY	;$84 132
	.dw	SLOPE45LPASS,SLOPE45RPASS,SKY,SKY
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	SOLIDPASS,SOLIDPASS,SKY,SKY
	.dw	SOLIDPASS,SOLIDPASS,SKY,SKY	;$88 136
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$8c 140
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLIDPASS,SOLIDPASS,SKY,SKY	;$90 144
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SLOPE22LBPASS,SLOPE22RBPASS,SKY,SKY	;$94 148
	.dw	SOLIDPASS,SOLIDPASS,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$98 152
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$9c 156
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS	;$a0 160
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a4 164
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a8 168
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ac 172
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR4PASS,FLOOR4PASS,FLOOR4PASS,FLOOR4PASS	;$b0 176
	.dw	SLOPE22RBPASS,SLOPE22LBPASS,FLOOR10PASS,FLOOR10PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$b4 180
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4	;$b8 184
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$bc 188
	.dw	SOLID,SOLID,SOLID,SOLID 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c0 192
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR14PASS,FLOOR14PASS,FLOOR14PASS,FLOOR14PASS
	.dw	FLOOR14PASS,FLOOR14PASS,FLOOR14PASS,FLOOR14PASS	;$c4 196
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$c8 200
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SKY,SKY,SKY,SKY	;$cc 204
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d0 208
	.dw	SKY,SKY,SKY,SKY 
	.dw	FLOOR12PASS,FLOOR12PASS,FLOOR12PASS,FLOOR12PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS	;$d4 212
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d8 216
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$dc 220
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e0 224
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e4 228
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e8 232
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ec 236
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$f0 240
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f4 244
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f8 248
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$fc 254
	.dw	SKY,SKY,SKY,SKY

   .dw   LAST

jungle1tile:
	.dw	SKY,SKY,SKY,SKY	;$00 0
	.dw	FLOOR2,FLOOR2,FLOOR2,FLOOR2
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS	;$04 4
	.dw	SLOPE45RPASS,SLOPE45LPASS,FLOOR8PASS,FLOOR8PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$08 8
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$0c 12
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$10 16
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	WALL,WALL,WALL,WALL
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$14 20
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$18 24
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SLOPE22LTPASS,SLOPE22LTPASS,FLOOR4PASS,FLOOR4PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$1c 28
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$20 32
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$24 36
	.dw	FLOOR10PASS,FLOOR10PASS,FLOOR10PASS,FLOOR10PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$28 40
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$2c 44
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$30 48
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SLOPE45LPASS,SLOPE45RPASS,SKY,SKY
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS	;$34 52
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	PIT,PIT,PIT,PIT	;$38 56
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS	;$3c 60
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$40 64
	.dw	SKY,SKY,SKY,SKY
	.dw	SLOPE45LPASS,SLOPE45RPASS,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$44 68
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$48 72
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$4c 76
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$50 80
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$54 84
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$58 88
	.dw	SKY,SKY,SKY,SKY 
	.dw	FLOOR2,FLOOR2,FLOOR2,FLOOR2
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$5c 92
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS	;$60 96
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$64 100
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$68 104
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS	;$6c 108
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS	;$70 112
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$74 116
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$78 120
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	SKY,SKY,SKY,SKY	;$7c 124
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8	;$80 128
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8 
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS	;$84 132
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$88 136
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$8c 140
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$90 144
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$94 148
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$98 152
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$9c 156
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$a0 160
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a4 164
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a8 168
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ac 172
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$b0 176
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$b4 180
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$b8 184
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$bc 188
	.dw	FLOOR2,FLOOR2,FLOOR2,FLOOR2
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c0 192
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c4 196
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID 
	.dw	SKY,SKY,SKY,SKY	;$c8 200
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$cc 204
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d0 208
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d4 212
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d8 216
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$dc 220
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e0 224
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e4 228
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e8 232
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ec 236
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$f0 240
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f4 244
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f8 248
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$fc 254
	.dw	SKY,SKY,SKY,SKY

   .dw   LAST

jungle4tile:
	.dw	SKY,SKY,SKY,SKY	;$00 0
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS	;$04 4
	.dw	SLOPE45RPASS,SLOPE45LPASS,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$08 8
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$0c 12
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$10 16
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	WALL,WALL,WALL,WALL
	.dw	SLOPE22LBPASS,SLOPE22RBPASS,FLOOR10,FLOOR10 
	.dw	WALL,WALL,WALL,WALL	;$14 20
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$18 24
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SLOPE22LTPASS,SLOPE22RTPASS,FLOOR8,FLOOR8
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$1c 28
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$20 32
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SLOPE22LBPASS,SLOPE22RTPASS,FLOOR12,FLOOR12	;$24 36
	.dw	SLOPE22RBPASS,SLOPE22LBPASS,FLOOR12,FLOOR12
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$28 40
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$2c 44
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$30 48
	.dw	SKY,SKY,SKY,SKY 
	.dw	FLOOR12PASS,FLOOR12PASS,FLOOR12,FLOOR12
	.dw	SLOPE22LTPASS,SLOPE22RTPASS,FLOOR12,FLOOR12
	.dw	SOLIDPASS,SOLIDPASS,SKY,SKY	;$34 52
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$38 56
	.dw	SLOPE22RTPASS,SLOPE22LTPASS,SKY,SKY
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS 
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS	;$3c 60
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SLOPE22RBPASS,SLOPE22LBPASS,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$40 64
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$44 68
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$48 72
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$4c 76
	.dw	SKY,SKY,SKY,SKY
	.dw	SLOPE45LPASS,SLOPE45RPASS,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$50 80
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$54 84
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$58 88
	.dw	SKY,SKY,SKY,SKY 
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$5c 92
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$60 96
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$64 100
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$68 104
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8PASS,FLOOR8PASS,SKY,SKY	;$6c 108
	.dw	SLOPE22LTPASS,SLOPE22RTPASS,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$70 112
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$74 116
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$78 120
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SLOPE22LTPASS,SLOPE22RTPASS,FLOOR8,FLOOR8
	.dw	SKY,SKY,SKY,SKY	;$7c 124
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$80 128
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS	;$84 132
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$88 136
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$8c 140
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$90 144
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$94 148
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$98 152
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$9c 156
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$a0 160
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a4 164
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a8 168
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ac 172
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$b0 176
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$b4 180
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$b8 184
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$bc 188
	.dw	SOLID,SOLID,SOLID,SOLID 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c0 192
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c4 196
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$c8 200
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS	;$cc 204
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d0 208
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d4 212
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR10PASS,FLOOR10PASS,FLOOR10PASS,FLOOR10PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d8 216
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$dc 220
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR12PASS,FLOOR12PASS,FLOOR12PASS,FLOOR12PASS	;$e0 224
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS	;$e4 228
	.dw	FLOOR6PASS,FLOOR6PASS,FLOOR6PASS,FLOOR6PASS 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e8 232
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ec 236
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$f0 240
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f4 244
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f8 248
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$fc 254
	.dw	SKY,SKY,SKY,SKY

   .dw   LAST

beachtile:
	.dw	SKY,SKY,SKY,SKY	;$00 0
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	WALL,WALL,WALL,WALL	;$04 4
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$08 8
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$0c 12
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$10 16
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$14 20
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$18 24
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$1c 28
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$20 32
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$24 36
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLIDWALL8,SOLIDWALL8,SOLIDWALL8,SOLIDWALL8
	.dw	FLOOR2,FLOOR2,FLOOR2,FLOOR2 
	.dw	SLOPE45R,SLOPE45R,SLOPE45R,SLOPE45R	;$28 40
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$2c 44
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	FLOOR10,FLOOR10,FLOOR10,FLOOR10
	.dw	FLOOR10,FLOOR10,FLOOR10,FLOOR10
	.dw	SKY,SKY,SKY,SKY	;$30 48
	.dw	SKY,SKY,SKY,SKY 
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$34 52
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL
	.dw	WALL,WALL,WALL,WALL
	.dw	SKY,SKY,SKY,SKY	;$38 56
	.dw	WALL,WALL,WALL,WALL
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID 
	.dw	SOLID,SOLID,SOLID,SOLID	;$3c 60
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$40 64
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID 
	.dw	SOLID,SOLID,SOLID,SOLID	;$44 68
	.dw	SKY,SKY,SKY,SKY 
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL	;$48 72
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8	;$4c 76
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12 
	.dw	SKY,SKY,SKY,SKY	;$50 80
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY	;$54 84
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL
	.dw	SOLID,SOLID,SOLID,SOLID	;$58 88
	.dw	SOLID,SOLID,SOLID,SOLID 
	.dw	WALL,WALL,WALL,WALL
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$5c 92
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$60 96
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$64 100
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$68 104
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$6c 108
	.dw	SOLID,SOLID,SOLID,SOLID 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$70 112
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$74 116
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$78 120
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$7c 124
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$80 128
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$84 132
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$88 136
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$8c 140
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12
	.dw	SKY,SKY,SKY,SKY	;$90 144
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID	;$94 148
	.dw	SOLID,SOLID,SOLID,SOLID 
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$98 152
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALKWALL6,WALKWALL6,WALKWALL6,WALKWALL6	;$9c 156
	.dw	FLOOR6,FLOOR6,FLOOR6,FLOOR6
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$a0 160
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$a4 164
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$a8 168
	.dw	SOLID,SOLID,SOLID,SOLID 
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	WALL,WALL,WALL,WALL	;$ac 172
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$b0 176
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY 
	.dw	SOLID,SOLID,SOLID,SOLID	;$b4 180
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$b8 184
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$bc 188
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY	;$c0 192
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c4 196
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$c8 200
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$cc 204
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d0 208
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d4 212
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d8 216
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$dc 220
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	SKY,SKY,SKY,SKY	;$e0 224
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	SKY,SKY,SKY,SKY	;$e4 228
	.dw	SKY,SKY,SKY,SKY 
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e8 232
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ec 236
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$f0 240
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f4 244
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$f8 248
	.dw	SOLID,SOLID,SOLID,SOLID 
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$fc 254
	.dw	SKY,SKY,SKY,SKY
				          
   .dw   LAST

waterfaltile:
	.dw	SKY,SKY,SKY,SKY	;$00 0
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS	;$04 4
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12	;$08 8
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12 
	.dw	FLOOR10,FLOOR10,FLOOR10,FLOOR10
	.dw	SLOPE45LPASS,SLOPE45LPASS,SLOPE45LPASS,SLOPE45LPASS
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS	;$0c 12
	.dw	FLOOR4PASS,FLOOR4PASS,FLOOR4PASS,FLOOR4PASS
	.dw	FLOOR4PASS,FLOOR4PASS,FLOOR4PASS,FLOOR4PASS
	.dw	SKY,SKY,SKY,SKY	
	.dw	SKY,SKY,SKY,SKY	;$10 16
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR4PASS,FLOOR4PASS,FLOOR4PASS,FLOOR4PASS
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS	;$14 20
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$18 24
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$1c 28
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$20 32
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$24 36
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$28 40
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$2c 44
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$30 48
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$34 52
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$38 56
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$3c 60
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$40 64
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$44 68
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$48 72
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$4c 76
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$50 80
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$54 84
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$58 88
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$5c 92
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$60 96
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$64 100
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$68 104
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$6c 108
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$70 112
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$74 116
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$78 120
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$7c 124
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$80 128
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$84 132
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$88 136
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12 
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8	;$8c 140
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$90 144
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$94 148
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$98 152
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$9c 156
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$a0 160
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a4 164
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a8 168
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ac 172
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8	;$b0 176
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8	;$b4
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	SKY,SKY,SKY,SKY	;$b8 184
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$bc 188
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c0 192
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c4 196
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$c8 200
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR6,FLOOR6,FLOOR6,FLOOR6	;$cc 204
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR6,FLOOR6,FLOOR6,FLOOR6
	.dw	SKY,SKY,SKY,SKY	;$d0 208
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d4 212
	.dw	FLOOR14,FLOOR14,FLOOR14,FLOOR14
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SKY,SKY,SKY,SKY	;$d8 216
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$dc 220
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e0 224
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e4 228
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e8 232
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS	;$ec 236
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$f0 240
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SKY,SKY,SKY,SKY	;$f4 244
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR6,FLOOR6,FLOOR6,FLOOR6
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8	;$f8 248
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$fc 254
	.dw	SKY,SKY,SKY,SKY
				          
   .dw   LAST

shiptile:
	.dw	SKY,SKY,SKY,SKY	;$00 0
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$04 4
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$08 8
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$0c 12
	.dw	FLOOR10,FLOOR10,FLOOR10,FLOOR10
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	SKY,SKY,SKY,SKY	;$10 16
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	CLIMB,CLIMB,CLIMB,CLIMB 
	.dw	SKY,SKY,SKY,SKY	;$14 20
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$18 24
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4	;$1c 28
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$20 32
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	CLIMB,CLIMB,CLIMB,CLIMB 
	.dw	SKY,SKY,SKY,SKY	;$24 36
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$28 40
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$2c 44
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL	;$30 48
	.dw	SKY,SKY,SKY,SKY 
	.dw	WALL,WALL,WALL,WALL
	.dw	CLIMB,CLIMB,CLIMB,CLIMB 
	.dw	FLOOR14,FLOOR14,FLOOR14,FLOOR14	;$34 52
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$38 56
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$3c 60
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL	;$40 64
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	WALL,WALL,WALL,WALL
	.dw	CLIMB,CLIMB,CLIMB,CLIMB 
	.dw	SKY,SKY,SKY,SKY	;$44 68
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$48 72
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$4c 76
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$50 80
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	CLIMB,CLIMB,CLIMB,CLIMB 
	.dw	SKY,SKY,SKY,SKY	;$54 84
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$58 88
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR14,FLOOR14,FLOOR14,FLOOR14	;$5c 92
	.dw	FLOOR14,FLOOR14,FLOOR14,FLOOR14
	.dw	FLOOR14,FLOOR14,FLOOR14,FLOOR14
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$60 96
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	CLIMB,CLIMB,CLIMB,CLIMB 
	.dw	SKY,SKY,SKY,SKY	;$64 100
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$68 104
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLIDWALL,SOLIDWALL,SOLIDWALL,SOLIDWALL
	.dw	SOLIDWALL,SOLIDWALL,SOLIDWALL,SOLIDWALL	;$6c 108
	.dw	SOLIDWALL,SOLIDWALL,SOLIDWALL,SOLIDWALL
	.dw	SOLIDWALL,SOLIDWALL,SOLIDWALL,SOLIDWALL
	.dw	SOLIDWALL,SOLIDWALL,SOLIDWALL,SOLIDWALL
	.dw	SKY,SKY,SKY,SKY	;$70 112
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	CLIMB,CLIMB,CLIMB,CLIMB 
	.dw	SKY,SKY,SKY,SKY	;$74 116
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$78 120
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL
	.dw	WALL,WALL,WALL,WALL	;$7c 124
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	WALL,WALL,WALL,WALL
	.dw	SKY,SKY,SKY,SKY	;$80 128
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	CLIMB,CLIMB,CLIMB,CLIMB 
	.dw	SKY,SKY,SKY,SKY	;$84 132
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$88 136
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	WALL,WALL,WALL,WALL	;$8c 140
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL
	.dw	WALL,WALL,WALL,WALL
	.dw	SKY,SKY,SKY,SKY	;$90 144
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	CLIMBSOLID,CLIMBSOLID,CLIMBSOLID,CLIMBSOLID
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12	;$94 148
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$98 152
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL
	.dw	WALL,WALL,WALL,WALL	;$9c 156
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8 
	.dw	SKY,SKY,SKY,SKY	;$a0 160
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12
	.dw	WALL,WALL,WALL,WALL	;$a4 164
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a8 168
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL	;$ac 172
	.dw	WALL,WALL,WALL,WALL
	.dw	WALL,WALL,WALL,WALL
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY	;$b0 176
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SOLID,SOLID,SOLID,SOLID	;$b4 180
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL
	.dw	WALL,WALL,WALL,WALL	;$b8 184
	.dw	WALL,WALL,WALL,WALL
	.dw	WALL,WALL,WALL,WALL
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$bc 188
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c0 192
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8	;$c4 196
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$c8 200
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$cc 204
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d0 208
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d4 212
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d8 216
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$dc 220
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e0 224
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e4 228
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e8 232
	.dw	WALL,WALL,WALL,WALL
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ec 236
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$f0 240
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f4 244
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f8 248
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$fc 254
	.dw	SKY,SKY,SKY,SKY
				          
   .dw   LAST

dnrivrtile:
	.dw	WATER,WATER,WATER,WATER	;$00 0
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$04 4
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$08 8
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$0c 12
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$10 16
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER	;$14 20
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$18 24
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$1c 28
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$20 32
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$24 36
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER	;$28 40
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$2c 44
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$30 48
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$34 52
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$38 56
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER	;$3c 60
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$40 64
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$44 68
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$48 72
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$4c 76
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER	;$50 80
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$54 84
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$58 88
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$5c 92
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$60 96
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER	;$64 100
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$68 104
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$6c 108
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$70 112
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$74 116
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER	;$78 120
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$7c 124
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$80 128
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$84 132
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$88 136
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER	;$8c 140
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$90 144
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$94 148
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$98 152
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$9c 156
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER	;$a0 160
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$a4 164
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$a8 168
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$ac 172
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$b0 176
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER	;$b4 180
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$b8 184
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$bc 188
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$c0 192
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$c4 196
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER	;$c8 200
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$cc 204
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$d0 208
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$d4 212
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$d8 216
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER	;$dc 220
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$e0 224
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$e4 228
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$e8 232
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$ec 236
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER	;$f0 240
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$f4 244
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$f8 248
	.dw	WATER,WATER,WATER,WATER 
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER
	.dw	WATER,WATER,WATER,WATER	;$fc 254
	.dw	WATER,WATER,WATER,WATER

   .dw   LAST

oparstretile:
	.dw	SKY,SKY,SKY,SKY	;$00 0
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$04 4
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$08 8
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$0c 12
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$10 16
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$14 20
	.dw	FLOOR12PASS,FLOOR12PASS,FLOOR12PASS,FLOOR12PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$18 24
	.dw	FLOOR12PASS,FLOOR12PASS,FLOOR12PASS,FLOOR12PASS
	.dw	FLOOR12PASS,FLOOR12PASS,FLOOR12PASS,FLOOR12PASS
	.dw	FLOOR12PASS,FLOOR12PASS,FLOOR12PASS,FLOOR12PASS
	.dw	FLOOR12PASS,FLOOR12PASS,FLOOR12PASS,FLOOR12PASS	;$1c 28
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$20 32
	.dw	WALL,WALL,WALL,WALL
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR12PASS,FLOOR12PASS,FLOOR12PASS,FLOOR12PASS
	.dw	FLOOR12PASS,FLOOR12PASS,FLOOR12PASS,FLOOR12PASS	;$24 36
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$28 40
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$2c 44
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY	;$30 48
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$34 52
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$38 56
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$3c 60
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$40 64
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$44 68
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$48 72
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$4c 76
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$50 80
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$54 84
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$58 88
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$5c 92
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY	;$60 96
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$64 100
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$68 104
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SLOPE45LPASS,SLOPE45LPASS,SLOPE45LPASS,SLOPE45LPASS	;$6c 108
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$70 112
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	SOLIDWALL4,SOLIDWALL4,SOLIDWALL4,SOLIDWALL4	;$74 116
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$78 120
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$7c 124
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$80 128
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$84 132
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$88 136
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$8c 140
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY	;$90 144
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS	;$94 148
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$98 152
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$9c 156
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$a0 160
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL	;$a4 164
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a8 168
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ac 172
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$b0 176
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL	;$b4 180
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$b8 184
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY	;$bc 188
	.dw	SOLID,SOLID,SOLID,SOLID 
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY	;$c0 192
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c4 196
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c8 200
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$cc 204
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$d0 208
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$d4 212
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d8 216
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$dc 220
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e0 224
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e4 228
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e8 232
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL
	.dw	SKY,SKY,SKY,SKY	;$ec 236
	.dw	WALL,WALL,WALL,WALL
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$f0 240
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f4 244
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f8 248
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$fc 252
	.dw	SKY,SKY,SKY,SKY

   .dw   LAST

oparwellstile:
	.dw	SKY,SKY,SKY,SKY	;$00 0
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$04 4
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$08 8
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$0c 12
	.dw	WALL,WALL,WALL,WALL
	.dw	SOLIDWALL8,SOLIDWALL8,SOLIDWALL8,SOLIDWALL8
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$10 16
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$14 20
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8	;$18 24
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	CLIMBSOLID8,CLIMBSOLID8,CLIMBSOLID8,CLIMBSOLID8
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8	;$1c 28
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8 
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$20 32
	.dw	SKY,SKY,SKY,SKY
	.dw	CLIMB,SKY,CLIMB,CLIMB 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$24 36
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	WALL,WALL,WALL,WALL	;$28 40
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL	;$2c 44
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	SKY,SKY,SKY,SKY	;$30 48
	.dw	SKY,SKY,SKY,SKY 
	.dw	CLIMB,CLIMB,CLIMB,CLIMB 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$34 52
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL	;$38 56
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL	;$3c 60
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	SKY,SKY,SKY,SKY	;$40 64
	.dw	SKY,SKY,SKY,SKY
	.dw	CLIMB,CLIMB,CLIMB,CLIMB 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$44 68
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL	;$48 72
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL	;$4c 76
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	SKY,SKY,SKY,SKY	;$50 80
	.dw	SKY,SKY,SKY,SKY
	.dw	CLIMB,CLIMB,CLIMB,CLIMB 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$54 84
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL	;$58 88
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL	;$5c 92
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	SKY,SKY,SKY,SKY	;$60 96
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$64 100
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL	;$68 104
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL	;$6c 108
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	SKY,SKY,SKY,SKY	;$70 112
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$74 116
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	WALL,WALL,WALL,WALL	;$78 120
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL	;$7c 124
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	SKY,SKY,SKY,SKY	;$80 128
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$84 132
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL	;$88 136
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL	;$8c 140
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	SKY,SKY,SKY,SKY	;$90 144
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$94 148
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL	;$98 152
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL	;$9c 156
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	SKY,SKY,SKY,SKY	;$a0 160
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a4 164
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL	;$a8 168
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL	;$ac 172
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	CEILWALL,CEILWALL,CEILWALL,CEILWALL
	.dw	SKY,SKY,SKY,SKY	;$b0 176
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$b4 180
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$b8 184
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$bc 188
	.dw	SOLID,SOLID,SOLID,SOLID 
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY	;$c0 192
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c4 196
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$c8 200
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$cc 204
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d0 208
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d4 212
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d8 216
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$dc 220
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e0 224
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e4 228
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e8 232
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ec 236
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$f0 240
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f4 244
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f8 248
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$fc 254
	.dw	SKY,SKY,SKY,SKY
				          
   .dw   LAST

shiphold1tile:
	.dw	SKY,SKY,SKY,SKY	;$00 0
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$04 4
	.dw	CLIMB,CLIMB,CLIMB,CLIMB
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$08 8
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$0c 12
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$10 16
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	CLIMB,CLIMB,CLIMB,CLIMB
	.dw	CLIMB,CLIMB,CLIMB,CLIMB	;$14 20
	.dw	CLIMB,CLIMB,CLIMB,CLIMB
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$18 24
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$1c 28
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$20 32
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$24 36
	.dw	CLIMB,CLIMB,CLIMB,CLIMB
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$28 40
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$2c 44
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4	;$30 48
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$34 52
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$38 56
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR4PASS,FLOOR4PASS,FLOOR4PASS,FLOOR4PASS
	.dw	FLOOR4PASS,FLOOR4PASS,FLOOR4PASS,FLOOR4PASS	;$3c 60
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$40 64
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$44 68
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$48 72
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$4c 76
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$50 80
	.dw	CLIMB,CLIMB,CLIMB,CLIMB
	.dw	CLIMB,CLIMB,CLIMB,CLIMB
	.dw	CLIMB,CLIMB,CLIMB,CLIMB
	.dw	CLIMB,CLIMB,CLIMB,CLIMB	;$54 84
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$58 88
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$5c 92
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$60 96
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$64 100
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$68 104
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$6c 108
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$70 112
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$74 116
	.dw	FLOOR14PASS,FLOOR14PASS,FLOOR14PASS,FLOOR14PASS
	.dw	FLOOR14PASS,FLOOR14PASS,FLOOR14PASS,FLOOR14PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$78 120
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$7c 124
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$80 128
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$84 132
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$88 136
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$8c 140
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4	;$90 144
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4	;$94 148
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$98 152
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$9c 156
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a0 160
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a4 164
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a8 168
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4	;$ac 172
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4	;$b0 176
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4	;$b4 180
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4	;$b8 184
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4	;$bc 188
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	SKY,SKY,SKY,SKY	;$c0 192
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c4 196
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c8 200
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$cc 204
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d0 208
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d4 212
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d8 216
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$dc 220
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e0 224
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e4 228
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e8 232
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ec 236
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f0 240
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f4 244
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f8 248
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$fc 254
	.dw	SKY,SKY,SKY,SKY


   .dw   LAST

templetile:
	.dw	SKY,SKY,SKY,SKY	;$00 0
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$04 4
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$08 8
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$0c 12
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$10 16
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$14 20
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12	;$18 24
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$1c 28
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$20 32
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$24 36
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$28 40
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$2c 44
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$30 48
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$34 52
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12	;$38 56
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4	;$3c 60
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$40 64
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12
	.dw	FLOOR12,FLOOR12,FLOOR12,FLOOR12
	.dw	SKY,SKY,SKY,SKY	;$44 68
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$48 72
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$4c 76
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$50 80
	.dw	WALL,WALL,WALL,WALL
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$54 84
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$58 88
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4	;$5c 92
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$60 96
	.dw	WALL,WALL,WALL,WALL
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$64 100
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$68 104
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$6c 108
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$70 112
	.dw	WALL,WALL,WALL,WALL
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$74 116
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$78 120
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$7c 124
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$80 128
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$84 132
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$88 136
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY	;$8c 140
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$90 144
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$94 148
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$98 152
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLIDWALL,SOLIDWALL,SOLIDWALL,SOLIDWALL	;$9c 156
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a0 160
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID	;$a4 164
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$a8 168
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLIDWALL,SOLIDWALL,SOLIDWALL,SOLIDWALL
	.dw	SOLIDWALL,SOLIDWALL,SOLIDWALL,SOLIDWALL
	.dw	WALL,WALL,WALL,WALL	;$ac 172
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$b0 176
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$b4 180
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$b8 184
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$bc 188
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c0 192
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c4 196
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c8 200
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$cc 204
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d0 208
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d4 212
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d8 216
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$dc 220
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e0 224
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e4 228
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e8 232
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ec 236
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f0 240
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f4 244
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f8 248
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$fc 254
	.dw	SKY,SKY,SKY,SKY



   .dw   LAST

apeclrtile:
	.dw	SKY,SKY,SKY,SKY	;$00 0
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS	;$04 4
	.dw	SLOPE45RPASS,SLOPE45LPASS,FLOOR8,FLOOR8
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$08 8
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$0c 12
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$10 16
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID	;$14 20
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$18 24
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SLOPE22LTPASS,SLOPE22RTPASS,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$1c 28
	.dw	SLOPE22RBPASS,SLOPE22LBPASS,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SLOPE22RTPASS,SLOPE22LTPASS,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$20 32
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$24 36
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$28 40
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$2c 44
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$30 48
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$34 52
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$38 56
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS	;$3c 60
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$40 64
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$44 68
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$48 72
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$4c 76
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8	;$50 80
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$54 84
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$58 88
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$5c 92
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$60 96
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$64 100
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$68 104
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS	;$6c 108
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$70 112
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$74 116
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$78 120
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR6PASS,FLOOR6PASS,FLOOR6PASS,FLOOR6PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$7c 124
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS	;$80 128
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SKY,SKY,SKY,SKY	;$84 132
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$88 136
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$8c 140
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$90 144
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$94 148
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$98 152
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$9c 156
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a0 160
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$a4 164
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a8 168
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ac 172
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$b0 176
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$b4 180
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$b8 184
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$bc 188
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c0 192
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY	;$c4 196
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c8 200
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$cc 204
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d0 208
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d4 212
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d8 216
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$dc 220
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e0 224
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e4 228
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e8 232
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ec 236
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f0 240
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f4 244
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f8 248
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$fc 254
	.dw	SKY,SKY,SKY,SKY


   .dw   LAST

swamptile:
	.dw	SKY,SKY,SKY,SKY	;$00 0
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR2,FLOOR2,FLOOR2,FLOOR2
	.dw	FLOOR2,FLOOR2,FLOOR2,FLOOR2	;$04 4
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS	;$08 8
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$0c 12
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$10 16
	.dw	QUIKSAND,QUIKSAND,QUIKSAND,QUIKSAND
	.dw	FLOOR2,FLOOR2,FLOOR2,FLOOR2
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$14 20
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$18 24
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$1c 28
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$20 32
	.dw	QUIKSAND,QUIKSAND,QUIKSAND,QUIKSAND
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR2,FLOOR2,FLOOR2,FLOOR2
	.dw	FLOOR2,FLOOR2,FLOOR2,FLOOR2	;$24 36
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$28 40
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$2c 44
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$30 48
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR14PASS,FLOOR14PASS,FLOOR14PASS,FLOOR14PASS
	.dw	SKY,SKY,SKY,SKY	;$34 52
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$38 56
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8	;$3c 60
	.dw	SLOPE22LT,SLOPE22RT,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$40 64
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS	;$44 68
	.dw	SOLIDPASS,SOLIDPASS,SOLIDPASS,SOLIDPASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$48 72
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$4c 76
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$50 80
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$54 84
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$58 88
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$5c 92
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$60 96
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$64 100
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$68 104
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4	;$6c 108
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	SKY,SKY,SKY,SKY	;$70 112
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$74 116
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$78 120
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$7c 124
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$80 128
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$84 132
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$88 136
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$8c 140
	.dw	SLOPE45L,SLOPE45R,SKY,SKY
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4
	.dw	SLOPE45R,SLOPE45L,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$90 144
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$94 148
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$98 152
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$9c 156
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	WALL,WALL,WALL,WALL 
	.dw	SKY,SKY,SKY,SKY	;$a0 160
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a4 164
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a8 168
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ac 172
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$b0 176
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$b4 180
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$b8 184
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4	;$bc 188
	.dw	FLOOR4,FLOOR4,FLOOR4,FLOOR4 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c0 192
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c4 196
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY	;$c8 200
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$cc 204
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d0 208
	.dw	SKY,SKY,SKY,SKY 
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d4 212
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d8 216
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	SKY,SKY,SKY,SKY	;$dc 220
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e0 224
	.dw	FLOOR8,FLOOR8,FLOOR8,FLOOR8
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e4 228
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e8 232
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ec 236
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f0 240
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f4 244
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f8 248
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$fc 254
	.dw	SKY,SKY,SKY,SKY


   .dw   LAST

hutxtile:
	.dw	SKY,SKY,SKY,SKY	;$00 0
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS	;$04 4
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$08 8
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$0c 12
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$10 16
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$14 20
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$18 24
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$1c 28
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$20 32
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$24 36
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$28 40
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$2c 44
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$30 48
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS	;$34 52
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$38 56
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS	;$3c 60
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$40 64
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$44 68
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$48 72
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$4c 76
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$50 80
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$54 84
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$58 88
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$5c 92
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$60 96
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$64 100
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$68 104
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR8PASS,FLOOR8PASS,FLOOR8PASS,FLOOR8PASS	;$6c 108
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$70 112
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$74 116
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$78 120
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$7c 124
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$80 128
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$84 132
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$88 136
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$8c 140
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$90 144
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$94 148
	.dw	SKY,SKY,SKY,SKY
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$98 152
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$9c 156
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a0 160
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a4 164
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a8 168
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ac 172
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$b0 176
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$b4 180
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$b8 184
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$bc 188
	.dw	FLOOR2PASS,FLOOR2PASS,FLOOR2PASS,FLOOR2PASS
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c0 192
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c4 196
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c8 200
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$cc 204
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d0 208
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d4 212
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d8 216
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$dc 220
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e0 224
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e4 228
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e8 232
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ec 236
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f0 240
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f4 244
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f8 248
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$fc 254
	.dw	SKY,SKY,SKY,SKY

   .dw   LAST




shamontile:
	.dw	SKY,SKY,SKY,SKY	;$00 0
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$04 4
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$08 8
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$0c 12
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$10 16
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$14 20
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$18 24
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$1c 28
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$20 32
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$24 36
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$28 40
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$2c 44
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$30 48
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$34 52
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$38 56
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$3c 60
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$40 64
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$44 68
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$48 72
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$4c 76
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$50 80
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$54 8
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$58 88
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$5c 92
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$60 96
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$64 100
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$68 104
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$6c 108
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$70 112
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$74 116
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$78 120
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$7c 124
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$80 128
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$84 132
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$88 136
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$8c 140
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$90 144
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$94 148
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$98 152
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$9c 156
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$a0 160
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SOLID,SOLID,SOLID,SOLID	;$a4 164
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID
	.dw	SOLID,SOLID,SOLID,SOLID	;$a8 168    
	.dw	SOLID,SOLID,SOLID,SOLID	            
	.dw	SKY,SKY,SKY,SKY	            
	.dw	SKY,SKY,SKY,SKY	            
	.dw	SKY,SKY,SKY,SKY	;$ac 172    
	.dw	SKY,SKY,SKY,SKY	            
	.dw	SKY,SKY,SKY,SKY	            
	.dw	SKY,SKY,SKY,SKY	            
	.dw	SKY,SKY,SKY,SKY	;$b0 176    
	.dw	SKY,SKY,SKY,SKY	            
	.dw	SKY,SKY,SKY,SKY	            
	.dw	SKY,SKY,SKY,SKY	            
	.dw	SKY,SKY,SKY,SKY	;$b4 180
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$b8 184
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$bc 188
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c0 192
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c4 196
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$c8 200
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$cc 204
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d0 208
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d4 212
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$d8 216
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$dc 220
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e0 224
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e4 228
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$e8 232
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$ec 236
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f0 240
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f4 244
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$f8 248
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY
	.dw	SKY,SKY,SKY,SKY	;$fc 254
	.dw	SKY,SKY,SKY,SKY



   .dw   LAST


